'use strict';
angularApp.controller('addBankSuccessController',
    ["$scope",
        "yfeiUPIService", "$state",
        function (
            $scope, yfeiUPIService, $state
        ) {

            var addBankSuccessVm = this;
            $scope.$on('$ionicView.beforeEnter', function () {

                addBankSuccessVm.buttonFlag = yfeiUPIService.addBankFlag;
                addBankSuccessVm.bankDetails = yfeiUPIService.addBankDetails;
            });

            addBankSuccessVm.goProfile = function () {
                yfeiUPIService.payerProfileDtls = "";
                $state.go('menu.profileLanding');
            }

            addBankSuccessVm.goToPayment = function () {
                yfeiUPIService.payerProfileDtls = "";
                $state.go('menu.dashboard');
            }

            addBankSuccessVm.continuePayment = function () {
                if (addBankSuccessVm.buttonFlag == "addBankPaymentTime") {
                    $state.go('menu.scanAndPay');
                } else if (addBankSuccessVm.buttonFlag == "addBankGenQRCodeTime") {
                    $state.go('menu.reqMoneyWithoutUPI');
                }
            }
        }
    ]);