'use strict';
angularApp.controller('yfeiContactUsController',
	["$scope",
		"yfeiUPIService", "$state", "utilityService", "constantConfig",
		function (
			$scope, yfeiUPIService, $state, utilityService, constantConfig
		) {

			var yfeiContactUsControllerVm = this;
			$scope.$on('$ionicView.beforeEnter', function () {
				yfeiContactUsControllerVm.getContactData();
			});

			yfeiContactUsControllerVm.getContactData = function () {
				var ContactUsload = {
					"contentName": "getContactUsData"
				}
				yfeiUPIService.getContent(ContactUsload).then(
					function (data) {
						if (data) {
							if (data.data.mainContent) {
								yfeiContactUsControllerVm.mainContent = data.data.mainContent;
							}
							if (data.data.additionalContent) {
								yfeiContactUsControllerVm.additionalContent = data.data.additionalContent;
							}
						}

					},
					function (error) {
						yfeiUPIService.showUpiAlert("error", error);
					}
				);

			};

			yfeiContactUsControllerVm.goBack = function () {
				if (yfeiUPIService.yfeiNavigation && yfeiUPIService.yfeiNavigation == 'login') {
					$state.go('menu.yfeiLogin');
				}
				else {
					$state.go('menu.helpSupport');
				}
			}
		}
	]);