'use strict';
angularApp.controller('removeAccountSuccessController',
    ["$scope", "$state", "yfeiUPIService", "APICUtils",

        function ($scope, $state, yfeiUPIService, APICUtils) {

            var removeAccVm = this;


            $scope.$on('$ionicView.beforeEnter', function () {
                removeAccVm.title = yfeiUPIService.headerTitle;
                removeAccVm.iconFlag = yfeiUPIService.iconFlag;
                removeAccVm.tryAndCancel = yfeiUPIService.footerBtn;
                removeAccVm.successMessage = yfeiUPIService.proSuccessMessage;
                removeAccVm.successMessageSecond = yfeiUPIService.proSuccessMessageSecond;
            });

            $scope.$on('$ionicView.leave', function () {
                yfeiUPIService.iconFlag = "";
                yfeiUPIService.footerBtn = "";
                yfeiUPIService.proSuccessMessage = '';
                yfeiUPIService.proSuccessMessageSecond = '';
            });

            removeAccVm.goBack = function () {
                $state.go('menu.profileLanding');
            }

            removeAccVm.goToHome = function () {
                $state.go('menu.dashboard');
            }

            removeAccVm.goToLogin = function () {
                APICUtils.secretId = "";
                $state.go('menu.yfeiLogin');
            }

        }
    ]);
