'use strict';

angularApp.controller('applicationTrackerNRIController',
    ["$state",
        "$scope",
        "NRIAOService",

        function ($state,
            $scope,
            NRIAOService) {
            var applicationTrackerNRIVm = this;
            applicationTrackerNRIVm.stage = NRIAOService.NriSubmittedStage;
            $scope.$on('$ionicView.beforeEnter', function () {

                if (applicationTrackerNRIVm.stage == "1") {
                    applicationTrackerNRIVm.supportNumberOne = NRIAOService.supportNumberOne;
                    applicationTrackerNRIVm.supportNumberTwo = NRIAOService.supportNumberTwo;
                    applicationTrackerNRIVm.supportNumberThree = NRIAOService.supportNumberThree;
                }


                if (applicationTrackerNRIVm.stage == "3") {

                    if (NRIAOService.customerNumber) {
                        applicationTrackerNRIVm.customerNumber = NRIAOService.customerNumber;
                    }


                    if (NRIAOService.nreAccountNumber) {
                        applicationTrackerNRIVm.nreAccountNumber = NRIAOService.nreAccountNumber;
                        applicationTrackerNRIVm.nreAccountType = NRIAOService.nreAccountType;
                    }
                    else{
                        applicationTrackerNRIVm.nreAccountNumber = null;
                        applicationTrackerNRIVm.nreAccountType = null;
                    }

                    if (NRIAOService.nroAccountNumber) {
                        applicationTrackerNRIVm.nroAccountNumber = NRIAOService.nroAccountNumber;
                        applicationTrackerNRIVm.nroAccountType = NRIAOService.nroAccountType;
                    }
                    else{
                        applicationTrackerNRIVm.nroAccountNumber = null;
                        applicationTrackerNRIVm.nroAccountType = null;
                    }

                }
                else if (applicationTrackerNRIVm.stage == "4") {
                    applicationTrackerNRIVm.checkerReason = NRIAOService.checkerReason;
                    applicationTrackerNRIVm.footerMessage = NRIAOService.footerMessage;
                }

            });
            applicationTrackerNRIVm.exit = function () {
                $state.go("menu.otpInitialNRIAO");
            }


        }
    ]);