'use strict';

angularApp.controller('nonEUConsentController', ["$scope",
    "$ionicScrollDelegate",
    "NRIAOService",
    "utilityService",
    "$ionicHistory",
    function ($scope,
        $ionicScrollDelegate,
        NRIAOService,
        utilityService,
        $ionicHistory
    ) {

        var nonEUConsentVm = this;


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            nonEUConsentVm.consentData = NRIAOService.nonEuConsentData;
        });


        function initPage() {
            utilityService.showBhimUpiAlert("", "Please read full consent", "", "", "");
        }

        nonEUConsentVm.goBack = function () {
            $ionicHistory.goBack();
        }
     
        nonEUConsentVm.checkScroll = function (event) {
            var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
            var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if (maxTop !== 0) {
                if (currentTop >= maxTop) {
                    NRIAOService.consentValueForNo = true;
                }
            }
        }



        return this;
    }
]);
