'use strict';

angularApp.controller('taxationDetailsNRIController',
    ["$scope",
        "utilityService",
        "$state",
        "$ionicHistory",
        "NRIAOService",
        function (
            $scope,
            utilityService,
            $state,
            $ionicHistory,
            NRIAOService) {
            var taxationDetailsNRIVm = this;
            $scope.$on('$ionicView.beforeEnter', function () {
               
                taxationDetailsNRIVm.initPage();
            });
            taxationDetailsNRIVm.initPage = function () {
                taxationDetailsNRIVm.taxCountry = {};
              
                if (NRIAOService.resumeApplication || NRIAOService.review) {
                    if (NRIAOService.resumeNRIresponse.taxDetail != null) {
                        if (NRIAOService.resumeNRIresponse.taxDetail.taxCountries.length == 3) {
                            taxationDetailsNRIVm.secondCountry = true;
                            taxationDetailsNRIVm.firstCountry = true;
                            taxationDetailsNRIVm.addedCountry1 = true;
                            taxationDetailsNRIVm.addedCountry2 = true;
                            taxationDetailsNRIVm.addedCountry3 = true;
                            taxationDetailsNRIVm.taxAddressDetailsCard = true;
                            taxationDetailsNRIVm.taxDetailsCard = true;
                            taxationDetailsNRIVm.checkCountry1True = true;
                            taxationDetailsNRIVm.checkCountry2True = true;
                            taxationDetailsNRIVm.taxIdentification = NRIAOService.resumeNRIresponse.taxDetail.taxCountries[0].taxIdNum;
                            taxationDetailsNRIVm.selectedOthersubtype = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.taxDetail.taxCountries[0].taxResidenceCountry)
                            taxationDetailsNRIVm.taxIdentificationtwo = NRIAOService.resumeNRIresponse.taxDetail.taxCountries[1].taxIdNum;
                            taxationDetailsNRIVm.selectedcountrytwo = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.taxDetail.taxCountries[1].taxResidenceCountry)
                            taxationDetailsNRIVm.taxIdentificationthree = NRIAOService.resumeNRIresponse.taxDetail.taxCountries[2].taxIdNum;
                            taxationDetailsNRIVm.selectedcountrythree = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.taxDetail.taxCountries[2].taxResidenceCountry)
                            taxationDetailsNRIVm.selectedResidencytype = NRIAOService.getTaxAddressType(NRIAOService.resumeNRIresponse.taxDetail.taxAddrProof);
                            taxationDetailsNRIVm.nomineeAddr = NRIAOService.resumeNRIresponse.taxDetail.sameAddress;
                             if(NRIAOService.resumeNRIresponse.taxDetail.sameAddress == 'N'){
                                taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.addressLine1;
                                taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.city;
                                taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.state;
                                taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.pincode;
                                taxationDetailsNRIVm.taxCountry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.taxDetail.taxAddress.country);
                             }else{
                                if (NRIAOService.resumeNRIresponse.sameAddress) {
                                        taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.currentAddress.addressLine1;
                                        taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.currentAddress.city;
                                        if (NRIAOService.resumeNRIresponse.currentAddress.country == 'IN') {
                                            taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.currentAddress.state);
                                        } else {
                                            taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.currentAddress.state
                                        }
                                        taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.currentAddress.pincode;
                                        taxationDetailsNRIVm.taxCountry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.currentAddress.country);
                                }else{
                                        taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.permanentAddress.addressLine1;
                                        taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.permanentAddress.city;
                                        if (NRIAOService.resumeNRIresponse.permanentAddress.country == 'IN') {
                                            taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.permanentAddress.state);
                                        } else {
                                            taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.permanentAddress.state
                                        }
                                        taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.permanentAddress.pincode;
                                        var contry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.permanentAddress.country);
                                        taxationDetailsNRIVm.taxCountry = contry;

                                }
                             }
                            
                            if (NRIAOService.resumeNRIresponse.taxDetail.sameAddress == 'C' || NRIAOService.resumeNRIresponse.taxDetail.sameAddress == 'P') {
                                taxationDetailsNRIVm.addressReadOnly = true;
                            } else {
                                taxationDetailsNRIVm.addressReadOnly = false;
                            }


                        } else if (NRIAOService.resumeNRIresponse.taxDetail.taxCountries.length == 2) {
                            taxationDetailsNRIVm.secondCountry = false;
                            taxationDetailsNRIVm.firstCountry = true;
                            taxationDetailsNRIVm.showCountryOne = true;
                            taxationDetailsNRIVm.addedCountry1 = true;
                            taxationDetailsNRIVm.addedCountry2 = true;
                            taxationDetailsNRIVm.taxAddressDetailsCard = true;
                            taxationDetailsNRIVm.taxDetailsCard = true;
                            taxationDetailsNRIVm.taxIdentification = NRIAOService.resumeNRIresponse.taxDetail.taxCountries[0].taxIdNum;
                            taxationDetailsNRIVm.selectedOthersubtype = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.taxDetail.taxCountries[0].taxResidenceCountry)
                            taxationDetailsNRIVm.taxIdentificationtwo = NRIAOService.resumeNRIresponse.taxDetail.taxCountries[1].taxIdNum;
                            taxationDetailsNRIVm.selectedcountrytwo = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.taxDetail.taxCountries[1].taxResidenceCountry)
                            taxationDetailsNRIVm.selectedResidencytype = NRIAOService.getTaxAddressType(NRIAOService.resumeNRIresponse.taxDetail.taxAddrProof);
                            taxationDetailsNRIVm.nomineeAddr = NRIAOService.resumeNRIresponse.taxDetail.sameAddress;
                             if(NRIAOService.resumeNRIresponse.taxDetail.sameAddress == 'N'){
                                taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.addressLine1;
                                taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.city;
                                taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.state;
                                taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.pincode;
                                taxationDetailsNRIVm.taxCountry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.taxDetail.taxAddress.country);
                             }else{
                                 if (NRIAOService.resumeNRIresponse.sameAddress) {
                                        taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.currentAddress.addressLine1;
                                        taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.currentAddress.city;
                                        if (NRIAOService.resumeNRIresponse.currentAddress.country == 'IN') {
                                            taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.currentAddress.state);
                                        } else {
                                            taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.currentAddress.state
                                        }
                                        taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.currentAddress.pincode;
                                        taxationDetailsNRIVm.taxCountry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.currentAddress.country);
                                 }else{
                                        taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.permanentAddress.addressLine1;
                                        taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.permanentAddress.city;
                                        if (NRIAOService.resumeNRIresponse.permanentAddress.country == 'IN') {
                                            taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.permanentAddress.state);
                                        } else {
                                            taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.permanentAddress.state
                                        }
                                        taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.permanentAddress.pincode;
                                        var contry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.permanentAddress.country);
                                        taxationDetailsNRIVm.taxCountry = contry;
                                 }

                             }
                            
                            if (NRIAOService.resumeNRIresponse.taxDetail.sameAddress == 'C' || NRIAOService.resumeNRIresponse.taxDetail.sameAddress == 'P') {
                                taxationDetailsNRIVm.addressReadOnly = true;
                            } else {
                                taxationDetailsNRIVm.addressReadOnly = false;
                            }

                        } else {
                            taxationDetailsNRIVm.taxAddressDetailsCard = true;
                            taxationDetailsNRIVm.taxDetailsCard = true;
                            taxationDetailsNRIVm.taxIdentification = NRIAOService.resumeNRIresponse.taxDetail.taxCountries[0].taxIdNum;
                            taxationDetailsNRIVm.selectedOthersubtype = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.taxDetail.taxCountries[0].taxResidenceCountry)
                            taxationDetailsNRIVm.selectedResidencytype = NRIAOService.getTaxAddressType(NRIAOService.resumeNRIresponse.taxDetail.taxAddrProof);
                            taxationDetailsNRIVm.nomineeAddr = NRIAOService.resumeNRIresponse.taxDetail.sameAddress;
                            if(NRIAOService.resumeNRIresponse.taxDetail.sameAddress == 'N'){
                                taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.addressLine1;
                                taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.city;
                                taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.state;
                                taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.taxDetail.taxAddress.pincode;
                                taxationDetailsNRIVm.taxCountry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.taxDetail.taxAddress.country);
                            }else{
                                if (NRIAOService.resumeNRIresponse.sameAddress) {
                                    taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.currentAddress.addressLine1;
                                    taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.currentAddress.city;
                                    if (NRIAOService.resumeNRIresponse.currentAddress.country == 'IN') {
                                        taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.currentAddress.state);
                                    } else {
                                        taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.currentAddress.state
                                    }
                                    taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.currentAddress.pincode;
                                    taxationDetailsNRIVm.taxCountry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.currentAddress.country);
                                }else{
                                    taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.permanentAddress.addressLine1;
                                    taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.permanentAddress.city;
                                    if (NRIAOService.resumeNRIresponse.permanentAddress.country == 'IN') {
                                        taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.permanentAddress.state);
                                    } else {
                                        taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.permanentAddress.state
                                    }
                                    taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.permanentAddress.pincode;
                                    var contry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.permanentAddress.country);
                                    taxationDetailsNRIVm.taxCountry = contry;
                                }
                            }
                            if (NRIAOService.resumeNRIresponse.taxDetail.sameAddress == 'C' || NRIAOService.resumeNRIresponse.taxDetail.sameAddress == 'P') {
                                taxationDetailsNRIVm.addressReadOnly = true;
                            } else {
                                taxationDetailsNRIVm.addressReadOnly = false;
                            }

                        }

                        taxationDetailsNRIVm.removeSelectedCountry();
                    }

                }
            }
            $scope.$on('$ionicView.loaded', function () {
                $scope.nriNamePattern = /^[a-zA-Z0-9]{1}[a-z0-9A-Z@# &*:,._\-/]*$/
          
                taxationDetailsNRIVm.addedCountry1 = true;
                taxationDetailsNRIVm.errorCountry = false;
                taxationDetailsNRIVm.addedCountry2 = false;
                taxationDetailsNRIVm.showCountryOne = false;
                taxationDetailsNRIVm.addedCountry3 = false;
                taxationDetailsNRIVm.countryCount = 1;
                taxationDetailsNRIVm.stateMaster = NRIAOService.stateMasterdata;
                taxationDetailsNRIVm.selectedResidencysubtype = NRIAOService.keyValueMap.TaxResidenceProofMaster;
                taxationDetailsNRIVm.countrySubType = NRIAOService.countryMaster;
                taxationDetailsNRIVm.countryOneList = taxationDetailsNRIVm.countrySubType ;
                taxationDetailsNRIVm.taxDetailsCard = true;
                taxationDetailsNRIVm.showTaxAddress = false;
                taxationDetailsNRIVm.errorTaxAddress = false;

            });

            taxationDetailsNRIVm.toggleContent = function (item) {
                if (item == 'taxDet') {

                    taxationDetailsNRIVm.taxDetailsCard = true;
                    taxationDetailsNRIVm.taxAddressDetailsCard = false;
                }
                else if (item == 'taxAddDet') {
                    taxationDetailsNRIVm.validateTaxDetails();
                    taxationDetailsNRIVm.taxAddressDetailsCard = true;
                    taxationDetailsNRIVm.taxDetailsCard = false;
                }

            }

            taxationDetailsNRIVm.removeCountryOneInTwo = function(List1){
                return (List1 != taxationDetailsNRIVm.selectedOthersubtype);
            } 
            taxationDetailsNRIVm.removeCountryOneThreeInTwo = function(List2){                 
                return(!(List2 == taxationDetailsNRIVm.selectedOthersubtype || List2 == taxationDetailsNRIVm.selectedcountrythree));
            }    
            taxationDetailsNRIVm.removeCountryOneTwoInThree = function(List3){ 
                return(!(List3 == taxationDetailsNRIVm.selectedOthersubtype || List3 == taxationDetailsNRIVm.selectedcountrytwo  ));
            } 
            taxationDetailsNRIVm.removeCountryTwoInThree = function(List2){     
                return(List2 != taxationDetailsNRIVm.selectedcountrytwo);
            }
            taxationDetailsNRIVm.removeCountryTwoInOne = function(List11){    
                return(List11 != taxationDetailsNRIVm.selectedcountrytwo)
            }
            taxationDetailsNRIVm.removeCountryTwoThreeInOne = function(List11){                 
                return(!(List11 == taxationDetailsNRIVm.selectedcountrytwo || List11 == taxationDetailsNRIVm.selectedcountrythree));
            }
            taxationDetailsNRIVm.removeCountryTwoThreeInOneAll = function(List111){                 
                return(!(List111 == taxationDetailsNRIVm.selectedcountrythree || List111 == taxationDetailsNRIVm.selectedcountrytwo));
            }    
            taxationDetailsNRIVm.removeCountryOneThreeInTwoAll = function(List222){ 
                return(!(List222 == taxationDetailsNRIVm.selectedcountrythree || List222 == taxationDetailsNRIVm.selectedOthersubtype));
            }         
            taxationDetailsNRIVm.removeCountryOneTwoInThreeAll = function(List22){ 
                return(!(List22 == taxationDetailsNRIVm.selectedOthersubtype || List22 == taxationDetailsNRIVm.selectedcountrytwo));
            }

            taxationDetailsNRIVm.removeSelectedCountry = function(SelCountry){
      
                if(SelCountry == '1')
                {
                   
                    if (taxationDetailsNRIVm.countrySubType == undefined || !taxationDetailsNRIVm.checkCountry1True) {
                        taxationDetailsNRIVm.countryOneList = taxationDetailsNRIVm.countrySubType;
                        const countryList1 = taxationDetailsNRIVm.countryOneList;
                        taxationDetailsNRIVm.removeCountryOneInTwo(countryList1);
                        taxationDetailsNRIVm.countryTwoList = countryList1.filter(taxationDetailsNRIVm.removeCountryOneInTwo);
                    }

                    else {
                        const countryList2 = taxationDetailsNRIVm.countrySubType;
                        taxationDetailsNRIVm.removeCountryOneThreeInTwo(countryList2);
                        taxationDetailsNRIVm.countryTwoList = countryList2.filter(taxationDetailsNRIVm.removeCountryOneThreeInTwo);

                        const countryList3 = taxationDetailsNRIVm.countrySubType;
                        taxationDetailsNRIVm.removeCountryOneTwoInThree(countryList3);
                        taxationDetailsNRIVm.countryThreeList = countryList3.filter(taxationDetailsNRIVm.removeCountryOneTwoInThree);
                    }
                }        
   
                  else if(SelCountry == '2')
                {
                    if (!taxationDetailsNRIVm.checkCountry2True) {
                        const countryList2 = taxationDetailsNRIVm.countryTwoList;
                        taxationDetailsNRIVm.removeCountryTwoInThree(countryList2);
                        taxationDetailsNRIVm.countryThreeList = countryList2.filter(taxationDetailsNRIVm.removeCountryTwoInThree);

                        taxationDetailsNRIVm.countryOneList = taxationDetailsNRIVm.countrySubType;
                        const countryList11 = taxationDetailsNRIVm.countryOneList;
                        taxationDetailsNRIVm.removeCountryTwoInOne(countryList11);
                        taxationDetailsNRIVm.countryOneList = countryList11.filter(taxationDetailsNRIVm.removeCountryTwoInOne);
                    }

                    else {
                        const countryList11 = taxationDetailsNRIVm.countrySubType;
                        taxationDetailsNRIVm.removeCountryTwoThreeInOne(countryList11);
                        taxationDetailsNRIVm.countryOneList = countryList11.filter(taxationDetailsNRIVm.removeCountryTwoThreeInOne);

                        const countryList22 = taxationDetailsNRIVm.countrySubType;
                        taxationDetailsNRIVm.removeCountryOneTwoInThree(countryList22);
                        taxationDetailsNRIVm.countryThreeList = countryList22.filter(taxationDetailsNRIVm.removeCountryOneTwoInThree);
                    }  
                 }
   
                 else if(SelCountry == '3')
                 {
                    const countryList111 = taxationDetailsNRIVm.countrySubType;
                    taxationDetailsNRIVm.removeCountryTwoThreeInOne(countryList111);
                    taxationDetailsNRIVm.countryOneList = countryList111.filter(taxationDetailsNRIVm.removeCountryTwoThreeInOne);


                    const countryList222 = taxationDetailsNRIVm.countrySubType;
                    taxationDetailsNRIVm.removeCountryOneThreeInTwo(countryList222);
                    taxationDetailsNRIVm.countryTwoList = countryList222.filter(taxationDetailsNRIVm.removeCountryOneThreeInTwo);            
                  }

                else {
                    const countryList111 = taxationDetailsNRIVm.countrySubType;
                    taxationDetailsNRIVm.removeCountryTwoThreeInOneAll(countryList111);
                    taxationDetailsNRIVm.countryOneList = countryList111.filter(taxationDetailsNRIVm.removeCountryTwoThreeInOneAll);

                    const countryList222 = taxationDetailsNRIVm.countrySubType;
                    taxationDetailsNRIVm.removeCountryOneThreeInTwoAll(countryList222);
                    taxationDetailsNRIVm.countryTwoList = countryList222.filter(taxationDetailsNRIVm.removeCountryOneThreeInTwoAll);

                    const countryList333 = taxationDetailsNRIVm.countrySubType;
                    taxationDetailsNRIVm.removeCountryOneTwoInThreeAll(countryList333);
                    taxationDetailsNRIVm.countryThreeList = countryList333.filter(taxationDetailsNRIVm.removeCountryOneTwoInThreeAll);
                }
               }
            taxationDetailsNRIVm.addressSelect = function (subType) {
                if (NRIAOService.resumeApplication) {
                    if (subType == 'CUR_ADDR') {
                        taxationDetailsNRIVm.nomineeAddr = 'C';
                        taxationDetailsNRIVm.addressReadOnly = true;
                        var contry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.currentAddress.country)
                        taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.currentAddress.addressLine1;
                        taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.currentAddress.city;
                        if (NRIAOService.resumeNRIresponse.currentAddress.country == 'IN') {
                            taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.currentAddress.state);
                        } else {
                            taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.currentAddress.state
                        }
                        taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.currentAddress.pincode;
                        taxationDetailsNRIVm.taxCountry = contry;
                    } else if (subType == 'PER_ADDR') {
                        taxationDetailsNRIVm.nomineeAddr = 'P';
                        taxationDetailsNRIVm.addressReadOnly = true;
                        if (NRIAOService.resumeNRIresponse.sameAddress) {
                            taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.currentAddress.addressLine1;
                            taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.currentAddress.city;
                            if (NRIAOService.resumeNRIresponse.currentAddress.country == 'IN') {
                                taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.currentAddress.state);
                            } else {
                                taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.currentAddress.state
                            }
                            taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.currentAddress.pincode;
                            taxationDetailsNRIVm.taxCountry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.currentAddress.country);
                        } else {
                            taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.permanentAddress.addressLine1;
                            taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.permanentAddress.city;
                            if (NRIAOService.resumeNRIresponse.permanentAddress.country == 'IN') {
                                taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.permanentAddress.state);
                            } else {
                                taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.permanentAddress.state
                            }
                            taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.permanentAddress.pincode;
                            var contry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.permanentAddress.country);
                            taxationDetailsNRIVm.taxCountry = contry;
                        }

                    } else if (subType == 'NEW_ADDR') {
                        taxationDetailsNRIVm.addressReadOnly = false
                        taxationDetailsNRIVm.nomineeAddr = 'N';
                        taxationDetailsNRIVm.address = '';
                        taxationDetailsNRIVm.city = '';
                        taxationDetailsNRIVm.state = '';
                        taxationDetailsNRIVm.pin = '';
                        taxationDetailsNRIVm.taxCountry = '';
                    }
                } else {
                    if (subType == 'CUR_ADDR') {
                        taxationDetailsNRIVm.nomineeAddr = 'C';
                        taxationDetailsNRIVm.addressReadOnly = true;
                        taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.currentAddress.addressLine1;
                        taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.currentAddress.city;
                        var contry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.currentAddress.country)
                        if (NRIAOService.resumeNRIresponse.currentAddress.country == 'IN') {
                            taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.currentAddress.state);
                        } else {
                            taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.currentAddress.state
                        }
                        taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.currentAddress.pincode;
                        taxationDetailsNRIVm.taxCountry = contry;
                    } else if (subType == 'PER_ADDR') {
                        taxationDetailsNRIVm.nomineeAddr = 'P';
                        taxationDetailsNRIVm.addressReadOnly = true;


                        if (NRIAOService.resumeNRIresponse.sameAddress) {
                            taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.currentAddress.addressLine1;
                            taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.currentAddress.city;
                            if (NRIAOService.resumeNRIresponse.currentAddress.country == 'IN') {
                                taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.currentAddress.state);
                            } else {
                                taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.currentAddress.state
                            }
                            taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.currentAddress.pincode;
                            taxationDetailsNRIVm.taxCountry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.currentAddress.country);
                        } else {
                            taxationDetailsNRIVm.address = NRIAOService.resumeNRIresponse.permanentAddress.addressLine1;
                            taxationDetailsNRIVm.city = NRIAOService.resumeNRIresponse.permanentAddress.city;
                            if (NRIAOService.resumeNRIresponse.permanentAddress.country == 'IN') {
                                taxationDetailsNRIVm.state = NRIAOService.getStateName(NRIAOService.resumeNRIresponse.permanentAddress.state);
                            } else {
                                taxationDetailsNRIVm.state = NRIAOService.resumeNRIresponse.permanentAddress.state
                            }
                            taxationDetailsNRIVm.pin = NRIAOService.resumeNRIresponse.permanentAddress.pincode;
                            taxationDetailsNRIVm.taxCountry = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.permanentAddress.country);
                        }


                    } else if (subType == 'NEW_ADDR') {
                        taxationDetailsNRIVm.nomineeAddr = 'N';
                        taxationDetailsNRIVm.addressReadOnly = false;
                        taxationDetailsNRIVm.address = '';
                        taxationDetailsNRIVm.city = '';
                        taxationDetailsNRIVm.state = '';
                        taxationDetailsNRIVm.pin = '';
                        taxationDetailsNRIVm.taxCountry = '';
                    }
                }
            }

            taxationDetailsNRIVm.cancel = function (selectedtab) {
                if (selectedtab == '2') {
                    if(!taxationDetailsNRIVm.addedCountry3){
                    taxationDetailsNRIVm.addedCountry1 = true;
                    taxationDetailsNRIVm.addedCountry2 = false;
                    taxationDetailsNRIVm.secondCountry = true;
                    taxationDetailsNRIVm.firstCountry = true;
                    taxationDetailsNRIVm.errorCountry = false;
                    taxationDetailsNRIVm.checkCountry1True = false;
                    taxationDetailsNRIVm.taxIdentificationtwo = "";
                    taxationDetailsNRIVm.selectedcountrytwo = "";
                   }
                    else{
                        taxationDetailsNRIVm.addedCountry1 = true;
                        taxationDetailsNRIVm.addedCountry2 = true;
                        taxationDetailsNRIVm.addedCountry3 = false;
                        taxationDetailsNRIVm.errorCountry = false;
                        taxationDetailsNRIVm.firstCountry = true;
                        taxationDetailsNRIVm.checkCountry1True = true;
                        taxationDetailsNRIVm.checkCountry2True = false;
                        taxationDetailsNRIVm.selectedcountrytwo = taxationDetailsNRIVm.selectedcountrythree;
                         taxationDetailsNRIVm.taxIdentificationtwo = taxationDetailsNRIVm.taxIdentificationthree;
                         taxationDetailsNRIVm.selectedcountrythree = "";
                         taxationDetailsNRIVm.taxIdentificationthree = "";
                        taxationDetailsNRIVm.removeSelectedCountry();
                    }
                } else if (selectedtab == '3') {
                    taxationDetailsNRIVm.addedCountry1 = true;
                    taxationDetailsNRIVm.addedCountry2 = true;
                    taxationDetailsNRIVm.addedCountry3 = false;
                    taxationDetailsNRIVm.secondCountry = false;
                    taxationDetailsNRIVm.firstCountry = true;
                    taxationDetailsNRIVm.errorCountry = false;
                    taxationDetailsNRIVm.checkCountry2True = false;
                    taxationDetailsNRIVm.selectedcountrythree = "";
                    taxationDetailsNRIVm.taxIdentificationthree = "";
                }
            }
            taxationDetailsNRIVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go("menu.nriAccountServicePage");
                } else {
                    $ionicHistory.goBack();
                }
            }

            taxationDetailsNRIVm.isNotNullOrUndefined = function (varNull) {
                return (varNull != null && varNull != undefined && varNull != "");
            }

            taxationDetailsNRIVm.checkCountry1 = function () {
                taxationDetailsNRIVm.selectedOthersubtypeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedOthersubtype);
                taxationDetailsNRIVm.taxIdentificationNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentification);

                return (taxationDetailsNRIVm.selectedOthersubtypeNotNull && taxationDetailsNRIVm.taxIdentificationNotNull);
            }
            taxationDetailsNRIVm.checkCountry2 = function () {
                taxationDetailsNRIVm.selectedcountrytwoNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedcountrytwo);
                taxationDetailsNRIVm.taxIdentificationtwoNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentificationtwo);
                return (taxationDetailsNRIVm.selectedcountrytwoNotNull && taxationDetailsNRIVm.taxIdentificationtwoNotNull);
            }

            taxationDetailsNRIVm.checkCountry1True = taxationDetailsNRIVm.checkCountry1();
            taxationDetailsNRIVm.checkCountry2True = taxationDetailsNRIVm.checkCountry2();

            taxationDetailsNRIVm.addCountryData1 = function () {
                taxationDetailsNRIVm.selectedOthersubtypeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedOthersubtype);
                taxationDetailsNRIVm.taxIdentificationNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentification);
                if (taxationDetailsNRIVm.selectedOthersubtypeNotNull && taxationDetailsNRIVm.taxIdentificationNotNull) {
                    taxationDetailsNRIVm.addedCountry1 = true;
                    taxationDetailsNRIVm.addedCountry2 = true;
                    taxationDetailsNRIVm.firstCountry = false;
                    taxationDetailsNRIVm.errorCountry = true;
                    taxationDetailsNRIVm.checkCountry1True = true;

                } else {
                    taxationDetailsNRIVm.errorCountry = true;
                    taxationDetailsNRIVm.firstCountry = false;

                }

            }
            taxationDetailsNRIVm.addCountryData2 = function () {
                taxationDetailsNRIVm.selectedcountrytwoNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedcountrytwo);
                taxationDetailsNRIVm.taxIdentificationtwoNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentificationtwo);

                if (taxationDetailsNRIVm.selectedcountrytwoNotNull && taxationDetailsNRIVm.taxIdentificationtwoNotNull) {
                    taxationDetailsNRIVm.addedCountry3 = true;
                    taxationDetailsNRIVm.addedCountry2 = true;
                    taxationDetailsNRIVm.secondCountry = true;
                    taxationDetailsNRIVm.firstCountry = false;
                    taxationDetailsNRIVm.errorCountry = true;
                    taxationDetailsNRIVm.checkCountry2True = true;
                } else {
                    taxationDetailsNRIVm.errorCountry = true;
                    taxationDetailsNRIVm.firstCountry = false;
                }

            }
            taxationDetailsNRIVm.addCountryData3 = function () {
                taxationDetailsNRIVm.selectedcountrythreeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedcountrythree);
                taxationDetailsNRIVm.taxIdentificationthreeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentificationthree);
                if (taxationDetailsNRIVm.selectedcountrythreeNotNull && taxationDetailsNRIVm.taxIdentificationthreeNotNull) {
                    taxationDetailsNRIVm.addedCountry1 = false;
                    taxationDetailsNRIVm.addedCountry2 = false;
                    taxationDetailsNRIVm.addedCountry3 = true;
                    taxationDetailsNRIVm.firstCountry = true;
                    taxationDetailsNRIVm.errorCountry = false;

                } else {
                    taxationDetailsNRIVm.errorCountry = true;
                    taxationDetailsNRIVm.firstCountry = false;

                }

            }

            taxationDetailsNRIVm.validateTaxDetails = function () {
                if (taxationDetailsNRIVm.addedCountry3) {
                    if (taxationDetailsNRIVm.taxDetailsForm.countryOfTax.$invalid && taxationDetailsNRIVm.taxDetailsForm.taxidentification.$invalid &&
                        taxationDetailsNRIVm.taxDetailscountrytwoForm.residencyCountry.$invalid && taxationDetailsNRIVm.taxDetailscountrytwoForm.taxidentificationtwo.$invalid &&
                        taxationDetailsNRIVm.taxDetailscountrythreeForm.residencyCountrythree.$invalid && taxationDetailsNRIVm.taxDetailscountrythreeForm.taxidentificationthree.$invalid) {
                        taxationDetailsNRIVm.errorCountry = true;
                        taxationDetailsNRIVm.firstCountry = false;
                    }
                    else {
                        taxationDetailsNRIVm.errorCountry = false;
                        taxationDetailsNRIVm.firstCountry = true;
                    }
                }
                else if (taxationDetailsNRIVm.addedCountry2) {
                    if (taxationDetailsNRIVm.taxDetailsForm.countryOfTax.$invalid && taxationDetailsNRIVm.taxDetailsForm.taxidentification.$invalid &&
                        taxationDetailsNRIVm.taxDetailscountrytwoForm.residencyCountry.$invalid && taxationDetailsNRIVm.taxDetailscountrytwoForm.taxidentificationtwo.$invalid) {
                        taxationDetailsNRIVm.errorCountry = true;
                        taxationDetailsNRIVm.firstCountry = false;
                    }
                    else {
                        taxationDetailsNRIVm.errorCountry = false;
                        taxationDetailsNRIVm.firstCountry = true;
                    }
                }
                else {
                    if (taxationDetailsNRIVm.taxDetailsForm.countryOfTax.$invalid && taxationDetailsNRIVm.taxDetailsForm.taxidentification.$invalid) {
                        taxationDetailsNRIVm.errorCountry = true;
                        taxationDetailsNRIVm.firstCountry = false;
                    }
                    else {
                        taxationDetailsNRIVm.errorCountry = false;
                        taxationDetailsNRIVm.firstCountry = true;
                        taxationDetailsNRIVm.checkCountry1True = false;
                    }
                }
            }

            taxationDetailsNRIVm.validateTaxationAddress = function () {
                taxationDetailsNRIVm.selectedResidencytypeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedResidencytype);
                taxationDetailsNRIVm.addressNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.address);
                taxationDetailsNRIVm.cityNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.city);
                taxationDetailsNRIVm.taxCountryNameNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxCountry.name);
                taxationDetailsNRIVm.stateNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.state);
                if (taxationDetailsNRIVm.selectedResidencytypeNotNull && taxationDetailsNRIVm.addressNotNull && taxationDetailsNRIVm.cityNotNull
                    && taxationDetailsNRIVm.taxCountryNameNotNull && taxationDetailsNRIVm.stateNotNull) {
                    taxationDetailsNRIVm.showTaxAddress = true;
                }
                else {
                    taxationDetailsNRIVm.errorTaxAddress = true;
                }
            }

            taxationDetailsNRIVm.getUpdatedData = function () {
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }
                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        if (NRIAOService.resumeNRIresponse.branchPref) {
                            $state.go("menu.nriReviewPage");
                        } else {
                            $state.go("menu.gncHomeBranchSelectionNRI");
                        }
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            taxationDetailsNRIVm.submittaxationDetails = function () {

                if (taxationDetailsNRIVm.addedCountry3) {
                    if ((taxationDetailsNRIVm.taxDetailsForm.countryOfTax.$invalid || taxationDetailsNRIVm.taxDetailsForm.taxidentification.$invalid) ||
                        (taxationDetailsNRIVm.taxDetailscountrytwoForm.residencyCountry.$invalid || taxationDetailsNRIVm.taxDetailscountrytwoForm.taxidentificationtwo.$invalid) ||
                        (taxationDetailsNRIVm.taxDetailscountrythreeForm.residencyCountrythree.$invalid || taxationDetailsNRIVm.taxDetailscountrythreeForm.taxidentificationthree.$invalid)) {
                        taxationDetailsNRIVm.errorCountry = true;
                        taxationDetailsNRIVm.firstCountry = false;
                        taxationDetailsNRIVm.addedCountry2 = true;
                    }
                    else {
                        if (taxationDetailsNRIVm.taxAddressDetailsForm.taxAddressProof.$invalid && taxationDetailsNRIVm.taxAddressDetailsForm.flatHouseNo.$invalid
                            && taxationDetailsNRIVm.taxAddressDetailsForm.cityTown.$invalid && taxationDetailsNRIVm.taxAddressDetailsForm.taxCountry.$invalid && taxationDetailsNRIVm.taxAddressDetailsForm.state.$invalid) {
                            taxationDetailsNRIVm.errorTaxAddress = true;
                            taxationDetailsNRIVm.showTaxAddress = false;
                        } else {
                            taxationDetailsNRIVm.firstCountry = true;
                            taxationDetailsNRIVm.errorCountry = false;
                            taxationDetailsNRIVm.selectedOthersubtypeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedOthersubtype);
                            taxationDetailsNRIVm.taxIdentificationNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentification);
                            taxationDetailsNRIVm.selectedcountrytwoNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedcountrytwo);
                            taxationDetailsNRIVm.taxIdentificationtwoNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentificationtwo);
                            taxationDetailsNRIVm.selectedcountrythreeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedcountrythree);
                            taxationDetailsNRIVm.taxIdentificationthreeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentificationthree);
                            taxationDetailsNRIVm.selectedResidencytypeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedResidencytype);
                            taxationDetailsNRIVm.addressNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.address);
                            taxationDetailsNRIVm.cityNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.city);
                            taxationDetailsNRIVm.taxCountryNameNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxCountry);
                            taxationDetailsNRIVm.stateNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.state);


                            if (taxationDetailsNRIVm.selectedOthersubtypeNotNull && taxationDetailsNRIVm.taxIdentificationNotNull && taxationDetailsNRIVm.selectedcountrytwoNotNull
                                && taxationDetailsNRIVm.taxIdentificationtwoNotNull && taxationDetailsNRIVm.selectedcountrythreeNotNull && taxationDetailsNRIVm.taxIdentificationthreeNotNull
                                && taxationDetailsNRIVm.selectedResidencytypeNotNull && taxationDetailsNRIVm.addressNotNull && taxationDetailsNRIVm.cityNotNull && taxationDetailsNRIVm.taxCountryNameNotNull
                                && taxationDetailsNRIVm.stateNotNull) {
                                taxationDetailsNRIVm.errorTaxAddress = false;
                                taxationDetailsNRIVm.showTaxAddress = true;
                                taxationDetailsNRIVm.errorCountry = false;
                                taxationDetailsNRIVm.firstCountry = true;
                                if (typeof (taxationDetailsNRIVm.selectedvalidTill) === "object") {
                                    taxationDetailsNRIVm.countryOneValidity = taxationDetailsNRIVm.selectedvalidTill.getFullYear() + "-" + ('0' + (taxationDetailsNRIVm.selectedvalidTill.getMonth() + 1)).slice(-2) + "-" + ('0' + taxationDetailsNRIVm.selectedvalidTill.getDate()).slice(-2);
                                } else {
                                    taxationDetailsNRIVm.countryOneValidity = taxationDetailsNRIVm.selectedvalidTill
                                }
                                if (typeof (taxationDetailsNRIVm.validTilltwo) === "object") {
                                    taxationDetailsNRIVm.countrytwoValidity = taxationDetailsNRIVm.validTilltwo.getFullYear() + "-" + ('0' + (taxationDetailsNRIVm.validTilltwo.getMonth() + 1)).slice(-2) + "-" + ('0' + taxationDetailsNRIVm.validTilltwo.getDate()).slice(-2);
                                } else {
                                    taxationDetailsNRIVm.countrytwoValidity = taxationDetailsNRIVm.validTilltwo
                                }
                                if (typeof (taxationDetailsNRIVm.validTillthree) === "object") {
                                    taxationDetailsNRIVm.countrythreeValidity = taxationDetailsNRIVm.validTillthree.getFullYear() + "-" + ('0' + (taxationDetailsNRIVm.validTillthree.getMonth() + 1)).slice(-2) + "-" + ('0' + taxationDetailsNRIVm.validTillthree.getDate()).slice(-2);
                                } else {
                                    taxationDetailsNRIVm.countrythreeValidity = taxationDetailsNRIVm.validTillthree
                                }

                                var payload = {
                                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                                    "requestNo": NRIAOService.requestNo,
                                    "review": NRIAOService.review,
                                    "payload": {
                                        "taxAddrProof": taxationDetailsNRIVm.selectedResidencytype.key,
                                        "sameAddress": taxationDetailsNRIVm.nomineeAddr,
                                        "taxAddress": {
                                            "addressLine1": taxationDetailsNRIVm.address,
                                            "city": taxationDetailsNRIVm.city,
                                            "state": taxationDetailsNRIVm.state,
                                            "pincode": taxationDetailsNRIVm.pin,
                                            "country": taxationDetailsNRIVm.taxCountry.code
                                        },
                                        "taxCountries": [
                                            {
                                                "taxIdNum": taxationDetailsNRIVm.taxIdentification,
                                                "taxResidenceCountry": taxationDetailsNRIVm.selectedOthersubtype.code,
                                                "tinIssueCountry": taxationDetailsNRIVm.selectedOthersubtype.code
                                            },

                                            {
                                                "taxIdNum": taxationDetailsNRIVm.taxIdentificationtwo,
                                                "taxResidenceCountry": taxationDetailsNRIVm.selectedcountrytwo.code,
                                                "tinIssueCountry": taxationDetailsNRIVm.selectedcountrytwo.code
                                            },

                                            {
                                                "taxIdNum": taxationDetailsNRIVm.taxIdentificationthree,
                                                "taxResidenceCountry": taxationDetailsNRIVm.selectedcountrythree.code,
                                                "tinIssueCountry": taxationDetailsNRIVm.selectedcountrythree.code
                                            }
                                        ]
                                    }
                                }

                                NRIAOService.saveTaxDetails(payload).then(function (response) {
                                    if (response.responseCode == '0000') {
                                        NRIAOService.requestNo = response.data;
                                        taxationDetailsNRIVm.getUpdatedData();
                                    }
                                }, function (error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });

                            } else {

                                taxationDetailsNRIVm.errorTaxAddress = true;
                                taxationDetailsNRIVm.showTaxAddress = false;

                            }
                        }
                    }
                } else if (taxationDetailsNRIVm.addedCountry2) {
                    if (taxationDetailsNRIVm.taxDetailsForm.countryOfTax.$invalid || taxationDetailsNRIVm.taxDetailsForm.taxidentification.$invalid ||
                        taxationDetailsNRIVm.taxDetailscountrytwoForm.residencyCountry.$invalid || taxationDetailsNRIVm.taxDetailscountrytwoForm.taxidentificationtwo.$invalid) {
                        taxationDetailsNRIVm.errorCountry = true;
                        taxationDetailsNRIVm.firstCountry = false;
                        taxationDetailsNRIVm.addedCountry2 = true;
                    } else {
                        if (taxationDetailsNRIVm.taxAddressDetailsForm.taxAddressProof.$invalid && taxationDetailsNRIVm.taxAddressDetailsForm.flatHouseNo.$invalid
                            && taxationDetailsNRIVm.taxAddressDetailsForm.cityTown.$invalid && taxationDetailsNRIVm.taxAddressDetailsForm.taxCountry.$invalid && taxationDetailsNRIVm.taxAddressDetailsForm.state.$invalid) {
                            taxationDetailsNRIVm.errorTaxAddress = true;
                            taxationDetailsNRIVm.showTaxAddress = false;
                        } else {
                            taxationDetailsNRIVm.firstCountry = true;
                            taxationDetailsNRIVm.errorCountry = false;
                            taxationDetailsNRIVm.selectedOthersubtypeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedOthersubtype);
                            taxationDetailsNRIVm.taxIdentificationNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentification);
                            taxationDetailsNRIVm.selectedcountrytwoNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedcountrytwo);
                            taxationDetailsNRIVm.taxIdentificationtwoNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentificationtwo);
                            taxationDetailsNRIVm.selectedResidencytypeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedResidencytype);
                            taxationDetailsNRIVm.addressNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.address);
                            taxationDetailsNRIVm.cityNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.city);
                            taxationDetailsNRIVm.taxCountryNameNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxCountry);
                            taxationDetailsNRIVm.stateNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.state);


                            if (taxationDetailsNRIVm.selectedOthersubtypeNotNull && taxationDetailsNRIVm.taxIdentificationNotNull && taxationDetailsNRIVm.selectedcountrytwoNotNull
                                && taxationDetailsNRIVm.taxIdentificationtwoNotNull && taxationDetailsNRIVm.selectedResidencytypeNotNull && taxationDetailsNRIVm.addressNotNull
                                && taxationDetailsNRIVm.cityNotNull && taxationDetailsNRIVm.taxCountryNameNotNull && taxationDetailsNRIVm.stateNotNull) {
                                taxationDetailsNRIVm.errorTaxAddress = false;
                                taxationDetailsNRIVm.showTaxAddress = true;
                                taxationDetailsNRIVm.errorCountry = false;
                                taxationDetailsNRIVm.firstCountry = true;
                                if (typeof (taxationDetailsNRIVm.selectedvalidTill) === "object") {
                                    taxationDetailsNRIVm.countryOneValidity = taxationDetailsNRIVm.selectedvalidTill.getFullYear() + "-" + ('0' + (taxationDetailsNRIVm.selectedvalidTill.getMonth() + 1)).slice(-2) + "-" + ('0' + taxationDetailsNRIVm.selectedvalidTill.getDate()).slice(-2);
                                } else {
                                    taxationDetailsNRIVm.countryOneValidity = taxationDetailsNRIVm.selectedvalidTill
                                }
                                if (typeof (taxationDetailsNRIVm.validTilltwo) === "object") {
                                    taxationDetailsNRIVm.countrytwoValidity = taxationDetailsNRIVm.validTilltwo.getFullYear() + "-" + ('0' + (taxationDetailsNRIVm.validTilltwo.getMonth() + 1)).slice(-2) + "-" + ('0' + taxationDetailsNRIVm.validTilltwo.getDate()).slice(-2);
                                } else {
                                    taxationDetailsNRIVm.countrytwoValidity = taxationDetailsNRIVm.validTilltwo
                                }
                                var payload = {
                                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                                    "requestNo": NRIAOService.requestNo,
                                    "review": NRIAOService.review,
                                    "payload": {
                                        "taxAddrProof": taxationDetailsNRIVm.selectedResidencytype.key,
                                        "sameAddress": taxationDetailsNRIVm.nomineeAddr,
                                        "taxAddress": {
                                            "addressLine1": taxationDetailsNRIVm.address,
                                            "city": taxationDetailsNRIVm.city,
                                            "state": taxationDetailsNRIVm.state,
                                            "pincode": taxationDetailsNRIVm.pin,
                                            "country": taxationDetailsNRIVm.taxCountry.code
                                        },
                                        "taxCountries": [
                                            {
                                                "taxIdNum": taxationDetailsNRIVm.taxIdentification,
                                                "taxResidenceCountry": taxationDetailsNRIVm.selectedOthersubtype.code,
                                                "tinIssueCountry": taxationDetailsNRIVm.selectedOthersubtype.code
                                            },

                                            {
                                                "taxIdNum": taxationDetailsNRIVm.taxIdentificationtwo,
                                                "taxResidenceCountry": taxationDetailsNRIVm.selectedcountrytwo.code,
                                                "tinIssueCountry": taxationDetailsNRIVm.selectedcountrytwo.code
                                            }
                                        ]
                                    }
                                }

                                NRIAOService.saveTaxDetails(payload).then(function (response) {
                                    if (response.responseCode == '0000') {
                                        NRIAOService.requestNo = response.data;
                                        taxationDetailsNRIVm.getUpdatedData();
                                    }
                                }, function (error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });

                            } else {
                                taxationDetailsNRIVm.errorTaxAddress = true;
                                taxationDetailsNRIVm.showTaxAddress = false;
                            }
                        }
                    }
                } else {
                    if (
                        taxationDetailsNRIVm.taxDetailsForm.countryOfTax.$invalid || taxationDetailsNRIVm.taxDetailsForm.taxidentification.$invalid) {
                        taxationDetailsNRIVm.errorCountry = true;
                        taxationDetailsNRIVm.firstCountry = false;
                    } else {
                        if (taxationDetailsNRIVm.taxAddressDetailsForm.taxAddressProof.$invalid && taxationDetailsNRIVm.taxAddressDetailsForm.flatHouseNo.$invalid
                            && taxationDetailsNRIVm.taxAddressDetailsForm.cityTown.$invalid && taxationDetailsNRIVm.taxAddressDetailsForm.taxCountry.$invalid && taxationDetailsNRIVm.taxAddressDetailsForm.state.$invalid) {
                            taxationDetailsNRIVm.errorTaxAddress = true;
                            taxationDetailsNRIVm.showTaxAddress = false;

                        }
                        else {
                            taxationDetailsNRIVm.firstCountry = true;
                            taxationDetailsNRIVm.errorCountry = false;
                            taxationDetailsNRIVm.selectedOthersubtypeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedOthersubtype);
                            taxationDetailsNRIVm.taxIdentificationNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxIdentification);
                            taxationDetailsNRIVm.selectedResidencytypeNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.selectedResidencytype);
                            taxationDetailsNRIVm.addressNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.address);
                            taxationDetailsNRIVm.cityNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.city);
                            taxationDetailsNRIVm.taxCountryNameNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.taxCountry);
                            taxationDetailsNRIVm.stateNotNull = taxationDetailsNRIVm.isNotNullOrUndefined(taxationDetailsNRIVm.state);

                            if (taxationDetailsNRIVm.selectedOthersubtypeNotNull && taxationDetailsNRIVm.taxIdentificationNotNull && taxationDetailsNRIVm.selectedResidencytypeNotNull && taxationDetailsNRIVm.addressNotNull
                                && taxationDetailsNRIVm.cityNotNull && taxationDetailsNRIVm.taxCountryNameNotNull && taxationDetailsNRIVm.stateNotNull) {
                                taxationDetailsNRIVm.errorTaxAddress = false;
                                taxationDetailsNRIVm.showTaxAddress = true;
                                taxationDetailsNRIVm.errorCountry = false;
                                var payload = {
                                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                                    "requestNo": NRIAOService.requestNo,
                                    "lastSavedState": "TAXATION_DATA",
                                    "review": NRIAOService.review,
                                    "payload": {
                                        "taxAddrProof": taxationDetailsNRIVm.selectedResidencytype.key,
                                        "sameAddress": taxationDetailsNRIVm.nomineeAddr,
                                        "taxAddress": {
                                            "addressLine1": taxationDetailsNRIVm.address,
                                            "city": taxationDetailsNRIVm.city,
                                            "state": taxationDetailsNRIVm.state,
                                            "pincode": taxationDetailsNRIVm.pin,
                                            "country": taxationDetailsNRIVm.taxCountry.code
                                        },
                                        "taxCountries": [
                                            {
                                                "taxIdNum": taxationDetailsNRIVm.taxIdentification,
                                                "taxResidenceCountry": taxationDetailsNRIVm.selectedOthersubtype.code,
                                                "tinIssueCountry": taxationDetailsNRIVm.selectedOthersubtype.code
                                            }
                                        ]
                                    }
                                }


                                NRIAOService.saveTaxDetails(payload).then(function (response) {
                                    if (response.responseCode == '0000') {
                                        NRIAOService.requestNo = response.data;
                                        taxationDetailsNRIVm.getUpdatedData();

                                    }
                                }, function (error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });


                            } else {
                                taxationDetailsNRIVm.errorTaxAddress = true;
                                taxationDetailsNRIVm.showTaxAddress = false;
                            }

                        }
                    }
                }
            }

        }
    ]);