angularApp.service('bhimUpiService',
	function ($q, utilityService, constantConfig, AdapterUtils, mPinLoginService, $http, quickPayService,csatServices) {
		var bhimUpiService = this;
		bhimUpiService.isEnabledSuccess = false;
		bhimUpiService.loginFromCreateNewVPA = false;
		bhimUpiService.isUpiRegistration = false;
		bhimUpiService.isPrehomeLoginScan = false;
		bhimUpiService.scanPayResp = "";
		bhimUpiService.paymentSuccess = false;
		var mobileNumber = "";
		bhimUpiService.payToContactData = {};

		var isJsonString = function (str) {
			try {
				JSON.parse(str);
			} catch (e) {
				return false;
			}
			return true;
		}

		var isStringJson = function (str) {
			try {
				JSON.stringify(str);
			} catch (e) {
				return false;
			}
			return true;
		}

		bhimUpiService.getFTPurposes = function () {
			console.log("Service: getRemarkPurposes");        
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/getRemarkPurposes", {}, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			});
			return q.promise;
		};

		bhimUpiService.getNativeData = function (type, data, journeyName) {
			var q = $q.defer();
			var reqData = data;
			if (data === undefined) {
				data = '';
			}
			if (journeyName === undefined) {
				journeyName = 'UPI';
			}
			var successCallback = function (data) {
				bhimUpiService.data = data;

				if(isJsonString(data) && JSON.parse(data).apiResp){
					data = JSON.parse(data).apiResp;
				}

				var payload = {};
				if (isJsonString(data)) {
					if (data && JSON.parse(data) && ((JSON.parse(data).status && JSON.parse(data).status == 'S') || (!JSON.parse(data).status))) {
						payload = {
							upiJourneyName: journeyName,
							platform : device.platform.toLowerCase(),
							upiApiName: type,
							deviceId: device.uuid,
							apiStatus : "0000",
							auditData: {
								pspRefNo: isJsonString(reqData) && JSON.parse(reqData).requestInfo && JSON.parse(reqData).requestInfo.pspRefNo ? JSON.parse(reqData).requestInfo.pspRefNo : reqData.toString(),
								success: isStringJson(data) ? data : data.toString(),
								responseCode : JSON.parse(data) && (JSON.parse(data).responseCode || JSON.parse(data).errCode) ? (JSON.parse(data).responseCode || JSON.parse(data).errCode) : "",
								responseMessage : (JSON.parse(data).responseMsg || JSON.parse(data).statusDesc) ? (JSON.parse(data).responseMsg || JSON.parse(data).statusDesc) : ""
							}
						}
					} else {
						payload = {
							upiJourneyName: journeyName,
							platform : device.platform.toLowerCase(),
							upiApiName: type,
							deviceId: device.uuid,
							apiStatus : "0000",
							auditData: {
								pspRefNo: isJsonString(reqData) && JSON.parse(reqData).requestInfo && JSON.parse(reqData).requestInfo.pspRefNo ? JSON.parse(reqData).requestInfo.pspRefNo : reqData.toString(),
								failure: isStringJson(data) ? data : data.toString(),
								responseCode : JSON.parse(data) && (JSON.parse(data).responseCode || JSON.parse(data).errCode) ? (JSON.parse(data).responseCode || JSON.parse(data).errCode) : "",
								responseMessage : (JSON.parse(data).responseMsg || JSON.parse(data).statusDesc) ? (JSON.parse(data).responseMsg || JSON.parse(data).statusDesc) : ""
							}
						}
					}
				} else {
					if ((data.status && data.status == 'S') || (!data.status)) {
						payload = {
							upiJourneyName: journeyName,
							platform : device.platform.toLowerCase(),
							upiApiName: type,
							deviceId: device.uuid,
							apiStatus : "0000",
							auditData: {
								pspRefNo: isJsonString(reqData) && JSON.parse(reqData).requestInfo && JSON.parse(reqData).requestInfo.pspRefNo ? JSON.parse(reqData).requestInfo.pspRefNo : reqData.toString(),
								success: isStringJson(data) ? JSON.stringify(data) : data.toString(),
								responseCode : (data.responseCode || data.errCode) ? (data.responseCode || data.errCode) : "",
								responseMessage : (data.responseMsg || data.statusDesc) ? (data.responseMsg || data.statusDesc) : ""
							}
						}
					} else {
						payload = {
							upiJourneyName: journeyName,
							platform : device.platform.toLowerCase(),
							upiApiName: type,
							deviceId: device.uuid,
							apiStatus : "0000",
							auditData: {
								pspRefNo: isJsonString(reqData) && JSON.parse(reqData).requestInfo && JSON.parse(reqData).requestInfo.pspRefNo ? JSON.parse(reqData).requestInfo.pspRefNo : reqData.toString(),
								failure: isStringJson(data) ? JSON.stringify(data) : data.toString(),
								responseCode : (data.responseCode || data.errCode) ? (data.responseCode || data.errCode) : "",
								responseMessage : (data.responseMsg || data.statusDesc) ? (data.responseMsg || data.statusDesc) : ""
							}
						}
					}
				}
				
				//if (mPinLoginService.isLoggedIn == true) {
					AdapterUtils.postData("adapters/CommonAdapter/saveAuditLogsUpi", payload, false).then(function (response) {
						if((payload.upiJourneyName == "YQP" || payload.upiJourneyName =="YSP") && (payload.upiApiName == "onPayInitiation" || payload.upiApiName == "onCollectApprove") && (payload.auditData != "")) {
							if(csatServices.goldenJourneyCompletionCounter < 1) {
								csatServices.whetherGoldenJourney("YQP_UPI_PAY");
							}
						}
					}, function (error) {});
				//}
				q.resolve(bhimUpiService.data);
			}
			var failureCallback = function (error) {
				bhimUpiService.error = error;
				var payload = {
					upiJourneyName: journeyName,
					platform : device.platform.toLowerCase(),
					upiApiName: type,
					deviceId: device.uuid,
					apiStatus : "0001",
					auditData: {
						pspRefNo: isJsonString(reqData) && JSON.parse(reqData).requestInfo && JSON.parse(reqData).requestInfo.pspRefNo ? JSON.parse(reqData).requestInfo.pspRefNo : reqData.toString(),
						failure: isStringJson(error) ? JSON.stringify(error) : error.toString()
					}
				}
				//if (mPinLoginService.isLoggedIn == true) {
					AdapterUtils.postData("adapters/CommonAdapter/saveAuditLogsUpi", payload, false).then(function (response) {  }, function (error) { });
				//}
				q.reject(bhimUpiService.error);
			}


			if (device.platform.toLowerCase() == 'android') {
				cordova.exec(successCallback, failureCallback, "Upisdk", type, [data]);
			} else {
				cordova.exec(successCallback, failureCallback, "HyperTrackWrapper", type, [data]);
			}
			return q.promise;
		};

		bhimUpiService.getQRCode = function (scan_qr) {
			var q = $q.defer();
			var obj = {
				"scanQRCode": scan_qr
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getQRCode", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		bhimUpiService.getQRCodeInsecure = function (scan_qr) {
			var q = $q.defer();
			var obj = {
				"scanQRCode": scan_qr
			};
			AdapterUtils.postData("adapters/FundsTransferAdapter/getQRCode", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		bhimUpiService.getBankDetails = function () {
			var q = $q.defer();
			$http.get('pages/fundTransfer/bhimUpi/bankNames.json').then(function (response) {
				q.resolve(response.data);
			}, function (error) {
				q.reject(error);
			});
			return q.promise;
		};

		bhimUpiService.enableDisableAcc = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/BhimUpi/enableDisableUpi", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		 bhimUpiService.enableDisableAccountList = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FixedDepositAdapter/CMI/getAccountList", {"isValidateAccountList":true}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		bhimUpiService.getAccountStatus = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FundsTransferAdapter/BhimUpi/upiStatusEnquiry", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				});
			return q.promise;
		};

		bhimUpiService.selectMobileNumber = function (contactObj) {
			var q = $q.defer();
			var contactNum = "";
			if (contactObj) {
				if (utilityService.isAndroidPlatform()) {
					if (contactObj.number) {
						contactNum = contactObj.number.replace(/\s/g, '');
					}
				}
				if (utilityService.isIOSPlatform()) {
					contactNum = contactObj.replace(/\s/g, '');
				}
				if (contactNum && contactNum.length >= 10) {
					mobileNumber = contactNum.substr(contactNum.length - 10);
					q.resolve(mobileNumber);
				} else {
					q.reject({ "errorMsg": "Please select valid mobile number" });
				}
			} else {
				q.reject({ "errorMsg": "Please select valid mobile number" });
			}
			return q.promise;
		}

		bhimUpiService.verifyMobileNumber = function (mobileNumber) {
			var q = $q.defer();
			var params = { "mobileNumber": mobileNumber };
			quickPayService.getContactDetails(params).then(function (data) {
				q.resolve(data);
			}, function (error) {
				q.reject({ "errorMsg": error.responseMessage });
			});
			return q.promise;
		}

		bhimUpiService.checkVirtualAddress = function (upiId) {
			var q = $q.defer();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": "constantConfig.upiConstant.addInfo9"
				},
				"payeeType": {
					"virtualAddress": upiId.toString()
				},
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"vAReqType": constantConfig.upiConstant.vAReqType_T
			});

			bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json).then(function (data) {
				q.resolve(data);
			}, function (error) {
				q.reject({ "errorMsg": error });
			});
			return q.promise;
		}

		bhimUpiService.getProfile = function () {
			var q = $q.defer();
			var json = JSON.stringify({
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
				q.resolve(data);
			}, function (msg) {
				q.reject({ "errorMsg": msg });
			});
			return q.promise;
		}

		return bhimUpiService;
	});
