 
angularApp.service('fTSetOTPService',
	function($q, AdapterUtils){
		
		var fTSetOTPService =this;	
		
		//Generate OTP
		fTSetOTPService.generateOTP = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure",requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
		//Validate OTP
		fTSetOTPService.validateOTP = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure",requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};

		//New Validate OTP
		fTSetOTPService.validateOTPForNewDebitCard = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/ServiceRequestAdapter/validateOTPForNewDebitCardRequest",requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
		return fTSetOTPService;
	});   