'use strict';

angularApp.controller('instaCongratulationsController', [
    "$state", "$scope", "$translate", "instaHomeService", "$ionicPopover", "utilityService", "$ionicPopup", "$ionicScrollDelegate", "constantConfig","homeScreenService",
    function($state, $scope, $translate, instaHomeService, $ionicPopover, utilityService, $ionicPopup, $ionicScrollDelegate, constantConfig,homeScreenService) {

        var instaCongratulationsVm = this;
        function initPage() {
            instaCongratulationsVm.refNo = instaHomeService.refNo;           
        }

        instaCongratulationsVm.goToHome = function () {
            $state.go('menu.homeScreen');
        }

        instaCongratulationsVm.goToRelationships = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        instaCongratulationsVm.openPasswordInfo = function ($event) {
            instaCongratulationsVm.leftStyle = "left : " + ($event.clientX - 10) + "px";
            instaCongratulationsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info pswd-info-popnew-rlms passwordInfoPopup-rlms" id="runtimeHeight">'+ 
                '<div class="goldloan-arrow-upnew-rlms" style="{{instaCongratulationsVm.leftStyle}}"></div>'+'<div class="padBottom3"><span class="inb-lock-roboto-bold font-size-14">Password eg. - 05Mar!8899</span></div>'+
                '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="instaCongratulationsVm.closePopover()"><img src="img/Close.png" class="glPwdClose"></a>'+
                '<div class="popupDivider"></div>'+'<ion-content class="nfs-popover" has-bouncing="false">'+'<div class="row roboto-light font-size-12 padTop15">'+
                '<div class="col col-40"><div class="row"><div><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">05Mar</span><span>&nbsp;ch</span></div><span class="padLeft50">+</span></div><div class="row fss-text-center">Birth date and first 3 letters of birth month with first letter capital</div></div>'+
                '<div class="col col-20"><div class="row"><span class="inb-lock-roboto-bold font-size-12 text-underline-gl padLeft25">!</span><span class="padLeft50">+</span></div><div class="row fss-text-center">Mandatory "!" sign</div></div>'+
                '<div class="col col-40"><div class="row"><span class="padLeft30">9XXXXX</span><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">&nbsp;8899</span></div><div class="row fss-text-center padLeft25">Last 4 digits of the registered mobile number</div></div></div></ion-content></ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(instaCongratulationsVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);               
        }     

         function savebase64AsPDF(filename, content, contentType) {
            instaCongratulationsVm.popupFolderpath = "";
            var DataBlob = b64toBlob(content, contentType);
            if (utilityService.isAndroidPlatform()) {
                if(device.version == 10) {
                    const folderpath = cordova.file.externalDataDirectory;
                    instaCongratulationsVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function(dir) {
                        dir.getFile(filename, { create: true }, function(file) {
                            file.createWriter(function(fileWriter) {
                                fileWriter.write(DataBlob);
                                 //Show popup 
                                instaCongratulationsVm.showDownloadPopUp();
                            }, function(e) {
                                console.log(e);
                            });
                        });
                    });
                } else {
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
                        fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                            instaCongratulationsVm.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true }, function(file) {
                                file.createWriter(function(fileWriter) {
                                    fileWriter.write(DataBlob);
                                    //Show popup
                                    instaCongratulationsVm.showDownloadPopUp();
                                }, function(e) {
									console.log(e);
								});
                            });
                        });
                    });
                }               
            }
            if (utilityService.isIOSPlatform()){
                const folderpath = cordova.file.documentsDirectory;
                const finalPath = folderpath + filename;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
							fileWriter.onwrite = function(evt) {
								cordova.plugins.fileOpener2.open(
									finalPath,
									'application/pdf', {
										error: function (e) {
											console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
										},
										success: function () {
											console.log('file opened successfully');
										}
									}
								);
							};							
                            fileWriter.write(DataBlob);
                        },  function(e) {
							console.log(e);
						});
                    });
                });
            }          
        }

        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
             //Check PDF SIZE
            if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            return new Blob(byteArrays, { type: contentType });            
        }

        instaCongratulationsVm.showDownloadPopUp = function() {
            //Show popup 
			var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="RTXC_DOWNLOAD_RECEIPT" translate-values="{filePath:instaCongratulationsVm.popupFolderpath}"></div>';
			instaCongratulationsVm.downloadPopup = $ionicPopup.alert({
				title: '',
				template: template
			});
        }

        instaCongratulationsVm.downloadLetter = function(isEmail){
                var payload = {};
                if(!isEmail){
                    payload = {
                      "isEmail": "N"
                    };
                }else{
                    payload = {
                      "isEmail": "Y"
                    };
                }

                instaHomeService.getDocument(payload).then(function(data) {
                    if(!isEmail) {
                        var content = data.docList[0].base64;
                        var contentType = "application/pdf";
                        var filename = '';          
                        if (utilityService.isAndroidPlatform()) {
                            var pdfTimestamp = new Date().getTime();
                            filename = "terms_and_conditions_IHL_"+pdfTimestamp;
                        }else{
                            filename = "terms_and_conditions_IHL";
                        }
                        savebase64AsPDF(filename + ".pdf", content, contentType);
                    }else{
                        $ionicPopup.alert({
                            template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Email has been sent successfully</p>"
                        });
                    }
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        
        instaCongratulationsVm.closePopover = function(){
            $scope.popover.hide();
            $ionicScrollDelegate.resize();
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);