'use strict';

angularApp.controller('ntbAALandingPageController', [
    "$state",
    "$scope",
    "$ionicHistory",
    "clNTBCalculatorService",
    "hlNTBCalculatorService",
    function (
        $state,
        $scope,
        $ionicHistory,
        clNTBCalculatorService,
        hlNTBCalculatorService) {

        var ntbAALandingVm = this;

        ntbAALandingVm.initPage = function(){
            if(clNTBCalculatorService.productIDNTBCL){
                ntbAALandingVm.productIDNTBAA = clNTBCalculatorService.productIDNTBCL;
            }else if(hlNTBCalculatorService.productIDNTBHL){
                ntbAALandingVm.productIDNTBAA = hlNTBCalculatorService.productIDNTBHL;
            }
        }

        ntbAALandingVm.goToAAListPage = function (consent) {
            if(consent == 'Y'){
                clNTBCalculatorService.isIdAvailiable = true;
            }else{
                clNTBCalculatorService.isIdAvailiable = false;
            }
            $state.go('menu.ntbAccountAggregatorList');
        }

        ntbAALandingVm.goBack = function () {
            $ionicHistory.goBack();
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            ntbAALandingVm.initPage();
        });

        return this;
    }
])