'use strict';

angularApp.controller('newPreApprovedKnowMoreController', ["$state", "$scope", "$translate","newLoansLandingService","$ionicHistory","ompMerchantsService",
    function($state, $scope,$translate,newLoansLandingService,$ionicHistory,ompMerchantsService) {

        var newPreApprovedKnowMoreVm = this;
        newPreApprovedKnowMoreVm.initPage = function() {
            newPreApprovedKnowMoreVm.preApprovedCategory = newLoansLandingService.preApprovedCategory;
            newPreApprovedKnowMoreVm.contentData = newLoansLandingService.getPreApprovedContentData().data;
            newPreApprovedKnowMoreVm.rbiGuidelinesUrl = newLoansLandingService.getPreApprovedContentData().url; 
        }

        newPreApprovedKnowMoreVm.goToHome = function () {
            $state.go('menu.homeScreen');
        }

        newPreApprovedKnowMoreVm.applyNow = function() {
            if (newPreApprovedKnowMoreVm.preApprovedCategory == "PAPL") {
                $state.go('menu.plPanDob');
             }else if (newPreApprovedKnowMoreVm.preApprovedCategory== "PA2WL") {
                $state.go('menu.patwlLandingPage');
             }
        }  

        newPreApprovedKnowMoreVm.goBacktoPrevious = function() {
            $ionicHistory.goBack(-1);
        }

        newPreApprovedKnowMoreVm.openInChromeBrowser = function(url){
            ompMerchantsService.inChromeBrowser(url);
        }
       
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            newPreApprovedKnowMoreVm.initPage();
        });
	
        return this;
    }
]);