'use strict';

angularApp.controller('ppfReviewDtlController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup", "ppfEReceiptService","AdapterUtils","$q","ionicDatePicker","pdfDownloadService","constantConfig",
    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,ppfEReceiptService,AdapterUtils,$q,ionicDatePicker,pdfDownloadService,constantConfig) {

        var ppfReviewDtlVm = this;
        //functions, variables that can be accessed from the HTML template

        ppfReviewDtlVm.downloadppfDetails = function (){

            var q = $q.defer();
            var request = { "accountNumber": ppfReviewDtlVm.ppfDetailone.accountNumber,"referenceNumber":ppfReviewDtlVm.ppfDetail.referenceNumber }
                    ppfEReceiptService.getPPFTransactionReceipt(request).then(function(res){
                    ppfReviewDtlVm.response=res;
                    ppfReviewDtlVm.ppfreceiptDownload(res);
                },function (error) {
                utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
            });
        }


    // Download receipt code begin
        ppfReviewDtlVm.ppfreceiptDownload = function(res) {

            var content = res.pdf;
            var filename = res.fileName + '.pdf';
            pdfDownloadService.savePDF(filename, content, "").then(function(response){
                 ppfReviewDtlVm.folderpath = response.folderpath ? response.folderpath : "";
                if (utilityService.isAndroidPlatform()) {
                     var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:ppfReviewDtlVm.folderpath}"></div>';
                    ppfReviewDtlVm.downloadPopup = $ionicPopup.show({
                    title: '',
                    template: template,
                    scope: $scope,
                    cssClass: 'my-custom-popup',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive',
                        onTap: function() {
                            ppfReviewDtlVm.downloadPopup.close();
                            utilityService.setCsatJournies('ppfEReceipt');
                            $state.go('menu.serviceRequest');
                        }
                    }],
                });
                }
                else
                {
                     cordova.plugins.fileOpener2.open(
                                cordova.file.documentsDirectory + filename,
                                'application/pdf', {
                                    
                                error: function (e) {
                                    console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                                },
                                success: function () {
                                    console.log('file opened successfully');
                                    utilityService.setCsatJournies('ppfEReceipt');
                                    $state.go('menu.serviceRequest');
                                }                              
                                
                    });
                }
               
               
                 },function error(e){
                        utilityService.showErrorMessage(e);
                });
               
    };
    // Download receipt code ends

            $scope.$on('$ionicView.beforeEnter', function() {
            var ref = ppfEReceiptService.refno1;
            var ppfObj = ppfEReceiptService.getppfstmtList();

            ppfReviewDtlVm.ppfDetail =  ppfEReceiptService.obj;
            ppfReviewDtlVm.ppfDetailone  = ppfEReceiptService.getppfstmtList();
            });

            ppfReviewDtlVm.goToHome=function (){
                $state.go('menu.homeScreen');
            }

            ppfReviewDtlVm.goToback = function(){
                 $state.go('menu.ppfViewDetails');
             }
        return this;
    }

]);
