'use strict';

angularApp.controller('accountDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices) {

        var accountDetailsNPSControllerVM = this;
        $scope.currentPage = "1";
        $scope.lastPage = "16";
        accountDetailsNPSControllerVM.validAccountFlag = false;

        //initialize varibales
        accountDetailsNPSControllerVM.thEmailDis = false;
        accountDetailsNPSControllerVM.npsPranCard1 = false;
        accountDetailsNPSControllerVM.npsPhyPranCard = false;
        accountDetailsNPSControllerVM.npsPhyChecked = false;
        accountDetailsNPSControllerVM.npsthrough = false;
        accountDetailsNPSControllerVM.npsthroughChecked = false;
        accountDetailsNPSControllerVM.npsPhyKit = false;
        accountDetailsNPSControllerVM.npsPhyChecked = false;
        accountDetailsNPSControllerVM.disabledBtn = false;
        
        //default pran
        


       

        accountDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        accountDetailsNPSControllerVM.goBack = function () {
            $state.go('menu.termsConditionsNPSView');
        }

        accountDetailsNPSControllerVM.getAccountList = function () {

            accountDetailsNPSControllerVM.accDetails = npsServices.accDetails;
            accountDetailsNPSControllerVM.balance = accountDetailsNPSControllerVM.accDetails[0].accountBalance;
            accountDetailsNPSControllerVM.accType = accountDetailsNPSControllerVM.accDetails[0].accountType;
            accountDetailsNPSControllerVM.accountNumber = accountDetailsNPSControllerVM.accDetails[0].accountNumber;
        }


        accountDetailsNPSControllerVM.showPop = function () {
            accountDetailsNPSControllerVM.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/nps/accountDetails/accountListModal.html',
                scope: $scope
            });
        }
        accountDetailsNPSControllerVM.closePopup = function (index) {
            accountDetailsNPSControllerVM.popUp.close();
            accountDetailsNPSControllerVM.npsAccountDetails.accountSelectedIndex = index;
            accountDetailsNPSControllerVM.balance = accountDetailsNPSControllerVM.accDetails[index].accountBalance;
            accountDetailsNPSControllerVM.accType = accountDetailsNPSControllerVM.accDetails[index].accountType;
            accountDetailsNPSControllerVM.accountNumber = accountDetailsNPSControllerVM.accDetails[index].accountNumber;
            accountDetailsNPSControllerVM.showSelect = false;
            accountDetailsNPSControllerVM.validateAccountNumber();
        }

        accountDetailsNPSControllerVM.validateAccountNumber = function () {

            var requestParams = {
                "cif": "",
                "makerId": "",
                "accNo": accountDetailsNPSControllerVM.accountNumber,
                "branchCode": ""
              }

            npsServices.validateAccountNumber(requestParams).then(function (data) {
                accountDetailsNPSControllerVM.validAccountFlag = true;
                console.log("Validate account success");

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                accountDetailsNPSControllerVM.validAccountFlag = false;
            });

        }



        accountDetailsNPSControllerVM.goNext = function () {
            npsServices.npsAccountDetails.accountSelectedIndex = accountDetailsNPSControllerVM.npsAccountDetails.accountSelectedIndex;
            npsServices.npsAccountDetails.npsAccountType = accountDetailsNPSControllerVM.npsAccountDetails.npsAccountType;
            npsServices.npsAccountDetails.ckycNumber = accountDetailsNPSControllerVM.npsAccountDetails.ckycNumber;
            npsServices.npsAccountDetails.preExistingNpsAccount = accountDetailsNPSControllerVM.npsAccountDetails.preExistingNpsAccount;
            npsServices.npsAccountDetails.bankAccountNumber = accountDetailsNPSControllerVM.accountNumber;
            npsServices.npsAccountDetails.bankAccountType = accountDetailsNPSControllerVM.accType;
            npsServices.npsAccountDetails.prancardandwelcomekit = accountDetailsNPSControllerVM.setPranValue;

            var requestParams = {
                "cifNumber": "",
                "accountNo": accountDetailsNPSControllerVM.accountNumber,
                "npsAccountType": accountDetailsNPSControllerVM.npsAccountDetails.npsAccountType,
                "npsAccountTypeCode": "",
                "recordingAgencyCode": "",
                "recordingAgency": accountDetailsNPSControllerVM.npsAccountDetails.crAgency,
                "ckycNO": accountDetailsNPSControllerVM.npsAccountDetails.ckycNumber,
                "prancardandwelcomekit":accountDetailsNPSControllerVM.setPranValue,
                "deviceInfo": {
                    "deviceIMEI": npsServices.deviceInfo.deviceIMEI,
                    "deviceOS": npsServices.deviceInfo.deviceOS
                },
                "userConsent": {
                    "termsAndConditionsFlag": npsServices.npsTermsAndCondition.tncFlag ? "Y" : "N",
                    "noNPSConsent": accountDetailsNPSControllerVM.npsAccountDetails.preExistingNpsAccount ? "Y" : "N"
                }
            };
           

                npsServices.registerCustomerForNPS(requestParams).then(function (response) {
                    npsServices.npsTprnSuccessData.tprn = response.data.tprn;
                    npsServices.npsTprnSuccessData.createdDate = response.data.createdDate;
                    if (!accountDetailsNPSControllerVM.npsTprnSuccessData.tprn) {
                        $state.go('menu.trpnSuccess');
                    } else {
                        if (!npsServices.applicantData.panNumber) {
                            npsServices.getCIFDetails().then(function (data) {
                                npsServices.applicantData = data;
                                $state.go('menu.npsPersonalDetails');
                             }, function (error) {
                                utilityService.enableShowErrorMessage();
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        } else {
                            $state.go('menu.npsPersonalDetails');
                        }
                    }


                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });

           

        }

        accountDetailsNPSControllerVM.npsCheckedV = function(){
            if(accountDetailsNPSControllerVM.npsPranCard == 'npsPranECard'){
                
                 

                if(accountDetailsNPSControllerVM.npsPranKit == 'npsthrough'){
                    accountDetailsNPSControllerVM.npsthrough = true;
                    accountDetailsNPSControllerVM.npsthroughChecked = true;
                    accountDetailsNPSControllerVM.npsPhyChecked = false;
                    accountDetailsNPSControllerVM.npsPhyKit = false;
                }else{
                    accountDetailsNPSControllerVM.npsPranCard1 = true;
                    accountDetailsNPSControllerVM.npsPhyPranCard = false;
                    accountDetailsNPSControllerVM.thEmailDis = false;
                    accountDetailsNPSControllerVM.npsPhyKit = true;
                    accountDetailsNPSControllerVM.npsthroughChecked = false;
                    accountDetailsNPSControllerVM.npsthrough = false;
                }
                    
               
            }else{
                accountDetailsNPSControllerVM.npsPranCard1 = false;
                accountDetailsNPSControllerVM.npsPhyPranCard = true;

                accountDetailsNPSControllerVM.npsPranKit = 'npsPhyKit';
                accountDetailsNPSControllerVM.npsPhyChecked = true;
                accountDetailsNPSControllerVM.npsPhyKit = true;

                accountDetailsNPSControllerVM.thEmailDis = true;
                accountDetailsNPSControllerVM.npsthroughChecked = false;
                 accountDetailsNPSControllerVM.npsthrough = false;

                
            }

           

            accountDetailsNPSControllerVM.setPran();
        }


        //check setPranValue is available and set values
        
        accountDetailsNPSControllerVM.isSetPranAvailable = function(){
            accountDetailsNPSControllerVM.setPranValue = npsServices.npsAccountDetails.prancardandwelcomekit;
                if(accountDetailsNPSControllerVM.setPranValue == '1'){
                    accountDetailsNPSControllerVM.npsPranCard = 'npsPhyPranCard';
                    accountDetailsNPSControllerVM.npsPhyPranCard = true;
                    accountDetailsNPSControllerVM.npsPhyChecked = true;
                    accountDetailsNPSControllerVM.thEmailDis = true;
                }
                
               
                if(accountDetailsNPSControllerVM.setPranValue == '2'){
                    accountDetailsNPSControllerVM.npsPranCard = 'npsPranECard';
                    accountDetailsNPSControllerVM.npsPhyChecked = true;
                    accountDetailsNPSControllerVM.npsPranCard1 = true;
                    accountDetailsNPSControllerVM.npsPhyKit = true;
                }
                
              
                if(accountDetailsNPSControllerVM.setPranValue == '3'){
                    accountDetailsNPSControllerVM.npsPranCard = 'npsPranECard';
                    accountDetailsNPSControllerVM.npsPranCard1 = true;
                    accountDetailsNPSControllerVM.npsthroughChecked = true;
                    accountDetailsNPSControllerVM.npsthrough = true;
                }
                
              
        }

        accountDetailsNPSControllerVM.setPran = function(){
           //for setPran value
             if(accountDetailsNPSControllerVM.npsPranCard1 && accountDetailsNPSControllerVM.npsPhyKit){
                accountDetailsNPSControllerVM.setPranValue = "2";
            }else if(accountDetailsNPSControllerVM.npsPranCard1 && accountDetailsNPSControllerVM.npsthrough){
                accountDetailsNPSControllerVM.setPranValue = "3";
            }else if(accountDetailsNPSControllerVM.npsPhyPranCard){
                accountDetailsNPSControllerVM.setPranValue = "1";
            }else{
                accountDetailsNPSControllerVM.setPranValue = "";
            }
        }

        


        $scope.$on('$ionicView.beforeEnter', function () {
          
            accountDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            accountDetailsNPSControllerVM.getAccountList();
            accountDetailsNPSControllerVM.npsTprnSuccessData = angular.copy(npsServices.npsTprnSuccessData);
            if (npsServices.npsAccountDetails) {
                accountDetailsNPSControllerVM.npsAccountDetails = angular.copy(npsServices.npsAccountDetails);

                
                if (accountDetailsNPSControllerVM.accDetails && accountDetailsNPSControllerVM.npsAccountDetails.bankAccountNumber) {
                    for (var i = 0; i < accountDetailsNPSControllerVM.accDetails.length; i++) {
                        if (accountDetailsNPSControllerVM.accDetails[i].accountNumber.trim() == accountDetailsNPSControllerVM.npsAccountDetails.bankAccountNumber.trim()) {
                            accountDetailsNPSControllerVM.balance = accountDetailsNPSControllerVM.accDetails[i].accountBalance;
                            accountDetailsNPSControllerVM.accType = accountDetailsNPSControllerVM.accDetails[i].accountType;
                            accountDetailsNPSControllerVM.accountNumber = accountDetailsNPSControllerVM.accDetails[i].accountNumber;
                            accountDetailsNPSControllerVM.showSelect = false;
                        }
                    }

                }
            }

            
             accountDetailsNPSControllerVM.validateAccountNumber();

             if(npsServices.npsAccountDetails.prancardandwelcomekit){
                 accountDetailsNPSControllerVM.setPranValue = npsServices.npsAccountDetails.prancardandwelcomekit;
                accountDetailsNPSControllerVM.isSetPranAvailable();
             }else{
                 accountDetailsNPSControllerVM.setPranValue = "2";
                 accountDetailsNPSControllerVM.npsPranCard = 'npsPranECard';
                accountDetailsNPSControllerVM.npsPranKit = 'npsPhyKit';
                if(accountDetailsNPSControllerVM.npsPranCard == 'npsPranECard'){
                accountDetailsNPSControllerVM.npsPranCard1 = true;
                
                if(accountDetailsNPSControllerVM.npsPranKit == 'npsPhyKit'){
                            accountDetailsNPSControllerVM.npsPhyChecked = true;
                            accountDetailsNPSControllerVM.npsPhyKit = true;
                        }else{
                            accountDetailsNPSControllerVM.npsPhyChecked = false;
                            accountDetailsNPSControllerVM.npsPhyKit = false;
                        }
                
                }else{
                    accountDetailsNPSControllerVM.npsPranCard1 = false;
                }
                accountDetailsNPSControllerVM.setPran();
             }
            
            
        });



        return this;
    }
]);
