'use strict';

angularApp.controller('nominationDetailsTierIINPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "ionicDatePicker",
    "$q",
    "$ionicPopover",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        ionicDatePicker,
        $q,
        $ionicPopover) {

        var nominationDetailsTierIINPSControllerVM = this;
        nominationDetailsTierIINPSControllerVM.totalPercentageShare = 0;
        $scope.currentPage = "11";
        $scope.lastPage = "16";
        nominationDetailsTierIINPSControllerVM.nomineeLabel = "Nominee";
        nominationDetailsTierIINPSControllerVM.nominees = [{
            count: 1,
            enableDelete: false,
            npsNomineeType: "",
            nomineeFirstName: "",
            nomineeMiddleName: "",
            nomineeSurname: "",
            nomineeRelationship: "",
            nomineeDob: "",
            percentageShare: "",
            guardianFirstName: "",
            
            guardianSurname: ""

        }];


        //contact data edit from review page 
            nominationDetailsTierIINPSControllerVM.reviewBtn = false;
            nominationDetailsTierIINPSControllerVM.originalFBtn = true;
            var reviewEditData = npsServices.getReviewEditData();
            nominationDetailsTierIINPSControllerVM.showArrow = false;

            nominationDetailsTierIINPSControllerVM.comingFromReview = function () {
                if(reviewEditData == 'npsNominationDetailsTierII'){
                    nominationDetailsTierIINPSControllerVM.reviewBtn = true;
                    nominationDetailsTierIINPSControllerVM.originalFBtn = false;
                }
            }

            nominationDetailsTierIINPSControllerVM.goCancel = function(){
                nominationDetailsTierIINPSControllerVM.originalFBtn = true;
                nominationDetailsTierIINPSControllerVM.reviewBtn = false;
                npsServices.npsNominationDetailsTierII.nominees = angular.copy(nominationDetailsTierIINPSControllerVM.nomineesTemp);
                $state.go("menu.reviewDetailsNps");
            }

           
        //end code here


        nominationDetailsTierIINPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        nominationDetailsTierIINPSControllerVM.goBack = function () {
            $state.go('menu.npsNominationDetails');
        }

        nominationDetailsTierIINPSControllerVM.getRelationshipDpwn = function () {
            npsServices.getRelationshipDrpwn().then(function (response) {
                
                nominationDetailsTierIINPSControllerVM.relationshipOptions = response;
                

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        

        nominationDetailsTierIINPSControllerVM.goNext = function () {

            npsServices.npsNominationDetailsTierII.numberOfNominee = nominationDetailsTierIINPSControllerVM.nominees.length;
            npsServices.npsNominationDetailsTierII.nominees = nominationDetailsTierIINPSControllerVM.nominees;
            var requestParams;

            if (nominationDetailsTierIINPSControllerVM.nominees.length > 1) {
                nominationDetailsTierIINPSControllerVM.nomineesRequest = [];

            for (var i = 0; i < nominationDetailsTierIINPSControllerVM.nominees.length; i++) {
                var insert = {
                    "type": "Tier2_Nominee" + (i + 1),
                    "firstName": npsServices.npsNominationDetailsTierII.nominees[i].nomineeFirstName,
                    "middleName": npsServices.npsNominationDetailsTierII.nominees[i].nomineeMiddleName,
                    "lastName": npsServices.npsNominationDetailsTierII.nominees[i].nomineeSurname,
                    "relationship": npsServices.npsNominationDetailsTierII.nominees[i].relationshipcode,
                    "isMajor": npsServices.npsNominationDetailsTierII.nominees[i].npsNomineeType,
                    "percentageShare": npsServices.npsNominationDetailsTierII.nominees[i].percentageShare,
                    "dob": npsServices.npsNominationDetailsTierII.nominees[i].nomineeDob,
                    "guardian": {
                        "firstName": npsServices.npsNominationDetailsTierII.nominees[i].guardianFirstName,
                        "middleName": npsServices.npsNominationDetailsTierII.nominees[i].guardianMiddleName,
                        "lastName": npsServices.npsNominationDetailsTierII.nominees[i].guardianSurname
                    },
                    "nomineeage":nominationDetailsTierIINPSControllerVM.nominees[0].nomineeage,
                    "relationshipcode":nominationDetailsTierIINPSControllerVM.nominees[0].nomineeRelationship
                }

                nominationDetailsTierIINPSControllerVM.nomineesRequest.push(insert);

            }

            requestParams = {
                "npsAccountType": "Tier2",
                "isNomineeSame": "",
                "nominees": nominationDetailsTierIINPSControllerVM.nomineesRequest
            };
            } else {


             requestParams = {
                    "npsAccountType": "Tier2",
                    "isNomineeSame": nominationDetailsTierIINPSControllerVM.sameNomineeForTierII,
                    "nominees": [{
                        "type": "Tier2_Nominee1",
                        "firstName": nominationDetailsTierIINPSControllerVM.nominees[0].nomineeFirstName,
                        "middleName": nominationDetailsTierIINPSControllerVM.nominees[0].nomineeMiddleName,
                        "lastName": nominationDetailsTierIINPSControllerVM.nominees[0].nomineeSurname,
                        "relationship": nominationDetailsTierIINPSControllerVM.nominees[0].relationshipcode,
                        "isMajor": nominationDetailsTierIINPSControllerVM.nominees[0].npsNomineeType,
                        "percentageShare": nominationDetailsTierIINPSControllerVM.nominees[0].percentageShare,
                        "dob": nominationDetailsTierIINPSControllerVM.nominees[0].nomineeDob,
                        "guardian": {
                            "firstName": nominationDetailsTierIINPSControllerVM.nominees[0].guardianFirstName,
                            "middleName": nominationDetailsTierIINPSControllerVM.nominees[0].guardianMiddleName,
                            "lastName": nominationDetailsTierIINPSControllerVM.nominees[0].guardianSurname
                        },
                        "nomineeage":nominationDetailsTierIINPSControllerVM.nominees[0].nomineeage,
                        "relationshipcode":nominationDetailsTierIINPSControllerVM.nominees[0].nomineeRelationship,
                    }]
                };


            }

             

                if (!npsServices.npsPensionDetails.pensionFundList[0] || !npsServices.npsPensionDetails.assetAllocationList[0]) {

                    $q.all([npsServices.saveNomineeDetails(requestParams), npsServices.fetchPensionFundList()]).then(function (response) {
                        npsServices.npsPensionDetails.pensionFundList = response[1].pensionFundList;
                        npsServices.npsPensionDetails.assetAllocationList = response[1].autoAssetAllocationList;
                        
                        if(nominationDetailsTierIINPSControllerVM.reviewBtn && reviewEditData == 'npsNominationDetailsTierII'){
                                $state.go("menu.reviewDetailsNps");
                            }else{
                                $state.go("menu.npsPensionFundDetails");   
                            }

                    }, function (error) {
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                } else {

                    npsServices.saveNomineeDetails(requestParams).then(function (response) {
                        
                        if(nominationDetailsTierIINPSControllerVM.reviewBtn && reviewEditData == 'npsNominationDetailsTierII'){
                                $state.go("menu.reviewDetailsNps");
                            }else{
                                $state.go("menu.npsPensionFundDetails");   
                            }

                    }, function (error) {
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                }
        }

        nominationDetailsTierIINPSControllerVM.selectRelationship = function (index) {
            nominationDetailsTierIINPSControllerVM.nominees[index].relationshipcode = utilityService.getTextFromDropdown("value", nominationDetailsTierIINPSControllerVM.nominees[index].nomineeRelationship, nominationDetailsTierIINPSControllerVM.relationshipOptions, "description");

            if(nominationDetailsTierIINPSControllerVM.nominees[index].relationshipcode){
                nominationDetailsTierIINPSControllerVM.nextBtnFRelAct = false;
            }else{
                nominationDetailsTierIINPSControllerVM.nextBtnFRelAct = true;
            }
            
        }

        nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare = function () {
            nominationDetailsTierIINPSControllerVM.totalPercentageShare = 0;
            for (var i = 0; i < (nominationDetailsTierIINPSControllerVM.nominees.length); i++) {
                nominationDetailsTierIINPSControllerVM.totalPercentageShare = nominationDetailsTierIINPSControllerVM.totalPercentageShare + parseFloat(nominationDetailsTierIINPSControllerVM.nominees[i].percentageShare);
            }

            if (nominationDetailsTierIINPSControllerVM.totalPercentageShare == 100.0) {
                nominationDetailsTierIINPSControllerVM.disableNextButton = false
                nominationDetailsTierIINPSControllerVM.disableAddNominiee = true;
            } else {
                nominationDetailsTierIINPSControllerVM.disableNextButton = true
                if (nominationDetailsTierIINPSControllerVM.nominees.length < 3) {
                    nominationDetailsTierIINPSControllerVM.disableAddNominiee = false;
                }
            }
        }

        nominationDetailsTierIINPSControllerVM.addNominee = function () {
            

            if (nominationDetailsTierIINPSControllerVM.nominees.length < 3) {

                if (nominationDetailsTierIINPSControllerVM.nominees.length == 2) {
                    nominationDetailsTierIINPSControllerVM.disableAddNominiee = true;
                } else {
                    nominationDetailsTierIINPSControllerVM.disableAddNominiee = false;
                }

                var incrementValue = nominationDetailsTierIINPSControllerVM.nominees[nominationDetailsTierIINPSControllerVM.nominees.length - 1].count + 1;

                var insert = {
                    count: incrementValue,
                    enableDelete: true,
                    npsNomineeType: "",
                    nomineeFirstName: "",
                    nomineeMiddleName: "",
                    nomineeSurname: "",
                    nomineeRelationship: "",
                    nomineeDob: "",
                    percentageShare: nominationDetailsTierIINPSControllerVM.percentageShareList[0].value,
                    guardianFirstName: "",
                    guardianMiddleName: "",
                    guardianSurname: ""
                }

                nominationDetailsTierIINPSControllerVM.nominees.push(insert);
            } else {
                console.log("Not allowed");
                nominationDetailsTierIINPSControllerVM.disableAddNominiee = true;
            }

            nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare();

           

        }

        nominationDetailsTierIINPSControllerVM.deleteNominee = function (index) {
            nominationDetailsTierIINPSControllerVM.nominees.splice(index, 1);

            if (nominationDetailsTierIINPSControllerVM.nominees.length < 3) {
                nominationDetailsTierIINPSControllerVM.disableAddNominiee = false;
            }

            for (var i = 0; i < (nominationDetailsTierIINPSControllerVM.nominees.length); i++) {
                nominationDetailsTierIINPSControllerVM.nominees[i].count = i + 1;
            }

            nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare();

        }

        nominationDetailsTierIINPSControllerVM.percentageShareChange = function (index) {

            nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare();

            console.log(nominationDetailsTierIINPSControllerVM.totalPercentageShare);
            if (nominationDetailsTierIINPSControllerVM.totalPercentageShare > 100.0) {
                var message = "Nominee share cannot be more than 100%";
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(message);
                nominationDetailsTierIINPSControllerVM.nominees[index].percentageShare = nominationDetailsTierIINPSControllerVM.percentageShareList[0].value;

                nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare();
            }

            if (nominationDetailsTierIINPSControllerVM.totalPercentageShare >= 100.0) {
                nominationDetailsTierIINPSControllerVM.disableAddNominiee = true;
            } else {
                nominationDetailsTierIINPSControllerVM.disableAddNominiee = false;
            }
        }


        //for info popup
        var template = '<ion-popover-view class="tooltiptext commonPopNps nps-tooltip nps-fatca-tooltip nps-fatca-tooltipNom nps-fatca-tooltipNomII roboto-regular npsNominee">' + '<ion-content>' +
            '<div class="npsInfoHeading"><p>Nominee Information</p></div><div class="text-left" ng-bind-html="nominationDetailsTierIINPSControllerVM.NPSDetails.nominformation"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        nominationDetailsTierIINPSControllerVM.npsNomineeInfo = function ($event) {
           $scope.popover.show($event);
        };

         function getCalculatedAge(born) {
            var now = new Date();
            var birthday = new Date(now.getFullYear(), born.getMonth(), born.getDate());
            if (now >= birthday)
                return now.getFullYear() - born.getFullYear();
            else
                return (now.getFullYear() - born.getFullYear()) - 1;
        }

        nominationDetailsTierIINPSControllerVM.getNomineeAge = function (index) {
            if (nominationDetailsTierIINPSControllerVM.nominees[index].nomineeage !== undefined && nominationDetailsTierIINPSControllerVM.nominees[index].nomineeage !== "" && nominationDetailsTierIINPSControllerVM.nominees[index].nomineeage !== null) {
                nominationDetailsTierIINPSControllerVM.nominees[index].nomineeage = parseInt(nominationDetailsTierIINPSControllerVM.nominees[index].nomineeage);
               
            } else {
                nominationDetailsTierIINPSControllerVM.nominees[index].nomineeage = "";
            }
        }

        /* Open the date picker popup */
        nominationDetailsTierIINPSControllerVM.openDatePicker = function (index) {


           

            nominationDetailsTierIINPSControllerVM.ipObj1 = {
                callback: function (val) {
                    var dateN = new Date(val);
                    nominationDetailsTierIINPSControllerVM.nominees[index].nomineeage = parseInt(getCalculatedAge(dateN));
                    nominationDetailsTierIINPSControllerVM.nominees[index].nomineeageAge = nominationDetailsTierIINPSControllerVM.nominees[index].nomineeage + ' ' + 'years';
                    nominationDetailsTierIINPSControllerVM.nominees[index].nomineeDob = $filter('date')(dateN, "dd MMM yyyy");
                },
                inputDate: new Date(),
                to: new Date(),
                mondayFirst: true,
                closeOnSelect: false,
                templateType: 'popup',
            };

            ionicDatePicker.openDatePicker(nominationDetailsTierIINPSControllerVM.ipObj1);
        };
        $scope.$on('$ionicView.beforeEnter', function () {
            nominationDetailsTierIINPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            nominationDetailsTierIINPSControllerVM.percentageShareList = npsServices.npsDropdownData.nomineePercentage;
            nominationDetailsTierIINPSControllerVM.nominees[0].percentageShare = nominationDetailsTierIINPSControllerVM.percentageShareList[nominationDetailsTierIINPSControllerVM.percentageShareList.length - 1].value;

            if (npsServices.npsNominationDetailsTierII.nominees[0]) {
                nominationDetailsTierIINPSControllerVM.nominees = angular.copy(npsServices.npsNominationDetailsTierII.nominees);
                nominationDetailsTierIINPSControllerVM.nomineesTemp = angular.copy(npsServices.npsNominationDetailsTierII.nominees);
            }

            nominationDetailsTierIINPSControllerVM.NPSDetails =  npsServices.NPSDetails;
            nominationDetailsTierIINPSControllerVM.resetTotalPercentageShare();
            nominationDetailsTierIINPSControllerVM.getRelationshipDpwn();
            nominationDetailsTierIINPSControllerVM.comingFromReview();

            //for nominee age
             if (nominationDetailsTierIINPSControllerVM.nominees[0].nomineeage !== undefined && nominationDetailsTierIINPSControllerVM.nominees[0].nomineeage !== "" && nominationDetailsTierIINPSControllerVM.nominees[0].nomineeage !== null) {
                nominationDetailsTierIINPSControllerVM.nominees[0].nomineeage = parseInt(nominationDetailsTierIINPSControllerVM.nominees[0].nomineeage);
                nominationDetailsTierIINPSControllerVM.nominees[0].nomineeageAge = nominationDetailsTierIINPSControllerVM.nominees[0].nomineeage + ' ' + 'years';
                
            } else {
                nominationDetailsTierIINPSControllerVM.nominees[0].nomineeage = "";
            }
        });
        return this;
    }
]);
