'use strict';

angularApp.controller('showAllSiContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "$ionicViewSwitcher",
    "$ionicPopover",
    "homeScreenService",
    "npsContributionServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        $ionicViewSwitcher,
        $ionicPopover,
        homeScreenService,
        npsContributionServices) {

        var showAllSiContributionControllerVM = this;

        showAllSiContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        showAllSiContributionControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }

        showAllSiContributionControllerVM.setNewSi = function () {
            npsContributionServices.setNpsAccntData("setNewSI");
            $state.go("menu.newStandingInstructionContribution");
        }

          //for delete single SI
         showAllSiContributionControllerVM.deleteSI = function (refVal) {
                if(refVal){
                    showAllSiContributionControllerVM.refVal = refVal;
                }
             
               var paramFDeleteSI = {
                    "pranNo": showAllSiContributionControllerVM.SIStngUserAccntDetails.pranNoOnClick,
                    "epactRefno": showAllSiContributionControllerVM.refVal,
                    "transactionType": "",
                    "channelRefno": "",
                    "totalCharges": "",
                    "gst": ""
                }

                 var alertPopup = $ionicPopup.alert({
                        template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/nps/nps_alert_icon.svg" /></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">' + 'Are you sure you want to delete selected SI' + '</span></div></div></div>',
                        scope: $scope,
                        cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup insurButton npsContriPopup',
                        buttons: [
                            {
                                text: "Cancel",
                                type: 'button-negative',
                                onTap: function () {
                                    alertPopup.close();
                                }
                            },
                            {
                                text: "Yes",
                                type: 'button-positive',
                                onTap: function () {
                                    npsContributionServices.deleteSI(paramFDeleteSI).then(function (data) {
                                        $state.go("menu.deleteSISuccessPage");
                                    }, function (error) {
                                        utilityService.enableShowErrorMessage();
                                        utilityService.showErrorMessage(error.responseMessage);
                                    });
                                }
                            }
                        ],
                    });

            
         }

         //for get SI details
         showAllSiContributionControllerVM.goToSIDetails = function (refNo) {


            showAllSiContributionControllerVM.epactRefno = refNo;
            npsContributionServices.epactRefno = showAllSiContributionControllerVM.epactRefno;
            console.log("refno.", showAllSiContributionControllerVM.epactRefno);
            var rParamSIDet = {
                "epactRefno": npsContributionServices.epactRefno,
                "pranNo": showAllSiContributionControllerVM.SIStngUserAccntDetails.pranNoOnClick,
                "transactionType":""
            }

            npsContributionServices.getSIDetails(rParamSIDet).then(function (data) {
                showAllSiContributionControllerVM.getSIDetailData = data;
                npsContributionServices.getSIDetailData = showAllSiContributionControllerVM.getSIDetailData;
                showAllSiContributionControllerVM.getSiExecutionDetails = showAllSiContributionControllerVM.getSIDetailData.siExecutionDetails;
                npsContributionServices.siExecutionDetails = showAllSiContributionControllerVM.getSiExecutionDetails;
                 $state.go("menu.showSIDetails");
            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });
            
        }

         showAllSiContributionControllerVM.goNext = function () {
            npsContributionServices.setNpsAccntData("makeContri");
            $state.go("menu.contriDetailsContribution");
        }


      // on page landing
        $scope.$on('$ionicView.beforeEnter', function () {
            showAllSiContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            showAllSiContributionControllerVM.getAllnpsContWcmCont = angular.copy(npsContributionServices.getAllnpsContWcmCont);
            showAllSiContributionControllerVM.npsChannelCode = showAllSiContributionControllerVM.getAllnpsContWcmCont.npsChannelCode;
            showAllSiContributionControllerVM.getAllActiveSiList = angular.copy(npsContributionServices.getAllActiveSiList);
            showAllSiContributionControllerVM.SIStngUserAccntDetails = angular.copy(npsContributionServices.SIStngUserAccntDetails);

             // for all active si list - create new array for channel des
                showAllSiContributionControllerVM.allActiveList = [];
                if(showAllSiContributionControllerVM.getAllActiveSiList){
                    for (var k = 0; k < showAllSiContributionControllerVM.getAllActiveSiList.length; k++) {
                        for (var j = 0; j < showAllSiContributionControllerVM.npsChannelCode.length; j++) {
                            if((showAllSiContributionControllerVM.getAllActiveSiList[k].channel == showAllSiContributionControllerVM.npsChannelCode[j].value) && showAllSiContributionControllerVM.getAllActiveSiList[k].epactRefno){
                                showAllSiContributionControllerVM.channelDes = showAllSiContributionControllerVM.npsChannelCode[j].description;
                                var obj = {'channel':showAllSiContributionControllerVM.channelDes, 'epactRefno':showAllSiContributionControllerVM.getAllActiveSiList[k].epactRefno}
                                showAllSiContributionControllerVM.allActiveList.push(obj);
                            }
                        }
                    }
                }

             console.log("showAllSiContributionControllerVM.allActiveList", showAllSiContributionControllerVM.allActiveList);
             
    });


        return this;
    }
]);
