'use strict';

angularApp.controller('contriReviewDetailsContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "npsContributionServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        npsContributionServices) {

        var contriReviewDetailsContributionControllerVM = this;
        $scope.currentPage = "1";
        $scope.lastPage = "16";
        contriReviewDetailsContributionControllerVM.validAccountFlag = false;

        contriReviewDetailsContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        contriReviewDetailsContributionControllerVM.goBack = function () {
            npsContributionServices.setNpsAccntData("");
            $ionicHistory.goBack();
        }

        //for toggle arrow
        contriReviewDetailsContributionControllerVM.clickOnArrow = function () {
            contriReviewDetailsContributionControllerVM.npsContriAmntSection = !contriReviewDetailsContributionControllerVM.npsContriAmntSection;
        }


        //got to otp page for confirmation
        contriReviewDetailsContributionControllerVM.goNext = function () {
            npsContributionServices.setNpsAccntData("fromNpsContriReviewDetails");

            var requestParamsConfRev = {
                    "pranNumber": contriReviewDetailsContributionControllerVM.userAccntDetails.pranNoOnClick,
                    "tierType": contriReviewDetailsContributionControllerVM.contributionDetails.tierTypePassData,
                    "tier1Amount": contriReviewDetailsContributionControllerVM.contributionAmountTierI,
                    "tier2Amount": contriReviewDetailsContributionControllerVM.contributionAmountTierII,
                    "accountNumber": contriReviewDetailsContributionControllerVM.userAccntDetails.accountNumber
                }

                npsContributionServices.preConfirmContribution(requestParamsConfRev).then(function (data) {
                    $state.go('menu.otpLinkAccountContribution'); 
                
                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
                    
        }


        //before page load
        $scope.$on('$ionicView.beforeEnter', function () {
            contriReviewDetailsContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
           
            contriReviewDetailsContributionControllerVM.npsTprnSuccessData = angular.copy(npsServices.npsTprnSuccessData);
            
            //for contribution details
            contriReviewDetailsContributionControllerVM.contributionDetails = angular.copy(npsContributionServices.contributionDetails);
            contriReviewDetailsContributionControllerVM.tierId = contriReviewDetailsContributionControllerVM.contributionDetails.tierId;
            contriReviewDetailsContributionControllerVM.contributionAmountTierI = contriReviewDetailsContributionControllerVM.contributionDetails.contributionAmountTierI;
            contriReviewDetailsContributionControllerVM.contributionAmountTierII = contriReviewDetailsContributionControllerVM.contributionDetails.contributionAmountTierII;
            console.log("contriReviewDetailsContributionControllerVM.contributionAmountTierII", contriReviewDetailsContributionControllerVM.contributionAmountTierII);

            //for userAccount details
            contriReviewDetailsContributionControllerVM.userAccntDetails = angular.copy(npsContributionServices.userAccntDetails);
            

           
        });



        return this;
    }
]);
