'use strict';

angularApp.controller('linkAccountSuccessContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "openUrlInAppbroswerService",
    "npsContributionServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        openUrlInAppbroswerService,
        npsContributionServices) {

        var linkAccountSuccessContributionControllerVM = this;

        linkAccountSuccessContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        linkAccountSuccessContributionControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }

        linkAccountSuccessContributionControllerVM.goNext = function () {
            $state.go("menu.linkedAccountsContribution");
        }

        

        $scope.$on('$ionicView.beforeEnter', function () {
            linkAccountSuccessContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            linkAccountSuccessContributionControllerVM.pranDetails = angular.copy(npsContributionServices.pranDetails);
            
        });

        return this;
    }
]);
