'use strict';

angularApp.controller('newNpsReviewContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "$ionicViewSwitcher",
    "homeScreenService",
    "npsContributionServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        $ionicViewSwitcher,
        homeScreenService,
        npsContributionServices) {

        var newNpsReviewContributionControllerVM = this;


        newNpsReviewContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        newNpsReviewContributionControllerVM.goBack = function () {
            npsContributionServices.setNpsAccntData("");
            $ionicHistory.goBack();
        }

        newNpsReviewContributionControllerVM.goNext = function () {
            npsContributionServices.setNpsAccntData("fromnpsReview");
            $state.go("menu.otpLinkAccountContribution");
        }




        $scope.$on('$ionicView.beforeEnter', function () {
            newNpsReviewContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            newNpsReviewContributionControllerVM.pranDetails = angular.copy(npsContributionServices.pranDetails);
            newNpsReviewContributionControllerVM.getUserList = angular.copy(npsContributionServices.getUserList);
            //fetch data for other details
            newNpsReviewContributionControllerVM.getAllnpsContWcmCont = angular.copy(npsContributionServices.getAllnpsContWcmCont);

            //check sectorCd description using sectorcode
            newNpsReviewContributionControllerVM.npsAllSectorCode = newNpsReviewContributionControllerVM.getAllnpsContWcmCont.npsSectorCode;

            for (var i = 0; i < newNpsReviewContributionControllerVM.npsAllSectorCode.length; i++) {
                if (newNpsReviewContributionControllerVM.getUserList.tier1SectorCd == newNpsReviewContributionControllerVM.npsAllSectorCode[i].value) {
                    newNpsReviewContributionControllerVM.tier1SectorDes = newNpsReviewContributionControllerVM.npsAllSectorCode[i].description;
                    npsContributionServices.tier1SectorDes = newNpsReviewContributionControllerVM.tier1SectorDes;
                }

                if (newNpsReviewContributionControllerVM.getUserList.tier2SectorCd == newNpsReviewContributionControllerVM.npsAllSectorCode[i].value) {
                    newNpsReviewContributionControllerVM.tier2SectorDes = newNpsReviewContributionControllerVM.npsAllSectorCode[i].description;
                    npsContributionServices.tier2SectorDes = newNpsReviewContributionControllerVM.tier2SectorDes;
                }

            }
        });


        return this;
    }
]);
