'use strict';

angularApp.controller('reviewStandingInstructionContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "npsContributionServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        npsContributionServices) {

        var reviewStandingInstructionContributionControllerVM = this;
        $scope.currentPage = "1";
        $scope.lastPage = "16";
        reviewStandingInstructionContributionControllerVM.validAccountFlag = false;

        reviewStandingInstructionContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

         //for toggle arrow
        reviewStandingInstructionContributionControllerVM.clickOnArrow = function () {
            reviewStandingInstructionContributionControllerVM.npsContriAmntSection = !reviewStandingInstructionContributionControllerVM.npsContriAmntSection;
        }

        reviewStandingInstructionContributionControllerVM.goBack = function () {
            npsContributionServices.setNpsAccntData('')
            $ionicHistory.goBack();
        }



        reviewStandingInstructionContributionControllerVM.goNext = function () {
            npsContributionServices.setNpsAccntData("fromNpsContriSIStandingPage");
            $state.go('menu.otpLinkAccountContribution');
        }


        $scope.$on('$ionicView.beforeEnter', function () {
            reviewStandingInstructionContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;

            //for userAccount details
            reviewStandingInstructionContributionControllerVM.SIStngUserAccntDetails = angular.copy(npsContributionServices.SIStngUserAccntDetails);
            reviewStandingInstructionContributionControllerVM.getAllMasterData = angular.copy(npsContributionServices.getAllMasterData);
            reviewStandingInstructionContributionControllerVM.SIStandingAccntDetails = angular.copy(npsContributionServices.SIStandingAccntDetails);
            reviewStandingInstructionContributionControllerVM.setSIStandingDetails = angular.copy(npsContributionServices.setSIStandingDetails);

            if (reviewStandingInstructionContributionControllerVM.SIStandingAccntDetails.tierId == 3) {
                if (reviewStandingInstructionContributionControllerVM.SIStandingAccntDetails.tier2DeActive || reviewStandingInstructionContributionControllerVM.SIStandingAccntDetails.tier2Inactive) {
                    if (reviewStandingInstructionContributionControllerVM.SIStandingAccntDetails.tierTypePassData == 'Tier1') {
                        reviewStandingInstructionContributionControllerVM.tierType = 'Tier 1'
                    }
                } else {
                    if (reviewStandingInstructionContributionControllerVM.SIStandingAccntDetails.tierTypePassData == 'Both') {
                        reviewStandingInstructionContributionControllerVM.tierType = 'Tier 1 & Tier 2'
                    }
                }
            }



        });



        return this;
    }
]);
