'use strict';

angularApp.controller('setSiContributionController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "$ionicViewSwitcher",
    "homeScreenService",
    "npsContributionServices",
    "$filter",
    "ionicDatePicker",
    "constantConfig",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        $ionicViewSwitcher,
        homeScreenService,
        npsContributionServices,
        $filter,
        ionicDatePicker,
        constantConfig) {

        var setSiContributionControllerVM = this;

        setSiContributionControllerVM.getNpsAccntData = npsContributionServices.getNpsAccntData();

        setSiContributionControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        setSiContributionControllerVM.goBack = function () {
            npsContributionServices.setNpsAccntData('')
            $ionicHistory.goBack();
        }

        setSiContributionControllerVM.goNext = function () {
            npsContributionServices.setSIStandingDetails.siStartDate = setSiContributionControllerVM.siStartDate;
            console.log("setSiContributionControllerVM.siStartDate", setSiContributionControllerVM.siStartDate);
            npsContributionServices.setSIStandingDetails.equityVal = setSiContributionControllerVM.equityVal;
            var dateFormatForSiDay = new Date(setSiContributionControllerVM.siStartDate);

            setSiContributionControllerVM.siDay = (dateFormatForSiDay).getDate();
            console.log("dateFormatForSiDay", dateFormatForSiDay.getDate());


            npsContributionServices.setSIStandingDetails.siDay = setSiContributionControllerVM.siDay;
            $state.go("menu.reviewStandingInstructionContribution")
        }

        setSiContributionControllerVM.changeSi = function () {
            setSiContributionControllerVM.equitySlider.value = setSiContributionControllerVM.equityVal;
        }

        setSiContributionControllerVM.equitySlider = {
            value: Number(setSiContributionControllerVM.equityVal),
            options: {
                showSelectionBar: true,
                floor: 1,
                ceil: 120,
                step: 1,
                onChange: function (id, model) {
                    setSiContributionControllerVM.equityVal = setSiContributionControllerVM.equitySlider.value;
                    $scope.npsAccountList.forEach(function (ele) {
                        if (ele.name == constantConfig.npsDetails.equity) {
                            ele.val = setSiContributionControllerVM.equityVal;
                        }
                    });

                },
                translate: function (value, id, label) {
                    if (label === 'ceil' || label === 'floor') {
                        return value + "";
                    }
                }
            }
        };


        setSiContributionControllerVM.equityVal = setSiContributionControllerVM.equitySlider.options.floor;



        /* Open the date picker popup */
        setSiContributionControllerVM.openDatePicker = function (index) {



            
            var nextDate = new Date().setDate(new Date().getDate() + 1);
            var toDate = new Date().setDate(new Date().getDate() + 365);
            console.log("todate", toDate);


            setSiContributionControllerVM.ipObj1 = {
                callback: function (val) {
                    var date = new Date(val);
                    setSiContributionControllerVM.siStartDate = $filter('date')(date, "dd MMM yyyy");
                },
                inputDate: new Date(nextDate),
                
                from: nextDate,
                to: toDate,
                mondayFirst: true,
                closeOnSelect: false,
                templateType: 'popup',
            };

            ionicDatePicker.openDatePicker(setSiContributionControllerVM.ipObj1);
        };




        $scope.$on('$ionicView.beforeEnter', function () {
            setSiContributionControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            setSiContributionControllerVM.setSIStandingDetails = angular.copy(npsContributionServices.setSIStandingDetails);
            setSiContributionControllerVM.SIStandingAccntDetails = angular.copy(npsContributionServices.SIStandingAccntDetails);

            if (setSiContributionControllerVM.SIStandingAccntDetails.tierId == 3) {
                if (setSiContributionControllerVM.SIStandingAccntDetails.tier2DeActive || setSiContributionControllerVM.SIStandingAccntDetails.tier2Inactive) {
                    if (setSiContributionControllerVM.SIStandingAccntDetails.tierTypePassData == 'Tier1') {
                        setSiContributionControllerVM.tierType = 'Tier 1'
                    }
                } else {
                    if (setSiContributionControllerVM.SIStandingAccntDetails.tierTypePassData == 'Both') {
                        setSiContributionControllerVM.tierType = 'Tier 1 & Tier 2'
                    }
                }
            }


            if(setSiContributionControllerVM.getNpsAccntData == 'setNewSI'){
                    setSiContributionControllerVM.equityVal = '';
                    setSiContributionControllerVM.equitySlider.value = '';
                    setSiContributionControllerVM.siStartDate = '';
            }else{
                if(setSiContributionControllerVM.setSIStandingDetails.siStartDate){
                    setSiContributionControllerVM.siStartDate = moment(setSiContributionControllerVM.setSIStandingDetails.siStartDate).format("DD MMM YYYY");
                }

                if (setSiContributionControllerVM.setSIStandingDetails.equityVal) {
                    setSiContributionControllerVM.equityVal = setSiContributionControllerVM.setSIStandingDetails.equityVal;
                    setSiContributionControllerVM.equitySlider.value = setSiContributionControllerVM.equityVal;
                }
            }



        });


        return this;
    }
]);
