'use strict';

angularApp.controller('plTermsController', ["$state",
    "$scope",
    "$translate",
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicPopup",
    "personalLoanService", "$sce", "$rootScope", "constantConfig",

    function ($state,
        $scope,
        $translate,
        $ionicScrollDelegate,
        utilityService,
        $ionicPopup,
        personalLoanService, $sce, $rootScope, constantConfig) {

        var plTermsVm = this;
        $rootScope.currentPage = 3;

        function initPage() {
            plTermsVm.showBack = true;
            plTermsVm.showNext = true;
            plTermsVm.disableNext = true;
            plTermsVm.aofooter = true;
            plTermsVm.isTncDownloaded = false;
            plTermsVm.ConditionsJson = [];
            plTermsVm.conditionsList();
            plTermsVm.disableCheckbox = true;
        }

        plTermsVm.goBacktoPrevious = function () {
            $state.go('menu.emiPayDate');
        }

        plTermsVm.goToNextPage = function () {
            //$state.go('menu.plOTP');
            $state.go('menu.reviewLoan');
        }

        plTermsVm.checkScroll = function () {
            var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
            var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if (currentTop >= maxTop) {
                plTermsVm.disableCheckbox = false;
                var childNodes = document.getElementById('TNC_CHK').children[0].children[0].removeAttribute("disabled");
            }
        }

        plTermsVm.conditionsList = function () {
            plTermsVm.ConditionsJson = personalLoanService.ConditionsJson;
        }

        $scope.goToHome = function () {
            $state.go('menu.homeScreen');
        }

        plTermsVm.agreeChkBox = function () {
            if (plTermsVm.isChecked) {
                plTermsVm.disableNext = false;
                personalLoanService.checkTnC = true;                
            } else {
                plTermsVm.disableNext = true;
                personalLoanService.checkTnC = false;
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        return this;
    }
]);
