'use strict';
angularApp.controller('prehomeLoginRevampController', [
  "$state",
  "$scope",
  "$rootScope",
  "$ionicPopup",
  "$ionicPopover",
  "$timeout",
  "$translate",
  "loggedInUserService",
  "mPinLoginService",
  "ConnectivityMonitorUtils",
  "utilityService",
  "quickPayService",
  "clickStreamService",
  "cryptoService",
  "encryptionService",
  "AdapterUtils",
  "bhimUpiService",
  "constantConfig",
  "homeScreenService",
  "locateNearestBranchService",  
  "internetBankingService",
  "currentLocationService",
  "aoService",
  "inbLockUnlockService",
  "registerWithSimService",
  "$filter",
  "ompOffersService",
  "newCardService",
  "agriMandiService",
  "getAccountDetailsService",
  "customerInfoService",
  "cardCompareService",
  "$ionicSideMenuDelegate",
  "$ionicSlideBoxDelegate",
  "mpassbookdetailsService",  
  "preHomeLoginService",
  "leadGenerationService","linkCardService","applyNowService","cardsService","myDreamsService",
  "openAccountService","mutualFundsService","myBalanceService","fTBeneficiaryService",  
  "$interval",
  "$q",
  "ionicToast","ompMerchantsService","supportServices","menuService",
  function ($state,
    $scope,
    $rootScope,
	$ionicPopup,
	$ionicPopover,
	$timeout,
	$translate,   
    loggedInUserService,
    mPinLoginService,
    ConnectivityMonitorUtils,
    utilityService,
    quickPayService,
    clickStreamService,
    cryptoService,
    encryptionService,
    AdapterUtils,
	bhimUpiService,
	constantConfig,
	homeScreenService,
	locateNearestBranchService,	
	internetBankingService,
	currentLocationService,
	aoService,
	inbLockUnlockService,
	registerWithSimService,
	$filter,
	ompOffersService,
	newCardService,
	agriMandiService,
	getAccountDetailsService,
	customerInfoService,
	cardCompareService,
	$ionicSideMenuDelegate,
	$ionicSlideBoxDelegate,
	mpassbookdetailsService,	
	preHomeLoginService,
	leadGenerationService,linkCardService,applyNowService,cardsService,myDreamsService,
	openAccountService,mutualFundsService,myBalanceService,fTBeneficiaryService,	
	$interval,
	$q,
	ionicToast, ompMerchantsService,supportServices,menuService) {
    
	var prehomeLoginVm = this;
	prehomeLoginVm.mpinErrorMsg = "";
	prehomeLoginVm.mpinErrorMsgFlag = false;		
	prehomeLoginVm.userType = '';
	prehomeLoginVm.isChallenged = false;
	prehomeLoginVm.securityCheckName = "AuthenticateMPinSecurityCheck";
	prehomeLoginVm.mPinAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(prehomeLoginVm.securityCheckName);
	prehomeLoginVm.mPinAuthChallengeHandler.securityCheckName = prehomeLoginVm.securityCheckName;
	prehomeLoginVm.userName = "";
	prehomeLoginVm.password = "";
	prehomeLoginVm.userLoginErrorMsg = "";
	prehomeLoginVm.userLoginErrorFlag = false;	
	prehomeLoginVm.keystoreValue = loggedInUserService.keystoreValue;	
	prehomeLoginVm.openLoginoption = false;
	prehomeLoginVm.productClicked = "";
	prehomeLoginVm.viewBalanceLoginScreen = false;
	prehomeLoginVm.viewbalAvl = false;
	prehomeLoginVm.fingerPrintCancelled = false;
	prehomeLoginVm.hideFooter = false;
	prehomeLoginVm.loginVia = '';
	prehomeLoginVm.popupClass = [];
	
	$scope.banners = {};		
	$scope.err = '';

	if (!localStorage.getItem('ignoredVersion'))
		localStorage.setItem('ignoredVersion', "0.0.0");

	if (device.platform.toLowerCase() == 'android' || device.platform.toLowerCase() == 'windows') {
		prehomeLoginVm.isAndroidDevice = true;
	} else {
		prehomeLoginVm.isAndroidDevice = false;
	}

    // code to select login Option for MPIN or username - taken from existing userLoginController.js - starts    

	prehomeLoginVm.toggleLoginMenu = function (loginOption) {		
		if (loginOption === 'MPINLogin') {			
			clearMpin();
			$scope.eraseMpin();
			if(prehomeLoginVm.mpinConsent){
				prehomeLoginVm.MPINLoginFlag = true;
				prehomeLoginVm.UserIdLoginFlag = false;				
				prehomeLoginVm.mpinErrorMsgFlag = false;
				prehomeLoginVm.screenSizeReduced = false;
			}							
		}
		if (loginOption === 'UserIdLogin') {
			if(!prehomeLoginVm.keyguardValue && prehomeLoginVm.lockPopupEnabled){
				prehomeLoginVm.deviceLockPopup.close();
			} 			
			prehomeLoginVm.userName = '';
			prehomeLoginVm.password = '';
			prehomeLoginVm.MPINLoginFlag = false;
			prehomeLoginVm.UserIdLoginFlag = true;			
			prehomeLoginVm.userLoginErrorFlag = false;		
		}
		if(loggedInUserService.productClicked){
			removePopupClass();
			determinePopupClass();
			addPopupClass();
		}
	};

	prehomeLoginVm.expandUsernameLogin = function(){
		prehomeLoginVm.clearAllData();
		prehomeLoginVm.lockPopupEnabled = false;
		prehomeLoginVm.openLoginoption = true;		
		prehomeLoginVm.clickOn = '';
		loggedInUserService.productClicked = '';
	}

    /*Custom Keypad for MPIN - taken from existing userLoginController.js*/
	$scope.password = '';
	$scope.canErase = false;
	$scope.pinDotVisible = {};
	$scope.success = null;
	$scope.keyboardVisible = false;
	$scope.pinArray = [];

	$scope.keyboardSettings = {
		// settings here
		action: function (number) {					
			if ($scope.password.length < 6) {
				$scope.password += number;
				$scope.pinArray.push(number);				
				$scope.pinDotVisible[$scope.password.length] = true;
				$scope.canErase = true;
				$scope.success = null;
				var pass = $scope.password;
				pass = pass.split("");
				try {
					prehomeLoginVm.first = pass[0];
					prehomeLoginVm.second = pass[1];
					prehomeLoginVm.third = pass[2];
					prehomeLoginVm.fourth = pass[3];
					prehomeLoginVm.fifth = pass[4];
					prehomeLoginVm.sixth = pass[5];
				} catch (err) { }
			}			
			if(prehomeLoginVm.clickOn == 'view_balance'){
				if ($scope.password && $scope.password.length === 6 && !($scope.passLenLimitReached)) {
					$scope.passLenLimitReached = true;
					var e = {};
					$scope.newMpin = $scope.password;
					var pass = $scope.password;
					pass = pass.split("");
					try {
						prehomeLoginVm.first = pass[0];
						prehomeLoginVm.second = pass[1];
						prehomeLoginVm.third = pass[2];
						prehomeLoginVm.fourth = pass[3];
						prehomeLoginVm.fifth = pass[4];
						prehomeLoginVm.sixth = pass[5];
	
						e.srcElement = {};
						e.srcElement.value = 2;
						prehomeLoginVm.changeInput(e, 6);
					} catch (err) { }			
				}
			}
			else{
				if ($scope.password && $scope.password.length === 6) {
					var e = {};
					$scope.newMpin = $scope.password;
					var pass = $scope.password;
					pass = pass.split("");
					try {
						prehomeLoginVm.first = pass[0];
						prehomeLoginVm.second = pass[1];
						prehomeLoginVm.third = pass[2];
						prehomeLoginVm.fourth = pass[3];
						prehomeLoginVm.fifth = pass[4];
						prehomeLoginVm.sixth = pass[5];
					} catch (err) {  }
					var e = {};
					e.srcElement = {};
					e.srcElement.value = 2;
					prehomeLoginVm.changeInput(e, 6);
				}
			}			
		},
		// Clear
		leftButton: {
			html: '<i class="icon ion-backspace"></i>',
			action: function () {
				$scope.doErase();
			},
			style: {
				bgColor: '#fff',
				activeBgColor: '#dfdfdf',
				borderColor: '#dfdfdf',
				fontSize: '20px'
			}
		},
		// Submit login
		rightButton: {
			html: '<i class="icon ion-eye"></i>	<i class="icon ion-eye-disabled login-eye-btn" ></i>',			
			action: function () {				
				if ($scope.isPassVisible) {
					var elementHide = document.getElementsByClassName("ion-eye-disabled")[0];
					elementHide.classList.add("login-eye-btn");
					var elementShow = document.getElementsByClassName("ion-eye")[0];
					elementShow.classList.remove("login-eye-btn");

					$scope.isPassVisible = false;
				} else {
					$scope.isPassVisible = true;
					var elementHide = document.getElementsByClassName("ion-eye")[0];
					elementHide.classList.add("login-eye-btn");
					var elementShow = document.getElementsByClassName("ion-eye-disabled")[0];
					elementShow.classList.remove("login-eye-btn");
				}
			},
			style: {
				bgColor: '#fff',
				activeBgColor: '#dfdfdf',
				borderColor: '#dfdfdf',
				fontSize: '30px'
			}
		}
	}
    prehomeLoginVm.changeInput = function ($event, index) {

		cordova.plugins.Keyboard.close();
		/*login flow improvements*/
		if (loggedInUserService.isServerConnected) {
			prehomeLoginVm.loginWithMpin();
		} else {
			connectServer();
		}

	}  
	prehomeLoginVm.loginWithMpin = function () {

		if(utilityService.isAndroidPlatform() && registerWithSimService.isSimRegistration && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (prehomeLoginVm.isSimChanged || prehomeLoginVm.simList == undefined || prehomeLoginVm.simList.length == 0)){
			if(prehomeLoginVm.isSimChanged)
			{
				prehomeLoginVm.reloadApp(registerWithSimService.changedSimMsg, true);
			}			
			else if(prehomeLoginVm.simList == undefined || prehomeLoginVm.simList.length == 0)
				utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
			clearMpin();
			$scope.eraseMpin();			
			return;
		}
		var newMpin = prehomeLoginVm.first.trim() +
			prehomeLoginVm.second.trim() +
			prehomeLoginVm.third.trim() +
			prehomeLoginVm.fourth.trim() +
			prehomeLoginVm.fifth.trim() +
			prehomeLoginVm.sixth.trim();		
		if (newMpin.length == 6) {
			if (ConnectivityMonitorUtils.isOffline()) {
				clearMpin();
				$scope.eraseMpin();				
				utilityService.offlineAlert();
				return;
			}
			if (prehomeLoginVm.clickOn == 'view_balance')
				prehomeLoginVm.viewBalanceMPINLogin(newMpin);
			else
				prehomeLoginVm.userMPINloginStart(newMpin);			
		} else {			
			clearMpin();
			$scope.eraseMpin();				
			if (prehomeLoginVm.clickOn == 'view_balance'){
				prehomeLoginVm.authFailure = true;
				quickPayService.showAuthFailurePopup('error', 'Please Enter 6 digit valid MPIN', '', '', 'OK', '', $scope, true, function () { prehomeLoginVm.authFailure = false; });
			} else {
				utilityService.showErrorMessage('Please Enter 6 digit valid MPIN');
			}
			
		}
	};

	prehomeLoginVm.viewBalanceMPINLogin = function(newMpin){
		var hasedSimInfo = "";
		if(utilityService.isAndroidPlatform()){
			hasedSimInfo = prehomeLoginVm.hasedSimInfo;
		}
		var requestParams = {
			"mPinNumber": newMpin,
			"type": "mpin",
			"simId": hasedSimInfo.toString(),
			"simSubId" : prehomeLoginVm.simSubscriptionId,
			//"source" : "yqp_mpin_vb"
		};    
		quickPayService.userAuthentication(requestParams).then(function (data) {
			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYMPINSUCCESS"));
			$scope.hideKeyboard();
			afterUserAuthSuccess(data);			
			$scope.passLenLimitReached = false;
			clearMpin();
			$scope.eraseMpin();

		}, function (error) {
			$scope.passLenLimitReached = false;
			clearMpin();
			$scope.eraseMpin();			
			prehomeLoginVm.authFailure = true;
			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYMPINFAIL"));
			if(error.responseCode == "SB001" || error.responseCode == "F001"){
				registerWithSimService.reloadAppSimOk(error.responseMessage);
			}
			else if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
				prehomeLoginVm.authFailure = false;
				utilityService.showForcePasswordPopup(error.responseMessage,"");
			}else {
				prehomeLoginVm.mpinErrorMsg = error.responseMessage;
				prehomeLoginVm.mpinErrorMsgFlag = true;
				prehomeLoginVm.authFailure = false;
			}  
		});
	}

	prehomeLoginVm.userMPINloginStart = function(newMpin){
		utilityService.showSpinner();

		loggedInUserService.finalSHA512Val = registerWithSimService.isSimRegistration && registerWithSimService.isSimLogin ?
			loggedInUserService.generateMPINSHA512ValWithSim(newMpin, prehomeLoginVm.simSubscriptionId) :
			loggedInUserService.generateMPINSHA512Val(newMpin);
		prehomeLoginVm.mPinAuthChallengeHandler.handleChallenge = function (challenge) {
			prehomeLoginVm.isChallenged = true;				
			clearMpin();
			$scope.eraseMpin();				
			utilityService.accessRestricted = "";
			utilityService.hideSpinner();
			if(loggedInUserService.productClicked == 'paycontact' || loggedInUserService.productClicked == 'payContact_secondAuthentication') {		
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYMPINFAIL"));
			} 
			else if(loggedInUserService.productClicked == 'paybank' || loggedInUserService.productClicked == 'payBank_secondAuthentication') {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYMPINFAIL"));
			}
			else if(loggedInUserService.productClicked == "menu.scanQRCode" || loggedInUserService.productClicked == "scanPay_secondAuthentication"){				
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYMPINFAIL"));	
			}
			else if(loggedInUserService.productClicked == "receiveQR"){
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYMPINFAIL"));
			}
			else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YONOCASH_AUTHBYMPINFAIL"));
			}
			else {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN"));
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
			}
			if (challenge.errorMsg !== null) {

					if (challenge.errorMsg.indexOf("2003:") !== -1) {
					challenge.errorMsg = challenge.errorMsg.replace("2003:", "");
					prehomeLoginVm.reloadApp(registerWithSimService.changedSimMsg, true);
				} else if (challenge.errorMsg.indexOf("2005:") !== -1) {
					challenge.errorMsg = challenge.errorMsg.replace("2005:", "");
					prehomeLoginVm.reloadApp(challenge.errorMsg);
				} else if (challenge.errorCode == "M003" || challenge.errorCode == "LOCK.001") {
					if (challenge.errorCode == "LOCK.001") {
						inbLockUnlockService.challengeErrorCode = "LOCK.001";
					}
					inbLockUnlockService.displayErrorPopUp('<img class="inb-error-icon" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12">Your access has been locked.</p>',
						challenge.errorMsg, ["Cancel", "Unlock"], function () {
							//added comment to retain existing code structure
						}, function () {
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
							var reqParams = {
								"deviceId": device.uuid,
							}
							internetBankingService.fetchDetailsByDeviceID(reqParams).then(function (data) {									
								loggedInUserService.setInbUserId(data);
								prehomeLoginVm.closePopupLogin();									
								$state.go('menu.inbUnlockAccessDetails');
							}, function (error) {									
								utilityService.showErrorMessage(error.responseMessage);									
							});								
						});
					return
				} else if (challenge.errorCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01) {
					utilityService.showForcePasswordPopup(challenge.errorMsg, "");
				} else if (challenge.errorCode == "SB001") {
						prehomeLoginVm.reloadApp(challenge.errorMsg);
				}
				else if(challenge.errorCode === "F001"){
					registerWithSimService.reloadAppSimBinding(error.responseMessage);
				}
				else {
					//here need to add error msg if sim info changed according to the adapter response msg
					prehomeLoginVm.mpinErrorMsg = challenge.errorMsg;
					prehomeLoginVm.mpinErrorMsgFlag = true;
					if(loggedInUserService.productClicked){
						removePopupClass();
						determinePopupClass();
						addPopupClass();
					}
				}
			} else {
				utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
			}			
		};

		prehomeLoginVm.mPinAuthChallengeHandler.handleSuccess = function (data) {
			prehomeLoginVm.isChallenged = false;
			if (data.user) {
				loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
				loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
				var userDetails = AdapterUtils.secretData == "" ? data.user.attributes.userDetails : encryptionService.getAES256DecryptedData(data.user.attributes.userDetails);
				if (data.user.attributes.sessionId && data.user.attributes.lotusId) {
					clickStreamService.sessionId = AdapterUtils.secretData == "" ? data.user.attributes.sessionId : encryptionService.getAES256DecryptedData(data.user.attributes.sessionId);
					clickStreamService.lotusId = AdapterUtils.secretData == "" ? data.user.attributes.lotusId : encryptionService.getAES256DecryptedData(data.user.attributes.lotusId);
				}
				loggedInUserService.setUserProfileDetails(JSON.parse(userDetails));
			}
		};

		prehomeLoginVm.mPinAuthChallengeHandler.handleFailure = function (error) {
			prehomeLoginVm.mPinAuthChallengeHandler.cancel();
			prehomeLoginVm.isChallenged = false;				
			clearMpin();
			$scope.eraseMpin();				
			utilityService.accessRestricted = "";
			utilityService.hideSpinner();
			if(loggedInUserService.productClicked == 'paycontact' || loggedInUserService.productClicked == 'payContact_secondAuthentication') {		
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYMPINFAIL"));
			} 
			else if(loggedInUserService.productClicked == 'paybank' || loggedInUserService.productClicked == 'payBank_secondAuthentication') {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYMPINFAIL"));
			}
			else if(loggedInUserService.productClicked == "menu.scanQRCode" || loggedInUserService.productClicked == "scanPay_secondAuthentication"){				
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYMPINFAIL"));	
			}
			else if(loggedInUserService.productClicked == "receiveQR"){
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYMPINFAIL"));
			}
			else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YONOCASH_AUTHBYMPINFAIL"));
			}
			else {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN"));
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
			}				
			if (error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client") {
				loggedInUserService.setMFPUrl(false);
				return;
			}
			if (error.failure) {
				utilityService.showErrorMessage(error.failure);
			} else {
				utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
			}
		}

		var payload = {};
		var hasedSimInfo = "";
		if(utilityService.isAndroidPlatform() && registerWithSimService.isSimRegistration && registerWithSimService.isSimLogin){

			hasedSimInfo = prehomeLoginVm.hasedSimInfo;
		}
		var requestParams = {
			"mPinNumber": loggedInUserService.finalSHA512Val,
			"mfDeviceId": loggedInUserService.deviceIdForMpin,
			"id": loggedInUserService.deviceInfo,
			"osName": device.platform,
			"keyId": loggedInUserService.keyId,
			"simId": hasedSimInfo.toString(),
			//"reqTimeStamp": (new Date()).toString()			
		};

		var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
		payload = {
			"data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
			"src": src
		}
		payload = AdapterUtils.secretData == "" ? requestParams : payload;
		if (prehomeLoginVm.isChallenged) {
			prehomeLoginVm.mPinAuthChallengeHandler.submitChallengeAnswer(payload);
		} else {
			WLAuthorizationManager.login(prehomeLoginVm.mPinAuthChallengeHandler.securityCheckName, payload).then(function (data) {						
				utilityService.accessRestricted = utilityService.mPinAuthRequire;						
				utilityService.csatJournies = [];
				homeScreenService.isCustCalled = true;
				quickPayService.getCustomerInfo().then(function (data1) {							
					mPinLoginService.isLoggedIn = true;
					getAccountDetailsService.accountOverviewData = data1;
					homeScreenService.isCustCalled = false;
					customerInfoService.customerInfo = data1.customerInformation;
					customerInfoService.customer = data1.customerInformation;
					customerInfoService.customer.name = data1.customerInformation.customerName;
					quickPayService.customerInfo = getAccountDetailsService.accountOverviewData;
					if (loggedInUserService.productClicked != "") {
						var redirecturl;
						if (loggedInUserService.productClicked == "menu.cardIntroduction") {
							cardCompareService.getShikharEligibilityCheck().then(function (response) {
								cardCompareService.shikharFlag = response.data.shikharFlag;
								if (cardCompareService.shikharFlag || cardCompareService.shikharFlag == "true") {
									redirecturl = 'menu.shikharCards';
									loggedInUserService.productClicked = "";
									$state.go(redirecturl);
								} else {
									redirecturl = loggedInUserService.productClicked;
									loggedInUserService.productClicked = "";
									$state.go(redirecturl);
								}
							}, function (error) {
								redirecturl = loggedInUserService.productClicked;
								loggedInUserService.productClicked = "";
								$state.go(redirecturl);
							})
						}
						else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
							prehomeLoginVm.closePopupLogin();
							loggedInUserService.productClicked = "";
							$state.go("menu.yonoCash");	
							homeScreenService.preLoginYonoCash=false;
						}
						else if (loggedInUserService.productClicked == "menu.scanQRCode") {
							prehomeLoginVm.closePopupLogin();	
							loggedInUserService.productClicked = "";								
							loggedInUserService.isBiometricLogin = prehomeLoginVm.isBiometricLogin;								
							scanQRCode();
						}
						else if (loggedInUserService.productClicked == "receiveQR") {
							prehomeLoginVm.closePopupLogin();	
							loggedInUserService.productClicked = "";
							viewMyQrCode ();								
						}
						else if (loggedInUserService.productClicked == "createRetreiveUPI") {	
							prehomeLoginVm.closePopupLogin();								
							loggedInUserService.productClicked = "";
							prehomeLoginVm.goToSelectNumber();
						}
						else if(loggedInUserService.productClicked == 'paycontact'){
							prehomeLoginVm.closePopupLogin();
							loggedInUserService.productClicked = "";
							quickPayService.preAuthType = 'mpin';
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYMPINSUCCESS"));
							prehomeLoginVm.disableCommonClickStream = true;
							$state.go('menu.payToContactLanding');					
						}
						else if(loggedInUserService.productClicked == 'paybank'){
							prehomeLoginVm.closePopupLogin();
							loggedInUserService.productClicked = "";
							quickPayService.preAuthType = 'mpin';
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYMPINSUCCESS"));
							prehomeLoginVm.disableCommonClickStream = true;
							$state.go('menu.quickPayLanding');					
						}
						else if(loggedInUserService.productClicked == 'payContact_secondAuthentication'){		
							quickPayService.preAuthType = 'mpin';
							loggedInUserService.isSecondAuthCompleted = true;
							prehomeLoginVm.closePopupLogin();

							loggedInUserService.Accntamount = quickPayService.payToContactData.amount;
							loggedInUserService.AccntRemark = quickPayService.payToContactData.remark;
							
							loggedInUserService.productClicked = "";
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYMPINSUCCESS"));	
							prehomeLoginVm.disableCommonClickStream = true;					

							if(quickPayService.payToContactData.payment_type == 'account'){
								loggedInUserService.AccntPayeeName = quickPayService.payToContactData.name;
								loggedInUserService.AccntPayeeAcnt_number = quickPayService.payToContactData.account_number;
								loggedInUserService.isPaytoAccntSecondAuth = true;
								$state.go('menu.payToContactDetails');
							}else{
								loggedInUserService.fromPaytoContactNumb = quickPayService.fromPaytoContactNumb;
								loggedInUserService.isPaytoUpiContSecondAuth = true;
								$state.go('menu.payToContactUPIDetails');
							}
						
						} 
						else if(loggedInUserService.productClicked == 'payBank_secondAuthentication'){		
							quickPayService.preAuthType = 'mpin';
							loggedInUserService.isSecondAuthCompleted = true;
							prehomeLoginVm.closePopupLogin();
							loggedInUserService.productClicked = "";						
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYMPINSUCCESS"));
							prehomeLoginVm.disableCommonClickStream = true;					
							$state.go('menu.quickPayLanding');
						} 															
						else if(loggedInUserService.productClicked == 'setBiometric'){
							prehomeLoginVm.closePopupLogin();
							loggedInUserService.productClicked = "";
							$state.go('menu.quickPayBiometricSetUp',{goBackToState:3});				
						}
						else if(loggedInUserService.productClicked == 'Banners'){
							prehomeLoginVm.closePopupLogin();
							homeScreenService.isBackCheck = true;									
							if(prehomeLoginVm.bannerSelected.bannerSubject == "Farming") {							
								if (localStorage.getItem('customerlanguage')) {
									agriMandiService.selectLanguage = localStorage.getItem('customerlanguage').toLowerCase();
									loggedInUserService.productClicked = "";
									$state.go(prehomeLoginVm.bannerSelected.redirectionURL,{goBackToState:'menu.prehomeLoginRevamp'});
								}
								else {
									loggedInUserService.productClicked = "";
									$state.go('menu.selectLanguage');
								}
							} else{
								loggedInUserService.productClicked = "";
								$state.go(prehomeLoginVm.bannerSelected.redirectionURL,{goBackToState:'menu.prehomeLoginRevamp'});
							}				
						}								
						else if (loggedInUserService.productClicked == "menu.termsAndConditionsOutboundAnalytics") {
							prehomeLoginVm.redirectToFSSJourney();

						} else if(loggedInUserService.productClicked == "menu.goToMyInsurance"){									
							redirecturl = 'menu.accountOverviewMyBalance';
							homeScreenService.isInsuranceFlag = true;
							getAccountDetailsService.tabIndex.tabIndex = 4;        
							loggedInUserService.productClicked = "";
							$state.go(redirecturl);
						} else if (loggedInUserService.productClicked == "scanPay_secondAuthentication") {
							prehomeLoginVm.closePopupLogin();
							loggedInUserService.isSecondAuthCompleted = true;
							loggedInUserService.productClicked = "";
							$state.go('menu.payToVpa_Review');

						} else if(loggedInUserService.productClicked == "linkCard"){
							utilityService.showSpinner();
							linkCardService.getLinkedCards({}).then(function (response) {
								utilityService.hideSpinner();
								prehomeLoginVm.cardList = response.data.cards;
								if(prehomeLoginVm.cardList.length>0){
									homeScreenService.ishamburgerMenuRO = false;
									fTBeneficiaryService.isCreditCardFlag = true;
									getAccountDetailsService.setRewTab = true;
									getAccountDetailsService.tabIndex.tabIndex = 5;											
									$state.go('menu.accountOverviewMyBalance');
								}else{
									myBalanceService.LinkCreditCards();
								}
							},function (error) {
								utilityService.hideSpinner();
								utilityService.showErrorMessage(error.responseMessage);
							});

						} else {
							redirecturl = loggedInUserService.productClicked;
							loggedInUserService.productClicked = "";
							$state.go(redirecturl);
						}
					} else {
						internetBankingService.checkSession().then(function (data) {									
							utilityService.hideSpinner();							
							if (ompOffersService.fromOfferPage) {
								ompOffersService.fromOfferPage = false;
								var redirectPath = ompOffersService.redirectURL;
								$state.go(redirectPath);
							}
							else {
								prehomeLoginVm.setRedirection();
							}
							
						}, function (error) {							
							utilityService.hideSpinner();							
							if (ompOffersService.fromOfferPage) {
								ompOffersService.fromOfferPage = false;
								var redirectPath = ompOffersService.redirectURL;
								$state.go(redirectPath);
							}
							else {
								prehomeLoginVm.setRedirection();
							}							
						});
					}
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN"));
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_SUCCESS"));
				}, function (error) {							
					homeScreenService.isCustCalled = false;							
					$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
					clearMpin();
					$scope.eraseMpin();							
					if(loggedInUserService.productClicked == 'paycontact' || loggedInUserService.productClicked == 'payContact_secondAuthentication') {		
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYMPINFAIL"));
					} 
					else if(loggedInUserService.productClicked == 'paybank' || loggedInUserService.productClicked == 'payBank_secondAuthentication') {
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYMPINFAIL"));
					}
					else if(loggedInUserService.productClicked == "menu.scanQRCode" || loggedInUserService.productClicked == "scanPay_secondAuthentication"){				
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYMPINFAIL"));	
					}
					else if(loggedInUserService.productClicked == "receiveQR"){
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYMPINFAIL"));
					}
					else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YONOCASH_AUTHBYMPINFAIL"));
					}
					else {
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN"));
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
					}													
					if (error.responseCode == "SB001") {
						prehomeLoginVm.reloadApp(error.responseMessage, true);
					}
					else {
						utilityService.showErrorMessage(error.responseMessage);

					}
				});
			},
			function (error) {						
				clearMpin();
				$scope.eraseMpin();						
				utilityService.accessRestricted = "";
				utilityService.hideSpinner();
				if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
					return;
				}
				if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
					prehomeLoginVm.mPinAuthChallengeHandler.cancel();
				}						
				if(loggedInUserService.productClicked == 'paycontact' || loggedInUserService.productClicked == 'payContact_secondAuthentication') {		
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYMPINFAIL"));
				} 
				else if(loggedInUserService.productClicked == 'paybank' || loggedInUserService.productClicked == 'payBank_secondAuthentication') {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYMPINFAIL"));
				}
				else if(loggedInUserService.productClicked == "menu.scanQRCode" || loggedInUserService.productClicked == "scanPay_secondAuthentication"){				
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYMPINFAIL"));	
				}
				else if(loggedInUserService.productClicked == "receiveQR"){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYMPINFAIL"));
				}
				else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YONOCASH_AUTHBYMPINFAIL"));
				}
				else {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN"));
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
				}						
				if (error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client") {
					loggedInUserService.setMFPUrl(false);
					return;
				}
				utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));				
			});
		}
	}

	prehomeLoginVm.setRedirection = function () {
		if (!homeScreenService.setBannerRedirection) {
			$state.go('menu.homeScreen');
		}
		else {
			if ($scope.banners.isLanguageRequired == 'Y') {
				if (localStorage.getItem('customerlanguage')) {
					agriMandiService.selectLanguage = localStorage.getItem('customerlanguage').toLowerCase();
					$state.go($scope.banners.redirectionURL);
				}
				else {
					$state.go('menu.selectLanguage');
				}
			}
			else {
				$state.go($scope.banners.redirectionURL);
			}
		}
	}

    function connectServer() {
		try {
			var payload = {
				"data": cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey),
				"src": prehomeLoginVm.keystoreValue != "" ? cryptoService.encryptRSAWithPublicKey(prehomeLoginVm.keystoreValue, cryptoService.rsaPublicKey) : "",
			};
			utilityService.showSpinner();
			var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/saveCustomInformation", WLResourceRequest.POST, { timeout: 15000 });
			resourceRequest.send(payload).then(function (response) {
				utilityService.lastTimeStamp = new Date();
				response.responseText = utilityService.isJSON(response.responseText) ? JSON.parse(response.responseText) : JSON.parse(encryptionService.getAES256DecryptedData(response.responseText));
				if (response.responseText.responseCode == '0000') {						
					AdapterUtils.secretData = response.responseText.data.key;
					loggedInUserService.keyId = response.responseText.data.keyId;
					loggedInUserService.deviceIdForMpin = response.responseText.data.deviceId;
					loggedInUserService.upiPermissionKey = response.responseText.data.upiPermissionVal;
					loggedInUserService.billDeskUrl = response.responseText.data.billDeskUrl;
					loggedInUserService.sbiCollectUrl = response.responseText.data.sbiCollectUrl;
					utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
					loggedInUserService.isServerConnected = true;
					utilityService.hideSpinner();
					if (prehomeLoginVm.MPINLoginFlag) {
						prehomeLoginVm.loginWithMpin();
					} 
					else if (prehomeLoginVm.UserIdLoginFlag) {  
						prehomeLoginVm.loginWithUserName();
					}
				} else if (response.responseText.responseCode == '0001' || response.responseText.responseCode == '0002') {
					$scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
					loggedInUserService.isServerConnected = false;
					prehomeLoginVm.serverConnectErrorPopup(null);
					return;					
				} else if (response.responseText.responseCode == '0003' || response.responseText.responseCode == '0004') {
					$scope.err = response.responseText.responseCode + " : " + response.responseText.responseMessage;
					loggedInUserService.isServerConnected = false;
					prehomeLoginVm.serverConnectErrorPopup(null);
					return;
				}
			}, function (error) {
				if (error.errorCode == 'APPLICATION_DOES_NOT_EXIST') {
					$scope.err = error;
					prehomeLoginVm.showUpgradeMsg($scope.err);
				} else {
					$scope.err = utilityService.getServerExceptionMessage(error);
					prehomeLoginVm.serverConnectErrorPopup(null);
				}
				loggedInUserService.isServerConnected = false;
			});
		} catch (err) {
			$scope.err = constantConfig.adapter.SOMETHING_WENT_WRONG;
			loggedInUserService.isServerConnected = false;
			prehomeLoginVm.serverConnectErrorPopup(null);
		}
	}

    prehomeLoginVm.serverConnectErrorPopup = function (errorMsg) {
		if (prehomeLoginVm.MPINLoginFlag) {
			clearMpin();
			$scope.eraseMpin();
		}
		else {                             
			prehomeLoginVm.userName = "";
			prehomeLoginVm.password = "";
		}
		utilityService.hideSpinner();
		if (errorMsg == null || errorMsg == "" || errorMsg == '') {
			utilityService.showErrorMessage($scope.err);
		}
		else {
			utilityService.showErrorMessage(errorMsg);
		}
	};

	prehomeLoginVm.showUpgradeMsg = function (errormessage) {
		if (prehomeLoginVm.MPINLoginFlag) {
			clearMpin();
			$scope.eraseMpin();			
		} else {
			prehomeLoginVm.userName = "";
			prehomeLoginVm.password = "";
		}
		utilityService.hideSpinner();
		utilityService.showUpgradeMessage(errormessage);
	}

	$scope.doErase = function () {
		$scope.pinDotVisible[$scope.password.length] = false;
		$scope.password = $scope.password.slice(0, -1);
		if ($scope.password.length == 0) $scope.canErase = false;
		try {
			var pass = $scope.password;
			pass = pass.split("");
			prehomeLoginVm.first = pass[0] ? pass[0] : "";
			prehomeLoginVm.second = pass[1] ? pass[1] : "";
			prehomeLoginVm.third = pass[2] ? pass[2] : "";
			prehomeLoginVm.fourth = pass[3] ? pass[3] : "";
			prehomeLoginVm.fifth = pass[4] ? pass[4] : "";
			prehomeLoginVm.sixth = pass[5] ? pass[5] : "";
		} catch (err) { }
	}


	$scope.rightAction = function () {
		pinDotVisible[0] = false;
		pinDotVisible[1] = false;
		pinDotVisible[2] = false;
		pinDotVisible[3] = false;
		pinDotVisible[4] = false;
		pinDotVisible[5] = false;
	}

	$scope.showKeyboard = function () {		
		if(prehomeLoginVm.keyguardValue) {			
			$scope.keyboardVisible = true;
			prehomeLoginVm.lockPopupEnabled = false;
		} else {			
			prehomeLoginVm.openDeviceLockPopup();
		}		
	}	
	prehomeLoginVm.openDeviceLockPopup = function () {
		prehomeLoginVm.deviceLockPopup = $ionicPopup.show({
			templateUrl: 'pages/preHomeLogin/deviceLockErrorPopup.html',				
			title: 'deviceLockError',
			cssClass: 'dialog-prelogin',
			scope: $scope,
		});
		prehomeLoginVm.lockPopupEnabled = true;
	}

	
	$rootScope.hidekeypad = function ($event) {		
		switch ($event.target.className) {
			case "mpin1 activated":
			// code block

			case "mpin1":
			// code block

			case "digit-keyboard-key":
			// code block

			case "digit-keyboard-key-action ng-binding":
			// code block

			case "icon ion-record":
			// code block

			case "digit-keyboard-key activated":
			// code block

			case "icon ion-backspace":
			// code block

			case "mpin1 ng-pristine ng-untouched ng-valid ng-empty activated":
			// code block

			case "mpin1 ng-binding":
			// code block

			case "icon ion-eye-disabled login-eye-btn":
			// code block

			case "icon ion-eye login-eye-btn":
			// code block

			case "digit-keyboard-key-number":
				// code block
				if(prehomeLoginVm.keyguardValue) {
					if (!$scope.keyboardVisible) {
						$scope.showKeyboard();
					}
				}				
				break;
			default:
				// code block
				if ($scope.keyboardVisible) {
					$scope.hideKeyboard();
				}
				break;
		}
	}

	$scope.hideKeyboard = function () {		
		$scope.keyboardVisible = false;
	}

    $scope.eraseMpin = function () {
      $scope.doErase();
      $scope.doErase();
      $scope.doErase();
      $scope.doErase();
      $scope.doErase();
      $scope.doErase();
    }

	function clearMpin() {
		prehomeLoginVm.first = '';
		prehomeLoginVm.second = '';
		prehomeLoginVm.third = '';
		prehomeLoginVm.fourth = '';
		prehomeLoginVm.fifth = '';
		prehomeLoginVm.sixth = '';
	}
	/*End of Custom Keypad for MPIN - taken from existing userLoginController.js*/

	prehomeLoginVm.loginWithUserNameCheck = function () {		
		if (loggedInUserService.isServerConnected) {
			prehomeLoginVm.loginWithUserName();
		} else {
			connectServer();
		}
	}

	//Function used for Cards journey apply part
	function allowApplications(card) { 
		if(newCardService.getParams().applyCardName == ''){
			applyNowService.resetApplyForm();
			newCardService.setParams({ "applyCardType": card.cardType });
			newCardService.setParams({ "applyCardName": card.cardName });
			newCardService.setParams({ "applyPictureURL": card.pictureURL });
			newCardService.setParams({ "applyCardCategory": card.categoryName });

			applyNowService.getCities().then(function(response) {
				cardsService.errorLogger(response);
				cardsService.setParams({ "city": response.data.cities });
				cardsService.setParams({ 'pendingApplication': false });
				$state.go('menu.cardPersonalDetails1');
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			}); 
		}else{
			applyNowService.getCities().then(function(response) {
				cardsService.errorLogger(response);
				cardsService.setParams({ "city": response.data.cities });
				cardsService.setParams({ 'pendingApplication': false });
				$state.go('menu.cardPersonalDetails1');
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});            
		}        
    }
    //This method is called from redirectToFSSJourney function 
    prehomeLoginVm.getServerUrl = function () {
        var q = $q.defer();
        mutualFundsService.getServerUrl().then(function (data) {
            q.resolve(data);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    }

	//Function call for Outbound Analytics and centralized consent FSS journey redirection to various FSS Screens
	prehomeLoginVm.redirectToFSSJourney = function (){
		utilityService.showSpinner();
		var preLoginSelectedMenu = newCardService.getPreLoginSelectedMenu();
		var postLoginSelectedMenu = newCardService.getPostLoginSelectedMenu();
		//Adding below lines for Zero is Hero banner redirection in prelogin invest option
		customerInfoService.customer = customerInfoService.customerInfo;
		customerInfoService.customer.isPanAvailable = customerInfoService.customerInfo.panNumber;
		customerInfoService.customer.DOB = customerInfoService.customerInfo.dob;
		var termsAndConditionsOutboundAnalyticsData = newCardService.getTermsAndConditionsOutboundAnalyticsData;
		//Adding below code for centralised consent sprint 2 journey
		leadGenerationService.checkConsent().then(function(response){
			utilityService.hideSpinner();
			if(response.customerRecordExists == "false"){
				var redirecturl = loggedInUserService.productClicked;
				loggedInUserService.productClicked = "";
				$state.go(redirecturl, { data: termsAndConditionsOutboundAnalyticsData });
			}else{
				if(preLoginSelectedMenu == 'cards'){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "CC_START_NXT_BTN"));
					var card = termsAndConditionsOutboundAnalyticsData;
					utilityService.showSpinner();
					if(linkCardService.getAllowAppStatus() == ""){
						linkCardService.getPendingApplicationStatus({}).then(function(response) {
							cardsService.errorLogger(response);
							if (response.data) {
								if (response.data.allow == "false"){
									linkCardService.setAllowAppStatus(response.data);
									utilityService.hideSpinner();
									utilityService.enableShowErrorMessage(); 
									utilityService.showErrorMessage(response.data.allowMessage);   
									return false;       
								}
								else{
									linkCardService.setAllowAppStatus(response.data);
									allowApplications(card);
								}
							}
						},
						function(error) {
							utilityService.hideSpinner();
								allowApplications(card);
						});
					}
					else{
						if(linkCardService.getAllowAppStatus().allow == "false"){
							utilityService.hideSpinner();
							utilityService.enableShowErrorMessage(); 
							utilityService.showErrorMessage(linkCardService.getAllowAppStatus().allowMessage);   
							return false;       
						}
						else{
							utilityService.hideSpinner();
							allowApplications(card);
						}
					}
				}else if(preLoginSelectedMenu == 'invest'){
					loggedInUserService.productClicked = "";
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "MF_START_NXT_BTN"));
					newCardService.checkInvestNowClicked = 'True';
					$state.go('menu.fundDetails');
				}else if(preLoginSelectedMenu == 'myInvestment'){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "MF_START_NXT_BTN"));   
					myDreamsService.dreamId = "";   
					homeScreenService.ishamburgerMenuRO=false;
					homeScreenService.isInvestmentFlag = true;
					getAccountDetailsService.tabIndex.tabIndex=3;
					$state.go('menu.accountOverviewMyBalance');
				}else if(preLoginSelectedMenu == 'myInvestmentAllProducts'){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "MF_START_NXT_BTN"));
					$state.go('menu.Investments');
				}else if(preLoginSelectedMenu == 'know'){
					$state.go('menu.startInvesting');
				}else if(preLoginSelectedMenu == 'open'){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "DM_START_NXT_BTN"));
					openAccountService.setStatusOfOpenAccount(0);
					$state.go('menu.dematAndTradingAccount');
				}else if(preLoginSelectedMenu == 'linkDematAccount'){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "DM_START_NXT_BTN"));
					$state.go('menu.linkAccount');
				}else if(preLoginSelectedMenu == 'folio'){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "MF_START_NXT_BTN"));
					prehomeLoginVm.getServerUrl().then(function (_data) {
						prehomeLoginVm.URL = _data;
						prehomeLoginVm.panCard = prehomeLoginVm.URL.kycNo;
						if (prehomeLoginVm.panCard == '' || prehomeLoginVm.panCard == null || prehomeLoginVm.panCard == undefined) {
							$rootScope.isCreateFolio = 1;
							$rootScope.checkStatusPage = 1;
							$rootScope.kycCompliant = 0;
							$rootScope.kycNonCompliant = 0;
							$state.go('menu.KYC');
						} else {
							prehomeLoginVm.checkKycStatus();
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}else if(preLoginSelectedMenu == 'linkOrOpenNewAcc'){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "DM_START_NXT_BTN"));          
					myDreamsService.dreamId = "";
					homeScreenService.ishamburgerMenuRO=false;
					homeScreenService.isInvestmentFlag = true;
					getAccountDetailsService.tabIndex.tabIndex=3;
					$state.go('menu.accountOverviewMyBalance');
				}else if(postLoginSelectedMenu == 'goRinnRaksha'){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "LI_START_NXT_BTN"));
					$state.go('menu.rinnRaksha');
				}else if(postLoginSelectedMenu == 'goRinnRakshaGLI'){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "LI_START_NXT_BTN"));  
					$state.go('menu.rinnRaksha', {lifeGeneInsure : true});
				}else if(preLoginSelectedMenu == 'allMFSchemes'){
					$state.go('menu.mutualFundsList');
				}			
			}
		},function(error) {
			utilityService.hideSpinner();
			var redirecturl = loggedInUserService.productClicked;
			loggedInUserService.productClicked = "";
			$state.go(redirecturl, { data: termsAndConditionsOutboundAnalyticsData });
		});
	};

	//Login with Username and Password
	prehomeLoginVm.loginWithUserName = function () {

		if(utilityService.isAndroidPlatform() && registerWithSimService.isSimRegistration && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (prehomeLoginVm.isSimChanged || prehomeLoginVm.simList == undefined || prehomeLoginVm.simList.length == 0)){
			if(prehomeLoginVm.isSimChanged)
			{
				prehomeLoginVm.reloadApp(registerWithSimService.changedSimMsg, true);
			}			
			else if(prehomeLoginVm.simList == undefined || prehomeLoginVm.simList.length == 0)
				utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
			return;
		}
		prehomeLoginVm.userLoginErrorFlag = false;		
		prehomeLoginVm.validateUnameDetails();
		prehomeLoginVm.validatePDetails();
		if(prehomeLoginVm.unameValidated && prehomeLoginVm.pValidated){
			if (prehomeLoginVm.userName && prehomeLoginVm.password) {				
				utilityService.showSpinner();
				internetBankingService.getServiceIdAndKey().then(function (data) {
					loggedInUserService.keyIdINB = data.keyId;
					loggedInUserService.serviceIdINB = data.serviceId;
					loggedInUserService.finalSHA512Val = loggedInUserService.generateINBSHA512Val(prehomeLoginVm.userName, prehomeLoginVm.password);
					utilityService.hideSpinner();
					if (prehomeLoginVm.clickOn == 'view_balance')
						prehomeLoginVm.viewBalanceLogin();
					else
						prehomeLoginVm.userloginStart();
				}, function (error) {
					prehomeLoginVm.userName = '';
					prehomeLoginVm.password = '';
					utilityService.hideSpinner();
					if (prehomeLoginVm.clickOn == 'view_balance'){
						prehomeLoginVm.authFailure = true;
						if (error.responseMessage) {							
							quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { prehomeLoginVm.authFailure = false; });
						} else {							
							quickPayService.showAuthFailurePopup('error', constantConfig.adapter.CANNOT_PROCESS_NOW, '', '', 'OK', '', $scope, true, function () { prehomeLoginVm.authFailure = false; });
						}
					} else {
						if(loggedInUserService.productClicked == 'paycontact' || loggedInUserService.productClicked == 'payContact_secondAuthentication') {		
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYUSERNAMEFAIL"));
						} 
						else if(loggedInUserService.productClicked == 'paybank' || loggedInUserService.productClicked == 'payBank_secondAuthentication') {
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYUSERNAMEFAIL"));
						}
						else if(loggedInUserService.productClicked == "menu.scanQRCode" || loggedInUserService.productClicked == "scanPay_secondAuthentication"){				
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYUSERNAMEFAIL"));	
						}
						else if(loggedInUserService.productClicked == "receiveQR"){
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYUSERNAMEFAIL"));
						}
						else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YONOCASH_AUTHBYUSERNAMEFAIL"));
						}
						else {
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN"));
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
						}
						if (error.responseMessage) {
							utilityService.showErrorMessage(error.responseMessage);
						} else {
							utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
						}
					}				
				});
			}
		}		
	};

	prehomeLoginVm.userloginStart = function () {
		prehomeLoginVm.mPinAuthChallengeHandler.handleChallenge = function (challenge) {
			prehomeLoginVm.isChallenged = true;
			prehomeLoginVm.userName = '';
			prehomeLoginVm.password = '';
			utilityService.accessRestricted = "";
			utilityService.hideSpinner();
			if(loggedInUserService.productClicked == 'paycontact' || loggedInUserService.productClicked == 'payContact_secondAuthentication') {		
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYUSERNAMEFAIL"));
			} 
			else if(loggedInUserService.productClicked == 'paybank' || loggedInUserService.productClicked == 'payBank_secondAuthentication') {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYUSERNAMEFAIL"));
			}
			else if(loggedInUserService.productClicked == "menu.scanQRCode" || loggedInUserService.productClicked == "scanPay_secondAuthentication"){				
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYUSERNAMEFAIL"));	
			}
			else if(loggedInUserService.productClicked == "receiveQR"){
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYUSERNAMEFAIL"));
			}
			else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YONOCASH_AUTHBYUSERNAMEFAIL"));
			}
			else {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN"));
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
			}
			if (challenge.errorMsg !== null) {

				if (challenge.errorMsg.indexOf("2003:") !== -1) {
					challenge.errorMsg = challenge.errorMsg.replace("2003:", "");					
					loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false, "simSubscriptionId":""}').then(function (res) {
						localStorage.setItem('isDeviceRegistered', false);
						localStorage.setItem('mpinConsent', false);
						prehomeLoginVm.reloadApp(challenge.errorMsg);
					}, function (err) {
						localStorage.setItem('isDeviceRegistered', false);
						localStorage.setItem('mpinConsent', false);
						prehomeLoginVm.reloadApp(challenge.errorMsg);
					});
				} else if (challenge.errorMsg.indexOf("2005:") !== -1) {
					challenge.errorMsg = challenge.errorMsg.replace("2005:", "");
					prehomeLoginVm.reloadApp(challenge.errorMsg);
				} else if (challenge.errorCode == "M003" || challenge.errorCode == "LOCK.001") {
					if (challenge.errorCode == "LOCK.001") {
						inbLockUnlockService.challengeErrorCode = "LOCK.001";
					}
					inbLockUnlockService.displayErrorPopUp('<img class="inb-error-icon" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12">Your access has been locked.</p>',
						challenge.errorMsg, ["Cancel", "Unlock"], function () {
							// added comment to retain the existing code structure
						}, function () {
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
							var reqParams = {
								"deviceId": device.uuid
							}
							internetBankingService.fetchDetailsByDeviceID(reqParams).then(function (data) {								
								loggedInUserService.setInbUserId(data);
								prehomeLoginVm.closePopupLogin();
								$state.go('menu.inbUnlockAccessUserName');								
							}, function (error) {
								utilityService.showErrorMessage(error.responseMessage);
							});
						});
					return
				} else if (challenge.errorCode == "FP01") {
					utilityService.showForcePasswordPopup(challenge.errorMsg, "menu.prehomeLoginRevamp");
				} else if (challenge.errorCode == "SB001") {
					loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false, "simSubscriptionId":""}').then(function (res) {
						localStorage.setItem('isDeviceRegistered', false);
						localStorage.setItem('mpinConsent', false);
						prehomeLoginVm.reloadApp(challenge.errorMsg);
					}, function (err) {
						localStorage.setItem('isDeviceRegistered', false);
						localStorage.setItem('mpinConsent', false);
						prehomeLoginVm.reloadApp(challenge.errorMsg);
					});
				}
				else if (challenge.errorCode == "F001") {
					utilityService.showErrorMessage(challenge.errorMsg);
				}
				else {
					prehomeLoginVm.userLoginErrorMsg = challenge.errorMsg;
					prehomeLoginVm.userLoginErrorFlag = true;
					if(loggedInUserService.productClicked){
						removePopupClass();
						determinePopupClass();
						addPopupClass();
					}
				}
			} else {
				utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
			}			
		};

		prehomeLoginVm.mPinAuthChallengeHandler.handleSuccess = function (data) {
			prehomeLoginVm.isChallenged = false;
			if (data.user) {
				loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
				loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
				var userDetails = AdapterUtils.secretData == "" ? data.user.attributes.userDetails : encryptionService.getAES256DecryptedData(data.user.attributes.userDetails);
				if (data.user.attributes.sessionId && data.user.attributes.lotusId) {
					clickStreamService.sessionId = AdapterUtils.secretData == "" ? data.user.attributes.sessionId : encryptionService.getAES256DecryptedData(data.user.attributes.sessionId);
					clickStreamService.lotusId = AdapterUtils.secretData == "" ? data.user.attributes.lotusId : encryptionService.getAES256DecryptedData(data.user.attributes.lotusId);
				}
				loggedInUserService.setUserProfileDetails(JSON.parse(userDetails));
			}
		};

		prehomeLoginVm.mPinAuthChallengeHandler.handleFailure = function (error) {
				prehomeLoginVm.mPinAuthChallengeHandler.cancel();
				prehomeLoginVm.isChallenged = false;
			prehomeLoginVm.userName = '';
			prehomeLoginVm.password = '';
			utilityService.accessRestricted = "";
			utilityService.hideSpinner();
			if(loggedInUserService.productClicked == 'paycontact' || loggedInUserService.productClicked == 'payContact_secondAuthentication') {		
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYUSERNAMEFAIL"));
			} 
			else if(loggedInUserService.productClicked == 'paybank' || loggedInUserService.productClicked == 'payBank_secondAuthentication') {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYUSERNAMEFAIL"));
			}
			else if(loggedInUserService.productClicked == "menu.scanQRCode" || loggedInUserService.productClicked == "scanPay_secondAuthentication"){				
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYUSERNAMEFAIL"));	
			}
			else if(loggedInUserService.productClicked == "receiveQR"){
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYUSERNAMEFAIL"));
			}
			else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YONOCASH_AUTHBYUSERNAMEFAIL"));
			}
			else {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN"));
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
			}
			if (error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client") {
				loggedInUserService.setMFPUrl(false);
				return;
			}
			if (error.failure) {
				utilityService.showErrorMessage(error.failure);
			} else {
				utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
			}			
		}

		var payload = {};
		var hasedSimInfo = "";
		if (utilityService.isAndroidPlatform()) {
			hasedSimInfo = prehomeLoginVm.hasedSimInfo;
		}
		var requestParams = {
			"userName": prehomeLoginVm.userName,
			"sha512Password": loggedInUserService.finalSHA512Val,
			"bankCode": "0",
			"osName": device.platform,
			"channel": "lotus",
			"serviceId": loggedInUserService.serviceIdINB,
			"referralMobNo": "",
			"mfDeviceId": loggedInUserService.deviceIdForMpin,
			"id": loggedInUserService.deviceInfo,
			"isRegister": "false",
			"simId": hasedSimInfo.toString()
		};
		var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
		payload = {
			"data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
			"src": src
		}
		payload = AdapterUtils.secretData == "" ? requestParams : payload;
		if (prehomeLoginVm.isChallenged) {
			prehomeLoginVm.mPinAuthChallengeHandler.submitChallengeAnswer(payload);
		} else {
			WLAuthorizationManager.login(prehomeLoginVm.mPinAuthChallengeHandler.securityCheckName, payload).then(function (data) {
				utilityService.accessRestricted = utilityService.mPinAuthRequire;					
				utilityService.csatJournies = [];
				homeScreenService.isCustCalled = true;
				quickPayService.getCustomerInfo().then(function (data1) {
					mPinLoginService.isLoggedIn = true;
					getAccountDetailsService.accountOverviewData = data1;
					homeScreenService.isCustCalled = false;
					customerInfoService.customerInfo = data1.customerInformation;
					customerInfoService.customer = data1.customerInformation;
					customerInfoService.customer.name = data1.customerInformation.customerName;
					quickPayService.customerInfo = getAccountDetailsService.accountOverviewData;
					if (loggedInUserService.productClicked) {
						var redirecturl;
						if (loggedInUserService.productClicked == "menu.cardIntroduction") {
							cardCompareService.getShikharEligibilityCheck().then(function (response) {
								cardCompareService.shikharFlag = response.data.shikharFlag;
								if (cardCompareService.shikharFlag || cardCompareService.shikharFlag == "true") {
									redirecturl = 'menu.shikharCards';
									loggedInUserService.productClicked = "";
									$state.go(redirecturl);
								} else {
									redirecturl = loggedInUserService.productClicked;
									loggedInUserService.productClicked = "";
									$state.go(redirecturl);
								}
							}, function (error) {
								redirecturl = loggedInUserService.productClicked;
								loggedInUserService.productClicked = "";
								$state.go(redirecturl);
							})
						}
						else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
									prehomeLoginVm.closePopupLogin();
									loggedInUserService.productClicked = "";	
									$state.go("menu.yonoCash");	
									homeScreenService.preLoginYonoCash=false;
						}

						else if (loggedInUserService.productClicked == "menu.scanQRCode") {
							prehomeLoginVm.closePopupLogin();								
							loggedInUserService.isBiometricLogin = prehomeLoginVm.isBiometricLogin;
							loggedInUserService.productClicked = "";								
							scanQRCode();
						}
						else if (loggedInUserService.productClicked == "receiveQR") {
							prehomeLoginVm.closePopupLogin();	
							loggedInUserService.productClicked = "";
							viewMyQrCode ();								
						}
						else if (loggedInUserService.productClicked == "createRetreiveUPI") {	
							prehomeLoginVm.closePopupLogin();								
							loggedInUserService.productClicked = "";
							prehomeLoginVm.goToSelectNumber();
						}
						else if(loggedInUserService.productClicked == 'paycontact'){
							prehomeLoginVm.closePopupLogin();
							quickPayService.preAuthType = 'userName';
							loggedInUserService.productClicked = "";
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYUSERNAMESUCCESS"));
							prehomeLoginVm.disableCommonClickStream = true;
							$state.go('menu.payToContactLanding');
						}
						else if(loggedInUserService.productClicked == 'paybank'){
							prehomeLoginVm.closePopupLogin();
							quickPayService.preAuthType = 'userName';
							loggedInUserService.productClicked = "";
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYUSERNAMESUCCESS"));
							prehomeLoginVm.disableCommonClickStream = true;
							$state.go('menu.quickPayLanding');
						}
						else if(loggedInUserService.productClicked == 'payContact_secondAuthentication'){		
							quickPayService.preAuthType = 'userName';
							loggedInUserService.isSecondAuthCompleted = true;
							prehomeLoginVm.closePopupLogin();
							loggedInUserService.productClicked = "";

							loggedInUserService.Accntamount = quickPayService.payToContactData.amount;
							loggedInUserService.AccntRemark = quickPayService.payToContactData.remark;
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYUSERNAMESUCCESS"));
							prehomeLoginVm.disableCommonClickStream = true;

							if(quickPayService.payToContactData.payment_type == 'account'){
								loggedInUserService.AccntPayeeName = quickPayService.payToContactData.name;
								loggedInUserService.AccntPayeeAcnt_number = quickPayService.payToContactData.account_number;
								loggedInUserService.isPaytoAccntSecondAuth = true;
								$state.go('menu.payToContactDetails');
							}else{
								loggedInUserService.fromPaytoContactNumb = quickPayService.fromPaytoContactNumb;
								loggedInUserService.isPaytoUpiContSecondAuth = true;
								$state.go('menu.payToContactUPIDetails');
							}
							
						}
						else if( loggedInUserService.productClicked == 'payBank_secondAuthentication'){		
							quickPayService.preAuthType = 'userName';
							loggedInUserService.isSecondAuthCompleted = true;
							prehomeLoginVm.closePopupLogin();
							loggedInUserService.productClicked = "";
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYUSERNAMESUCCESS"));
							prehomeLoginVm.disableCommonClickStream = true;
							$state.go('menu.quickPayLanding');
						}
						else if(loggedInUserService.productClicked == 'setBiometric'){
							prehomeLoginVm.closePopupLogin();
							loggedInUserService.productClicked = "";
							$state.go('menu.quickPayBiometricSetUp',{goBackToState:3});
				
						}
						else if(loggedInUserService.productClicked == 'Banners'){
							prehomeLoginVm.closePopupLogin();
							homeScreenService.isBackCheck = true;								
							if(prehomeLoginVm.bannerSelected.bannerSubject == "Farming") {
								
								if (localStorage.getItem('customerlanguage')) {
									agriMandiService.selectLanguage = localStorage.getItem('customerlanguage').toLowerCase();
									loggedInUserService.productClicked = "";
									$state.go(prehomeLoginVm.bannerSelected.redirectionURL,{goBackToState:'menu.prehomeLoginRevamp'});
								}
								else {
									loggedInUserService.productClicked = "";
									$state.go('menu.selectLanguage');
								}	
							}
							else{
								loggedInUserService.productClicked = "";
								$state.go(prehomeLoginVm.bannerSelected.redirectionURL,{goBackToState:'menu.prehomeLoginRevamp'});
							}				
						}			
						else if (loggedInUserService.productClicked == "menu.termsAndConditionsOutboundAnalytics") {								
							prehomeLoginVm.redirectToFSSJourney();
						
						} else if(loggedInUserService.productClicked == "menu.goToMyInsurance"){									
							redirecturl = 'menu.accountOverviewMyBalance';
							homeScreenService.isInsuranceFlag = true;
							getAccountDetailsService.tabIndex.tabIndex = 4;        
							loggedInUserService.productClicked = "";
							$state.go(redirecturl);
						} else if (loggedInUserService.productClicked == "scanPay_secondAuthentication") {
							prehomeLoginVm.closePopupLogin();	
							loggedInUserService.productClicked = "";
							loggedInUserService.isSecondAuthCompleted = true;							
							$state.go('menu.payToVpa_Review');							
						
						}else if(loggedInUserService.productClicked == "linkCard"){
							utilityService.showSpinner();
							//added below code for centralised journey
								linkCardService.getLinkedCards({}).then(function (response) {
									utilityService.hideSpinner();
									prehomeLoginVm.cardList = response.data.cards;
									if(prehomeLoginVm.cardList.length>0){
										homeScreenService.ishamburgerMenuRO = false;
										fTBeneficiaryService.isCreditCardFlag = true;
										getAccountDetailsService.setRewTab = true;
										getAccountDetailsService.tabIndex.tabIndex = 5;
										$state.go('menu.accountOverviewMyBalance');
									}else{
										myBalanceService.LinkCreditCards();
									}
								},function (error) {
									utilityService.hideSpinner();
									utilityService.showErrorMessage(error.responseMessage);
								});
								
						} else {
							redirecturl = loggedInUserService.productClicked;
							loggedInUserService.productClicked = "";
							$state.go(redirecturl);
						}

					} else {
						internetBankingService.checkSession().then(function (data) {								
							utilityService.hideSpinner();
							if (ompOffersService.fromOfferPage) {
								ompOffersService.fromOfferPage = false;
								var redirectPath = ompOffersService.redirectURL;
								$state.go(redirectPath);
							}
							else {
								prehomeLoginVm.setRedirection();
							}
							//notification changes ends
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN_MOB"));
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_SUCCESS_MOB"));
						}, function (error) {								
							utilityService.hideSpinner();
							//notiiiii changes starts
							if (ompOffersService.fromOfferPage) {
								ompOffersService.fromOfferPage = false;
								var redirectPath = ompOffersService.redirectURL;
								$state.go(redirectPath);
							}
							else {
								prehomeLoginVm.setRedirection();
							}
							//notiii changes ends
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN_MOB"));
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_SUCCESS_MOB"));
						});
					}
				}, function (error) {
					homeScreenService.isCustCalled = false;						
					$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
					prehomeLoginVm.userName = '';
					prehomeLoginVm.password = '';
					if(loggedInUserService.productClicked == 'paycontact' || loggedInUserService.productClicked == 'payContact_secondAuthentication') {		
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYUSERNAMEFAIL"));
					} 
					else if(loggedInUserService.productClicked == 'paybank' || loggedInUserService.productClicked == 'payBank_secondAuthentication') {
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYUSERNAMEFAIL"));
					}
					else if(loggedInUserService.productClicked == "menu.scanQRCode" || loggedInUserService.productClicked == "scanPay_secondAuthentication"){				
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYUSERNAMEFAIL"));	
					}
					else if(loggedInUserService.productClicked == "receiveQR"){
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYUSERNAMEFAIL"));
					}
					else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YONOCASH_AUTHBYUSERNAMEFAIL"));
					}
					else {
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN"));
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
					}
					if (error.responseCode === "SB001") {
						prehomeLoginVm.reloadApp(error.responseMessage, true);
					}
					else if (error.errorCode === "F001") {
						registerWithSimService.reloadAppSimBinding(error.responseMessage);
					}
					else {
						utilityService.showErrorMessage(error.responseMessage);

					}
				});
			},
			function (error) {
				prehomeLoginVm.userName = '';
				prehomeLoginVm.password = '';
				utilityService.accessRestricted = "";
				utilityService.hideSpinner();
				if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
					return;
				}
				if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
					prehomeLoginVm.mPinAuthChallengeHandler.cancel();
				}					
				if(loggedInUserService.productClicked == 'paycontact' || loggedInUserService.productClicked == 'payContact_secondAuthentication') {		
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYUSERNAMEFAIL"));
				} 
				else if(loggedInUserService.productClicked == 'paybank' || loggedInUserService.productClicked == 'payBank_secondAuthentication') {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYUSERNAMEFAIL"));
				}
				else if(loggedInUserService.productClicked == "menu.scanQRCode" || loggedInUserService.productClicked == "scanPay_secondAuthentication"){				
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYUSERNAMEFAIL"));	
				}
				else if(loggedInUserService.productClicked == "receiveQR"){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYUSERNAMEFAIL"));
				}
				else if (loggedInUserService.productClicked == "menu.yonoCashLanding") {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YONOCASH_AUTHBYUSERNAMEFAIL"));
				}
				else {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN"));
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE"));
				}
				if (error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client") {
					loggedInUserService.setMFPUrl(false);
					return;
				}
				utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
			});
		}
	}

	//Reload App
	prehomeLoginVm.reloadApp = function (message, sbFlag) {
		prehomeLoginVm.mPinAuthChallengeHandler.cancel();
		prehomeLoginVm.isChallenged = false;
		if (sbFlag) {
			registerWithSimService.reloadAppSimOk(message);
		}
		else {
			if (utilityService.isAndroidPlatform()) {
				var reloadPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">' + message + '</div>',
					scope: '',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							reloadPopup.close();
							loggedInUserService.logoutUser();
						}
					}, {
						text: 'Exit',
						type: 'button-assertive',
						onTap: function () {
							reloadPopup.close();
							loggedInUserService.logoutUser('exitApplication');
						}
					}],
				});
			} else {
				var reloadPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">' + message + '</div>',
					scope: '',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							reloadPopup.close();
							loggedInUserService.logoutUser();
						}
					}],
				});
			}
		}
	}

	prehomeLoginVm.resetTimeStamp = function () {
		prehomeLoginVm.userLoginErrorFlag = false;		
		if (!utilityService.lastTimeStamp) {
			utilityService.lastTimeStamp = new Date();
		} else {
			var diff = Math.ceil(((new Date()) - utilityService.lastTimeStamp) / 60000);
			if (diff > constantConfig.SBITIMEOUT) {
				prehomeLoginVm.reloadApp(constantConfig.adapter.SESSION_INACTIVITY);
				return true;
			}
		}
	}
	prehomeLoginVm.validateNull  = function (userData) {
		var returnState;
		if(userData == "" || userData == undefined || userData == null){
			returnState = true;
		}
		else{
			returnState = false;
		}
		return returnState;
	}

	prehomeLoginVm.validateUnameDetails = function () {

		$scope.regex = /^[A-Za-z0-9_.#-]*$/;
		prehomeLoginVm.userNameNull = prehomeLoginVm.validateNull(prehomeLoginVm.userName);
		if(prehomeLoginVm.userNameNull){
			prehomeLoginVm.unameError = true;
			prehomeLoginVm.unameValidated = false;
			prehomeLoginVm.unamePatternError = false;
			prehomeLoginVm.inputFieldFocus(true);
		}
		else{
			if(prehomeLoginVm.userName.length > 30){
				prehomeLoginVm.unamePatternError = true;
				prehomeLoginVm.unameValidated = false;
				prehomeLoginVm.unameError = false;
				prehomeLoginVm.inputFieldFocus(true);
			}
			else{
				if(prehomeLoginVm.userName.match($scope.regex)){
					prehomeLoginVm.unamePatternError = false;
					prehomeLoginVm.unameValidated = true;
					prehomeLoginVm.unameError = false;
				}
				else{
					prehomeLoginVm.unamePatternError = true;
					prehomeLoginVm.unameValidated = false;
					prehomeLoginVm.unameError = false;
					prehomeLoginVm.inputFieldFocus(true);
				}
			}
		}	
	}

	prehomeLoginVm.validatePDetails = function () {
		prehomeLoginVm.pNull = prehomeLoginVm.validateNull(prehomeLoginVm.password);	
		if(prehomeLoginVm.pNull){
			prehomeLoginVm.pError = true;
			prehomeLoginVm.pValidated = false;
			prehomeLoginVm.inputFieldFocus(true);

		}
		else{
			prehomeLoginVm.pError = false;
			prehomeLoginVm.pValidated = true;
		}		
	}

	prehomeLoginVm.clearAllData = function(){
		prehomeLoginVm.userName = '';
		prehomeLoginVm.password = '';		
		clearMpin();
		$scope.eraseMpin();
		clearViewBalanceVariables();						
		prehomeLoginVm.userLoginErrorFlag = false;	
		prehomeLoginVm.unameError = false;	
		prehomeLoginVm.unamePatternError = false;	
		prehomeLoginVm.pError = false;	
		prehomeLoginVm.mpinErrorMsgFlag = false;		
		prehomeLoginVm.loginVia = '';
		//Inserted to reset the login option
		if((prehomeLoginVm.UserIdLoginFlag && prehomeLoginVm.userType == 'B')|| (prehomeLoginVm.UserIdLoginFlag && prehomeLoginVm.userType == 'D')){
			prehomeLoginVm.UserIdLoginFlag = false;
			prehomeLoginVm.MPINLoginFlag = true;				
		}
	}

	/*-------------------------View Balance functions----------------------------*/
	prehomeLoginVm.goToViewBalance = function ($event) {
		loggedInUserService.shopNOrderPre=''; //Reset OMP value after login  
		loggedInUserService.shopNOrderPreHash="";
		localStorage.setItem('isRedirectedTowdsLoan', "");
		localStorage.setItem('redirectOnlyFlow', "");
		prehomeLoginVm.clickOn = 'view_balance';		
		prehomeLoginVm.openLoginoption = false;
		prehomeLoginVm.lockPopupEnabled = false;
		prehomeLoginVm.clearAllData();

		if (!prehomeLoginVm.viewbalAvl && (prehomeLoginVm.userType == 'C' || prehomeLoginVm.userType == 'D')) {				
			if(prehomeLoginVm.isFingerprintAvl){
				var fingerprintToken = "";
				cordova.plugins.SecureKeyStore.get(function (res) {
				fingerprintToken = res;
				if (fingerprintToken == null || fingerprintToken == "null" || fingerprintToken == undefined || fingerprintToken == "undefined" || fingerprintToken == "") {
					prehomeLoginVm.isFingerprintAvl = false;
					prehomeLoginVm.viewBalanceLoginScreen = true;
				}
				else {
					prehomeLoginVm.isFingerprintAvl = true;
					clearViewBalanceVariables();					
					//to auto populate fingerprint option
					prehomeLoginVm.checkBiometric($event);
				}
				}, function (error) {
					// added comment to retain the existing code structure
				}, loggedInUserService.deviceInfo);
			}
			else{
				prehomeLoginVm.viewBalanceLoginScreen = true;
			}					
		}
		if (!prehomeLoginVm.viewbalAvl && (prehomeLoginVm.userType == 'A' || prehomeLoginVm.userType == 'B')) {	
			prehomeLoginVm.viewBalanceLoginScreen = true;			
		}
	}

	prehomeLoginVm.viewBalanceLogin = function () {
		
		var hasedSimInfo = "";
		if(utilityService.isAndroidPlatform()){
			hasedSimInfo = prehomeLoginVm.hasedSimInfo;
		}		
		var requestParams = {
			"userName": prehomeLoginVm.userName,
			"sha512Password": loggedInUserService.finalSHA512Val,
			"type" : "username",
			"simId": hasedSimInfo.toString()			
		};
		  
		quickPayService.userAuthentication(requestParams).then(function (data) {
		  clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYUSERNAMESUCCESS"));
		  $scope.hideKeyboard();
		  prehomeLoginVm.userName = "";
		  prehomeLoginVm.password = "";
  
		  afterUserAuthSuccess(data);
		}, function (error) {
		  prehomeLoginVm.authFailure = true;
		  clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYUSERNAMEFAIL"));
		  if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
			prehomeLoginVm.authFailure = false;
			utilityService.showForcePasswordPopup(error.responseMessage,"");
		  }else{
			quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { prehomeLoginVm.authFailure = false; });
		  }
  
		});
	}

	function clearViewBalanceVariables() {
		prehomeLoginVm.viewBalanceLoginScreen = false;
		prehomeLoginVm.viewbalAvl = false;
		
		prehomeLoginVm.loginVia = '';
	}
	
	$scope.slideHasChanged = function (index) {
		$scope.currentSlide = index;      
		//mpassbook related functionality added by GOC, Hyderabad
		$scope.slideIndex = index;
		mpassbookdetailsService.selectedACNo = prehomeLoginVm.accountList[$scope.slideIndex].accountNumber;
		mpassbookdetailsService.branchCode = prehomeLoginVm.accountList[$scope.slideIndex].branchCode;
		// end of mpassbook functionality
	}

	$scope.goNext = function (index) {
		$ionicSlideBoxDelegate.$getByHandle('slide-viewBalance').next();
		//mpassbook related functionality added by GOC, Hyderabad
	   	mpassbookdetailsService.selectedACNo = prehomeLoginVm.accountList[$scope.slideIndex].accountNumber;
		mpassbookdetailsService.branchCode = prehomeLoginVm.accountList[$scope.slideIndex].branchCode;
		$scope.currentSlide = $scope.slideIndex;
		// end of mpassbook functionality
	}

	$scope.goPrev = function (index) {
	$ionicSlideBoxDelegate.$getByHandle('slide-viewBalance').previous();
	//mpassbook related functionality added by GOC, Hyderabad	   
	mpassbookdetailsService.selectedACNo = prehomeLoginVm.accountList[$scope.slideIndex].accountNumber;
	mpassbookdetailsService.branchCode = prehomeLoginVm.accountList[$scope.slideIndex].branchCode;
	$scope.currentSlide = $scope.slideIndex;
	// end of mpassbook functionality  
	}

	prehomeLoginVm.goMpassbook = function (index) {
		mpassbookdetailsService.goBackToState = "menu.prehomeLoginRevamp";
		$state.go('menu.mpassbookdetails');		
	}

	prehomeLoginVm.viewBalClose = function ($event) {
		clearViewBalanceVariables();
		//to stop click event of outer div
		$event.stopPropagation();
	};

	/**************************** Icons functionality with login **************/
	prehomeLoginVm.goToQuickPay = function (type, $event) {
		loggedInUserService.shopNOrderPre=''; //Reset OMP value after login 
		loggedInUserService.shopNOrderPreHash=""; 
		localStorage.setItem('isRedirectedTowdsLoan', "");
		localStorage.setItem('redirectOnlyFlow', "");
		if(type == 'contact'){
			prehomeLoginVm.clickOn = 'pay_contact';
			prehomeLoginVm.productClicked = "paycontact";
			loggedInUserService.productClicked = "paycontact";
			loggedInUserService.qpayType = "paycontact";

		} else if (type == 'bank') {
			prehomeLoginVm.clickOn = 'pay_bank';
			prehomeLoginVm.productClicked = "paybank";
			loggedInUserService.productClicked = "paybank";
			loggedInUserService.qpayType = "paybank";
		} 
		loggedInUserService.payEventCaptured = $event;
		loggedInUserService.launchPageTxn = true;		
		initiateBiometric($event); //Inserted to have common login flow for quickpay & scanpay				
	}	

	function initiateBiometric($event){		
		prehomeLoginVm.isBiometricLogin = false;
		if(prehomeLoginVm.isFingerprintAvl){
			var fingerprintToken = "";
			cordova.plugins.SecureKeyStore.get(function (res) {
			fingerprintToken = res;
			if (fingerprintToken == null || fingerprintToken == "null" || fingerprintToken == undefined || fingerprintToken == "undefined" || fingerprintToken == "") {
				prehomeLoginVm.isFingerprintAvl = false;
			}
			else {
				prehomeLoginVm.isFingerprintAvl = true;
				//to auto populate fingerprint option
				prehomeLoginVm.checkBiometric($event);				  
			}
			}, function (error) {
				// added comment to retain the existing code structure
			}, loggedInUserService.deviceInfo);
		}
		else{				
			prehomeLoginVm.clearAllData();			
			prehomeLoginVm.isBiometricLogin = false;	
			$scope.openPopover($event);
			prehomeLoginVm.popoverBackdrop();
		}				
	}

	prehomeLoginVm.checkBiometric = function ($event) {

		if (quickPayService.isFingerprintAviFlag && !prehomeLoginVm.authfailure) {
			var encryptConfig = {
			clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
			clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
			disableBackup: true,
			};
			Fingerprint.show(encryptConfig, successCallback, errorCallback);
		}
	}

	function successCallback(result) {		
		prehomeLoginVm.isBiometricLogin = true;
		authByBiometric();	
	}
  
	function authByBiometric() { 
		loggedInUserService.productClicked = ""; 	// Inserted to clear login type after successful biometric authentication
		if(utilityService.isAndroidPlatform() && registerWithSimService.isSimRegistration && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (prehomeLoginVm.isSimChanged || prehomeLoginVm.simList == undefined || prehomeLoginVm.simList.length == 0)){
			if(prehomeLoginVm.isSimChanged)
			{
				registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
			}
			else if(prehomeLoginVm.simList == undefined || prehomeLoginVm.simList.length == 0)
				utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
			return;
		}
		var hasedSimInfo = "";
		if(utilityService.isAndroidPlatform()){
			hasedSimInfo = prehomeLoginVm.hasedSimInfo;
		}
		if(prehomeLoginVm.clickOn == 'view_balance'){
			var params = { 'type': 'biometric', "simId": hasedSimInfo.toString() };
			//call service to retrieve token at adapter
			quickPayService.userAuthentication(params).then(function (data) {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYBIOSUCCESS"));			
				afterUserAuthSuccess(data);
			}, function (error) {
				prehomeLoginVm.authFailure = true;
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYBIOFAIL"));
				if(error.responseCode == "SB001" || error.responseCode == "F001"){
					registerWithSimService.reloadAppSimOk(error.responseMessage);
				}
				else if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
					prehomeLoginVm.authFailure = false;
					utilityService.showForcePasswordPopup(error.responseMessage,"");
				}else{
					quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { prehomeLoginVm.authFailure = false; });
				}	
			});
		}
		else if(prehomeLoginVm.clickOn == 'pay_contact' ||  prehomeLoginVm.clickOn == 'pay_bank'|| prehomeLoginVm.clickOn == 'scanpay' || prehomeLoginVm.clickOn == "receiveQR"){
			var params = {};
			params = { 'type': 'biometric', "simId": hasedSimInfo.toString() };
            //call service to retrieve token at adapter
            quickPayService.userAuthentication(params).then(function (data) {
                quickPayService.preAuthType = 'biometric';
                afterUserAuthSuccess(data);
            }, function (error) {
				prehomeLoginVm.authFailure = true;
			if(prehomeLoginVm.clickOn == 'pay_contact') {		
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYBIOFAIL"));
			} 
			else if(prehomeLoginVm.clickOn == 'pay_bank') {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYBIOFAIL"));
			}
			else if(prehomeLoginVm.clickOn == 'scanpay'){				
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYBIOFAIL"));	
			}
			else if(prehomeLoginVm.clickOn == 'receiveQR'){
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYBIOFAIL"));
			}				
				if(error.responseCode == "SB001" || error.responseCode == "F001"){
					registerWithSimService.reloadAppSimOk(error.responseMessage);
				}
				else if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
					prehomeLoginVm.authFailure = false;
					utilityService.showForcePasswordPopup(error.responseMessage,"");
				}else{
					quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { prehomeLoginVm.authFailure = false; });
				}
            });
		} 		
	}

	function errorCallback(error,$event) {
		if(prehomeLoginVm.clickOn == 'view_balance'){
			prehomeLoginVm.viewBalanceLoginScreen = true;			
		}
		else if(prehomeLoginVm.clickOn == 'pay_contact' ||  prehomeLoginVm.clickOn == 'pay_bank' || prehomeLoginVm.clickOn == 'scanpay' || prehomeLoginVm.clickOn == "receiveQR"){					
			prehomeLoginVm.clearAllData();			
			prehomeLoginVm.isBiometricLogin = false;		
			if(prehomeLoginVm.clickOn == 'pay_contact') {		
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYBIOFAIL"));		
				$scope.openPopover(loggedInUserService.payEventCaptured);
			} 
			else if(prehomeLoginVm.clickOn == 'pay_bank') {
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYBIOFAIL"));
				$scope.openPopover(loggedInUserService.payEventCaptured);
			}
			else if(prehomeLoginVm.clickOn == 'scanpay'){
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYBIOFAIL"));		
				$scope.openPopover(loggedInUserService.scanPayEventCaptured);
			}
			else if(prehomeLoginVm.clickOn == 'receiveQR'){
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYBIOFAIL"));
				$scope.openPopover(loggedInUserService.receiveQREventCaptured);
			}			
			prehomeLoginVm.popoverBackdrop();			
		}
	}

	function afterUserAuthSuccess(data, $event) {
		if (data) {
			quickPayService.customerInfo = data;
			quickPayService.yqpBiometricLimit = quickPayService.customerInfo.yqpBiometricLimit;
			quickPayService.yqpVpaLimit = quickPayService.customerInfo.yqpVpaLimit;
			quickPayService.yqpBeneficiaryLimit = quickPayService.customerInfo.yqpBeneficiaryLimit;
			quickPayService.yqpRaiseRequestLimit = quickPayService.customerInfo.yqpRaiseRequestLimit;
			localStorage.setItem('customerImageId', quickPayService.customerInfo.customerInformation.imageUrl);
		}		

		var customerInfo = quickPayService.customerInfo;
		

		if (prehomeLoginVm.clickOn == 'view_balance') {
			prehomeLoginVm.accountList = customerInfo.accounts;
			prehomeLoginVm.showSliderArrow = (prehomeLoginVm.accountList.length > 1) ?true : false;
			//mpassbook related functionality added by GOC, Hyderabad
			$scope.slideIndex = 0;
			mpassbookdetailsService.selectedACNo = "";
			mpassbookdetailsService.branchCode = "";
			mpassbookdetailsService.goBackToState = "";
			mpassbookdetailsService.selectedACNo = prehomeLoginVm.accountList[0].accountNumber;
			mpassbookdetailsService.branchCode = prehomeLoginVm.accountList[0].branchCode;
			//end of mpassbook functionality			
			prehomeLoginVm.viewbalAvl = true;
				
		}
		else if (prehomeLoginVm.clickOn == 'pay_contact'){
					
			loggedInUserService.isBiometricLogin = prehomeLoginVm.isBiometricLogin;	
			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYCONTACT_AUTHBYBIOSUCCESS"));
			$state.go('menu.payToContactLanding');		
		}
		else if (prehomeLoginVm.clickOn == 'pay_bank'){
					
			loggedInUserService.isBiometricLogin = prehomeLoginVm.isBiometricLogin;	
			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_PAYBANK_AUTHBYBIOSUCCESS"));
			$state.go('menu.quickPayLanding');		
		}
		else if (prehomeLoginVm.clickOn == 'scanpay'){
			loggedInUserService.isBiometricLogin = prehomeLoginVm.isBiometricLogin;			
			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_SCANPAY_AUTHBYBIOSUCCESS"));
			scanQRCode();
		}
		else if (prehomeLoginVm.clickOn == "receiveQR") {	
			customerInfoService.customer.name = quickPayService.customerInfo.customerInformation.customerName;		
			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_RECEIVEQR_AUTHBYBIOSUCCESS"));
			viewMyQrCode ();								
		}
	}

	// Scan & Pay and Receive Money Functionalities before login/authentication.
	prehomeLoginVm.redirectToBharatQR = function (qrType, $event) {
		prehomeLoginVm.qrType = qrType;
		utilityService.showSpinner();
		if (!localStorage.getItem("appGenId")) {
			bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
				if (device.platform.toLowerCase() == 'android') {
					bhimUpiService.appGenId = data.appGenId;
				} else {
					bhimUpiService.appGenId = data;
				}
				prehomeLoginVm.redirectToBharatQrFlow($event);
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		} else {
			bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {			
				prehomeLoginVm.redirectToBharatQrFlow($event);
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}		
	}

	prehomeLoginVm.redirectToBharatQrFlow = function ($event) {
		if (device.platform.toLowerCase() == 'android') {
			utilityService.showSpinner();
			var json = JSON.stringify({});			
			bhimUpiService.getNativeData(constantConfig.upiConstant.getpermission, json).then( function (data) { 
				if (data.permission === 'Allowed') {
					prehomeLoginVm.redirectToBharatQRJourney($event);
				} else {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
				}
			}, function (msg) {
				utilityService.hideSpinner();
				prehomeLoginVm.showVpaErrorMessage(msg);
			});
		} else if (device.platform.toLowerCase() == 'windows') {
			ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
		} else {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"pspId": constantConfig.upiConstant.pspId,
				"encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
			});
			bhimUpiService.getNativeData("initializeIOSsdk", json).then(function (data) {			
				if (data !== "S") {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", data);
					return false;
				}
				utilityService.showSpinner();
				json = JSON.stringify({
					"addInfo": {
						"addInfo10": constantConfig.upiConstant.addInfo10,
						"addInfo9": constantConfig.upiConstant.addInfo9
					},
					"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
					"requestInfo": {
						"pspId": constantConfig.upiConstant.pspId,
						"pspRefNo": generateRandomString(27)
					},
					"updateFlag": constantConfig.upiConstant.updateFlag,
					"smsSent": "false"
				});
				bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (nData) {				
					$rootScope.checkDeviceInfo = JSON.parse(nData);
					utilityService.hideSpinner();
					if ($rootScope.checkDeviceInfo.status == 'S') {
						if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
							if(prehomeLoginVm.qrType == 'pay') {
								prehomeLoginVm.clickOn = 'scanpay';
								prehomeLoginVm.productClicked = "scanpay";
								loggedInUserService.productClicked = 'menu.scanQRCode';
								loggedInUserService.scanPayEventCaptured = $event;
							}
							else if(prehomeLoginVm.qrType == 'receive') {
								prehomeLoginVm.clickOn = 'receiveQR';
								prehomeLoginVm.productClicked = "receiveQR";
								loggedInUserService.productClicked = 'receiveQR';
								loggedInUserService.receiveQREventCaptured = $event;
							}
							initiateBiometric($event);
							
						} else if($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
								bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
									utilityService.hideSpinner();
									bhimUpiService.appGenId = data;								
									$state.go('menu.createNewVpaLogin');
								}, function (msg) {
									utilityService.hideSpinner();
									utilityService.showBhimUpiAlert("error", msg);
								});
							} 
						
					} else {
						utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
					}
				}, function (msg) {
					utilityService.hideSpinner();
					prehomeLoginVm.showVpaErrorMessage(msg);
				});
			}, function (msg) {
				utilityService.hideSpinner();
				prehomeLoginVm.showVpaErrorMessage(msg);
			});
		}
	}

	  prehomeLoginVm.redirectToBharatQRJourney = function ($event) {
		  function simInfosuccessCallback(result) {
			  if (result !== undefined && result != null && result != '') {
				  if (result.cards && result.cards.length > 0) {
					  customerInfoService.simCardInfo = result;
					  utilityService.showSpinner();
					  var json = JSON.stringify({
						  "addInfo": {
							  "addInfo10": constantConfig.upiConstant.addInfo10,
							  "addInfo9": constantConfig.upiConstant.addInfo9
						  },
						  "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
						  "requestInfo": {
							  "pspId": constantConfig.upiConstant.pspId,
							  "pspRefNo": generateRandomString(27)
						  },
						  "updateFlag": constantConfig.upiConstant.updateFlag,
						  "smsSent": false
					  });
					  bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
						  $rootScope.checkDeviceInfo = JSON.parse(data);
						  utilityService.hideSpinner();
						  if ($rootScope.checkDeviceInfo.status == 'S') {
							  if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
								  if (prehomeLoginVm.qrType == 'pay') {
									  prehomeLoginVm.clickOn = 'scanpay';
									  prehomeLoginVm.productClicked = "scanpay";
									  loggedInUserService.productClicked = 'menu.scanQRCode';
									  loggedInUserService.scanPayEventCaptured = $event;
								  }
								  else if (prehomeLoginVm.qrType == 'receive') {
									  prehomeLoginVm.clickOn = 'receiveQR';
									  prehomeLoginVm.productClicked = "receiveQR";
									  loggedInUserService.productClicked = 'receiveQR';
									  loggedInUserService.receiveQREventCaptured = $event;
								  }
								  initiateBiometric($event);
							  }
							  // else {							
							  // 	prehomeLoginVm.redirectToBhimUpi();
							  // }

							  else if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
								  bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
									  utilityService.hideSpinner();
									  bhimUpiService.appGenId = data;
									  $state.go('menu.createNewVpaLogin');
								  }, function (msg) {
									  utilityService.hideSpinner();
									  utilityService.showBhimUpiAlert("error", msg);
								  });
							  }
						  } else {
							  utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
						  }
					  }, function (msg) {
						  utilityService.hideSpinner();
						  prehomeLoginVm.showVpaErrorMessage(msg);
					  });
				  } else {
					  utilityService.hideSpinner();
					  utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
				  }
			  } else {
				  utilityService.hideSpinner();
				  utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
			  }
		  }
		  function HasPerminionSuccessCallback(result) {
			if (result) {
				window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
			} else {
				requestReadPermission();
			}
			}
			function errorCallback(error) {
				var elementSimInfo = document.getElementById('ErrorInfo');
				elementSimInfo.innerHTML = error;
			}
			function requestSuccessCallback(result) {
				if (result) {
					hasReadPermission();
				}
			}
			// Android only: check permission
			function hasReadPermission() {
				window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
			}
			// Android only: request permission
			function requestReadPermission() {
				window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
			}
			hasReadPermission();
			/*Sim card Info fetching - End*/
	  }

	prehomeLoginVm.showVpaErrorMessage = function (errorCode) {
		switch (errorCode) {
			case -1: utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
				break;

			case -2: utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
				break;

			case -3: utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
				break;

			case -4: utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
				break;

			case -5: utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
				break;

			case -6: utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
				break;

			case -7: utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
				break;

			default: utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
		}
	};

	/*-------------------------Scan Pay functions for Direct Scan & Pay feature after login---------------------------*/

	function scanQRCode () {
		
		prehomeLoginVm.isValidQrFlag = false;
		prehomeLoginVm.isBarcodeScanned = false;

		if (device.platform.toLowerCase() == 'android') {
			bhimUpiService.getNativeData(constantConfig.upiConstant.scanqrcode, {}, "YSP").then(function (data) {
				var barcodeData = data.scanResult;
				if (barcodeData.indexOf('upi://') == -1) {
					utilityService.showBhimUpiAlert("error", "Invalid QR");					
				} else {
					goToBhimUpiPayment(barcodeData);
				}
			}, function (error) {
				utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.");
			});
		} else {
			bhimUpiService.getNativeData(constantConfig.upiConstant.scanqrcode, {}, "YSP").then(function (data) {
				var barcodeData = data;

				if (barcodeData.indexOf("upi://pay?") !== 0) {
					utilityService.showBhimUpiAlert("error", "Invalid QR");					
				} else {
					goToBhimUpiPayment(barcodeData);
				}

			}, function (error) {
				utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.");
			});
		}
	}

	function goToBhimUpiPayment (barcodeData) {
		try {
			prehomeLoginVm.isBarcodeScanned = !utilityService.isEmpty(barcodeData);
			if (prehomeLoginVm.isBarcodeScanned) {
				prehomeLoginVm.payeeVpa = getParameterByName('pa', barcodeData);
				prehomeLoginVm.scannedImage = "img/FT/qrScanTap.svg";
				if (getParameterByName('am', barcodeData))
					prehomeLoginVm.amount = Number(getParameterByName('am', barcodeData));
				if (getParameterByName('tn', barcodeData))
					prehomeLoginVm.remark = getParameterByName('tn', barcodeData);
				if (getParameterByName('cu', barcodeData))
					prehomeLoginVm.currencyCode = getParameterByName('cu', barcodeData);
				if (getParameterByName('tr', barcodeData))
					prehomeLoginVm.ref_id = getParameterByName('tr', barcodeData);
				if (getParameterByName('mc', barcodeData))
					prehomeLoginVm.merchantCatCode = getParameterByName('mc', barcodeData);
				if (getParameterByName('mam', barcodeData))
					prehomeLoginVm.minAmount = getParameterByName('mam', barcodeData);
				if (getParameterByName('url', barcodeData))
					prehomeLoginVm.ref_url = getParameterByName('url', barcodeData);
				if (getParameterByName('tid', barcodeData))
					prehomeLoginVm.tid = getParameterByName('tid', barcodeData);
			
				checkVpaAvailability();
			} else {
				prehomeLoginVm.scannedImage = "img/FT/qrScanTap.svg";
			}
		} catch (e) { }
	}

	function getParameterByName (name, url) {
		if (!url) url = window.location.href;
		name = name.replace(/[\[\]]/g, "\\$&");
		var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
			results = regex.exec(url);
		if (!results) return null;
		if (!results[2]) return '';
		if(name=='am'){
			if(results[2].search("E")!==-1 || results[2].search("e")!==-1){
				return results[2];
			}
		}			
		return decodeURIComponent(results[2].replace(/\+/g, " "));
	}

	function checkVpaAvailability () {
		if (!prehomeLoginVm.payeeVpa) {
			utilityService.showBhimUpiAlert("alert", "Please Enter Payee UPI Id");
			return false;
		}

		utilityService.showSpinner();
		var json = JSON.stringify({
			"addInfo": {
				"addInfo10": constantConfig.upiConstant.addInfo10,
				"addInfo9": constantConfig.upiConstant.addInfo9
			},
			"payeeType": {
				"virtualAddress": prehomeLoginVm.payeeVpa.toString()
			},
			"requestInfo": {
				"pspId": constantConfig.upiConstant.pspId,
				"pspRefNo": generateRandomString(27)
			},
			"vAReqType": constantConfig.upiConstant.vAReqType_T
		});
		bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json, "YSP").then(function (data) {
			var checkVpaResponse = JSON.parse(data);
			if (checkVpaResponse.status == 'VE') {
				customerInfoService.payeeDetails = {
					payeeType: "QR",
					requestType: 'pay',
					accountNo: "",
					ifsc: "",
					name: checkVpaResponse.payeeType.name || "",
					vpa: checkVpaResponse.payeeType.virtualAddress || "",
					amount: prehomeLoginVm.amount || "",
					remark: prehomeLoginVm.remark || "",
					nickName: "",
					phoneNumber: "",
					savePayee: false,
					currencyCode : prehomeLoginVm.currencyCode || "",
					ref_id : prehomeLoginVm.ref_id || "",
					merchantCatCode : prehomeLoginVm.merchantCatCode || "",
					minAmount : prehomeLoginVm.minAmount || "",
					ref_url : prehomeLoginVm.ref_url || "",
					tid : prehomeLoginVm.tid || ""
				}
				getProfile();
			} else {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", checkVpaResponse.statusDesc);
			}
		}, function (msg) {
			utilityService.hideSpinner();			
			utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.", "menu.prehomeLoginRevamp");
		});
	}

	function getProfile () {
		utilityService.showSpinner();
		var json = JSON.stringify({
			"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
			"requestInfo": {
				"pspId": constantConfig.upiConstant.pspId,
				"pspRefNo": generateRandomString(27)
			},
			"updateFlag": constantConfig.upiConstant.updateFlag
		});
		bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json, "YSP").then(function (data) {
			utilityService.hideSpinner();
			var getProfileResponse = JSON.parse(data);
			if (getProfileResponse.status == "S") {
				customerInfoService.payerProfileDtls = getProfileResponse;
				bhimUpiService.isPrehomeLoginScan = true;				
				$state.go('menu.payToVpa_PayeeDetails');
			} else {
				utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
			}
		}, function (msg) {
			utilityService.hideSpinner();			
			utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.", "menu.prehomeLoginRevamp");
		});
	}

	// Function to view profile QR code to receive
	function viewMyQrCode () {
		utilityService.showSpinner();
		var json = JSON.stringify({
			"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
			"requestInfo": {
				"pspId": constantConfig.upiConstant.pspId,
				"pspRefNo": generateRandomString(27)
			},
			"updateFlag": constantConfig.upiConstant.updateFlag
		});
		bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
			utilityService.hideSpinner();
			var getProfileResponse = JSON.parse(data);
			if (getProfileResponse.status == "S") {
				customerInfoService.payerProfileDtls = getProfileResponse;
				loggedInUserService.goToHomeFromQR = true;
				$state.go('menu.viewMyQrCode');
			} else {
				utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
			}
		}, function (msg) {
			utilityService.hideSpinner();
			utilityService.showBhimUpiAlert("error", msg);
		});
	}

	/*-------------------------------Create / Retreive UPI Profile Integration------------------------------------------------------------------------------*/

	prehomeLoginVm.goToSelectNumber = function () {
		$rootScope.previousPage = 'preHomeLoginRevamp';
		if (device.platform.toLowerCase() == 'android') {
			$state.go('menu.selectNumber');
		} else {
			if ($rootScope.checkDeviceInfo.smsStatus == 'SS') {
				prehomeLoginVm.getBankList();
			} else {
				utilityService.showSpinner();
				var json = JSON.stringify({
					"smsGateWayContent": $rootScope.checkDeviceInfo.smsGateWayContent,
					"smsGateWayKey": $rootScope.checkDeviceInfo.smsGateWayKey,
					"smsGateWayNo": $rootScope.checkDeviceInfo.smsGateWayNo,
					"appGenId": bhimUpiService.appGenId
				});
				bhimUpiService.getNativeData(constantConfig.upiConstant.sendsms, json).then(function (data) {
					utilityService.hideSpinner();
					prehomeLoginVm.showTimerForReVerification();
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			}
		}
	}

	prehomeLoginVm.showTimerForReVerification = function () {
		var timeLeft = 10;
		prehomeLoginVm.spinner = $interval(function () {
			if (timeLeft == 0) {
				prehomeLoginVm.showWaitSpinner = false;
				prehomeLoginVm.checkDeviceAfterSMS();
			} else {
				prehomeLoginVm.showWaitSpinner = true;
				prehomeLoginVm.timeRemaining = timeLeft;
				timeLeft--;
			}
		}, 1000)
	}

	prehomeLoginVm.checkDeviceAfterSMS = function () {
		$interval.cancel(prehomeLoginVm.spinner);
		utilityService.showSpinner();
		var json = JSON.stringify({
			"addInfo": {
				"addInfo10": constantConfig.upiConstant.addInfo10,
				"addInfo9": constantConfig.upiConstant.addInfo9
			},
			"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
			"requestInfo": {
				"pspId": constantConfig.upiConstant.pspId,
				"pspRefNo": generateRandomString(27)
			},
			"updateFlag": constantConfig.upiConstant.updateFlag,
			"smsSent": "true"
		});
		bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
			$rootScope.checkDeviceInfo = JSON.parse(data);
			if ($rootScope.checkDeviceInfo.status == 'S') {
				if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM' &&
					$rootScope.checkDeviceInfo.re_verify && $rootScope.checkDeviceInfo.re_verify == 'Y') {
					utilityService.hideSpinner();
					$state.go('menu.reVerifyDevice');
				} else {
					if ($rootScope.checkDeviceInfo.smsStatus == 'SS') {
						prehomeLoginVm.getBankList();
					} else {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("error", "Currently system is facing the issues with SMS gateway. Please try after sometime.");
					}
				}
			} else {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
			}
		}, function (msg) {
			utilityService.hideSpinner();
			utilityService.showBhimUpiAlert("error", msg);
		});
	}

	prehomeLoginVm.getBankList = function () {
		var json = JSON.stringify({
			"addInfo": {
				"addInfo10": constantConfig.upiConstant.addInfo10,
				"addInfo9": constantConfig.upiConstant.addInfo9
			},
			"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
			"requestInfo": {
				"pspId": constantConfig.upiConstant.pspId,
				"pspRefNo": generateRandomString(27)
			},
			"updateFlag": constantConfig.upiConstant.updateFlag
		});
		bhimUpiService.getNativeData(constantConfig.upiConstant.getbankListAPI, json).then(function (data) {
			utilityService.hideSpinner();
			prehomeLoginVm.banklistResponse = JSON.parse(data);
			if (prehomeLoginVm.banklistResponse.status == 'S') {
				customerInfoService.bankList = prehomeLoginVm.banklistResponse.bankMasterList;
				customerInfoService.accountDtlAgainstBank = [];
				$state.go('menu.selectBank');
			} else {
				utilityService.showBhimUpiAlert("error", "Unable to fetch bank list. Please try after sometime.");
			}
		}, function (msg) {
			utilityService.hideSpinner();
			utilityService.showBhimUpiAlert("error", msg);
		});
	};

	// YONO Cash functionality 
	$scope.goToYonoCash=function($event){
		localStorage.setItem('isRedirectedTowdsLoan', "");
		localStorage.setItem('redirectOnlyFlow', "");
		homeScreenService.isBackCheck = false;
		homeScreenService.preLoginYonoCash = true;
		loggedInUserService.isFirstLogin=true;
		loggedInUserService.productClicked = 'menu.yonoCashLanding'; // 'menu.homeScreen ';
		prehomeLoginVm.productClicked = "yonoCashLanding";
		prehomeLoginVm.clickOn = '';  
		prehomeLoginVm.clearAllData();
		$scope.openPopover($event);
		prehomeLoginVm.popoverBackdrop();
	}

	// Popover login/auth functionalities for icons & banners
	prehomeLoginVm.popoverBackdrop = function () {
		var backDrop = document.getElementsByClassName("popover-backdrop");
		if (backDrop && backDrop[0]) {
		  backDrop[0].setAttribute("style", "background-color: rgba(0, 0, 0, 0.7) !important;");
		}
	}

	prehomeLoginVm.closePopupLogin = function($event){
		prehomeLoginVm.clearAllData();
		loggedInUserService.productClicked = "";
		if(prehomeLoginVm.productClicked == "yonoCashLanding"){
			homeScreenService.preLoginYonoCash = false;
		}		
		prehomeLoginVm.productClicked = "";	
		$scope.popover.hide();
		if ($scope.keyboardVisible) {
			$scope.hideKeyboard();
		}
		removePopupClass();				
	}

	$scope.openPopover = function ($event) {		
		if(prehomeLoginVm.popupClass.length != 0){
			removePopupClass();
		}
		determinePopupClass();
		prehomeLoginVm.lockPopupEnabled = false;	
		$scope.popover.show($event);
		addPopupClass();
	};

	prehomeLoginVm.inputFieldFocus = function(screenSizeReduced){
		prehomeLoginVm.screenSizeReduced = screenSizeReduced;
		removePopupClass();
		determinePopupClass();
		addPopupClass();		
	}

	function determinePopupClass() {
		if(prehomeLoginVm.productClicked == 'scanpay'){
			if(prehomeLoginVm.MPINLoginFlag){
				if(utilityService.isAndroidPlatform()){
				if(prehomeLoginVm.mpinErrorMsgFlag){
					prehomeLoginVm.popupClass = ['top-18per', 'height-32per'];
				}
					
				else{
					prehomeLoginVm.popupClass = ['top-18per', 'height-30per'];
				}
					
				}
				if(utilityService.isIOSPlatform()){
					if(prehomeLoginVm.mpinErrorMsgFlag){
						prehomeLoginVm.popupClass = ['top-18per', 'height-40per-ios'];
					}
					
					else{
						prehomeLoginVm.popupClass = ['top-18per', 'height-38per-ios'];
					}
					
				}
					
			} else if (prehomeLoginVm.UserIdLoginFlag){
				if(utilityService.isAndroidPlatform()){
				if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unameError || prehomeLoginVm.unamePatternError || prehomeLoginVm.pError){
					
						if(prehomeLoginVm.unamePatternError &&  prehomeLoginVm.pError){
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-5per', 'height-88per'];
							}
								
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-54per'];
							}
								
						}
						else if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unamePatternError){
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-5per', 'height-84per'];
							}
								
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-50per'];
							}
								
						}
						else if(prehomeLoginVm.unameError &&  prehomeLoginVm.pError){
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-5per', 'height-80per'];
							}
								
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-48per'];
							}
								
						}
						else if(prehomeLoginVm.unameError ||  prehomeLoginVm.pError){
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-5per', 'height-75per'];
							}
								
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-46per'];
							}
								
						}					
					}else{
						if(prehomeLoginVm.screenSizeReduced){
							prehomeLoginVm.popupClass = ['top-5per', 'height-70per']; 
						}
							
						else{
							prehomeLoginVm.popupClass = ['top-18per', 'height-42per'];
						}
							
					}	
					}
					if(utilityService.isIOSPlatform()){
						if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unameError || prehomeLoginVm.unamePatternError || prehomeLoginVm.pError){
							
							if(prehomeLoginVm.unamePatternError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-64per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-64per-ios'];
								}
									
							}
							else if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unamePatternError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-60per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-60per-ios'];
								}
									
							}
							else if(prehomeLoginVm.unameError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-57per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-57per-ios'];
								}
									
							}
							else if(prehomeLoginVm.unameError ||  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-54per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-54per-ios'];
								}
									
							}
							}
						else{
						
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-3per-ios', 'height-50per-ios']; 
							}
							
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-50per-ios'];
							}
							
						
						
						
						}
					}
				
			}
		} 
		if(prehomeLoginVm.userType == 'A' || prehomeLoginVm.userType == 'C'){
			if(prehomeLoginVm.productClicked == 'yonoCashLanding' || prehomeLoginVm.productClicked == 'createRetreiveUPI' || 
				prehomeLoginVm.productClicked == 'paycontact' || prehomeLoginVm.productClicked == 'paybank' || prehomeLoginVm.productClicked == 'receiveQR'){
				if (prehomeLoginVm.UserIdLoginFlag){
					if(utilityService.isAndroidPlatform()){
					if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unameError || prehomeLoginVm.unamePatternError || prehomeLoginVm.pError){
						if(prehomeLoginVm.unamePatternError &&  prehomeLoginVm.pError){
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-5per', 'height-88per'];
							}
								
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-54per'];
							}
								
						}
						else if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unamePatternError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-84per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-50per'];
								}
									
							}
							else if(prehomeLoginVm.unameError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-80per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-48per'];
								}
									
							}
							else if(prehomeLoginVm.unameError ||  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-75per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-46per'];
								}
									
							}
					}else{
						
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-5per', 'height-70per']; 
							}
								
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-42per'];
							}
								
						
						
						
					}			
					}
					if(utilityService.isIOSPlatform()){
						if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unameError || prehomeLoginVm.unamePatternError || prehomeLoginVm.pError){
							
								if(prehomeLoginVm.unamePatternError &&  prehomeLoginVm.pError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-3per-ios', 'height-64per-ios'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-64per-ios'];
									}
										
								}
								else if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unamePatternError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-3per-ios', 'height-60per-ios'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-60per-ios'];
									}
										
								}
						else if(prehomeLoginVm.unameError &&  prehomeLoginVm.pError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-3per-ios', 'height-57per-ios'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-57per-ios'];
									}
										
								}
								else if(prehomeLoginVm.unameError ||  prehomeLoginVm.pError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-3per-ios', 'height-54per-ios'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-54per-ios'];
									}
										
								}
						}else{
							
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-50per-ios']; 
								}
								
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-50per-ios'];
								}
								
							
							
							
						}			
					}
				
				}	
			}				
			else if(prehomeLoginVm.productClicked == 'Banners' || prehomeLoginVm.productClicked == 'setBiometric'){
					if (prehomeLoginVm.UserIdLoginFlag){	
						
						if(utilityService.isAndroidPlatform()){

							if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unameError || prehomeLoginVm.unamePatternError || prehomeLoginVm.pError){
								if(prehomeLoginVm.unamePatternError &&  prehomeLoginVm.pError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-5per', 'height-77per'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-44per'];
									}
										
								}
								else if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unamePatternError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-5per', 'height-69per'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-42per'];
									}
										
								}
								else if(prehomeLoginVm.unameError &&  prehomeLoginVm.pError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-5per', 'height-64per'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-39per'];
									}
										
								}
								else if(prehomeLoginVm.unameError ||  prehomeLoginVm.pError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-5per', 'height-60per'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-36per'];
									}
										
								}					
							}else{
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-54per']; 
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-33per'];
								}
									
							}	
						}
						if(utilityService.isIOSPlatform()){

							if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unameError || prehomeLoginVm.unamePatternError || prehomeLoginVm.pError){
								if(prehomeLoginVm.unamePatternError &&  prehomeLoginVm.pError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-3per-ios', 'height-53per-ios'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-53per-ios'];
									}
										
								}
								else if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unamePatternError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-3per-ios', 'height-50per-ios'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-50per-ios'];
									}
										
								}
								else if(prehomeLoginVm.unameError &&  prehomeLoginVm.pError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-3per-ios', 'height-46per-ios'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-46per-ios'];
									}
										
								}
								else if(prehomeLoginVm.unameError ||  prehomeLoginVm.pError){
									if(prehomeLoginVm.screenSizeReduced){
										prehomeLoginVm.popupClass = ['top-3per-ios', 'height-43per-ios'];
									}
										
									else{
										prehomeLoginVm.popupClass = ['top-18per', 'height-43per-ios'];
									}
										
								}					
							}else{
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-38per-ios']; 
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-38per-ios'];
								}
									
							}	
						}


							
					}
				
			} 
		}	
		else if(prehomeLoginVm.userType == 'B' || prehomeLoginVm.userType == 'D'){
			if(prehomeLoginVm.productClicked == 'yonoCashLanding' || prehomeLoginVm.productClicked == 'createRetreiveUPI' || 
				prehomeLoginVm.productClicked == 'paycontact' || prehomeLoginVm.productClicked == 'paybank' || prehomeLoginVm.productClicked == 'receiveQR'){
				if(prehomeLoginVm.MPINLoginFlag){
					if(utilityService.isAndroidPlatform()){
						if(prehomeLoginVm.mpinErrorMsgFlag){
							prehomeLoginVm.popupClass = ['top-18per', 'height-38per'];
						}
						
						else{
							prehomeLoginVm.popupClass = ['top-18per', 'height-36per'];
						}
						
					}
					if(utilityService.isIOSPlatform()){
						if(prehomeLoginVm.mpinErrorMsgFlag){
							prehomeLoginVm.popupClass = ['top-18per', 'height-44per-ios'];
						}
						
						else{
							prehomeLoginVm.popupClass = ['top-18per', 'height-42per-ios'];
						}
						
					}

				
						
				} else if (prehomeLoginVm.UserIdLoginFlag){

					if(utilityService.isAndroidPlatform()){

						if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unameError || prehomeLoginVm.unamePatternError || prehomeLoginVm.pError){
							if(prehomeLoginVm.unamePatternError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-95per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-58per'];
								}
									
							}
							else if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unamePatternError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-92per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-55per'];
								}
									
							}
							else if(prehomeLoginVm.unameError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-87per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-52per'];
								}
									
							}
							else if(prehomeLoginVm.unameError ||  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-82per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-50per'];
								}
									
							}					
						}else{
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-5per', 'height-78per']; 
							}
								
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-48per'];
							}
								
						}	
					}
					if(utilityService.isIOSPlatform()){

						if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unameError || prehomeLoginVm.unamePatternError || prehomeLoginVm.pError){
							if(prehomeLoginVm.unamePatternError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-70per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-70per-ios'];
								}
									
							}
							else if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unamePatternError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-66per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-66per-ios'];
								}
									
							}
							else if(prehomeLoginVm.unameError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-62per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-62per-ios'];
								}
									
							}
							else if(prehomeLoginVm.unameError ||  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-60per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-60per-ios'];
								}
									
							}					
						}else{
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-3per-ios', 'height-56per-ios']; 
							}
								
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-56per-ios'];
							}
								
						}	
					}

				}
			} 
			else if(prehomeLoginVm.productClicked == 'Banners' || prehomeLoginVm.productClicked == 'setBiometric'){
				if(prehomeLoginVm.MPINLoginFlag){

					if(utilityService.isAndroidPlatform()){
						if(prehomeLoginVm.mpinErrorMsgFlag){
							prehomeLoginVm.popupClass = ['top-18per', 'height-28per'];
						}
						
						else{
							prehomeLoginVm.popupClass = ['top-18per', 'height-26per'];
						}
						
					}
					if(utilityService.isIOSPlatform()){
						if(prehomeLoginVm.mpinErrorMsgFlag)
						{
							prehomeLoginVm.popupClass = ['top-18per', 'height-33per-ios'];
						}
						
						else{
							prehomeLoginVm.popupClass = ['top-18per', 'height-30per-ios'];
						}
						
					}

					
						
				} else if (prehomeLoginVm.UserIdLoginFlag){
					if(utilityService.isAndroidPlatform()){
						if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unameError || prehomeLoginVm.unamePatternError || prehomeLoginVm.pError){
							if(prehomeLoginVm.unamePatternError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-80per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-49per'];
								}
									
							}
							else if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unamePatternError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-75per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-46per'];
								}
									
							}
							else if(prehomeLoginVm.unameError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-72per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-43per'];
								}
									
							}
							else if(prehomeLoginVm.unameError ||  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-5per', 'height-67per'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-41per'];
								}
									
							}						
						}else {
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-5per', 'height-62per']; 
							}
								
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-38per'];
							}
								
						}		
					}
					if(utilityService.isIOSPlatform()){
						if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unameError || prehomeLoginVm.unamePatternError || prehomeLoginVm.pError){
							if(prehomeLoginVm.unamePatternError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-58per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-58per-ios'];
								}
									
							}
							else if(prehomeLoginVm.userLoginErrorFlag || prehomeLoginVm.unamePatternError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-55per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-55per-ios'];
								}
									
							}
							else if(prehomeLoginVm.unameError &&  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-52per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-52per-ios'];
								}
									
							}
							else if(prehomeLoginVm.unameError ||  prehomeLoginVm.pError){
								if(prehomeLoginVm.screenSizeReduced){
									prehomeLoginVm.popupClass = ['top-3per-ios', 'height-48per-ios'];
								}
									
								else{
									prehomeLoginVm.popupClass = ['top-18per', 'height-48per-ios'];
								}
									
							}						
						}else {
							if(prehomeLoginVm.screenSizeReduced){
								prehomeLoginVm.popupClass = ['top-3per-ios', 'height-45per-ios']; 
							}
								
							else{
								prehomeLoginVm.popupClass = ['top-18per', 'height-45per-ios'];
							}
								
						}		
					}
								
				}
			}			
		}				
	}

	function addPopupClass() {
		var popoverAdd = document.getElementsByClassName("user-auth-modal-prehome")[0];
		for(var i=0; i<prehomeLoginVm.popupClass.length; i++)
			popoverAdd.classList.add(prehomeLoginVm.popupClass[i]);
	}

	function removePopupClass() {
		var popoverRemove = document.getElementsByClassName("user-auth-modal-prehome")[0];
		for(var i=0; i<prehomeLoginVm.popupClass.length; i++)
			popoverRemove.classList.remove(prehomeLoginVm.popupClass[i]);
	}

/*-------------------------ICONS funtionality without login service----------------------------*/

	$scope.goToInvestment=function(){
		localStorage.setItem('isRedirectedTowdsLoan', "");
		localStorage.setItem('redirectOnlyFlow', "");
		loggedInUserService.productClicked='menu.leadGenerationInvestment';
		loggedInUserService.isFirstLogin=true;
		$state.go('menu.leadGenerationInvestment');
	}

	$scope.insurancePage=function(){
		localStorage.setItem('isRedirectedTowdsLoan', "");
		localStorage.setItem('redirectOnlyFlow', "");
		loggedInUserService.productClicked='menu.leadGenerationInsurance';
		loggedInUserService.isFirstLogin=true;
		$state.go('menu.leadGenerationInsurance');
  	}  

	prehomeLoginVm.goToLoansLanding = function () {
		$state.go('menu.loansLanding');
	};

	$scope.goToShopNOrder=function(){
		localStorage.setItem('isRedirectedTowdsLoan', "");
		localStorage.setItem('redirectOnlyFlow', "");
		homeScreenService.preLoginYonoCash = false;
		homeScreenService.irctcCallAfterSuccLogin = false;
		homeScreenService.automallCallAfterSuccLogin = false;
		homeScreenService.automobileCallAfterSuccLogin = false;
		loggedInUserService.isFirstLogin=true;
		loggedInUserService.shopNOrderPre="1";
		$state.go('menu.ompMerchants');
	}

	$scope.goToBestOffers=function(){
		localStorage.setItem('isRedirectedTowdsLoan', "");
		localStorage.setItem('redirectOnlyFlow', "");
		loggedInUserService.shopNOrderPre="1";
		homeScreenService.categoryCode='OMPBO60';
		homeScreenService.storeSelected='Best Offer';
		clickStreamService.clickStreamData = "websiteId," +  homeScreenService.categoryCode;
		homeScreenService.preLoginYonoCash = false;
		homeScreenService.irctcCallAfterSuccLogin = false;
		homeScreenService.automallCallAfterSuccLogin = false;
		homeScreenService.automobileCallAfterSuccLogin = false;
		loggedInUserService.isFirstLogin=true;
		loggedInUserService.preLoginRedirection = true;
		$state.go('menu.merchantList');
	}

	/*-------------------------Locate Nearest Branch----------------------------*/
	prehomeLoginVm.locateNearestBranch = function () {		
		utilityService.showSpinner();
		$timeout(function () {
			currentLocationService.getCurrentPosition().then(
				function (position) {
					var latitude = position.coords.latitude;
					var longitude = position.coords.longitude;
					aoService.locateByGPS.length = 0;
					var params = {
						"latitude": latitude,
						"longitude": longitude,
						"branchLocator": "true"
					}
					if (utilityService.isUndefined(aoService.locateByGPS) ||
						aoService.locateByGPS.length === 0) {
						locateNearestBranchService.getBranchesForGeo(params).then(function (data) {
							utilityService.hideSpinner();							
							if (!utilityService.isUndefined(data)) {
								for (var i = 0; i < data.branches.length; i++) {
									aoService.locateByGPS.push(data.branches[i]);
								}
								if (aoService.locateByGPS.length == 0) {
									var title = '';
									var template = 'No Branch is available within 5 km from your location';
									var onTap = '';
									var buttontext = 'OK';
									utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
								} else {
									$state.go('menu.locateNearestBranchByGPS');
								}
							}
						}, function (error) {
							utilityService.hideSpinner();
							utilityService.showErrorMessage(error.responseMessage);
						});						
					} else {
						utilityService.hideSpinner();
					}
				},
				function (err) {
					utilityService.hideSpinner();
					var title = '';
					var template = '{{"ON_GPS" | translate}}';
					var onTap = '';
					var buttontext = '<b>OK</b>';
					utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
				});
		}, 2000);
	};

	// Function for bill pay redirection
	prehomeLoginVm.redirectToBillPay = function() {
		var url = loggedInUserService.billDeskUrl;
		cordova.ThemeableBrowser.open(url, '_system', {
			statusbar: {
				color: '#ffffffff'
			},
			toolbar: {
				height: 44,
				color: '#ffffffff',
				image: 'share'
			},
			closeButton: {
				wwwImage: 'img/inappback.png',
				align: 'left',
				event: 'closePressed'
			},
			backButtonCanClose: true
		});
	}
	/*-------------------------------footer labels------------------------------------------------------------------------------*/
	prehomeLoginVm.inbLockApp = function () {

		inbLockUnlockService.displayErrorPopUp('<img class="inb-error-icon" src="img/FT/BhimUpi/alertSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p>',
			"Any Scheduled fund transfer, Night mode request & Running SIPs in Mutual Fund will be cancelled.Do you want to continue?", ["Cancel", "OK"], function () {
				// added comment to retain the existing code structure
		}, function () {
			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
			var reqParams = {
				"deviceId": device.uuid,
			}
			internetBankingService.fetchDetailsByDeviceID(reqParams).then(function (data) {					
				loggedInUserService.setInbUserId(data);
				$state.go('menu.inbLockAccessDeatils');					
			}, function (error) {					
				utilityService.showErrorMessage(error.responseMessage);					
			});

		});
	};

	prehomeLoginVm.goToTermsConditions = function () {
		$state.go('menu.termsandconditions');
	};

	prehomeLoginVm.goToPrivacyPolicy = function () {
		$state.go('menu.privacypolicy');
	};

	prehomeLoginVm.helpline = function(){
		prehomeLoginVm.helpPopUp = $ionicPopup.show({
			templateUrl: 'pages/preHomeLogin/helplinePopUp.html',				
			title: '',
			cssClass: 'dialog-prelogin',
			scope: $scope,
		});
	}

	prehomeLoginVm.closeHelplinePopup = function () {
		prehomeLoginVm.helpPopUp.close();
	}

	/*-------------------------------When user forgets MPIN or Password------------------------------------------------------------------------------*/
	

	//cant login functionality: switch on mpin and userlogin screen termsandcondition
	prehomeLoginVm.cantLogin = function () {
		if(prehomeLoginVm.productClicked == null || prehomeLoginVm.productClicked == "" || prehomeLoginVm.productClicked == undefined)
		{
			if (prehomeLoginVm.MPINLoginFlag) {
				prehomeLoginVm.showMpinHavingProblemPopup();
			} else if (prehomeLoginVm.UserIdLoginFlag) {
				prehomeLoginVm.showHavingProblemPopup();
			} else {
				//Do Nothing
			}
		}
		else{
			prehomeLoginVm.closePopupLogin();
			if (prehomeLoginVm.MPINLoginFlag) {
				prehomeLoginVm.showMpinHavingProblemPopup();
			} else if (prehomeLoginVm.UserIdLoginFlag) {
				prehomeLoginVm.showHavingProblemPopup();
			} else {
				//Do Nothing
			}
		}		
	}
		
	//Show popup for having problem link on mpin login screen when consent is given
	prehomeLoginVm.showMpinHavingProblemPopup = function () {
		$ionicPopup.show({
			template: '<p>(1) If you have forgotton your MPIN you may reset your MPIN by logging in using your INB credentials. Then go to settings, select "Remove MPIN".In your next login, you may go to the tab "Login using MPIN" and choose "Set MPIN"<br>(2) For changing MPIN, after logging in from the menu, go to Settings and select "Change MPIN".</p>',
			title: '',
			cssClass: 'dialog',
			scope: $scope,
			buttons: [{
				text: 'OK',
				type: 'button-positive',
				onTap: function () {
					angular.element(document.body).removeClass('popover-open'); // added to avoid un-responsive page CUG-263 observation.
				}
			}]
		});
	};

	//Show popup for having problem link on uname/password login screen
	prehomeLoginVm.showHavingProblemPopup = function () {		

			$state.go('menu.inbForgotPassword');			
		
	};
		
	/*-------------------------------SET MPIN------------------------------------------------------------------------------*/
	
	prehomeLoginVm.setMPIN = function(){
		prehomeLoginVm.goToRegistration();
	}

    prehomeLoginVm.goToRegistration = function () {
		mPinLoginService.isSetMPIN = true;
		$state.go('menu.inbLogin', { previousPage: "prehomeLoginRevamp" });
	};  

	/*-------------------------------SET BIOMETRIC------------------------------------------------------------------------------*/
	
	prehomeLoginVm.setBiometric = function($event){
		var messageOne = "You can enable Biometric Authentication for quick access to these services:";
		var messageTwo ="View Balance, Pay to Contact, Pay to Bank A/C and Scan & Pay.";
		var messageThree = "Do you want to enable it now?";
		var btn_array = [
			  {
					text: "No",
					type: 'button-negative',
					onTap: function () {
						prehomeLoginVm.checkEnablePopup.close();
					}
			  },
			  {
					text: "Yes",
					type: 'button-positive',
					onTap: function ($event) {						
						prehomeLoginVm.clickOn = '';
						loggedInUserService.productClicked = 'setBiometric'; // 'menu.homeScreen ';
						prehomeLoginVm.productClicked = "setBiometric";
						prehomeLoginVm.clearAllData();
						$scope.openPopover($event);
						prehomeLoginVm.popoverBackdrop();
					}
			  }
		];
		prehomeLoginVm.checkEnablePopup = $ionicPopup.alert({
			template: '<div style="margin-left: 95.5%;"><img src="img/prehomeLoginRevamp/Close-icon.svg" style="width:12px;height:12px;" alt="helpline" ng-click="prehomeLoginVm.closeBiometricPopup()"/></div><div class="row"><img class="camera-icon dis-block" src="img/quickpay/biometric.svg" alt="biometric" style="margin-left: 45.6%;width:7%;"></div><div class="row" style="text-align: center;margin-left: 34.1%;margin-top: 1.7%;"><div class="font-size-16" style="text-align:center;font-family: Roboto-Medium;font-size: 14px;color: #3F3F3F;line-height: 14px;font-weight: 500;">Set Biometric</div></div><div style="border: 0.75px dashed #3F3F3F;margin-top: 2.4%;margin-bottom:2%;"></div><div class="popupTextBottomPadding textAlignCenter" style="font-size: 0.8rem !important;">'+messageOne+'</div><div class="popupTextBottomPadding textAlignCenter" style="font-size: 0.8rem !important;">'+messageTwo+'</div><div class="popupTextBottomPadding fontSize-subHeading" style="margin-top:5% !important"><div class="textAlignCenter">'
			+ messageThree + '</div></div></div>', //template,
			scope: $scope,
			cssClass: 'setBiometric-popup',
			buttons: btn_array,
		});		
	}

	prehomeLoginVm.closeBiometricPopup = function () {
		prehomeLoginVm.checkEnablePopup.close();
	}

	/************************ Banner redirection logic ******************************/
	prehomeLoginVm.goToBanner = function ($event,bannerDetails){
		prehomeLoginVm.bannerSelected = bannerDetails;		
			   
	   if(bannerDetails.bannerClickable == "Yes" || bannerDetails.bannerClickable == "YES") {		  
		   if(bannerDetails.bannerLogin == "Yes" || bannerDetails.bannerLogin == "YES")
		   {
			   loggedInUserService.productClicked = "Banners"; 			  
			   prehomeLoginVm.productClicked = 'Banners';
			   prehomeLoginVm.clickOn = '';
			   loggedInUserService.isFirstLogin=true;				
			   prehomeLoginVm.clearAllData();	
			   $scope.openPopover($event);
			   prehomeLoginVm.popoverBackdrop();

		   } else if(bannerDetails.bannerLogin == "No" || bannerDetails.bannerLogin == "NO"){	
				if(bannerDetails.redirectionURL == 'menu.ompMerchants') {
					loggedInUserService.shopNOrderPre="1";
					localStorage.setItem('isRedirectedTowdsLoan', "");
					localStorage.setItem('redirectOnlyFlow', "");
				}																
			   $state.go(bannerDetails.redirectionURL,{goBackToState:'menu.prehomeLoginRevamp'});
		   }		
	   }				   
    }

	/*-------------------------------All calls before, enter an d after page calls------------------------------------------------------------------------------*/

	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function () {
		$ionicSideMenuDelegate.canDragContent(false);
		$rootScope.isInUserLogin = true;
		navigator.splashscreen.hide();
		$rootScope.checkLocationPermission();
	});

	prehomeLoginVm.updateToStore = function () {
		utilityService.upgradeApp()
	}

	prehomeLoginVm.exitForUpdateApp = function () {
		ionic.Platform.exitApp();
		navigator.app.exitApp();
	}

	$scope.$on('$ionicView.afterEnter', function () {

		if (loggedInUserService.appOutdateFlag) {
			var message = $filter('limitTo')(loggedInUserService.appOutdateMessage, 180);
			var exitAppButton = utilityService.isAndroidPlatform() ? '<button class="btn exitBtn" ng-click="prehomeLoginVm.exitForUpdateApp()">Exit</button>' : '';
			prehomeLoginVm.appUpdatePopup = $ionicPopup.show({
				template: '<div class="popup-body"><div class="appUpdateContainer"><img class="appUpdateLogo" src="img/OMP/appUpdate.svg" alt="App update Logo"/></div><div class="appUpdateHeading">App Update Available</div><div class="appUpdateInfo">' + message + '</div><button class="btn updateAppBtn marginBottom4" ng-click="prehomeLoginVm.updateToStore()">Update</button>' + exitAppButton + '</div></p>',
				title: '',
				scope: $scope,
				cssClass: 'app-update-popup'
			});
			var elem = angular.element(document.querySelector(".backdrop"));
			if (elem) {
				elem.addClass('app-update-backdrop');
			}
		}
		angular.element(document.body).removeClass('popover-open'); // added to avoid un-responsive page after popup login and back-button/close redirection.
		if (bhimUpiService.loginFromCreateNewVPA) {
			bhimUpiService.loginFromCreateNewVPA = false;
			prehomeLoginVm.productClicked = "createRetreiveUPI";
			loggedInUserService.productClicked = 'createRetreiveUPI';
			prehomeLoginVm.clearAllData();
			$scope.openPopover(bhimUpiService.createNewVPAEvent);
			prehomeLoginVm.popoverBackdrop();
		}
		else if(loggedInUserService.productClicked == "scanPay_secondAuthentication") {			
			prehomeLoginVm.productClicked = "scanpay";			
			prehomeLoginVm.clearAllData();
			$scope.openPopover(bhimUpiService.limitCheckScanPay);
			prehomeLoginVm.popoverBackdrop();
		}
		else if(loggedInUserService.productClicked == "payContact_secondAuthentication") {
			prehomeLoginVm.productClicked = "paycontact";			
			prehomeLoginVm.clearAllData();
			$scope.openPopover(loggedInUserService.limitCheckPayContact);
			prehomeLoginVm.popoverBackdrop();
		}
		else if(loggedInUserService.productClicked == "payBank_secondAuthentication") {
			prehomeLoginVm.productClicked = "paybank";			
			prehomeLoginVm.clearAllData();
			$scope.openPopover(loggedInUserService.limitCheckPayBank);
			prehomeLoginVm.popoverBackdrop();
		}
		else if(loggedInUserService.productClicked != 'payContact_secondAuthentication' && loggedInUserService.productClicked != 'payBank_secondAuthentication'){
			quickPayService.clearVariables();
		} 

		// cta push navigation
		if (ompMerchantsService.CTAPush && !ompMerchantsService.isPushLoginFlagEnabled) {  // CTA push with login false
			utilityService.showSpinner();
			ompMerchantsService.CTAPush = false;
			ompMerchantsService.authOnDisclaimer = false;
			loggedInUserService.shopNOrderPre = "1";
			if (ompMerchantsService.CTAPushData.redirectionType == "MERCHANT") {
				clickStreamService.clickStreamData = "websiteId," + ompMerchantsService.CTAPushData.affiliateId;
				homeScreenService.getMerchantDetailsByAffIdInPreLogin({ "affiliateId": ompMerchantsService.CTAPushData.affiliateId, "merchantKey": cryptoService.getSHA512EncryptedData(ompMerchantsService.CTAPushData.affiliateId).toString() }).then(function (data) {
					ompMerchantsService.listName = data[0];
					ompMerchantsService.listName.pageId = $state.current.data.pageId;
					loggedInUserService.isFirstLogin = true;
					ompMerchantsService.psudoIdEnble = data[0].psudoIdEnble;
					if (data[0].psudoIdEnble) {
						ompMerchantsService.authOnDisclaimer = true;
					} else {
						ompMerchantsService.authOnDisclaimer = false;
					}
					utilityService.hideSpinner();
					$state.go('menu.redirectionDiscliamer');
				}, function (error) {
					utilityService.hideSpinner();
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else if (ompMerchantsService.CTAPushData.redirectionType == "CATEGORY") {
				clickStreamService.clickStreamData = "websiteId," + ompMerchantsService.CTAPushData.categoryCode;
				homeScreenService.categoryCode = ompMerchantsService.CTAPushData.categoryCode;
				homeScreenService.storeSelected = ompMerchantsService.CTAPushData.categoryTitle;
				loggedInUserService.isFirstLogin = true;
				utilityService.hideSpinner();
				$state.go('menu.merchantList');
			} else {
				//APP Redirect
				clickStreamService.clickStreamData = "websiteId," + ompMerchantsService.CTAPushData.categoryCode;
				loggedInUserService.isFirstLogin = true;
				utilityService.hideSpinner();
				if (ompMerchantsService.CTAPushData.categoryCode == 'IRCTC') {
					irctcService.searchTrainObj = "";
					irctcService.myList = "";
					irctcService.masterData = "";
					irctcService.selectedTrainData = "";
					irctcService.myListFullData = "";
					irctcService.infantArray = [];
					irctcService.passArray = [];
					$state.go(ompMerchantsService.CTAPushData.redirectUrl);
				} else if (ompMerchantsService.CTAPushData.categoryCode.toLowerCase() == 'mandi') {
					agriMandiService.source = "mandi"
					$state.go(ompMerchantsService.CTAPushData.redirectUrl);
				} else if (ompMerchantsService.CTAPushData.categoryCode.toLowerCase() == 'mitra') {
					agriMandiService.source = "mitra"
					$state.go(ompMerchantsService.CTAPushData.redirectUrl);
				} else {
					$state.go(ompMerchantsService.CTAPushData.redirectUrl);
				}
			}
		}

	});


	$scope.$on('$ionicView.beforeEnter', function () {

		prehomeLoginVm.simSubscriptionId = "";
		prehomeLoginVm.isSimChanged = false;
		prehomeLoginVm.hasedSimInfo = "";
		prehomeLoginVm.simList = [];

		loadBannercontents();	
		
		quickPayService.exitYqp().then(function (data) {
			loggedInUserService.tokenLotus = "";
		}, function (error) {
			// added comment to retain the existing code structure			
		});		
		prehomeLoginVm.hasedSimInfo = "";
		loggedInUserService.shopNOrderPre = ''; //Reset OMP value after login  
		loggedInUserService.shopNOrderPreHash = "";
		$ionicSideMenuDelegate.canDragContent(false);
		mPinLoginService.userLoginStatus.isRegistered = true;
		mPinLoginService.isLoggedIn = false;
		homeScreenService.isBackCheck = false;		
		prehomeLoginVm.screenSizeReduced = false;		
		quickPayService.viewbalAvl = false;	
		prehomeLoginVm.lockPopupEnabled = false;

		prehomeLoginVm.keyguardValue = internetBankingService.checkKeyguardValue;
		if(prehomeLoginVm.keyguardValue == "true"){
			prehomeLoginVm.keyguardValue = true;
		} else {
			prehomeLoginVm.keyguardValue = false;
		}		
		bhimUpiService.isUpiRegistration = true;	// inserted for createNewVPA function integration
		prehomeLoginVm.showWaitSpinner = false;

		if (localStorage.getItem("customername")) {
			prehomeLoginVm.customerName = localStorage.getItem("customername");
		} else {
			prehomeLoginVm.customerName = "";
		}
		if (utilityService.isIOSPlatform()) {
			prehomeLoginVm.topStyle = "margin-top : -32px !important;";
		}
		else {
			prehomeLoginVm.topStyle = "margin-top : 13px !important;";
		}

		if (utilityService.isAndroidPlatform() && registerWithSimService.isSimRegistration && registerWithSimService.isSimLogin) {

			utilityService.showSpinner();
			readSimcardInfo();
		}
		setDefaultLoginOptions();
		$ionicPopover.fromTemplateUrl('pages/preHomeLogin/popupLogin.html', {
            scope: $scope,
			backdropClickToClose: false
        }).then(function (popover) {
            $scope.popover = popover;
        });	
		supportServices.getSBIHelplinePreLogin().then(function(data){
			if(data != "" && data != undefined && data != null){
				prehomeLoginVm.helpLine1 = data.defaultHelpline1;
				prehomeLoginVm.helpLine2 = data.defaultHelpline2;
				prehomeLoginVm.emergencyFraudNum = data.emergencyFraudNumber;
			}else{
				prehomeLoginVm.helpLine1 = '1800-1234';
				prehomeLoginVm.helpLine2 = '1800-2100' ;
				prehomeLoginVm.emergencyFraudNum = '1800-11-11-09';
			}
		},function(error){
			 utilityService.showErrorMessage(error.responseMessage);
		}); 

    }); 
	
	function readSimcardInfo() {
		/*Sim card Info fetching - Start*/
		function simInfosuccessCallback(result) {
			utilityService.hideSpinner();			
			var str = "";
			prehomeLoginVm.isSimChanged = false;

			if (result.cards && result.cards.length > 0) {
				prehomeLoginVm.simList = result.cards;
				var isAccountExists = -1;
				prehomeLoginVm.simList.some(function (obj, i) {
					if(obj.subscriptionId == registerWithSimService.simSubscriptionId){
						isAccountExists = i;
						return true;
					} else {
						return false;
					}
				});
				if (isAccountExists !== -1) {
					str = device.uuid + registerWithSimService.simSubscriptionId;
					prehomeLoginVm.simSubscriptionId = registerWithSimService.simSubscriptionId;
					prehomeLoginVm.hasedSimInfo = cryptoService.getSHA512EncryptedData(str);
				}
				else {
					//either sim card is removed or slot changed or subscription id changed due to sim changes
					prehomeLoginVm.isSimChanged = true;
					prehomeLoginVm.simSubscriptionId = "";

				}
			}

			if (prehomeLoginVm.simList == undefined || prehomeLoginVm.simList.length == 0) {
				utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
			}

			ompOffersService.isSimChangedForOmpPreLogin = prehomeLoginVm.isSimChanged;
			ompOffersService.hasedSimInfoForOmpPreLogin = prehomeLoginVm.hasedSimInfo;
			ompOffersService.simSubscriptionIdForOmpPreLogin = prehomeLoginVm.simSubscriptionId;
			ompOffersService.simListForOmpPreLogin = prehomeLoginVm.simList;	
			$scope.$apply();			
		}
		function HasPerminionSuccessCallback(result) {
			if (result) {
				window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
			} else {
				requestReadPermission();
			}
		}
		function errorCallback(error) {
			utilityService.hideSpinner();
			utilityService.showBhimUpiAlert("Permission denied.");
		}
		function requestSuccessCallback(result) {
			if (result) {
				hasReadPermission();
			}
		}
		// Android only: check permission
		function hasReadPermission() {
			window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
		}
		// Android only: request permission
		function requestReadPermission() {
			window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
		}
		hasReadPermission();
		/*Sim card Info fetching - End*/
	}

	/****Banner ************* */
	function loadBannercontents(){
		prehomeLoginVm.grabOffers = [];
		if(utilityService.isUndefined(preHomeLoginService.offers)){
			preHomeLoginService.getPreHomeLoginBanners().then(function (response) {
				if (response.transitInfo && response.transitInfo.transitUrl) {
					var transitGenHashVal = cryptoService.getSHA512EncryptedData(response.transitInfo.transitUrl).toString();
					if (transitGenHashVal == response.transitInfo.responseKey) {
						menuService.transitUrl = response.transitInfo.transitUrl;
					} else {
						menuService.transitUrl = null;
					}
				} else {
					menuService.transitUrl = null;
				} 
				if(response.data.length >= 1 && response.tempCode) {
					prehomeLoginVm.offers = response.data;					
					var hashString = "";
					for(var i=1; i<=prehomeLoginVm.offers.length; i++){
						hashString = hashString + prehomeLoginVm.offers[i-1].imageUrl + prehomeLoginVm.offers[i-1].redirectionURL;					
					}
					var hashVal = cryptoService.getSHA512EncryptedData(hashString).toString();				
					if(hashVal == response.tempCode){							
						preHomeLoginService.offers = prehomeLoginVm.offers;					
						for (var i=1; i<=prehomeLoginVm.offers.length; i++){
							for (var j=1; j<=prehomeLoginVm.offers.length; j++){
								if(i == prehomeLoginVm.offers[j-1].bannerDisplayOrder){
									prehomeLoginVm.grabOffers[i-1] = prehomeLoginVm.offers[j-1];
								}							
							} 
						}					
						setTimeout(function(){							
							$ionicSlideBoxDelegate.$getByHandle('image-viewer').update();
						},1000);			
						$ionicSlideBoxDelegate.$getByHandle('image-viewer').loop(true);						
					} else {
						loadDefaultBanners();
					}										
				} else {
					loadDefaultBanners();
				}				
			}, function (err) {		
				loadDefaultBanners();
			});
		}
		else {
			prehomeLoginVm.offers = preHomeLoginService.offers;
			for (var i=1; i<=prehomeLoginVm.offers.length; i++){
				for (var j=1; j<=prehomeLoginVm.offers.length; j++){
					if(i == prehomeLoginVm.offers[j-1].bannerDisplayOrder){
						prehomeLoginVm.grabOffers[i-1] = prehomeLoginVm.offers[j-1];
					}							
				} 
			}
			setTimeout(function(){				
				$ionicSlideBoxDelegate.$getByHandle('image-viewer').update();
			},1000);			
			$ionicSlideBoxDelegate.$getByHandle('image-viewer').loop(true);		
		}					
	}
	function loadDefaultBanners(){	
		prehomeLoginVm.offers = [{
			"bannerSubject":"ShopNOrder",
				"imageUrl": "img/prehomeLoginRevamp/Banner_ShopnOrder.png",
				"bannerClickable":"YES",
				"bannerLogin":"NO",
				"redirectionURL":"menu.ompMerchants",
				"bannerDisplayOrder":"1"
	   },{
			"bannerSubject":"CreditCard",
				"imageUrl": "img/prehomeLoginRevamp/Banner_Creditcard.png",
				"bannerClickable":"YES",
				"bannerLogin":"NO",
				"redirectionURL":"menu.leadGenerationCreditCard",
				"bannerDisplayOrder":"2"
	   },{
			"bannerSubject":"Farming",
				"imageUrl": "img/prehomeLoginRevamp/Banner_farming.png",
				"bannerClickable":"YES",
				"bannerLogin":"YES",
				"redirectionURL":"menu.agriLanding",
				"bannerDisplayOrder":"3"
	   },{
			"bannerSubject":"Payments",
				"imageUrl": "img/prehomeLoginRevamp/Banner_Payments.png",
				"bannerClickable":"YES",
				"bannerLogin":"YES",
				"redirectionURL":"menu.fundsTransferLanding",
				"bannerDisplayOrder":"4"
	   },{
			"bannerSubject":"Loan",
				"imageUrl": "img/prehomeLoginRevamp/Banner_Loan.png",
				"bannerClickable":"YES",
				"bannerLogin":"NO",
				"redirectionURL":"menu.loansLanding",
				"bannerDisplayOrder":"5"
   		}];
		for (var i=1; i<=prehomeLoginVm.offers.length; i++){
			for (var j=1; j<=prehomeLoginVm.offers.length; j++){
				if(i == prehomeLoginVm.offers[j-1].bannerDisplayOrder){
					prehomeLoginVm.grabOffers[i-1] = prehomeLoginVm.offers[j-1];
				}
			} 
		}		
		setTimeout(function(){			
			$ionicSlideBoxDelegate.$getByHandle('image-viewer').update();
		},1000);			
		$ionicSlideBoxDelegate.$getByHandle('image-viewer').loop(true);	
	}

	function setDefaultLoginOptions(){
		$scope.passLenLimitReached = false;
		prehomeLoginVm.mpinConsent = loggedInUserService.mpinConsent; // To check MPIN availability
		// Logic to check biometric availability & type (Fingerprint/Face)
		prehomeLoginVm.isBiometricSet = localStorage.getItem("isBiometricSet");
		if (prehomeLoginVm.isBiometricSet == undefined || prehomeLoginVm.isBiometricSet == "false") {
			prehomeLoginVm.isBiometricSet = false;
		}
		else {
			prehomeLoginVm.isBiometricSet = true;
			quickPayService.isFingerprintAvailable().then(function (response) {
				prehomeLoginVm.isFingerprintAvl = response.responseMessage;			
				if (quickPayService.isBiometricType == 'face')
					prehomeLoginVm.bio_text = "Face ID";
				else if (quickPayService.isBiometricType == 'finger')
					prehomeLoginVm.bio_text = "Touch ID";
				else
					prehomeLoginVm.bio_text = "";
			});	

			$translate(['ENABLE_FACEID', 'ENABLE_FACEID_DESC', 'YQP_AUTH_MSG'], { FIELD_1: prehomeLoginVm.bio_text }).then(function (translations) {
                prehomeLoginVm.ENABLE_FACEID = translations['ENABLE_FACEID'];
                prehomeLoginVm.ENABLE_FACEID_DESC = translations['ENABLE_FACEID_DESC'];
                prehomeLoginVm.YQP_AUTH_MSG = translations['YQP_AUTH_MSG'];
            });
		}			

		// Logic to determine the user type of customer and set default login options.
		if (!prehomeLoginVm.mpinConsent && !prehomeLoginVm.isBiometricSet) {
			prehomeLoginVm.MPINLoginFlag = false;
			prehomeLoginVm.UserIdLoginFlag = true;
			prehomeLoginVm.openLoginoption = false;
			prehomeLoginVm.userType = 'A';

		} else if (prehomeLoginVm.mpinConsent && !prehomeLoginVm.isBiometricSet) {
			prehomeLoginVm.MPINLoginFlag = true;
			prehomeLoginVm.UserIdLoginFlag = false;
			prehomeLoginVm.openLoginoption = true;
			prehomeLoginVm.userType = 'B';			

		} else if (!prehomeLoginVm.mpinConsent && prehomeLoginVm.isBiometricSet) {
			prehomeLoginVm.MPINLoginFlag = false;
			prehomeLoginVm.UserIdLoginFlag = true;
			prehomeLoginVm.openLoginoption = false;
			prehomeLoginVm.userType = 'C';

		} else if (prehomeLoginVm.mpinConsent && prehomeLoginVm.isBiometricSet) {
			prehomeLoginVm.MPINLoginFlag = true;
			prehomeLoginVm.UserIdLoginFlag = false;
			prehomeLoginVm.openLoginoption = true;
			prehomeLoginVm.userType = 'D';
			
		} else {
			prehomeLoginVm.userType = '';
			prehomeLoginVm.MPINLoginFlag = false;
			prehomeLoginVm.UserIdLoginFlag = false;		
		}		
	}

	$scope.$on('$ionicView.enter', function () {		
		homeScreenService.setBannerRedirection = false;
		$rootScope.appIsRunning = true;
	});

	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function () {
		$ionicSideMenuDelegate.canDragContent(false);
		$rootScope.isInUserLogin = false;		
	});

	$scope.$on('$destroy', function () {
		$scope.popover.remove();
	});

    return this;
}

]);