'use strict';

angularApp.controller('skipsetMpinController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "ionicDatePicker",
    "internetBankingService",
    "regProcessWithAccNoService",
    "loggedInUserService",
    "registerWithSimService","csatServices",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        ionicDatePicker,
        internetBankingService,
        regProcessWithAccNoService,
        loggedInUserService,
        registerWithSimService,csatServices) {

        var skipsetMpinVm = this;
        skipsetMpinVm.registerWithATM = regProcessWithAccNoService.registerWithATM;
        
        skipsetMpinVm.close = function(){
            $state.go("menu.selectSim");
        }
        skipsetMpinVm.gotoYonoHome = function(){
            $state.go("menu.regSetInbPassword");
        }

        skipsetMpinVm.skip = function(){
            if(skipsetMpinVm.registerWithATM == 'Y') {
                $state.go('menu.prehomeLoginRevamp');
            }
            else {
                utilityService.showSpinner();
                loggedInUserService.fileForStorageData('{"isDeviceRegistered":true,"mpinConsent":false, "simSubscriptionId":"' + registerWithSimService.simSubscriptionId +'"}').then(function (res) {
                    utilityService.hideSpinner();
                    $state.go("menu.homeScreen");
                }, function (error) {
                    utilityService.hideSpinner();
                    $state.go("menu.homeScreen");
                });
            }
        }
        skipsetMpinVm.setMPIN = function(){
            loggedInUserService.isNormalRegistration = false;
            $state.go("menu.mpinConsent");
        }

         $scope.$on('$ionicView.beforeEnter', function () {
            if(regProcessWithAccNoService.registerWithATM == 'Y'){
                if(csatServices.goldenJourneyCompletionCounter < 1){
                    csatServices.whetherGoldenJourney("REG");
                }
            }            
        });
}]);
