'use strict';

angularApp.controller('paymentRequestController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$rootScope",

    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $rootScope
    ) {

        var paymentReqVm = this;
        $scope.$on('$ionicView.beforeEnter', function () {
            paymentReqVm.colorCode = yfeiUPIService.colorCode;
            paymentReqVm.collectRequestsList = yfeiUPIService.collectRequestsList
        });
        paymentReqVm.goBack = function () {
            $state.go("menu.dashboard");
        }

        paymentReqVm.paymentForm = function (request) {
            yfeiUPIService.collectRequests = request;
            yfeiUPIService.dashTransactionSelection = "Payment Request";
            $state.go("menu.paymentRequestForm");
        }

        return this;
    }



]);
