'use strict';

angularApp.controller('vpaRegistrationSuccessController', ["$state",
	"$scope",
	"yfeiUPIService",
	"utilityService",
	"constantConfig",
	"$rootScope",

	function ($state,
		$scope,
		yfeiUPIService,
		utilityService,
		constantConfig,
		$rootScope) {

		var vpaRegistrationSuccessVm = this;

		$scope.$on('$ionicView.beforeEnter', function () {
			yfeiUPIService.isUpiRegistration = false;
			vpaRegistrationSuccessVm.registeredUpiId = yfeiUPIService.registeredUpiId;
			vpaRegistrationSuccessVm.isMpinSet = yfeiUPIService.selectedAccountDtls.mpinFlag;
			
		});

		vpaRegistrationSuccessVm.setUpUpiPin = function () {
		   yfeiUPIService.navigatedSetPinFrom = "newRegistration";
			$state.go('menu.setUPIPin');
		}
         

		vpaRegistrationSuccessVm.setLoginMpin = function () {
		  
			yfeiUPIService.welComePageNav = "registrationVPASucc";
			$state.go('menu.yfeiWelcome');
			
		}

		

		vpaRegistrationSuccessVm.goBack = function () {
			
		yfeiUPIService.bankCreateVPAPage = true;
		yfeiUPIService.bankListPage = false;
		yfeiUPIService.bankAccountListPage = false;
		yfeiUPIService.getAccountListTimerPage = false;
		}

		return this;
	}



]);
