'use strict';

angularApp.controller('yfeiMpinConsentController', ["$timeout", "$state", "$scope", "$translate", "$ionicPopup", "yfeiUPIService", "utilityService", "$stateParams", "$ionicSideMenuDelegate",
	function ($timeout, $state, $scope, $translate, $ionicPopup, yfeiUPIService, utilityService, $stateParams, $ionicSideMenuDelegate) {

		var yfeiMpinConsentVm = this;

		yfeiMpinConsentVm.consentDataAvl = true;
		yfeiMpinConsentVm.getMpinConsentData = function () {
			if (!yfeiUPIService.consentData) {
				yfeiUPIService.getMpinConsent().then(
					function (data) {
						yfeiMpinConsentVm.consentDataAvl = true;					
						yfeiMpinConsentVm.mpinConsentData = data.data.mpinConsentContent;
						yfeiUPIService.consentData = yfeiMpinConsentVm.mpinConsentData;
					},
					function (error) {
						yfeiMpinConsentVm.consentDataAvl = false;
					}
				);
			} else {
				yfeiMpinConsentVm.mpinConsentData = yfeiUPIService.consentData;
			}
		};
        
		yfeiMpinConsentVm.goToSetMpin = function () {
            $state.go('menu.setDeviceMpin');
		}
         

		 yfeiMpinConsentVm.goBack = function () {
			if(yfeiUPIService.selectedAccountDtls.mpinFlag == 'N')
			{
                 $state.go('menu.yfeiWelcome');
			}
			else
			{
				 $state.go('menu.vpaRegistrationSuccess');
			}
            
		}


		$scope.$on('$ionicView.loaded', function () {
			$ionicSideMenuDelegate.canDragContent(false)
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			$ionicSideMenuDelegate.canDragContent(false);
		});

		$scope.$on('$ionicView.afterLeave', function () {
			$ionicSideMenuDelegate.canDragContent(false)
		});

	}]);
