'use strict';

angularApp.controller('previousComplaintsController', ["$state",
    "$scope",
    "yfeiUPIService",
    "utilityService",
    "constantConfig",
    "$rootScope",
    "bhimUpiService",

    function ($state,
        $scope,
        yfeiUPIService,
        utilityService,
        constantConfig,
        $rootScope,
        bhimUpiService) {

        var previousComplaintsVm = this;
        var allComplaints = [];

        $scope.$on('$ionicView.beforeEnter', function () {
            previousComplaintsVm.previousComList = yfeiUPIService.previousComplaints
            allComplaints = previousComplaintsVm.previousComList;
        });

         previousComplaintsVm.complaintDetails = function (details) {
            yfeiUPIService.previousComplaintDetail = details; 
            $state.go("menu.previousComDetails");
        }
        
         previousComplaintsVm.goBack = function ()
        {
          $state.go("menu.helpSupport");  
        }
        

        previousComplaintsVm.checkString = function (value) {
            if (value === '') {
                previousComplaintsVm.previousComList = allComplaints;
            } else {
                previousComplaintsVm.previousComList = allComplaints.filter(function (item, index) {
                    return ( 
                        (item.payeeName != undefined) && item.payeeName.toLowerCase().includes(value.toLowerCase()) ||
                        (item.amount != undefined) && item.amount.toString().toLowerCase().includes(value.toLowerCase())  || 
                        (item.crtDate != undefined) && item.crtDate.toString().toLowerCase().includes(value.toLowerCase()) || 
                        (item.ticketNo != undefined) && item.ticketNo.toString().toLowerCase().includes(value.toLowerCase()) );
                });
            }
        }
        return this;
    }



]);
