'use strict';

angularApp.controller('euConsentController', ["$state",
    "$scope",
    "utilityService",
    "$ionicScrollDelegate",
    "NRIAOService",
    function ($state,
        $scope,
        utilityService,
        $ionicScrollDelegate,
        NRIAOService) {

        var euConsentVm = this;




        function initPage() {
            utilityService.showBhimUpiAlert("", "Please read full consent", "", "", "");
        }


        euConsentVm.goBack = function () {
            $state.go('menu.NRIConsent');
        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            euConsentVm.consentData = NRIAOService.euConsentData;

        });

        euConsentVm.checkScroll = function (event) {
            var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
            var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if (maxTop !== 0) {
                if (currentTop >= maxTop) {
                    NRIAOService.consentValueForYes = true;
                }
            }
        }



        return this;
    }
]);
