'use strict';

angularApp.controller('nriCurrentAddressDetailsController',
    ["$scope",
        "utilityService",
        "$state",
        "NRIAOService",
        "$ionicHistory",
        "$ionicPopover",
        function (
            $scope,
            utilityService,
            $state,
            NRIAOService,
            $ionicHistory,
            $ionicPopover) {
            var nriCurrentAdressDetailsVm = this;

            $scope.$on('$ionicView.beforeEnter', function () {
                nriCurrentAdressDetailsVm.initPage();
            });
            $scope.$on('$ionicView.loaded', function () {
                $scope.nriNamePattern = /^[a-zA-Z0-9]{1}[a-z0-9A-Z@# &*:,._\-/]*$/
              
                nriCurrentAdressDetailsVm.isChecked = false;
                nriCurrentAdressDetailsVm.idInputType = 'text';
                nriCurrentAdressDetailsVm.currentSameaAsPermanent = false;
                nriCurrentAdressDetailsVm.correspAddress = 'C';
                nriCurrentAdressDetailsVm.showPassport = false;
                document.getElementById("currentAdd").checked = true;
                document.getElementById("permanentAdd").checked = false;
               
                nriCurrentAdressDetailsVm.otherSubType1 = NRIAOService.keyValueMap.AddressSubTypeMaster;
                nriCurrentAdressDetailsVm.otherSubType2 = NRIAOService.countryMaster;
                nriCurrentAdressDetailsVm.stateMaster = NRIAOService.stateMasterdata;
                nriCurrentAdressDetailsVm.selectedOthersubtype1 = "";
                nriCurrentAdressDetailsVm.selectedOthersubtype2 = "";

            });
            nriCurrentAdressDetailsVm.initPage = function () {

                if (NRIAOService.resumeApplication || NRIAOService.review) {
                    
                    nriCurrentAdressDetailsVm.otherSubType = NRIAOService.keyValueMap.CurrentAddressProofMaster;
                    nriCurrentAdressDetailsVm.applicantStatus = NRIAOService.resumeNRIresponse.applicantStatus;
                    if (NRIAOService.resumeNRIresponse.passportVisaDetail) {
                       
                        nriCurrentAdressDetailsVm.addOnPassport = NRIAOService.resumeNRIresponse.passportVisaDetail.passportAddType;
                    }
                    else{
                        nriCurrentAdressDetailsVm.addOnPassport = NRIAOService.addressOnPassport;
                    }



                        if (nriCurrentAdressDetailsVm.addOnPassport == "Other Address") {
                            nriCurrentAdressDetailsVm.isChecked = false;
                        }
                        else {
                            if (NRIAOService.resumeNRIresponse.sameAddress) {
                                nriCurrentAdressDetailsVm.isChecked = true;
                                document.getElementById("currentAdd").checked = true;
                                document.getElementById("permanentAdd").checked = false;
                                 nriCurrentAdressDetailsVm.correspAddress = 'C';
                            } else {
                                nriCurrentAdressDetailsVm.isChecked = false;
                                if (NRIAOService.resumeNRIresponse.correspAddress) {
                      
                                    if (NRIAOService.resumeNRIresponse.correspAddress == "P") {
                                        nriCurrentAdressDetailsVm.correspAddress = 'P';
                                        document.getElementById("currentAdd").checked = false;
                                        document.getElementById("permanentAdd").checked = true;
                                    }
                                    else{
                                        nriCurrentAdressDetailsVm.correspAddress = 'C';
                                        document.getElementById("currentAdd").checked = true;
                                        document.getElementById("permanentAdd").checked = false;
                                    }
            
                                }
                            }

                        }

                        


                        if (NRIAOService.resumeNRIresponse.currentAddress) {
                            if (nriCurrentAdressDetailsVm.addOnPassport == 'Current Address' ||  
                            ((nriCurrentAdressDetailsVm.applicantStatus == "PIO" || nriCurrentAdressDetailsVm.addOnPassport == 'Permanent Address') && nriCurrentAdressDetailsVm.isChecked)) {
                                nriCurrentAdressDetailsVm.showPassport = true;
                                nriCurrentAdressDetailsVm.selectedOthersubtype = "Passport"
                            }
                            else if((nriCurrentAdressDetailsVm.applicantStatus == "PIO" || nriCurrentAdressDetailsVm.addOnPassport == 'Permanent Address')
                            && !nriCurrentAdressDetailsVm.isChecked){
                                nriCurrentAdressDetailsVm.showPassport = false;
                                nriCurrentAdressDetailsVm.otherSubTypeNotOther = NRIAOService.keyValueMap.CurrentAddressProofMaster;
                                nriCurrentAdressDetailsVm.otherSubType = [];
                                for (var i = 0; i < nriCurrentAdressDetailsVm.otherSubTypeNotOther.length; i++) {
                                    if (nriCurrentAdressDetailsVm.otherSubTypeNotOther[i].key != "A") {
                                        nriCurrentAdressDetailsVm.otherSubType.push(nriCurrentAdressDetailsVm.otherSubTypeNotOther[i])
                                    }
                                }
                                nriCurrentAdressDetailsVm.selectedOthersubtype = NRIAOService.getAddressProof(NRIAOService.resumeNRIresponse.currentAddress.addressProofType);
                            }
                            else {
                                nriCurrentAdressDetailsVm.showPassport = false;
                                nriCurrentAdressDetailsVm.otherSubType = NRIAOService.keyValueMap.CurrentAddressProofMaster;
                                nriCurrentAdressDetailsVm.selectedOthersubtype = NRIAOService.getAddressProof(NRIAOService.resumeNRIresponse.currentAddress.addressProofType);
                            }
                       


                            nriCurrentAdressDetailsVm.selectedOthersubtype1 = NRIAOService.getAddressType(NRIAOService.resumeNRIresponse.currentAddress.addressType);
                            nriCurrentAdressDetailsVm.flat = NRIAOService.resumeNRIresponse.currentAddress.addressLine1;
                            nriCurrentAdressDetailsVm.street = NRIAOService.resumeNRIresponse.currentAddress.addressLine2;
                            nriCurrentAdressDetailsVm.city = NRIAOService.resumeNRIresponse.currentAddress.city;
                            nriCurrentAdressDetailsVm.state = NRIAOService.resumeNRIresponse.currentAddress.state;
                            nriCurrentAdressDetailsVm.pin = NRIAOService.resumeNRIresponse.currentAddress.pincode;
                            nriCurrentAdressDetailsVm.selectedOthersubtype2 = NRIAOService.resumeNRIresponse.currentAddress.country;

                        }
                        else{
                            if (nriCurrentAdressDetailsVm.addOnPassport == 'Current Address' ||  
                            ((nriCurrentAdressDetailsVm.applicantStatus == "PIO" || nriCurrentAdressDetailsVm.addOnPassport == 'Permanent Address') && nriCurrentAdressDetailsVm.isChecked)) {
                                nriCurrentAdressDetailsVm.showPassport = true;
                                nriCurrentAdressDetailsVm.selectedOthersubtype = "Passport"
                            }
                            else if((nriCurrentAdressDetailsVm.applicantStatus == "PIO" || nriCurrentAdressDetailsVm.addOnPassport == 'Permanent Address')
                            && !nriCurrentAdressDetailsVm.isChecked){
                                nriCurrentAdressDetailsVm.showPassport = false;
                                nriCurrentAdressDetailsVm.otherSubTypeNotOther = NRIAOService.keyValueMap.CurrentAddressProofMaster;
                                nriCurrentAdressDetailsVm.otherSubType = [];
                                for (var i = 0; i < nriCurrentAdressDetailsVm.otherSubTypeNotOther.length; i++) {
                                    if (nriCurrentAdressDetailsVm.otherSubTypeNotOther[i].key != "A") {
                                        nriCurrentAdressDetailsVm.otherSubType.push(nriCurrentAdressDetailsVm.otherSubTypeNotOther[i])
                                    }
                                }
                            }
                            else{
                                nriCurrentAdressDetailsVm.showPassport = false;
                                nriCurrentAdressDetailsVm.otherSubType = NRIAOService.keyValueMap.CurrentAddressProofMaster;
                            }
                        }

                }

                else {
                   
                    nriCurrentAdressDetailsVm.addOnPassport = NRIAOService.addressOnPassport;
                    nriCurrentAdressDetailsVm.applicantStatus = NRIAOService.resumeNRIresponse.applicantStatus;
                    if (nriCurrentAdressDetailsVm.addOnPassport == 'Current Address' ||
                        ((nriCurrentAdressDetailsVm.applicantStatus == "PIO" || nriCurrentAdressDetailsVm.addOnPassport == 'Permanent Address')
                            && nriCurrentAdressDetailsVm.isChecked)) {
                        nriCurrentAdressDetailsVm.showPassport = true;
                        nriCurrentAdressDetailsVm.selectedOthersubtype = "Passport"
                    }
                    else if((nriCurrentAdressDetailsVm.applicantStatus == "PIO" || nriCurrentAdressDetailsVm.addOnPassport == 'Permanent Address')
                    && !nriCurrentAdressDetailsVm.isChecked){
                        nriCurrentAdressDetailsVm.showPassport = false;
                        nriCurrentAdressDetailsVm.otherSubTypeNotOther = NRIAOService.keyValueMap.CurrentAddressProofMaster;
                        nriCurrentAdressDetailsVm.otherSubType = [];
                        for (var i = 0; i < nriCurrentAdressDetailsVm.otherSubTypeNotOther.length; i++) {
                            if (nriCurrentAdressDetailsVm.otherSubTypeNotOther[i].key != "A") {
                                nriCurrentAdressDetailsVm.otherSubType.push(nriCurrentAdressDetailsVm.otherSubTypeNotOther[i])
                            }
                        }

                    }
                    else{  
                        nriCurrentAdressDetailsVm.showPassport = false;
                        nriCurrentAdressDetailsVm.otherSubType = NRIAOService.keyValueMap.CurrentAddressProofMaster;
                    }
                    if (nriCurrentAdressDetailsVm.addOnPassport == "Other Address") {
                        nriCurrentAdressDetailsVm.isChecked = false;
                    }
                    if (nriCurrentAdressDetailsVm.correspAddress) {
                        if (nriCurrentAdressDetailsVm.correspAddress == "P") {
                            nriCurrentAdressDetailsVm.correspAddress = 'P';
                            document.getElementById("currentAdd").checked = false;
                            document.getElementById("permanentAdd").checked = true;
                        } else {
                            nriCurrentAdressDetailsVm.correspAddress = 'C';
                            document.getElementById("currentAdd").checked = true;
                            document.getElementById("permanentAdd").checked = false;
                        }
                    }
                }

            }

            var template = '<ion-popover-view class="tooltiptextAddress ao-NRI-long-popupInfo-address roboto-regular">' + '<ion-content>' +
                '<div class="" ng-bind="nriCurrentAdressDetailsVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

            $scope.popover = $ionicPopover.fromTemplate(template, {
                scope: $scope
            });

            nriCurrentAdressDetailsVm.infoPopup = function ($event) {
                nriCurrentAdressDetailsVm.getInfoMsg = "Address proof of the blood relative (spouse, father, mother, sister, brother and child) with whom you are staying along with supporting proof of relationship (Passport, PAN Card, Driving License, Voter Identity Card, Aadhaar Card, Marriage Certificate, Birth Certificate).";
                $scope.popover.show($event);

            };



            nriCurrentAdressDetailsVm.changeCountry = function () {
                if (nriCurrentAdressDetailsVm.selectedOthersubtype2.code != 'IN') {
                    nriCurrentAdressDetailsVm.state = "";
                }
            }
            nriCurrentAdressDetailsVm.agreeChkBox = function () {


                if (nriCurrentAdressDetailsVm.isChecked) {
                    nriCurrentAdressDetailsVm.currentSameaAsPermanent = true;
                    document.getElementById("currentAdd").checked = true;
                    document.getElementById("permanentAdd").checked = false;
                    nriCurrentAdressDetailsVm.correspAddress = 'C';
                }
                else {
                    nriCurrentAdressDetailsVm.currentSameaAsPermanent = false;
                }

                if (nriCurrentAdressDetailsVm.addOnPassport == 'Current Address') {
                    nriCurrentAdressDetailsVm.selectedOthersubtype = "Passport"
                    nriCurrentAdressDetailsVm.showPassport = true;
                }



                if (nriCurrentAdressDetailsVm.addOnPassport == 'Permanent Address' && nriCurrentAdressDetailsVm.currentSameaAsPermanent) {
                    nriCurrentAdressDetailsVm.selectedOthersubtype = "Passport"
                    nriCurrentAdressDetailsVm.showPassport = true;

                }
                if (nriCurrentAdressDetailsVm.addOnPassport == 'Permanent Address' && !nriCurrentAdressDetailsVm.currentSameaAsPermanent) {

                    nriCurrentAdressDetailsVm.showPassport = false;

                }



            }
            nriCurrentAdressDetailsVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go("menu.passportVisaDetailsNRI");
                } else {
                    $ionicHistory.goBack();
                }
            }

            nriCurrentAdressDetailsVm.updateCorresAddress = function (value) {
                if (value == 'C') {
                    nriCurrentAdressDetailsVm.currentAddress = true;

                }
                else {
                    nriCurrentAdressDetailsVm.currentAddress = false;
                }
                nriCurrentAdressDetailsVm.correspAddress = value;
            }


            nriCurrentAdressDetailsVm.getUpdatedData = function () {

                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }
                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        $state.go("menu.nriPermanentAddressDetails");
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }



            nriCurrentAdressDetailsVm.submitReviewData = function () {


                if (nriCurrentAdressDetailsVm.addOnPassport != 'Current Address') {
                    if (nriCurrentAdressDetailsVm.currentAddressDetailsForm.CurrentAddressProof.$invalid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.AddressType.$invalid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.flatHouseNo.$invalid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.cityTown.$invalid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.state.$invalid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.CurrentCountry.$invalid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.pincodeZipcode.$invalid) {
                        utilityService.showErrorMessage("Please enter all detail");
                    }
                    else {
                        if (nriCurrentAdressDetailsVm.selectedOthersubtype != undefined && nriCurrentAdressDetailsVm.selectedOthersubtype != '' && nriCurrentAdressDetailsVm.selectedOthersubtype != null
                            && nriCurrentAdressDetailsVm.flat != undefined && nriCurrentAdressDetailsVm.city != undefined &&
                            nriCurrentAdressDetailsVm.state != undefined && nriCurrentAdressDetailsVm.selectedOthersubtype2 != undefined &&
                            nriCurrentAdressDetailsVm.selectedOthersubtype2 != '' && nriCurrentAdressDetailsVm.selectedOthersubtype2 != null &&
                            nriCurrentAdressDetailsVm.selectedOthersubtype1 != undefined && nriCurrentAdressDetailsVm.selectedOthersubtype1 != ''
                            && nriCurrentAdressDetailsVm.selectedOthersubtype1 != null && nriCurrentAdressDetailsVm.currentSameaAsPermanent != undefined
                            && nriCurrentAdressDetailsVm.pin != "" && nriCurrentAdressDetailsVm.pin != undefined && nriCurrentAdressDetailsVm.pin != null) {

                            if (nriCurrentAdressDetailsVm.selectedOthersubtype == "Passport") {
                                nriCurrentAdressDetailsVm.passportKey = "A";
                            }
                            else {
                                nriCurrentAdressDetailsVm.passportKey = null;
                            }
                            
                            var requestCreateApp = {
                                "id": NRIAOService.countryCode + NRIAOService.mobile,
                                "requestNo": NRIAOService.requestNo,
                                "review": NRIAOService.review,
                                "payload": {

                                    "sameAddress": nriCurrentAdressDetailsVm.isChecked,
                                    "correspAddress": nriCurrentAdressDetailsVm.correspAddress,
                                    "currentAddress": {
                                        "addressProofType": nriCurrentAdressDetailsVm.selectedOthersubtype.key ? nriCurrentAdressDetailsVm.selectedOthersubtype.key : nriCurrentAdressDetailsVm.passportKey,
                                        "addressType": nriCurrentAdressDetailsVm.selectedOthersubtype1.key,
                                        "addressLine1": nriCurrentAdressDetailsVm.flat,
                                        "addressLine2": nriCurrentAdressDetailsVm.street ? nriCurrentAdressDetailsVm.street : null,
                                        "city": nriCurrentAdressDetailsVm.city,
                                        "state": nriCurrentAdressDetailsVm.state,
                                        "pincode": nriCurrentAdressDetailsVm.pin,
                                        "country": nriCurrentAdressDetailsVm.selectedOthersubtype2
                                    },

                                    "permanentAddress": null
                                }

                            }
                            NRIAOService.saveAddressDetails(requestCreateApp).then(function (response) {
                                if (response.responseCode == '0000') {

                                    if (nriCurrentAdressDetailsVm.isChecked) {
                                        $state.go("menu.nriAdditionalDetails");
                                    }
                                    else {
                                        var currentAddress = {
                                            "addressProofType": nriCurrentAdressDetailsVm.selectedOthersubtype.key ? nriCurrentAdressDetailsVm.selectedOthersubtype.key : nriCurrentAdressDetailsVm.passportKey,
                                            "addressType": nriCurrentAdressDetailsVm.selectedOthersubtype1.key,
                                            "addressLine1": nriCurrentAdressDetailsVm.flat,
                                            "addressLine2": nriCurrentAdressDetailsVm.street ? nriCurrentAdressDetailsVm.street : null,
                                            "city": nriCurrentAdressDetailsVm.city,
                                            "state": nriCurrentAdressDetailsVm.state,
                                            "pincode": nriCurrentAdressDetailsVm.pin,
                                            "country": nriCurrentAdressDetailsVm.selectedOthersubtype2
                                        }
                                        NRIAOService.currentAddDetail = currentAddress;
                                        NRIAOService.corresadd = nriCurrentAdressDetailsVm.correspAddress;
                                        NRIAOService.sameAddress = nriCurrentAdressDetailsVm.isChecked;
                                        NRIAOService.currentAddCountry = nriCurrentAdressDetailsVm.selectedOthersubtype2;
                                        nriCurrentAdressDetailsVm.getUpdatedData();
                                    }


                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });

                        } else {
                            utilityService.showErrorMessage("Please enter all detail");
                        }

                    }
                } else {
                    if (nriCurrentAdressDetailsVm.currentAddressDetailsForm.AddressType.$valid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.flatHouseNo.$valid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.cityTown.$valid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.state.$valid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.CurrentCountry.$valid
                        && nriCurrentAdressDetailsVm.currentAddressDetailsForm.pincodeZipcode.$valid) {
                        if (nriCurrentAdressDetailsVm.selectedOthersubtype != undefined && nriCurrentAdressDetailsVm.selectedOthersubtype != '' && nriCurrentAdressDetailsVm.selectedOthersubtype != null
                            && nriCurrentAdressDetailsVm.flat != undefined && nriCurrentAdressDetailsVm.city != undefined &&
                            nriCurrentAdressDetailsVm.state != undefined && nriCurrentAdressDetailsVm.selectedOthersubtype2 != undefined &&
                            nriCurrentAdressDetailsVm.selectedOthersubtype2 != '' && nriCurrentAdressDetailsVm.selectedOthersubtype2 != null &&
                            nriCurrentAdressDetailsVm.selectedOthersubtype1 != undefined && nriCurrentAdressDetailsVm.selectedOthersubtype1 != ''
                            && nriCurrentAdressDetailsVm.selectedOthersubtype1 != null && nriCurrentAdressDetailsVm.currentSameaAsPermanent != undefined
                            && nriCurrentAdressDetailsVm.pin != "" && nriCurrentAdressDetailsVm.pin != undefined && nriCurrentAdressDetailsVm.pin != null) {

                            if (nriCurrentAdressDetailsVm.selectedOthersubtype == "Passport") {
                                nriCurrentAdressDetailsVm.passportKey = "A";
                            }
                            else {
                                nriCurrentAdressDetailsVm.passportKey = null;
                            }

                            var requestCreateApp = {
                                "id": NRIAOService.countryCode + NRIAOService.mobile,
                                "requestNo": NRIAOService.requestNo,
                                "review": NRIAOService.review,
                                "payload": {

                                    "sameAddress": nriCurrentAdressDetailsVm.isChecked,
                                    "correspAddress": nriCurrentAdressDetailsVm.correspAddress,
                                    "currentAddress": {
                                        "addressProofType": nriCurrentAdressDetailsVm.selectedOthersubtype.key ? nriCurrentAdressDetailsVm.selectedOthersubtype.key : nriCurrentAdressDetailsVm.passportKey,
                                        "addressType": nriCurrentAdressDetailsVm.selectedOthersubtype1.key,
                                        "addressLine1": nriCurrentAdressDetailsVm.flat,
                                        "addressLine2": nriCurrentAdressDetailsVm.street ? nriCurrentAdressDetailsVm.street : null,
                                        "city": nriCurrentAdressDetailsVm.city,
                                        "state": nriCurrentAdressDetailsVm.state,
                                        "pincode": nriCurrentAdressDetailsVm.pin,
                                        "country": nriCurrentAdressDetailsVm.selectedOthersubtype2
                                    },
                                    "permanentAddress": null
                                }
                            }
                            NRIAOService.saveAddressDetails(requestCreateApp).then(function (response) {
                                if (response.responseCode == '0000') {

                                    if (nriCurrentAdressDetailsVm.isChecked) {
                                        $state.go("menu.nriAdditionalDetails");
                                    }
                                    else {
                                        var currentAddress = {
                                            "addressProofType": nriCurrentAdressDetailsVm.selectedOthersubtype.key ? nriCurrentAdressDetailsVm.selectedOthersubtype.key : nriCurrentAdressDetailsVm.passportKey,
                                            "addressType": nriCurrentAdressDetailsVm.selectedOthersubtype1.key,
                                            "addressLine1": nriCurrentAdressDetailsVm.flat,
                                            "addressLine2": nriCurrentAdressDetailsVm.street ? nriCurrentAdressDetailsVm.street : null,
                                            "city": nriCurrentAdressDetailsVm.city,
                                            "state": nriCurrentAdressDetailsVm.state,
                                            "pincode": nriCurrentAdressDetailsVm.pin,
                                            "country": nriCurrentAdressDetailsVm.selectedOthersubtype2
                                        }
                                        NRIAOService.currentAddDetail = currentAddress;
                                        NRIAOService.corresadd = nriCurrentAdressDetailsVm.correspAddress;
                                        NRIAOService.sameAddress = nriCurrentAdressDetailsVm.isChecked;
                                        NRIAOService.currentAddCountry = nriCurrentAdressDetailsVm.selectedOthersubtype2;
                                        nriCurrentAdressDetailsVm.getUpdatedData();
                                    }


                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });

                        }
                        else {
                            utilityService.showErrorMessage("Please enter all detail");
                        }

                    } else {

                        utilityService.showErrorMessage("Please enter all detail");

                    }
                }

            }
        }
    ]);