'use strict';

angularApp.controller('nriPermanentAddressDetailsController',
    ["$scope",
        "utilityService",
        "$state",
        "NRIAOService",
        "$ionicHistory",

        function (
            $scope,
            utilityService,
            $state,
            NRIAOService,
            $ionicHistory
        ) {
            var nriPermanentAddressDetailsVm = this;
           $scope.$on('$ionicView.beforeEnter', function () {
            $scope.nriNamePattern = /^[a-zA-Z0-9]{1}[a-z0-9A-Z@# &*:,._\-/]*$/
          
                nriPermanentAddressDetailsVm.PermanentAddressProofMaster = NRIAOService.keyValueMap.PermanentAddressProofMaster
                nriPermanentAddressDetailsVm.otherSubType1 = NRIAOService.keyValueMap.AddressSubTypeMaster
                nriPermanentAddressDetailsVm.otherSubType2 = NRIAOService.countryMaster;
                nriPermanentAddressDetailsVm.addOnPassport = NRIAOService.addressOnPassport;
                nriPermanentAddressDetailsVm.stateMaster = NRIAOService.stateMasterdata;
                nriPermanentAddressDetailsVm.initPage();
            });
            $scope.$on('$ionicView.loaded', function () {
                if (NRIAOService.isPIO || NRIAOService.addressOnPassport == 'Permanent Address') {
                    if (NRIAOService.resumeNRIresponse.applicantStatus == "PIO") {
                        nriPermanentAddressDetailsVm.pio = true;
                    }
                    else {
                        nriPermanentAddressDetailsVm.pio = false;
                    }
                    nriPermanentAddressDetailsVm.proofAddressValue = "Passport";
                    nriPermanentAddressDetailsVm.selectedOthersubtype = "04";
                    nriPermanentAddressDetailsVm.idNum = NRIAOService.idNumber;
                } else {
                    nriPermanentAddressDetailsVm.idNum = "";
                }

                nriPermanentAddressDetailsVm.selectedOthersubtype1 = "";
                nriPermanentAddressDetailsVm.selectedOthersubtype2 = "";
            });

            nriPermanentAddressDetailsVm.initPage = function () {


                nriPermanentAddressDetailsVm.otherSubType = [];
                for (var i = 0; i < nriPermanentAddressDetailsVm.PermanentAddressProofMaster.length; i++) {
                    if (nriPermanentAddressDetailsVm.PermanentAddressProofMaster[i].key != "04") {
                        nriPermanentAddressDetailsVm.otherSubType.push(nriPermanentAddressDetailsVm.PermanentAddressProofMaster[i])
                    }
                }

                if (NRIAOService.resumeApplication || NRIAOService.review) {
                 
             
                    if (NRIAOService.resumeNRIresponse.currentAddress) {
                        NRIAOService.currentAddDetail = NRIAOService.resumeNRIresponse.currentAddress;
                    }
                    if (NRIAOService.resumeNRIresponse.correspAddress) {
                        NRIAOService.corresadd = NRIAOService.resumeNRIresponse.correspAddress;
                    }
                    nriPermanentAddressDetailsVm.addOnPassport = NRIAOService.resumeNRIresponse.passportVisaDetail.passportAddType;

                    if (NRIAOService.resumeNRIresponse.passportVisaDetail.passportAddType == 'Permanent Address' || NRIAOService.resumeNRIresponse.applicantStatus == "PIO") {

                        if (NRIAOService.resumeNRIresponse.applicantStatus == "PIO") {
                            nriPermanentAddressDetailsVm.pio = true;
                        }
                        else {
                            nriPermanentAddressDetailsVm.pio = false;
                        }
                        nriPermanentAddressDetailsVm.proofAddressValue = "Passport";
                        nriPermanentAddressDetailsVm.selectedOthersubtype = "04"
                        nriPermanentAddressDetailsVm.idNum = NRIAOService.resumeNRIresponse.passportVisaDetail.passportNumber
                    } else {
                        if (NRIAOService.resumeNRIresponse.permanentAddress) {
                            nriPermanentAddressDetailsVm.selectedOthersubtype = NRIAOService.resumeNRIresponse.permanentAddress.addressProofType;
                            if(nriPermanentAddressDetailsVm.selectedOthersubtype != "04"){
                                nriPermanentAddressDetailsVm.selectedOthersubtype = NRIAOService.getAddressProofPermanent(NRIAOService.resumeNRIresponse.permanentAddress.addressProofType);
                            }
                            if((NRIAOService.resumeNRIresponse.passportVisaDetail.passportAddType == 'Current Address' || NRIAOService.resumeNRIresponse.passportVisaDetail.passportAddType == 'Other Address') && nriPermanentAddressDetailsVm.selectedOthersubtype == '04'){
                                nriPermanentAddressDetailsVm.idNum = null;
                            }
                            else{
                                nriPermanentAddressDetailsVm.idNum = NRIAOService.resumeNRIresponse.permanentAddress.idNumber;
                            }
                            
                        }
                    }

                    if (NRIAOService.resumeNRIresponse.permanentAddress) {
                        nriPermanentAddressDetailsVm.selectedOthersubtype1 = NRIAOService.getAddressType(NRIAOService.resumeNRIresponse.permanentAddress.addressType)
                        nriPermanentAddressDetailsVm.flat = NRIAOService.resumeNRIresponse.permanentAddress.addressLine1
                        nriPermanentAddressDetailsVm.street = NRIAOService.resumeNRIresponse.permanentAddress.addressLine2
                        nriPermanentAddressDetailsVm.city = NRIAOService.resumeNRIresponse.permanentAddress.city
                        nriPermanentAddressDetailsVm.state = NRIAOService.resumeNRIresponse.permanentAddress.state
                        nriPermanentAddressDetailsVm.pin = NRIAOService.resumeNRIresponse.permanentAddress.pincode
                        nriPermanentAddressDetailsVm.selectedOthersubtype2 = NRIAOService.getCountryName(NRIAOService.resumeNRIresponse.permanentAddress.country)
                    }
                }
                else{

                    if (NRIAOService.resumeNRIresponse.passportVisaDetail.passportAddType == 'Permanent Address' || NRIAOService.resumeNRIresponse.applicantStatus == "PIO") {

                        if (NRIAOService.resumeNRIresponse.applicantStatus == "PIO") {
                            nriPermanentAddressDetailsVm.pio = true;
                        }
                        else {
                            nriPermanentAddressDetailsVm.pio = false;
                        }
                        nriPermanentAddressDetailsVm.proofAddressValue = "Passport";
                        nriPermanentAddressDetailsVm.selectedOthersubtype = "04"
                        nriPermanentAddressDetailsVm.idNum = NRIAOService.resumeNRIresponse.passportVisaDetail.passportNumber
                    }
                   
                  
                    else if((NRIAOService.resumeNRIresponse.passportVisaDetail.passportAddType == 'Current Address' || NRIAOService.resumeNRIresponse.passportVisaDetail.passportAddType == 'Other Address') && nriPermanentAddressDetailsVm.selectedOthersubtype == '04' && NRIAOService.resumeNRIresponse.applicantStatus != "PIO"){
                        nriPermanentAddressDetailsVm.idNum = null;
                    }
                  
                }
            }
            nriPermanentAddressDetailsVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go("menu.nriCurrentAddressDetailPage");
                } else {
                    $ionicHistory.goBack();
                }
            }
            nriPermanentAddressDetailsVm.changeCountry = function () {
                if (nriPermanentAddressDetailsVm.otherSubType2.code != 'IN') {
                    nriPermanentAddressDetailsVm.state = "";
                }
            }

            nriPermanentAddressDetailsVm.idnull  = function () {
                if (nriPermanentAddressDetailsVm.selectedOthersubtype.key == '49') {
                    nriPermanentAddressDetailsVm.idNum = "";
                }
            }

            nriPermanentAddressDetailsVm.getUpdatedData = function () {
                var payload = {
                    "id": NRIAOService.countryCode + NRIAOService.mobile,
                    "isdCode": NRIAOService.countryCode,
                    "mobileNo": NRIAOService.mobile,
                }

                NRIAOService.showReviewDetails(payload).then(function (response) {
                    if (response.responseCode == '0000') {
                        NRIAOService.resumeNRIresponse = response.data;
                        $state.go("menu.nriAdditionalDetails");
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }



            nriPermanentAddressDetailsVm.submitReviewData = function () {


                if (nriPermanentAddressDetailsVm.addOnPassport == 'Permanent Address' || NRIAOService.resumeNRIresponse.applicantStatus == "PIO" || (nriPermanentAddressDetailsVm.addOnPassport == 'Current Address' && !NRIAOService.sameAddress)) {
                    if (nriPermanentAddressDetailsVm.selectedOthersubtype != undefined && nriPermanentAddressDetailsVm.selectedOthersubtype != ''
                        && nriPermanentAddressDetailsVm.selectedOthersubtype != null && nriPermanentAddressDetailsVm.selectedOthersubtype1 != undefined
                        && nriPermanentAddressDetailsVm.selectedOthersubtype1 != '' && nriPermanentAddressDetailsVm.selectedOthersubtype1 != null
                        && nriPermanentAddressDetailsVm.flat != undefined && nriPermanentAddressDetailsVm.flat != null && nriPermanentAddressDetailsVm.flat != ""
                        && nriPermanentAddressDetailsVm.city != undefined && nriPermanentAddressDetailsVm.city != null && nriPermanentAddressDetailsVm.city != ""
                        && nriPermanentAddressDetailsVm.state != undefined && nriPermanentAddressDetailsVm.state != null && nriPermanentAddressDetailsVm.state != ""
                        && nriPermanentAddressDetailsVm.selectedOthersubtype2 != undefined && nriPermanentAddressDetailsVm.selectedOthersubtype2 != '' && nriPermanentAddressDetailsVm.selectedOthersubtype2 != null
                        && nriPermanentAddressDetailsVm.pin != "" && nriPermanentAddressDetailsVm.pin != undefined && nriPermanentAddressDetailsVm.pin != null) {
                        if (nriPermanentAddressDetailsVm.permanentAddressDetailsForm.ParmanentAddressProof.$invalid && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.AddressType.$invalid && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.flatHouseNo.$invalid
                            && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.cityTown.$invalid && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.state.$invalid
                            && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.CurrentCountry.$invalid && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.pincodeZipcode.$invalid) {
                         
                           utilityService.showBhimUpiAlert("", "Please enter all detail", "", "", "");

                        }
                        else {
                            if (nriPermanentAddressDetailsVm.idNum != null && nriPermanentAddressDetailsVm.idNum != "" && nriPermanentAddressDetailsVm.idNum != undefined) {
                                if (nriPermanentAddressDetailsVm.permanentAddressDetailsForm.idNumber.$invalid) {
                                    nriPermanentAddressDetailsVm.permanentAddressDetailsForm.idNumber.$error.pattern = true;
                                    utilityService.showBhimUpiAlert("", "Please enter all detail", "", "", "");
                                }
                            }
                            else {
                                nriPermanentAddressDetailsVm.idNum = "";
                            }

                            var requestCreateApp = {
                                "id": NRIAOService.countryCode + NRIAOService.mobile,
                                "requestNo": NRIAOService.requestNo,
                                "review": NRIAOService.review,
                                "payload": {
                                    "sameAddress": false,
                                    "correspAddress": NRIAOService.corresadd,
                                    "currentAddress": NRIAOService.currentAddDetail,
                                    "permanentAddress": {
                                        "addressProofType": nriPermanentAddressDetailsVm.selectedOthersubtype.key ? nriPermanentAddressDetailsVm.selectedOthersubtype.key : nriPermanentAddressDetailsVm.selectedOthersubtype,
                                        "idNumber": nriPermanentAddressDetailsVm.idNum ? nriPermanentAddressDetailsVm.idNum : null,
                                        "addressType": nriPermanentAddressDetailsVm.selectedOthersubtype1.key,
                                        "addressLine1": nriPermanentAddressDetailsVm.flat,
                                        "addressLine2": nriPermanentAddressDetailsVm.street ? nriPermanentAddressDetailsVm.street : null,
                                        "city": nriPermanentAddressDetailsVm.city,
                                        "state": nriPermanentAddressDetailsVm.state,
                                        "pincode": nriPermanentAddressDetailsVm.pin,
                                        "country": nriPermanentAddressDetailsVm.selectedOthersubtype2.code
                                    }
                                }
                            }

                            NRIAOService.saveAddressDetails(requestCreateApp).then(function (response) {
                                if (response.responseCode == '0000') {
                                    NRIAOService.requestNo = response.data;
                                    NRIAOService.permanentAddDeail = requestCreateApp.payload.permanentAddress;
                                    NRIAOService.permanentAddCountry = nriPermanentAddressDetailsVm.selectedOthersubtype2;
                                    nriPermanentAddressDetailsVm.getUpdatedData()
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        }
                    }
                    else {
                        utilityService.showBhimUpiAlert("", "Please enter all detail", "", "", "");
                    }
                }
               else if (nriPermanentAddressDetailsVm.addOnPassport == 'Other Address') {
                    if (nriPermanentAddressDetailsVm.selectedOthersubtype != undefined && nriPermanentAddressDetailsVm.selectedOthersubtype != ''
                        && nriPermanentAddressDetailsVm.selectedOthersubtype != null && nriPermanentAddressDetailsVm.idNum != null && nriPermanentAddressDetailsVm.idNum != "" && nriPermanentAddressDetailsVm.idNum != undefined
                        && nriPermanentAddressDetailsVm.selectedOthersubtype1 != undefined && nriPermanentAddressDetailsVm.selectedOthersubtype1 != '' && nriPermanentAddressDetailsVm.selectedOthersubtype1 != null
                        && nriPermanentAddressDetailsVm.flat != undefined && nriPermanentAddressDetailsVm.flat != null && nriPermanentAddressDetailsVm.flat != ""
                        && nriPermanentAddressDetailsVm.city != undefined && nriPermanentAddressDetailsVm.city != null && nriPermanentAddressDetailsVm.city != ""
                        && nriPermanentAddressDetailsVm.state != undefined && nriPermanentAddressDetailsVm.state != null && nriPermanentAddressDetailsVm.state != ""
                        && nriPermanentAddressDetailsVm.selectedOthersubtype2 != undefined && nriPermanentAddressDetailsVm.selectedOthersubtype2 != '' && nriPermanentAddressDetailsVm.selectedOthersubtype2 != null
                        && nriPermanentAddressDetailsVm.pin != "" && nriPermanentAddressDetailsVm.pin != undefined && nriPermanentAddressDetailsVm.pin != null) {
                        if (nriPermanentAddressDetailsVm.permanentAddressDetailsForm.ParmanentAddressProof.$invalid && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.idNumber.$invalid
                            && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.AddressType.$invalid && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.flatHouseNo.$invalid
                            && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.cityTown.$invalid && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.state.$invalid
                            && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.CurrentCountry.$invalid && nriPermanentAddressDetailsVm.permanentAddressDetailsForm.pincodeZipcode.$invalid) {
                                utilityService.showBhimUpiAlert("", "Please enter all detail", "", "", "");

                        }
                        else {


                            var requestCreateApp = {
                                "id": NRIAOService.countryCode + NRIAOService.mobile,
                                "requestNo": NRIAOService.requestNo,
                                "review": NRIAOService.review,
                                "payload": {
                                    "sameAddress": false,
                                    "correspAddress": NRIAOService.corresadd,
                                    "currentAddress": NRIAOService.currentAddDetail,
                                    "permanentAddress": {
                                        "addressProofType": nriPermanentAddressDetailsVm.selectedOthersubtype.key,
                                        "idNumber": nriPermanentAddressDetailsVm.idNum,
                                        "addressType": nriPermanentAddressDetailsVm.selectedOthersubtype1.key,
                                        "addressLine1": nriPermanentAddressDetailsVm.flat,
                                        "addressLine2": nriPermanentAddressDetailsVm.street ? nriPermanentAddressDetailsVm.street : null,
                                        "city": nriPermanentAddressDetailsVm.city,
                                        "state": nriPermanentAddressDetailsVm.state,
                                        "pincode": nriPermanentAddressDetailsVm.pin,
                                        "country": nriPermanentAddressDetailsVm.selectedOthersubtype2.code
                                    }
                                }
                            }
                            NRIAOService.saveAddressDetails(requestCreateApp).then(function (response) {
                                if (response.responseCode == '0000') {
                                    NRIAOService.requestNo = response.data;
                                    NRIAOService.permanentAddDeail = requestCreateApp.payload.permanentAddress;
                                    NRIAOService.permanentAddCountry = nriPermanentAddressDetailsVm.selectedOthersubtype2;
                                    nriPermanentAddressDetailsVm.getUpdatedData()
                                }
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        }
                    }
                    else {
                        utilityService.showBhimUpiAlert("", "Please enter all detail", "", "", ""); 
                    }
                }




            }

        }
    ]);