'use strict';

angularApp.controller('personalPanDetailsController',
    ["$state",
        "$scope",
        "$ionicHistory",
        "NRIAOService",
        "utilityService",
        "$ionicPopup",
        "$ionicPopover",
        "$translate",
        "$ionicScrollDelegate",
        function ($state,
            $scope,
            $ionicHistory,
            NRIAOService,
            utilityService,
            $ionicPopup,
            $ionicPopover,
            $translate,
            $ionicScrollDelegate) {
            var personalPanDetailsdetailsVm = this;
             //one time initialization to be done when the controller is loaded
            $scope.$on('$ionicView.loaded', function (ev) {
                $scope.nriNamePattern = /^[a-zA-Z0-9]{1}[a-z0-9A-Z@# &*:,._\-/]*$/
              
                personalPanDetailsdetailsVm.genderMaster = NRIAOService.masterList.GenderMaster;
                personalPanDetailsdetailsVm.titleMaster = NRIAOService.keyValueMap.TitleMaster;
                
                personalPanDetailsdetailsVm.supportNumberOne = NRIAOService.supportNumberOne;
                personalPanDetailsdetailsVm.supportNumberTwo = NRIAOService.supportNumberTwo;
                personalPanDetailsdetailsVm.supportNumberThree = NRIAOService.supportNumberThree;    
                personalPanDetailsdetailsVm.maxAllowedIncome = 100000000000;
                if (ev.targetScope !== $scope)
                    return;
                initPage();

            });
            personalPanDetailsdetailsVm.scrollUP = function(view){
                    document.getElementById(view).scrollIntoView(); 
            }
            function initPage() {
                if (NRIAOService.resumeNRIresponse || NRIAOService.review) {
                    if (NRIAOService.resumeNRIresponse.branchPref != null) {
                        if (NRIAOService.resumeNRIresponse.branchPref) {
                            personalPanDetailsdetailsVm.branch = true;
                            personalPanDetailsdetailsVm.gnc = false;
                        } else {
                            personalPanDetailsdetailsVm.branch = false;
                            personalPanDetailsdetailsVm.gnc = true;
                        }
                    }
                    personalPanDetailsdetailsVm.toggleCard = 'OA';
                    if (NRIAOService.resumeNRIresponse.title != null)
                        personalPanDetailsdetailsVm.titleSelected = NRIAOService.resumeNRIresponse.title;
                    if(NRIAOService.resumeNRIresponse.title == 'O-99'){
                        personalPanDetailsdetailsVm.othersTitleDesc = NRIAOService.resumeNRIresponse.otherTitle;
                    }

                    if (NRIAOService.resumeNRIresponse.firstName != null)
                        personalPanDetailsdetailsVm.firstName = NRIAOService.resumeNRIresponse.firstName;
                    if (NRIAOService.resumeNRIresponse.middleName != null)
                        personalPanDetailsdetailsVm.middleName = NRIAOService.resumeNRIresponse.middleName;
                    if (NRIAOService.resumeNRIresponse.lastName != null)
                        personalPanDetailsdetailsVm.lastName = NRIAOService.resumeNRIresponse.lastName;
                    if (NRIAOService.resumeNRIresponse.dob != null)
                        personalPanDetailsdetailsVm.dob = NRIAOService.resumeNRIresponse.dob;
                    if (NRIAOService.resumeNRIresponse.gender != null){
                        personalPanDetailsdetailsVm.gender = NRIAOService.resumeNRIresponse.gender;
                        if(personalPanDetailsdetailsVm.gender != "Female"){
                            personalPanDetailsdetailsVm.disableMaidenName = true;
                        }
                        else{
                            personalPanDetailsdetailsVm.disableMaidenName = false;
                        }
                    }
                    if (NRIAOService.resumeNRIresponse.maidenName != null)
                        personalPanDetailsdetailsVm.maidenName = NRIAOService.resumeNRIresponse.maidenName;

                    if (NRIAOService.resumeNRIresponse.panForm60Detail != null) {
                        if (NRIAOService.resumeNRIresponse.panForm60Detail.panNo != " "  && NRIAOService.resumeNRIresponse.panForm60Detail.panNo != null &&
                        NRIAOService.resumeNRIresponse.panForm60Detail.panNo != undefined && NRIAOService.resumeNRIresponse.panForm60Detail.panNo != "") {
                            personalPanDetailsdetailsVm.panAvailable = 'Yes';
                            personalPanDetailsdetailsVm.isPanAvailable = true;
                            personalPanDetailsdetailsVm.panNumber = NRIAOService.resumeNRIresponse.panForm60Detail.panNo;
                            personalPanDetailsdetailsVm.isPanTcAgreed = NRIAOService.resumeNRIresponse.panForm60Detail.indemnityCheckbox;
                        } else {
                            personalPanDetailsdetailsVm.isPanAvailable = false;
                            personalPanDetailsdetailsVm.panAvailable = 'No';
                            personalPanDetailsdetailsVm.isPanAvailable = false;
                            personalPanDetailsdetailsVm.agriIncome = NRIAOService.resumeNRIresponse.panForm60Detail.agriIncome
                            personalPanDetailsdetailsVm.nonAgriIncome = NRIAOService.resumeNRIresponse.panForm60Detail.otherIncome
                            if (NRIAOService.resumeNRIresponse.panForm60Detail.panAppliedFlag) {
                                personalPanDetailsdetailsVm.panAppliedValue = 'Yes';
                                personalPanDetailsdetailsVm.ackNumber = NRIAOService.resumeNRIresponse.panForm60Detail.ackNo;
                                personalPanDetailsdetailsVm.panAppliedDate = NRIAOService.resumeNRIresponse.panForm60Detail.panAppliedDate;
                            } else {
                                personalPanDetailsdetailsVm.panAppliedValue = 'No';
                            }

                        }
                    }


                } else {


                    var today = new Date();
                    var maxDOBDate = new Date(today.getFullYear() - 18, today.getMonth(), today.getDate());
                    personalPanDetailsdetailsVm.dateDOBobj = {};
                    personalPanDetailsdetailsVm.dateDOBobj.dt = maxDOBDate;
                    var appliedDate = new Date(today.getFullYear(), today.getMonth(), today.getDate());
                    personalPanDetailsdetailsVm.datePanAppliedobj = {};
                    personalPanDetailsdetailsVm.datePanAppliedobj.dtPan = appliedDate;
                    personalPanDetailsdetailsVm.disableMaidenName = true;
                    personalPanDetailsdetailsVm.agriIncomeErr = false;
                    personalPanDetailsdetailsVm.nonAgriIncomeErr = false;
                    personalPanDetailsdetailsVm.panDetailCardClicked = false;

                    personalPanDetailsdetailsVm.toggleCard = 'OA';
                    personalPanDetailsdetailsVm.openAccValidated = "";
                    personalPanDetailsdetailsVm.personalDetValidated = "";
                    personalPanDetailsdetailsVm.panDetValidated = "";
                    personalPanDetailsdetailsVm.branch = false;
                    personalPanDetailsdetailsVm.gnc = false;
                    personalPanDetailsdetailsVm.titleSelected = "";
                    personalPanDetailsdetailsVm.selectedTitleCode = "";

                    personalPanDetailsdetailsVm.showManualInp = false;
                    personalPanDetailsdetailsVm.panAvailable = "";
                    personalPanDetailsdetailsVm.panNumber = "";
                    personalPanDetailsdetailsVm.isPanTcAgreed = false;
                    personalPanDetailsdetailsVm.showAgeErr = false;
                    personalPanDetailsdetailsVm.panStatusError = false;

                    // Footer variables
                    personalPanDetailsdetailsVm.showNext = true;
                    personalPanDetailsdetailsVm.showBack = false;
                    personalPanDetailsdetailsVm.disableNext = false;
                    personalPanDetailsdetailsVm.aofooter = true;

                    $translate(['MANDATORY_ERR_TXT', 'INCOME_RANGE_ERR']).then(function (translations) {
                        personalPanDetailsdetailsVm.mandatoryError = translations['MANDATORY_ERR_TXT'];
                        personalPanDetailsdetailsVm.incomeRangeError = translations['INCOME_RANGE_ERR'];
                    });
                }
            }

            personalPanDetailsdetailsVm.goToBottom = function(){
                $ionicScrollDelegate.scrollBottom();
            }


            personalPanDetailsdetailsVm.disableMaiden = function () {
                if (personalPanDetailsdetailsVm.gender == 'Female') {
                    personalPanDetailsdetailsVm.disableMaidenName = false;
                } else {

                    personalPanDetailsdetailsVm.disableMaidenName = true;
                    personalPanDetailsdetailsVm.maidenName = "";

                }
            }

            personalPanDetailsdetailsVm.validateAgriIncome = function () {

                if (personalPanDetailsdetailsVm.agriIncome > personalPanDetailsdetailsVm.maxAllowedIncome) {
                    personalPanDetailsdetailsVm.agriIncomeErr = true;
                    personalPanDetailsdetailsVm.annualIncomeErrTxt = personalPanDetailsdetailsVm.incomeRangeError;
                    return false;
                }
                else {
                    personalPanDetailsdetailsVm.agriIncomeErr = false;
                    personalPanDetailsdetailsVm.annualIncomeErrTxt = '';
                    return true;
                }
            }

            personalPanDetailsdetailsVm.validateNonAgriIncome = function () {

                if (personalPanDetailsdetailsVm.nonAgriIncome > personalPanDetailsdetailsVm.maxAllowedIncome) {
                    personalPanDetailsdetailsVm.nonAgriIncomeErr = true;
                    personalPanDetailsdetailsVm.annualIncomeErrTxt = personalPanDetailsdetailsVm.incomeRangeError;
                    return false;
                }
                else {
                    personalPanDetailsdetailsVm.nonAgriIncomeErr = false;
                    personalPanDetailsdetailsVm.annualIncomeErrTxt = '';
                    return true;
                }
            }

            var template = '<ion-popover-view class=" nri-cont-style tooltiptext nri-info-text roboto-regular ">' + '<ion-content>' +
                '<div class="" ng-bind="personalPanDetailsdetailsVm.getMaidenInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

            $scope.popover = $ionicPopover.fromTemplate(template, {
                scope: $scope
            });

            personalPanDetailsdetailsVm.maidenInfoPopup = function ($event) {
                personalPanDetailsdetailsVm.getMaidenInfoMsg = "Applicable for female applicant only";
                $scope.popover.show($event);

            };
            personalPanDetailsdetailsVm.goBack = function () {
                if (NRIAOService.resumeApplication) {
                    $state.go("menu.nriProductInfoPage");
                } else {
                    $ionicHistory.goBack();
                }

            }


            personalPanDetailsdetailsVm.selectGender = function (titleSelected) {

               if(titleSelected == 'M-01')
               {
                personalPanDetailsdetailsVm.genderMaster = ['Male','Transgender'];
                personalPanDetailsdetailsVm.othersTitleDesc = "";
               }
               else if(titleSelected == 'F-02' || titleSelected == 'F-03')
               {
                personalPanDetailsdetailsVm.genderMaster = ['Female','Transgender'];
                personalPanDetailsdetailsVm.othersTitleDesc = "";
               }
               else{
                personalPanDetailsdetailsVm.genderMaster = NRIAOService.masterList.GenderMaster;
               }
            }

            personalPanDetailsdetailsVm.goToNextPage = function () {

                personalPanDetailsdetailsVm.validateOpenAcctCard();
                if( personalPanDetailsdetailsVm.openAccValidated == "Y"){
                    personalPanDetailsdetailsVm.validatePersonalDetails();
                    if(personalPanDetailsdetailsVm.personalDetValidated == "Y"){
                        personalPanDetailsdetailsVm.panform60Valid();
                        if(personalPanDetailsdetailsVm.panDetValidated == "Y"){
                            if (personalPanDetailsdetailsVm.openAccValidated == 'Y' && personalPanDetailsdetailsVm.personalDetValidated == 'Y' && personalPanDetailsdetailsVm.panDetValidated == 'Y') {
                                personalPanDetailsdetailsVm.createSaveApplication();
                            }
                        }
                    }
                }
                
            }

            personalPanDetailsdetailsVm.createSaveApplication = function () {
                if (typeof (personalPanDetailsdetailsVm.dob) === "object") {
                    personalPanDetailsdetailsVm.dateOfBirth = personalPanDetailsdetailsVm.dob.getFullYear() + "-" + ('0' + (personalPanDetailsdetailsVm.dob.getMonth() + 1)).slice(-2) + "-" + ('0' + personalPanDetailsdetailsVm.dob.getDate()).slice(-2);
                } else {
                    personalPanDetailsdetailsVm.dateOfBirth = NRIAOService.resumeNRIresponse.dob;
                }
                if (personalPanDetailsdetailsVm.panAppliedDate != null && personalPanDetailsdetailsVm.panAppliedDate != undefined && personalPanDetailsdetailsVm.panAppliedDate != "") {
                    if (typeof (personalPanDetailsdetailsVm.panAppliedDate) === "object") {
                        personalPanDetailsdetailsVm.DateOfAppliedPan = personalPanDetailsdetailsVm.panAppliedDate.getFullYear() + "-" + ('0' + (personalPanDetailsdetailsVm.panAppliedDate.getMonth() + 1)).slice(-2) + "-" + ('0' + personalPanDetailsdetailsVm.panAppliedDate.getDate()).slice(-2);
                    } else {
                        personalPanDetailsdetailsVm.DateOfAppliedPan = NRIAOService.resumeNRIresponse.panForm60Detail.panAppliedDate;
                    }
                }
                else {
                    personalPanDetailsdetailsVm.DateOfAppliedPan = "";
                }
                if (NRIAOService.review || NRIAOService.requestNo) {

                    personalPanDetailsdetailsVm.action = "UPDATE";
                    if (NRIAOService.nreAccTypeSel && !NRIAOService.nroAccTypeSel) {
                        personalPanDetailsdetailsVm.nreAccountDetail = { "accountType": NRIAOService.nreAccTypeSel };
                        personalPanDetailsdetailsVm.nroAccountDetail = null;

                    }
                    else if (NRIAOService.nroAccTypeSel && !NRIAOService.nreAccTypeSel) {
                        personalPanDetailsdetailsVm.nreAccountDetail = null;
                        personalPanDetailsdetailsVm.nroAccountDetail = { "accountType": NRIAOService.nroAccTypeSel };
                    }                    
                    else if (NRIAOService.nreAccTypeSel && NRIAOService.nroAccTypeSel) {
                        personalPanDetailsdetailsVm.nreAccountDetail = {"accountType": NRIAOService.nreAccTypeSel};
                        personalPanDetailsdetailsVm.nroAccountDetail = {"accountType": NRIAOService.nroAccTypeSel};
                    }else{
                        personalPanDetailsdetailsVm.nreAccountDetail = NRIAOService.resumeNRIresponse.nreAccountDetail;
                        personalPanDetailsdetailsVm.nroAccountDetail = NRIAOService.resumeNRIresponse.nroAccountDetail;
                    }

                    

                  
                    var requestCreateApp = {
                        "id": NRIAOService.countryCode + NRIAOService.mobile,
                        "countryCode": NRIAOService.countryCode,
                        "mobileNo": NRIAOService.mobile,
                        "email": NRIAOService.emailId,
                        "applicantStatus": NRIAOService.applicantStatus ? NRIAOService.applicantStatus : NRIAOService.resumeNRIresponse.applicantStatus,
                        "dataSharingConsent": NRIAOService.dataSharingConsent ? NRIAOService.dataSharingConsent : NRIAOService.resumeNRIresponse.dataSharingConsent,
                        "euResident": NRIAOService.euResident ? NRIAOService.euResident : NRIAOService.resumeNRIresponse.euResident,
                        "consent": NRIAOService.consent ? NRIAOService.consent : NRIAOService.resumeNRIresponse.consent,
                        "declineConsent": NRIAOService.declineConsent ? NRIAOService.declineConsent : NRIAOService.resumeNRIresponse.declineConsent,
                        "privacyNoticeViewed": NRIAOService.privacyNoticeViewed ? NRIAOService.privacyNoticeViewed : NRIAOService.resumeNRIresponse.privacyNoticeViewed,
                        "privacyNoticeDownloaded": NRIAOService.privacyNoticeDownloaded ? NRIAOService.privacyNoticeDownloaded : NRIAOService.resumeNRIresponse.privacyNoticeDownloaded,
                        "title": personalPanDetailsdetailsVm.titleSelected,
                        "otherTitle": personalPanDetailsdetailsVm.othersTitleDesc ? personalPanDetailsdetailsVm.othersTitleDesc : " ",
                        "firstName": personalPanDetailsdetailsVm.firstName ? personalPanDetailsdetailsVm.firstName.toUpperCase() : personalPanDetailsdetailsVm.firstName,
                        "middleName": personalPanDetailsdetailsVm.middleName ? personalPanDetailsdetailsVm.middleName.toUpperCase() : " ",
                        "lastName": personalPanDetailsdetailsVm.lastName ? personalPanDetailsdetailsVm.lastName.toUpperCase() : personalPanDetailsdetailsVm.lastName,
                        "maidenName": personalPanDetailsdetailsVm.maidenName ? personalPanDetailsdetailsVm.maidenName : " ",
                        "dob": personalPanDetailsdetailsVm.dateOfBirth,
                        "gender": personalPanDetailsdetailsVm.gender,
                        "branchPref": personalPanDetailsdetailsVm.branch,
                        "panAvailable": personalPanDetailsdetailsVm.isPanAvailable,
                        "action": personalPanDetailsdetailsVm.action,
                        "review": NRIAOService.review,
                        "nreAccountDetail": personalPanDetailsdetailsVm.nreAccountDetail,
                        "nroAccountDetail": personalPanDetailsdetailsVm.nroAccountDetail,
                        "panForm60Detail": {
                            "panNo": personalPanDetailsdetailsVm.panNumber ? personalPanDetailsdetailsVm.panNumber.toUpperCase() : null,
                            "agriIncome": personalPanDetailsdetailsVm.agriIncome ? personalPanDetailsdetailsVm.agriIncome : null,
                            "otherIncome": personalPanDetailsdetailsVm.nonAgriIncome ? personalPanDetailsdetailsVm.nonAgriIncome : null,
                            "indemnityCheckbox": personalPanDetailsdetailsVm.isPanTcAgreed ? personalPanDetailsdetailsVm.isPanTcAgreed : null,
                            "panAppliedFlag": personalPanDetailsdetailsVm.panAppliedValue == 'Yes' ? true : false,
                            "ackNo": personalPanDetailsdetailsVm.ackNumber ? personalPanDetailsdetailsVm.ackNumber : null,
                            "panAppliedDate": personalPanDetailsdetailsVm.DateOfAppliedPan ? personalPanDetailsdetailsVm.DateOfAppliedPan : null
                        }
                        
                    }
                    NRIAOService.createSaveApplication(requestCreateApp).then(function (response) {
                        if (response.responseCode == '0000') {
                            NRIAOService.requestNo = response.data;
                            NRIAOService.gender = personalPanDetailsdetailsVm.gender;
                            NRIAOService.branchVisit = personalPanDetailsdetailsVm.branch;
                            $state.go("menu.fatcaDeclarationNRI");
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                }
              
                else {
                    personalPanDetailsdetailsVm.action = "SAVE";
                    if (NRIAOService.nreAccTypeSel && !NRIAOService.nroAccTypeSel) {
                        personalPanDetailsdetailsVm.nreAccountDetail = {"accountType": NRIAOService.nreAccTypeSel};
                        personalPanDetailsdetailsVm.nroAccountDetail = null;
                    }
                    else if (NRIAOService.nroAccTypeSel && !NRIAOService.nreAccTypeSel) {
                        personalPanDetailsdetailsVm.nreAccountDetail = null;
                        personalPanDetailsdetailsVm.nroAccountDetail = {"accountType": NRIAOService.nroAccTypeSel};
                    }
                    else if(NRIAOService.nreAccTypeSel && NRIAOService.nroAccTypeSel) {
                        personalPanDetailsdetailsVm.nreAccountDetail = {"accountType": NRIAOService.nreAccTypeSel};
                        personalPanDetailsdetailsVm.nroAccountDetail = {"accountType": NRIAOService.nroAccTypeSel};
                       
                    }

                    var requestCreateApp = {
                        "id": NRIAOService.countryCode + NRIAOService.mobile,
                        "countryCode": NRIAOService.countryCode,
                        "mobileNo": NRIAOService.mobile,
                        "email": NRIAOService.emailId,
                        "applicantStatus": NRIAOService.applicantStatus,
                        "dataSharingConsent": NRIAOService.dataSharingConsent,
                        "euResident": NRIAOService.euResident,
                        "consent": NRIAOService.consent,
                        "declineConsent": NRIAOService.declineConsent,
                        "privacyNoticeViewed": NRIAOService.privacyNoticeViewed ? NRIAOService.privacyNoticeViewed : null,
                        "privacyNoticeDownloaded": NRIAOService.privacyNoticeDownloaded ? NRIAOService.privacyNoticeDownloaded : null,
                        "title": personalPanDetailsdetailsVm.titleSelected,
                        "otherTitle": personalPanDetailsdetailsVm.othersTitleDesc ? personalPanDetailsdetailsVm.othersTitleDesc :null,
                        "firstName": personalPanDetailsdetailsVm.firstName ? personalPanDetailsdetailsVm.firstName.toUpperCase() : personalPanDetailsdetailsVm.firstName,
                        "middleName": personalPanDetailsdetailsVm.middleName ? personalPanDetailsdetailsVm.middleName.toUpperCase() : null,
                        "lastName": personalPanDetailsdetailsVm.lastName ? personalPanDetailsdetailsVm.lastName.toUpperCase() : personalPanDetailsdetailsVm.lastName,
                        "maidenName": personalPanDetailsdetailsVm.maidenName ? personalPanDetailsdetailsVm.maidenName : null,
                        "dob": personalPanDetailsdetailsVm.dateOfBirth,
                        "gender": personalPanDetailsdetailsVm.gender,
                        "branchPref": personalPanDetailsdetailsVm.branch,
                        "panAvailable": personalPanDetailsdetailsVm.isPanAvailable,
                        "action": personalPanDetailsdetailsVm.action,
                        "nreAccountDetail":personalPanDetailsdetailsVm.nreAccountDetail,
                        "nroAccountDetail":personalPanDetailsdetailsVm.nroAccountDetail,
                        "panForm60Detail": {
                            "panNo": personalPanDetailsdetailsVm.panNumber ? personalPanDetailsdetailsVm.panNumber.toUpperCase() : null,
                            "agriIncome": personalPanDetailsdetailsVm.agriIncome ? personalPanDetailsdetailsVm.agriIncome : null,
                            "otherIncome": personalPanDetailsdetailsVm.nonAgriIncome ? personalPanDetailsdetailsVm.nonAgriIncome : null,
                            "indemnityCheckbox": personalPanDetailsdetailsVm.isPanTcAgreed ? personalPanDetailsdetailsVm.isPanTcAgreed : null,
                            "panAppliedFlag": personalPanDetailsdetailsVm.panAppliedValue == 'Yes' ? true : false,
                            "ackNo": personalPanDetailsdetailsVm.ackNumber ? personalPanDetailsdetailsVm.ackNumber : null,
                            "panAppliedDate": personalPanDetailsdetailsVm.DateOfAppliedPan ? personalPanDetailsdetailsVm.DateOfAppliedPan : null
                        }
                    }


                    NRIAOService.createSaveApplication(requestCreateApp).then(function (response) {
                        if (response.responseCode == '0000') {
                            NRIAOService.requestNo = response.data;
                            NRIAOService.branchVisit = personalPanDetailsdetailsVm.branch;
                            NRIAOService.gender = personalPanDetailsdetailsVm.gender;
                            $state.go("menu.fatcaDeclarationNRI");
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                }
            }

            personalPanDetailsdetailsVm.openDOBdatepicker = function () {
                $scope.dateOptions = {
                    maxDate: new Date(),
                    minDate: (new Date().setYear(new Date().getFullYear() - 99)),
                    formatYear: 'yy',
                    startingDay: 1
                }
                var datePickerPopup = $ionicPopup.alert({
                    cssClass: 'rtxc-datepicker-popup',
                    template: '<div class="datePickerBlock font-size-14">' +
                        '<input type="text" datepicker="dd MMM yyyy" ng-model="personalPanDetailsdetailsVm.dateDOBobj.dt" max-date="dateOptions.maxDate" min-date="dateOptions.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>' +
                        '</div>',
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (res) {
                            datePickerPopup.close();
                        }
                    }, {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (res) {
                            personalPanDetailsdetailsVm.dob = personalPanDetailsdetailsVm.dateDOBobj.dt;
                        }
                    }],
                });
            }

            personalPanDetailsdetailsVm.openPanAppliedDatePicker = function () {
                $scope.dateOptions = {
                    maxDate: new Date(),
                    minDate: (new Date().setYear(new Date().getFullYear() - 1)),
                    formatYear: 'yy',
                    startingDay: 1
                }
                var datePickerPopup = $ionicPopup.alert({
                    cssClass: 'rtxc-datepicker-popup',
                    template: '<div class="datePickerBlock font-size-14">' +
                        '<input type="text" datepicker="dd MMM yyyy" ng-model="personalPanDetailsdetailsVm.datePanAppliedobj.dtPan" max-date="dateOptions.maxDate" min-date="dateOptions.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>' +
                        '</div>',
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (res) {
                            datePickerPopup.close();
                        }
                    }, {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (res) {
                            personalPanDetailsdetailsVm.panAppliedDate = personalPanDetailsdetailsVm.datePanAppliedobj.dtPan;
                        }
                    }],
                });
            }

            personalPanDetailsdetailsVm.toggleContent = function (item) {

                if (item == 'currLoc') {
                    personalPanDetailsdetailsVm.validatePersonalDetails();
                    if (personalPanDetailsdetailsVm.panDetailCardClicked) {
                        personalPanDetailsdetailsVm.panform60Valid();
                    }
                    personalPanDetailsdetailsVm.toggleCard = 'OA';
                }
                else if (item == 'perDet') {
                    personalPanDetailsdetailsVm.validateOpenAcctCard();
                    if (personalPanDetailsdetailsVm.panDetailCardClicked) {
                        personalPanDetailsdetailsVm.panform60Valid();
                    }
                    personalPanDetailsdetailsVm.toggleCard = 'PSD';

                }
                else if (item == 'panDet') {
                    personalPanDetailsdetailsVm.validateOpenAcctCard();
                    personalPanDetailsdetailsVm.validatePersonalDetails();
                    personalPanDetailsdetailsVm.toggleCard = 'PND';
                    personalPanDetailsdetailsVm.panDetailCardClicked = true;

                }
            }

            personalPanDetailsdetailsVm.selLocatn = function (aoThru) {
                if (aoThru == 'Branch') {
                    personalPanDetailsdetailsVm.branch = true;
                    personalPanDetailsdetailsVm.gnc = false;

                } else if (aoThru == 'Courier') {
                    personalPanDetailsdetailsVm.gnc = true;
                    personalPanDetailsdetailsVm.branch = false;

                }
                personalPanDetailsdetailsVm.openAccValidated = 'Y';
            }

            personalPanDetailsdetailsVm.panDetails = function (value) {
                if (value == 'Y') {
                    personalPanDetailsdetailsVm.panAvailable = 'Yes';
                    personalPanDetailsdetailsVm.isPanAvailable = true;
                    personalPanDetailsdetailsVm.agriIncome = "";
                    personalPanDetailsdetailsVm.nonAgriIncome = "";
                    personalPanDetailsdetailsVm.panApplied('N');
                    personalPanDetailsdetailsVm.ackNumber = "";
                    personalPanDetailsdetailsVm.DateOfAppliedPan = "";
                    personalPanDetailsdetailsVm.panAppliedDate = "";
                } else if (value == 'N') {
                    personalPanDetailsdetailsVm.panAvailable = 'No';
                    personalPanDetailsdetailsVm.isPanAvailable = false;
                    personalPanDetailsdetailsVm.panNumber = "";
                    personalPanDetailsdetailsVm.isPanTcAgreed = false;
                    
                }
                personalPanDetailsdetailsVm.panStatusError = false;
            }

            personalPanDetailsdetailsVm.panApplied = function (value) {
                if (value == 'Y') {
                    personalPanDetailsdetailsVm.panAppliedValue = 'Yes';

                } else if (value == 'N') {
                    personalPanDetailsdetailsVm.panAppliedValue = 'No';
                    personalPanDetailsdetailsVm.ackNumber = "";
                    personalPanDetailsdetailsVm.DateOfAppliedPan = "";
                }
            }

            personalPanDetailsdetailsVm.isNotNullOrUndefined = function (varNull) {
                return (varNull != null && varNull != undefined && varNull != "");
            }

            personalPanDetailsdetailsVm.validateOpenAcctCard = function () {
                if (personalPanDetailsdetailsVm.branch || personalPanDetailsdetailsVm.gnc) {
                    personalPanDetailsdetailsVm.openAccValidated = 'Y';

                } else {
                    personalPanDetailsdetailsVm.openAccValidated = 'N';
                    personalPanDetailsdetailsVm.toggleCard = 'OA';

                }
            }

            personalPanDetailsdetailsVm.validatePersonalDetails = function () {
                personalPanDetailsdetailsVm.titleSelectedNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.titleSelected);
                personalPanDetailsdetailsVm.othersTitleDescNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.othersTitleDesc);
                personalPanDetailsdetailsVm.firstNameNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.firstName);
                personalPanDetailsdetailsVm.middleNameNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.middleName);
                personalPanDetailsdetailsVm.lastNameNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.lastName);
                personalPanDetailsdetailsVm.dobNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.dob);
                personalPanDetailsdetailsVm.genderNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.gender);
                personalPanDetailsdetailsVm.maidenNameNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.maidenName);

                if (personalPanDetailsdetailsVm.titleSelected == 'O-99') {
                    if (personalPanDetailsdetailsVm.middleNameNotNull) {
                        if (personalPanDetailsdetailsVm.maidenNameNotNull) {
                            if (personalPanDetailsdetailsVm.titleSelectedNotNull && personalPanDetailsdetailsVm.othersTitleDescNotNull && personalPanDetailsdetailsVm.firstNameNotNull && personalPanDetailsdetailsVm.lastNameNotNull && personalPanDetailsdetailsVm.dobNotNull && personalPanDetailsdetailsVm.genderNotNull) {

                                if (personalPanDetailsdetailsVm.personalDetailsForm.titleSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.titleOthers.$valid && personalPanDetailsdetailsVm.personalDetailsForm.fName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.lName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.genSel.$valid) {
                                    personalPanDetailsdetailsVm.personalDetValidated = "Y";
                                }
                                else {
                                    personalPanDetailsdetailsVm.personalDetValidated = "N";
                                    personalPanDetailsdetailsVm.toggleCard = 'PSD';
                                }
                            }
                            else {
                                personalPanDetailsdetailsVm.personalDetValidated = "N";
                                personalPanDetailsdetailsVm.toggleCard = 'PSD';
                            }
                        }
                        if (!personalPanDetailsdetailsVm.maidenNameNotNull) {
                            if (personalPanDetailsdetailsVm.titleSelectedNotNull && personalPanDetailsdetailsVm.othersTitleDescNotNull && personalPanDetailsdetailsVm.firstNameNotNull && personalPanDetailsdetailsVm.lastNameNotNull && personalPanDetailsdetailsVm.dobNotNull && personalPanDetailsdetailsVm.genderNotNull) {
                                if (personalPanDetailsdetailsVm.personalDetailsForm.titleSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.titleOthers.$valid && personalPanDetailsdetailsVm.personalDetailsForm.fName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.lName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.genSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.maidenName.$valid) {
                                    personalPanDetailsdetailsVm.personalDetValidated = "Y";
                                }
                                else {
                                    personalPanDetailsdetailsVm.personalDetValidated = "N";
                                    personalPanDetailsdetailsVm.toggleCard = 'PSD';
                                }
                            }
                            else {
                                personalPanDetailsdetailsVm.personalDetValidated = "N";
                                personalPanDetailsdetailsVm.toggleCard = 'PSD';
                            }
                        }
                    }
                    if (!personalPanDetailsdetailsVm.middleNameNotNull) {
                        if (personalPanDetailsdetailsVm.maidenNameNotNull) {
                            if (personalPanDetailsdetailsVm.titleSelectedNotNull && personalPanDetailsdetailsVm.othersTitleDescNotNull && personalPanDetailsdetailsVm.firstNameNotNull && personalPanDetailsdetailsVm.lastNameNotNull
                                && personalPanDetailsdetailsVm.dobNotNull && personalPanDetailsdetailsVm.genderNotNull) {

                                if (personalPanDetailsdetailsVm.personalDetailsForm.titleSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.titleOthers.$valid && personalPanDetailsdetailsVm.personalDetailsForm.fName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.mName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.lName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.genSel.$valid) {
                                    personalPanDetailsdetailsVm.personalDetValidated = "Y";
                                }
                                else {
                                    personalPanDetailsdetailsVm.personalDetValidated = "N";
                                    personalPanDetailsdetailsVm.toggleCard = 'PSD';
                                }
                            }
                            else {
                                personalPanDetailsdetailsVm.personalDetValidated = "N";
                                personalPanDetailsdetailsVm.toggleCard = 'PSD';
                            }
                        }
                        if (!personalPanDetailsdetailsVm.maidenNameNotNull) {
                            if (personalPanDetailsdetailsVm.titleSelectedNotNull && personalPanDetailsdetailsVm.othersTitleDescNotNull && personalPanDetailsdetailsVm.firstNameNotNull && personalPanDetailsdetailsVm.lastNameNotNull &&
                                personalPanDetailsdetailsVm.dobNotNull && personalPanDetailsdetailsVm.genderNotNull) {
                                if (personalPanDetailsdetailsVm.personalDetailsForm.titleSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.titleOthers.$valid && personalPanDetailsdetailsVm.personalDetailsForm.fName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.mName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.lName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.genSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.maidenName.$valid) {
                                    personalPanDetailsdetailsVm.personalDetValidated = "Y";
                                }
                                else {
                                    personalPanDetailsdetailsVm.personalDetValidated = "N";
                                    personalPanDetailsdetailsVm.toggleCard = 'PSD';
                                }
                            }
                            else {
                                personalPanDetailsdetailsVm.personalDetValidated = "N";
                                personalPanDetailsdetailsVm.toggleCard = 'PSD';
                            }
                        }
                    }
                }

                if (personalPanDetailsdetailsVm.titleSelected != 'O-99') {
                    if (personalPanDetailsdetailsVm.middleNameNotNull) {
                        if (personalPanDetailsdetailsVm.maidenNameNotNull) {
                            if (personalPanDetailsdetailsVm.titleSelectedNotNull && personalPanDetailsdetailsVm.firstNameNotNull && personalPanDetailsdetailsVm.lastNameNotNull && personalPanDetailsdetailsVm.dobNotNull && personalPanDetailsdetailsVm.genderNotNull) {

                                if (personalPanDetailsdetailsVm.personalDetailsForm.titleSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.fName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.lName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.genSel.$valid) {
                                    personalPanDetailsdetailsVm.personalDetValidated = "Y";
                                }
                                else {
                                    personalPanDetailsdetailsVm.personalDetValidated = "N";
                                    personalPanDetailsdetailsVm.toggleCard = 'PSD';
                                }
                            }
                            else {
                                personalPanDetailsdetailsVm.personalDetValidated = "N";
                                personalPanDetailsdetailsVm.toggleCard = 'PSD';
                            }
                        }
                        if (!personalPanDetailsdetailsVm.maidenNameNotNull) {
                            if (personalPanDetailsdetailsVm.titleSelectedNotNull && personalPanDetailsdetailsVm.firstNameNotNull && personalPanDetailsdetailsVm.lastNameNotNull && personalPanDetailsdetailsVm.dobNotNull && personalPanDetailsdetailsVm.genderNotNull) {
                                if (personalPanDetailsdetailsVm.personalDetailsForm.titleSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.fName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.lName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.genSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.maidenName.$valid) {
                                    personalPanDetailsdetailsVm.personalDetValidated = "Y";
                                }
                                else {
                                    personalPanDetailsdetailsVm.personalDetValidated = "N";
                                    personalPanDetailsdetailsVm.toggleCard = 'PSD';
                                }
                            }
                            else {
                                personalPanDetailsdetailsVm.personalDetValidated = "N";
                                personalPanDetailsdetailsVm.toggleCard = 'PSD';
                            }
                        }
                    }
                    if (!personalPanDetailsdetailsVm.middleNameNotNull) {
                        if (personalPanDetailsdetailsVm.maidenNameNotNull) {
                            if (personalPanDetailsdetailsVm.titleSelectedNotNull && personalPanDetailsdetailsVm.firstNameNotNull && personalPanDetailsdetailsVm.lastNameNotNull && personalPanDetailsdetailsVm.dobNotNull && personalPanDetailsdetailsVm.genderNotNull) {

                                if (personalPanDetailsdetailsVm.personalDetailsForm.titleSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.fName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.mName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.lName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.genSel.$valid) {
                                    personalPanDetailsdetailsVm.personalDetValidated = "Y";

                                }
                                else {
                                    personalPanDetailsdetailsVm.personalDetValidated = "N";
                                    personalPanDetailsdetailsVm.toggleCard = 'PSD';
                                }
                            }
                            else {
                                personalPanDetailsdetailsVm.personalDetValidated = "N";
                                personalPanDetailsdetailsVm.toggleCard = 'PSD';
                            }
                        }
                        if (!personalPanDetailsdetailsVm.maidenNameNotNull) {
                            if (personalPanDetailsdetailsVm.titleSelectedNotNull && personalPanDetailsdetailsVm.firstNameNotNull && personalPanDetailsdetailsVm.lastNameNotNull && personalPanDetailsdetailsVm.dobNotNull && personalPanDetailsdetailsVm.genderNotNull) {
                                if (personalPanDetailsdetailsVm.personalDetailsForm.titleSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.fName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.mName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.lName.$valid && personalPanDetailsdetailsVm.personalDetailsForm.genSel.$valid && personalPanDetailsdetailsVm.personalDetailsForm.maidenName.$valid) {
                                    personalPanDetailsdetailsVm.personalDetValidated = "Y";
                                }
                                else {
                                    personalPanDetailsdetailsVm.personalDetValidated = "N";
                                    personalPanDetailsdetailsVm.toggleCard = 'PSD';
                                }
                            }
                            else {
                                personalPanDetailsdetailsVm.personalDetValidated = "N";
                                personalPanDetailsdetailsVm.toggleCard = 'PSD';
                            }
                        }
                    }
                }

                personalPanDetailsdetailsVm.birthday = new Date(personalPanDetailsdetailsVm.dob);
                personalPanDetailsdetailsVm.today = new Date();
                personalPanDetailsdetailsVm.currentAge = ((personalPanDetailsdetailsVm.today - personalPanDetailsdetailsVm.birthday) / (31557600000));
                if (Math.floor(personalPanDetailsdetailsVm.currentAge) < 18) {
                    personalPanDetailsdetailsVm.dobValidated = "N";
                    personalPanDetailsdetailsVm.toggleCard = 'PSD';
                    utilityService.showAlertPopUp("error", "Age is less than 18 years", "menu.newToSbiLanding", "", "", "");


                }
                else {
                    personalPanDetailsdetailsVm.dobValidated = "Y";
                }


            }


            personalPanDetailsdetailsVm.panform60Valid = function () {
                personalPanDetailsdetailsVm.panAvailableNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.panAvailable);
                personalPanDetailsdetailsVm.panNumberNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.panNumber);
                personalPanDetailsdetailsVm.isPanTcAgreedNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.isPanTcAgreed);
                personalPanDetailsdetailsVm.agriIncomeNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.agriIncome);
                personalPanDetailsdetailsVm.nonAgriIncomeNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.nonAgriIncome);
                personalPanDetailsdetailsVm.panAppliedNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.panAppliedValue);
                personalPanDetailsdetailsVm.ackNumberNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.ackNumber);
                personalPanDetailsdetailsVm.panAppliedDateNotNull = personalPanDetailsdetailsVm.isNotNullOrUndefined(personalPanDetailsdetailsVm.panAppliedDate);

                if (personalPanDetailsdetailsVm.panAvailableNotNull && personalPanDetailsdetailsVm.panAvailable == 'Yes') {
                    personalPanDetailsdetailsVm.panStatusError = false;

                    if (personalPanDetailsdetailsVm.panNumberNotNull && personalPanDetailsdetailsVm.isPanTcAgreedNotNull) {
                        if (personalPanDetailsdetailsVm.panDetailsForm.pNumber.$valid && personalPanDetailsdetailsVm.isPanTcAgreed) {
                            personalPanDetailsdetailsVm.panDetValidated = "Y";
                        }
                        else {
                            personalPanDetailsdetailsVm.panDetValidated = "N";
                            personalPanDetailsdetailsVm.toggleCard = 'PND';
                        }
                    }
                    else {
                        personalPanDetailsdetailsVm.panDetValidated = "N";
                        personalPanDetailsdetailsVm.toggleCard = 'PND';
                    }
                }
                else if (personalPanDetailsdetailsVm.panAvailableNotNull && personalPanDetailsdetailsVm.panAvailable == 'No') {
                    personalPanDetailsdetailsVm.panStatusError = false;

                    if (personalPanDetailsdetailsVm.agriIncomeNotNull && personalPanDetailsdetailsVm.nonAgriIncomeNotNull) {
                        if (personalPanDetailsdetailsVm.panDetailsForm.aIncome.$valid && personalPanDetailsdetailsVm.panDetailsForm.nonIncome.$valid && personalPanDetailsdetailsVm.panAppliedNotNull) {
                            personalPanDetailsdetailsVm.validAgriIncomeTrue = personalPanDetailsdetailsVm.validateAgriIncome();
                            personalPanDetailsdetailsVm.validNonAgriIncomeTrue = personalPanDetailsdetailsVm.validateNonAgriIncome();
                            if (personalPanDetailsdetailsVm.validAgriIncomeTrue && personalPanDetailsdetailsVm.validNonAgriIncomeTrue) {
                                if (personalPanDetailsdetailsVm.panAppliedNotNull && personalPanDetailsdetailsVm.panAppliedValue == 'Yes') {
                                    personalPanDetailsdetailsVm.panStatusError = false;
                                    if (personalPanDetailsdetailsVm.ackNumberNotNull && personalPanDetailsdetailsVm.panAppliedDateNotNull) {
                                        if (personalPanDetailsdetailsVm.panDetailsForm.ackNum.$valid) {
                                            personalPanDetailsdetailsVm.panDetValidated = "Y";
                                        }
                                        else {
                                            personalPanDetailsdetailsVm.panDetValidated = "N";
                                            personalPanDetailsdetailsVm.toggleCard = 'PND';
                                        }
                                    }
                                    else {
                                        personalPanDetailsdetailsVm.panDetValidated = "N";
                                        personalPanDetailsdetailsVm.toggleCard = 'PND';
                                    }
                                }

                                else if (personalPanDetailsdetailsVm.panAppliedNotNull && personalPanDetailsdetailsVm.panAppliedValue == 'No') {
                                    personalPanDetailsdetailsVm.panStatusError = false;
                                    personalPanDetailsdetailsVm.panDetValidated = "Y";
                                }
                                else {
                                    personalPanDetailsdetailsVm.panStatusError = true;
                                }
                            }
                            else {
                                personalPanDetailsdetailsVm.panDetValidated = "N";
                                personalPanDetailsdetailsVm.toggleCard = 'PND';
                            }
                        }
                        else {
                            personalPanDetailsdetailsVm.panDetValidated = "N";
                            personalPanDetailsdetailsVm.toggleCard = 'PND';
                        }
                    }
                    else {
                        personalPanDetailsdetailsVm.panDetValidated = "N";
                        personalPanDetailsdetailsVm.toggleCard = 'PND';
                    }
                }

                else if (!personalPanDetailsdetailsVm.panAvailableNotNull && (personalPanDetailsdetailsVm.panAvailable == 'No' || personalPanDetailsdetailsVm.panAvailable == '')) {

                    personalPanDetailsdetailsVm.panStatusError = true;
                    personalPanDetailsdetailsVm.panDetValidated = "N";
                    personalPanDetailsdetailsVm.toggleCard = 'PND';
                }
                else {
                    personalPanDetailsdetailsVm.panStatusError = true;

                }
            }
        }
    ]);