angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.csatNPSCESfeedbackMatters', {
                    url: '/csatNPSCESfeedbackMatters',
                    data: {
                        pageId: 'CSAT_NEW_FEEDBACK_MATTERS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/csatNew/feedbackMatters.html',
                            controller: 'feedbackMattersController',
                            controllerAs: 'feedbackMattersControllerVm'
                        }
                    }
                })

            $stateProvider
                .state('menu.feedbackPage', {
                    url: '/feedbackPage',
                    data: {
                        pageId: 'CSAT_NEW_FEEDBACK'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/csatNew/feedbackPage.html',
                            controller: 'feedbackPageController',
                            controllerAs: 'feedbackPageControllerVm'
                        }
                    }
                })

            $stateProvider
                .state('menu.feedbackThankYouPage', {
                    url: '/feedbackThankYouPage',
                    data: {
                        pageId: 'CSAT_NEW_FEEDBACK_THANK_YOU'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/csatNew/feedbackThankYouPage.html',
                            controller: 'feedbackThankYouPageController',
                            controllerAs: 'feedbackPageThankYouControllerVm'
                        }
                    }
                })
        }
    ]);
