angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
            .state('menu.newLoansLanding', {
                url: '/newLoansLanding',
                data: {
                    pageId: 'NEW_LOAN_LNDG'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/NewLoansLanding/newLoansLanding.html',
                        controller: 'newLoansLandingController',
                        controllerAs: 'newLoansLandingVm'
                    }
                }
            })

            .state('menu.newLoansEntry', {
                url: '/newLoansEntry',
                data: {
                    pageId: 'NEW_LOAN_ENTRY'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/NewLoansLanding/newLoansEntry.html',
                        controller: 'newLoansEntryController',
                        controllerAs: 'newLoansEntryVm'
                    }
                }
            })

            .state('menu.newCLCalculator', {
                url: '/newCLCalculator',
                data: {
                    pageId: 'NEW_CAR_LOAN_CALCULATOR'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/NewLoansLanding/newCLCalculator.html',
                        controller: 'newCLCalculatorController',
                        controllerAs: 'newCLCalculatorVm'
                    }
                }
            })

            .state('menu.newHLCalculator', {
                url: '/newHLCalculator',
                data: {
                    pageId: 'NEW_HOME_LOAN_CALCULATOR'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/NewLoansLanding/newHLCalculator.html',
                        controller: 'newHLCalculatorController',
                        controllerAs: 'newHLCalculatorVm'
                    }
                }
            })

            .state('menu.newPLCalculator', {
                url: '/newPLCalculator',
                data: {
                    pageId: 'NEW_PERSONAL_LOAN_CALCULATOR'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/NewLoansLanding/newPLCalculator.html',
                        controller: 'newPLCalculatorController',
                        controllerAs: 'newPLCalculatorVm'
                    }
                }
            })

            .state('menu.newPreApprovedKnowMore', {
                url: '/newPreApprovedKnowMore',
                data: {
                    pageId: 'NEW_PREAPPROVED_KNOW_MORE'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/NewLoansLanding/newPreApprovedKnowMore.html',
                        controller: 'newPreApprovedKnowMoreController',
                        controllerAs: 'newPreApprovedKnowMoreVm'
                    }
                }
            })

            .state('menu.newPreApprovedKnowMoreIHL', {
                url: '/newPreApprovedKnowMoreIHL',
                data: {
                    pageId: 'NEW_PREAPPROVED_KNOW_MORE_IHL'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/NewLoansLanding/newPreApprovedKnowMoreIHL.html',
                        controller: 'newPreApprovedKnowMoreIHLController',
                        controllerAs: 'newPreApprovedKnowMoreIHLVm'
                    }
                }
            })
        }
    ]);