'use strict';

angularApp.controller('newLoansEntryController', ["$state", "$scope", "$translate","mobilityLandingService","$ionicSideMenuDelegate","utilityService","$ionicSlideBoxDelegate","homeLoanService","automallService","$filter","homeScreenService","patwlService","getAccountDetailsService","newLoansLandingService","carLoanService","xpressCreditService","educationLoanService","goldLoanRLMSService","rxtcService","$ionicPopup","cryptoService","ompMerchantsService","mPinLoginService","loggedInUserService","instaHomeService","paclService","$ionicHistory","$timeout",
    function($state, $scope,$translate,mobilityLandingService, $ionicSideMenuDelegate, utilityService,$ionicSlideBoxDelegate,homeLoanService,automallService,$filter,homeScreenService,patwlService,getAccountDetailsService,newLoansLandingService,carLoanService,xpressCreditService,educationLoanService,goldLoanRLMSService,rxtcService,$ionicPopup,cryptoService,ompMerchantsService,mPinLoginService,loggedInUserService,instaHomeService,paclService,$ionicHistory,$timeout) {

        var newLoansEntryVm = this;
        var knowMoreRequest = {};

        newLoansEntryVm.initPage = function() {
            newLoansEntryVm.tab = 1;
            newLoansEntryVm.knowMoreDetails = {};
            newLoansEntryVm.rbiGuidelinesUrl = "";
            newLoansEntryVm.loanCategory = newLoansLandingService.getSelectedGroup().loanType;
            newLoansEntryVm.preApprovedBannerData = newLoansLandingService.getPreApprovedBannerData();

            if(newLoansEntryVm.preApprovedBannerData && newLoansEntryVm.preApprovedBannerData.length > 0){
                for (var i = 0; i < newLoansEntryVm.preApprovedBannerData.length; i++) {
                     if(newLoansEntryVm.preApprovedBannerData[i].category == 'PACL'){
                        newLoansEntryVm.preApprovedBannerCategoryPACL = newLoansEntryVm.preApprovedBannerData[i].category;
                        newLoansEntryVm.paclOfferData = newLoansEntryVm.preApprovedBannerData[i];
                    } else if(newLoansEntryVm.preApprovedBannerData[i].category == 'IHL'){
                        newLoansEntryVm.preApprovedBannerCategoryIHL = newLoansEntryVm.preApprovedBannerData[i].category;
                    }
                    
                }
            }

            if(homeLoanService.getlandingPageDetails()){
                newLoansEntryVm.groups = homeLoanService.getlandingPageDetails();
            }
            if(newLoansEntryVm.groups && newLoansEntryVm.groups.length > 0){
                for (var i = 0; i < newLoansEntryVm.groups.length; i++) {
                    if(newLoansEntryVm.loanCategory == newLoansEntryVm.groups[i].id){
                        knowMoreRequest = {
                            "url": newLoansEntryVm.groups[i].detailsService
                        }
                    }
                }
            }
            
            if(newLoansLandingService.getSelectedGroup().loanType == "home"){
                newLoansEntryVm.knowMoreDetails = newLoansLandingService.getHomeKnowMoreData().data;
                newLoansEntryVm.rbiGuidelinesUrl = newLoansLandingService.getHomeKnowMoreData().url ? newLoansLandingService.getHomeKnowMoreData().url :"";
                    newLoansEntryVm.fetchKnowMoreContent();
                    newLoansEntryVm.buttonText = homeLoanService.getButtonText();
                    if(homeLoanService.getYonoDedupeData()){
                        newLoansEntryVm.hlReferenceNo = homeLoanService.getYonoDedupeData().yonoRef ? homeLoanService.getYonoDedupeData().yonoRef :"";
                        newLoansEntryVm.resumeStatus = homeLoanService.getYonoDedupeData().status ? homeLoanService.getYonoDedupeData().status : "";
                    }
                    homeLoanService.getLoanDetail(knowMoreRequest).then(function(data) {
                        newLoansLandingService.setHomeLoanData(data);
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
            }else if(newLoansLandingService.getSelectedGroup().loanType == "car"){
                newLoansEntryVm.knowMoreDetails = newLoansLandingService.getCarKnowMoreData().data;
                newLoansEntryVm.rbiGuidelinesUrl = newLoansLandingService.getCarKnowMoreData().url ?  newLoansLandingService.getCarKnowMoreData().url : "";
                newLoansEntryVm.buttonText = carLoanService.buttonText;
                newLoansEntryVm.fetchKnowMoreContent();
                carLoanService.getCarLoanDetails(knowMoreRequest).then(function(data) {
                    newLoansLandingService.setCarLoanData(data);
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else if(newLoansLandingService.getSelectedGroup().loanType == "education"){
                newLoansEntryVm.knowMoreDetails = newLoansLandingService.getEducationKnowMoreData().data;
                newLoansEntryVm.rbiGuidelinesUrl = newLoansLandingService.getEducationKnowMoreData().url ?  newLoansLandingService.getEducationKnowMoreData().url : "";
                newLoansEntryVm.buttonText = educationLoanService.buttonText;
                newLoansEntryVm.fetchKnowMoreContent();
            }else if(newLoansLandingService.getSelectedGroup().loanType == "goldv2"){
                newLoansEntryVm.knowMoreDetails = newLoansLandingService.getGoldKnowMoreData().data;
                newLoansEntryVm.rbiGuidelinesUrl = newLoansLandingService.getGoldKnowMoreData().url ?  newLoansLandingService.getGoldKnowMoreData().url : "";
                newLoansEntryVm.buttonText = goldLoanRLMSService.getButtonText();
                newLoansEntryVm.fetchKnowMoreContent();
            }else if(newLoansLandingService.getSelectedGroup().loanType == "RTXC"){
                newLoansEntryVm.knowMoreDetails = newLoansLandingService.getPersonalKnowMoreData().data;
                newLoansEntryVm.rbiGuidelinesUrl = newLoansLandingService.getPersonalKnowMoreData().url ? newLoansLandingService.getPersonalKnowMoreData().url :"";
                newLoansEntryVm.buttonText = rxtcService.getButtonText();
                newLoansEntryVm.fetchKnowMoreContent();
                rxtcService.getKnowMoreDetails().then(function(data) {
                    rxtcService.setKnowMoreDetailsData(data);
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            utilityService.hideSpinner();
        }

        newLoansEntryVm.selTab = function(sel) {
            newLoansEntryVm.tab = sel;
        }

        newLoansEntryVm.gotoEMICalculator = function(loan){
            if(loan == "home"){
                $state.go('menu.newHLCalculator');
            }else if(loan == "car"){
                $state.go('menu.newCLCalculator');
            }else if(loan == "RTXC"){
                $state.go('menu.newPLCalculator');
            }
        }

        newLoansEntryVm.fetchKnowMoreContent = function () {
            if(newLoansEntryVm.knowMoreDetails){
                if(newLoansEntryVm.knowMoreDetails.features){
                    newLoansEntryVm.tab = 1;                  
                    newLoansEntryVm.features = newLoansEntryVm.knowMoreDetails.features;
                }
                if(newLoansEntryVm.knowMoreDetails.eligibility){
                    newLoansEntryVm.eligibilty = newLoansEntryVm.knowMoreDetails.eligibility;
                }
                if(newLoansEntryVm.knowMoreDetails.documents){
                    newLoansEntryVm.documentation = newLoansEntryVm.knowMoreDetails.documents;
                }
                if(newLoansEntryVm.knowMoreDetails.interest){
                    newLoansEntryVm.interest = newLoansEntryVm.knowMoreDetails.interest;
                }
            }
		};

        newLoansEntryVm.FlpcLanding = function () {
			$state.go('menu.flpcLanding');
		};
        newLoansEntryVm.gotoSearchSBIProperty = function () {
			newLoansEntryVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/loans/NewLoansLanding/newDisclaimerPopup.html",
                scope: $scope
            });
		};

        newLoansEntryVm.cancel = function () {        
            newLoansEntryVm.myPopup.close();
        };

        newLoansEntryVm.agree = function () {
            if (!mPinLoginService.isLoggedIn) {
                mPinLoginService.isLoggedIn = false;
            }
            var obj = {
                "pageId": "1"
            };
            ompMerchantsService.getAllCategory(obj).then(function (data) {
                for (var i = 0; i < data.length; i++) {
                    if (data[i].categoryCode.toUpperCase() == "OMPBO90") {
                        var obj = {
                        "categoryCode": data[i].categoryCode
                        };
                        ompMerchantsService.getMerchantsByCategory(obj).then(function(data) {
                            for (var i = 0; i < data.length; i++) {
                                if (data[i].merchant.categoryCode.toUpperCase() == "OMPBO90") {
                                    newLoansEntryVm.merchant = data[i];                                
                                    var mobileRedirectKey= cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + newLoansEntryVm.merchant.merchant.mobileData[0].row[0].mobileRedirectUrl).toString();

                                    var saveLeadObjData = {
                                        "leadId": "",
                                        "websiteId": newLoansEntryVm.merchant.merchant.mobileData[0].row[0].websiteId,
                                        "affiliateId": newLoansEntryVm.merchant.merchant.mobileData[0].row[0].affiliateId,
                                        "request": {
                                            "ompCcustToken": "",
                                            "loggedIn": "",
                                            "channel": "",
                                            "segId": "",
                                            "ompTokenId": "",
                                            "merchantSku": "",
                                            "prdPrice": "",
                                            "wishlistSkus": "",
                                            "ompDisValue": "",
                                            "ompDisPct": "",
                                            "ompDisType": "",
                                            "isLoggedIn": mPinLoginService.isLoggedIn
                                            },
                                        "leadParam": newLoansEntryVm.merchant.merchant.mobileData[0].row[0].leadParam,
                                        "segmentParam": newLoansEntryVm.merchant.merchant.mobileData[0].row[0].segmentParam,
                                        "affiliateIdParam": newLoansEntryVm.merchant.merchant.mobileData[0].row[0].affiliateIdParam,
                                        "mobileRedirectUrl" : newLoansEntryVm.merchant.merchant.mobileData[0].row[0].mobileRedirectUrl,
                                        "mobileRedirectKey" : mobileRedirectKey
                                    }
                                    ompMerchantsService.saveLead(saveLeadObjData).then(function (data) {
                                        var url = data.data.mobileUrl;
                                        ompMerchantsService.inChromeBrowser(url);
                                    }, function (error) {
                                        utilityService.showErrorMessage(error.responseMessage);
                                    });                                
                                }
                            }
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                }
            }, function (error) {
            utilityService.showErrorMessage(error.responseMessage);
            });
            newLoansEntryVm.myPopup.close();
        }

        newLoansEntryVm.applyLoan = function(group) {
            group = {id:group};
             if (group.id == "home") {
                var request = {
                    "loanType": group.id
                }
                homeLoanService.disableBackButton = false;
                if (homeLoanService.getYonoDedupeData().status == '0') {
                    homeLoanService.getEligiblityCheck(request).then(function(data) {
                        homeLoanService.homeBranch=data.homeBranch;
                        homeLoanService.setGroupId(group.id);
                        homeLoanService.userMaster = data;
                        if (data.status == "HL02") {
                            homeLoanService.dedupErrors = data.reasons;
                            $state.go('menu.homeLoanError');
                        } else if (data.status == "0000") {
                            $state.go('menu.homeLoanPersonalDetails');
                        } else if (data.status == "HL03") {
                            homeLoanService.multipleAppErrors = data;
                            homeLoanService.isMultipleLOS = true;
                            $state.go('menu.homeLoanRetApp');
                        }
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    homeLoanService.getLosDedupe(request).then(function (data) {
                        homeLoanService.setLosDedupeData(data);
                        homeLoanService.setGroupId(group.id);
                        $state.go('menu.homeLoanRetApp');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
             }else if (group.id == "car") {
                var request = {
                    "loanType": group.id
                }

                if (carLoanService.YonodedupeData.status == '0') {
                    carLoanService.getEligiblityCheck(request).then(function(data) {
                        carLoanService.userMaster = data;
                        carLoanService.homeBranch = data.homeBranch;
                        if (data.status == "CL02") {
                            homeLoanService.source='car';
                            homeLoanService.dedupErrors = data.reasons;
                            $state.go('menu.homeLoanError');
                        } else if (data.status == "0000") {
                            $state.go('menu.carPersonaldetails');

                        } else if (data.status == "CL03") {
                            $state.go('menu.cLExtinginLos');
                        }
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    $state.go('menu.clApplicationStatus');
                }

             }else if (group.id == "education") {
                if(newLoansLandingService.isApplyNew){
                    newLoansEntryVm.elMyPopup = $ionicPopup.show({
                        title: '',
                        cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                        templateUrl: "pages/loans/NewLoansLanding/newELConsent.html",
                        scope: $scope
                    });
                } else {
                    $state.go('menu.eduSummary');
                }
                
             }else if (group.id == "goldv2") {
                var request = {
                    "loanType": group.id
                }

                if (goldLoanRLMSService.getYonoDedupeData().status == '0') {
                    goldLoanRLMSService.getEligiblityCheck(request).then(function(data) {
                        goldLoanRLMSService.homeBranch=data.homeBranch;
                        goldLoanRLMSService.setGroupId(group.id);
                        goldLoanRLMSService.userMaster = data;
                        if (data.status == "PSGL02") {
                            goldLoanRLMSService.dedupErrors = data.reasons;
                            $state.go('menu.goldLoanErrorRLMS');
                        }else if(data.status == "0000") {
                            $state.go('menu.glPersonalDetailsRLMS');                            
                        }

                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else if (goldLoanRLMSService.getYonoDedupeData().status == '1') {
                    goldLoanRLMSService.getEligiblityCheck(request).then(function(data) {
                        goldLoanRLMSService.homeBranch = data.homeBranch;
                        goldLoanRLMSService.setGroupId(group.id);
                        goldLoanRLMSService.resumeData = data;
                        if (data.status == "PSGL02") {
                            goldLoanRLMSService.dedupErrors = data.reasons;
                            $state.go('menu.goldLoanErrorRLMS');
                        }else if(data.status == "0000") {
                            $state.go('menu.glApplicationStatusRLMS');                       
                        }
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else if (goldLoanRLMSService.getYonoDedupeData().status == '2') {
                    goldLoanRLMSService.getApplicationStatus(request).then(function(data) {
                        goldLoanRLMSService.homeBranch = data.homeBranch;
                        goldLoanRLMSService.setGroupId(group.id);
                        goldLoanRLMSService.retrieveData = data;
                        $state.go('menu.glApplicationStatusRLMS');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
             }else if (group.id == "RTXC") {
                rxtcService.salaryAccountSpecial = false;
                rxtcService.isLoanAppSanction = false;
                rxtcService.dataChangeforTNC = false;
                if (rxtcService.getYonoDedupeData().status == '0') {
                    rxtcService.getEligiblityCheck().then(function (data) {
                        rxtcService.clearAll();
                        rxtcService.rtxcPush = false;
                        rxtcService.backToDetails =  false;
                        rxtcService.resumeData = false;
                        rxtcService.setGroupId(group.id);
                        rxtcService.initialData = data;
                        rxtcService.userMaster = data.master;
                        rxtcService.yonoRef = data.yonoRef;
                        if (data.salaryAccountPackage == "DSP" || data.salaryAccountPackage == "PMSP" || data.salaryAccountPackage == "ICGSP") {
                            rxtcService.salaryAccountSpecial = true;
                        }
                        if (!rxtcService.initialData.isDuplicate && rxtcService.initialData.isSanctioned) {
                            rxtcService.isLoanAppSanction = true;
                            rxtcService.initialData.isYonoApp = false;
                            $state.go('menu.rtxcApplicationStatus');
                        }else if (!rxtcService.initialData.isYonoApp && !rxtcService.initialData.isNonYonoApp) {
                            $state.go('menu.rxtcDetails');
                        }else {
                            $state.go('menu.rtxcApplicationStatus');
                        }
                    }, function (error) {
                        if(error.responseCode == "IE01"){
                            rxtcService.showAlertPopup("error",error.responseMessage,"","menu.homeScreen","OK","","",""); 
                        }else{
                            utilityService.showErrorMessage(error.responseMessage);
                        }
                    });
                } else if (rxtcService.getYonoDedupeData().status == '1') {
                    rxtcService.getRlmsDedup().then(function (data) {
                        rxtcService.setGroupId(group.id);
                        rxtcService.resumeData = data;
                        rxtcService.userMaster = data.master;
                        rxtcService.yonoRef = data.referenceNo;
                        rxtcService.initialData = false;
                        if (!rxtcService.resumeData.isDuplicate && rxtcService.resumeData.isSanctioned) {
                            rxtcService.isLoanAppSanction = true;
                            rxtcService.resumeData.isYonoApp = false;
                            var reqParams = {
                                "isSanctioned": true
                            }                   
                            rxtcService.deleteApplication(reqParams).then(function() {
                                rxtcService.clearAll();
                                rxtcService.resumeData = false;
                                rxtcService.personalDetailCheck = false;                             
                            },function(error){
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                        }else if (rxtcService.resumeData.isDuplicate) {
                            rxtcService.resumeData.isNonYonoApp = false;
                        }
                        $state.go('menu.rtxcApplicationStatus');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
             }
        }  
           
        newLoansEntryVm.gotoAutoMall= function () {
            automallService.getEmiMasterService().then(function (emiMaster) {
                automallService.setMasterEmiData(emiMaster);
                automallService.getAutomallBanners().then(function (banner) {
                    automallService.setLandingBanners(banner);
                    automallService.getOEMListService().then(function (oemList) {
                        automallService.setOemList(oemList);
                        $state.go('menu.automall');
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                        })

                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
		}; 

        newLoansEntryVm.elTakeMeThere = function(){
            educationLoanService.getRedirection().then(function(data) {
                if(utilityService.isAndroidPlatform()){
                   ompMerchantsService.inChromeBrowser(data.url);
               }else{
                   ompMerchantsService.inAppBrowser(data.url);
               }
               newLoansEntryVm.elMyPopup.close();
           }, function(error) {
               utilityService.showErrorMessage(error.responseMessage);
           });
        }

        newLoansEntryVm.elCancel = function () {        
            newLoansEntryVm.elMyPopup.close();
        };

        newLoansEntryVm.goToPreApproved = function(category) {
            if(category == "home"){
                instaHomeService.getFetchData().then(function(data) {
                    instaHomeService.initialValueInsta();
                    if (data) {
                        instaHomeService.customer.accountno = data.loanAccountNumber;
                        instaHomeService.customer.bestofferamount = data.maxLoanAmount;
                        instaHomeService.customer.selectedamount = data.maxLoanAmount;
                        instaHomeService.customer.interestrate = data.interestRate;
                        instaHomeService.customer.loanduration = data.duration;
                        instaHomeService.customer.processingfees = data.processingFees;
                        instaHomeService.customer.creditToAccount = data.disbursementAccountNumber;
                        instaHomeService.customer.mclr = data.mclr;
                        instaHomeService.customer.nightMode = data.nightMode;
                        instaHomeService.customer.reviewProcessingFee = data.reviewProcessingFee;
                        instaHomeService.customer.minLoanAmount = data.minLoanAmount;
                        instaHomeService.customer.steppingAmount = data.steppingAmount;
                        instaHomeService.customer.customerName = data.customerName;
                    }
                    newLoansLandingService.getPreApprovedKnowMoreAPICall('IHL'); 
                }, function (error) {
                    if(error.responseCode == '0002')
                    {
                        $ionicPopup.show({
                        title: null,
                        cssClass: 'my-custom-popup',
                        template: '<div style="text-align:center"><img class="approvedIconPosition" src="img/errorImage.png"></div><div class="button_fund fontSize-subHeading roboto-light font-dark-grey">'+error.responseMessage+'</div>',
                        buttons: [{
                            text: 'OK',
                            type: 'button-assertive'
                        }]
                    });
                    }else{
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });
            }else if(category == "car"){
                paclService.setPACLData(newLoansEntryVm.paclOfferData);
                $state.go('menu.paclReqDetails');
            }
        }

        newLoansEntryVm.openInChromeBrowser = function(url){
            ompMerchantsService.inChromeBrowser(url);
        }

        newLoansEntryVm.goBacktoPrevious = function() {
            $timeout(function () {
                var backBtn = $ionicHistory.backView();
                var backState = backBtn.stateName;
                var currentStateName = $ionicHistory.currentStateName();
                if(backState == currentStateName){
                    $state.go('menu.newLoansLanding');
                } else {
                    $ionicHistory.goBack();
                }
            }, 300);
        };
       
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            newLoansEntryVm.initPage();
        });

        $scope.$on('$ionicView.afterEnter', function() {
            $timeout(function () {
                var header = document.getElementById("navEntry");
                if (header.classList) {
                    if (header.classList.contains('hide')) {
                        header.classList.remove('hide');
                    }
                }
            }, 300);
        });
	
	
        return this;
    }
]);