'use strict';

angularApp.service('newLoansLandingService',["$q","AdapterUtils","constantConfig","homeLoanService","utilityService","carLoanService","$state","educationLoanService","goldLoanRLMSService","rxtcService","homeScreenService","getAccountDetailsService","$ionicPopup","$ionicHistory",
    function($q, AdapterUtils, constantConfig, homeLoanService, utilityService, carLoanService, $state, educationLoanService, goldLoanRLMSService, rxtcService, homeScreenService, getAccountDetailsService,$ionicPopup,$ionicHistory) {
		var newLoansLandingService = this;

		var bannersData,group,homeLoanData, carLoanData, homeKnowMoreData, carKnowMoreData, personalKnowMoreData, goldKnowMoreData, educationKnowMoreData, preApprovedBannerData, preApprovedContentData;

		newLoansLandingService.loanButtonText = "";

		newLoansLandingService.setBannersData = function(data) {
            bannersData = data;
        };

        newLoansLandingService.getBannersData = function() {
            return bannersData;
        };

		newLoansLandingService.setSelectedGroup = function(data) {
            group = data;
        };

        newLoansLandingService.getSelectedGroup = function() {
            return group;
        };
		
		newLoansLandingService.setHomeLoanData = function(data) {
            homeLoanData = data;
        };

        newLoansLandingService.getHomeLoanData = function() {
            return homeLoanData;
        };

        newLoansLandingService.setCarLoanData = function(data) {
            carLoanData = data;
        };

        newLoansLandingService.getCarLoanData = function() {
            return carLoanData;
        };

        newLoansLandingService.setHomeKnowMoreData = function(data) {
            homeKnowMoreData = data;
        };

        newLoansLandingService.getHomeKnowMoreData = function() {
            return homeKnowMoreData;
        };

        newLoansLandingService.setCarKnowMoreData = function(data) {
            carKnowMoreData = data;
        };

        newLoansLandingService.getCarKnowMoreData = function() {
            return carKnowMoreData;
        };

        newLoansLandingService.setGoldKnowMoreData = function(data) {
            goldKnowMoreData = data;
        };

        newLoansLandingService.getGoldKnowMoreData = function() {
            return goldKnowMoreData;
        };

        newLoansLandingService.setPersonalKnowMoreData = function(data) {
            personalKnowMoreData = data;
        };

        newLoansLandingService.getPersonalKnowMoreData = function() {
            return personalKnowMoreData;
        };

        newLoansLandingService.setEducationKnowMoreData = function(data) {
            educationKnowMoreData = data;
        };

        newLoansLandingService.getEducationKnowMoreData = function() {
            return educationKnowMoreData;
        };
        newLoansLandingService.setPreApprovedBannerData = function(data) {
            preApprovedBannerData = data;
        };

        newLoansLandingService.getPreApprovedBannerData = function() {
            return preApprovedBannerData;
        };

        newLoansLandingService.setPreApprovedContentData = function(data) {
            preApprovedContentData = data;
        };

        newLoansLandingService.getPreApprovedContentData = function() {
            return preApprovedContentData;
        };

		newLoansLandingService.getLoansLandingData = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/loansLandingPage", {}, false).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

        newLoansLandingService.getLoansLandingKnowMoreData = function(requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/loansKnowMore", requestData, false).then(
				function(response) {
					q.resolve(response);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

        newLoansLandingService.getPreApprovedKnowMoreData = function(requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/preapproveloansKnowMore", requestData, false).then(
				function(response) {
					q.resolve(response);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

        newLoansLandingService.goToLoan = function(group) {
            utilityService.showSpinner();
            newLoansLandingService.setSelectedGroup(group);
            if (group.loanType == "home") {
                var requestHL = {
                    "loanType": group.loanType
                }
                homeLoanService.getYonoDedupe(requestHL).then(function(data) {
                    homeLoanService.setYonoDedupeData(data);  
                    var btnText = '';                  
                    if (data.status == "0") {
                        btnText = "Apply Now";
                    } else if (data.status == "1") {
                        btnText = "Resume";
                    } else if (data.status == "2") {
                        btnText = "Retrieve";
                    }
                    homeLoanService.setButtonText(btnText);
                    // get know more data
                    var payload = {
                        "loan": "Home"
                    };
                    newLoansLandingService.getLoansLandingKnowMoreData(payload).then(function(data){
                        newLoansLandingService.setHomeKnowMoreData(data);
                        newLoansLandingService.getlandingPageData();
                    },function(error){
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                }, function(error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });               
                
            } else if (group.loanType == "car") {
                var requestCL = {
                    "loanType": group.loanType
                }
                carLoanService.getYonoDedupe(requestCL).then(function(data) {
                    carLoanService.YonodedupeData = data;
                    var carBtnText ='';
                    if (data.status == "0") {
                        carBtnText = "Apply Now";
                    } else if (data.status == "1") {
                        carBtnText = "Resume";
                    }
                    carLoanService.buttonText = carBtnText;
                    // get know more data
                    var payload = {
                        "loan": "Car"
                    };
                    newLoansLandingService.getLoansLandingKnowMoreData(payload).then(function(data){
                        newLoansLandingService.setCarKnowMoreData(data);
                        newLoansLandingService.getlandingPageData(); 
                    },function(error){
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }, function(error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if(group.loanType == "education"){
                educationLoanService.knowMore().then(function (data) {
                    educationLoanService.setKnowMore(data);
                    if(educationLoanService.getKnowMore()){
                        var poilcyFeatures = educationLoanService.getKnowMore();
                        if(poilcyFeatures.accountSummary.accountflag == "true"){
                            newLoansLandingService.isApplyNew = false;
                        }else{
                            newLoansLandingService.isApplyNew = true;
                        } 

                        if(newLoansLandingService.isApplyNew){
                            educationLoanService.buttonText = "Apply Now";
                        } else {
                            educationLoanService.buttonText = "View Summary";
                        }
                        // get know more data
                        var payload = {
                            "loan": "Education"
                        };
                        newLoansLandingService.getLoansLandingKnowMoreData(payload).then(function(data){
                            newLoansLandingService.setEducationKnowMoreData(data);
                            newLoansLandingService.getlandingPageData();  
                        },function(error){
                            utilityService.hideSpinner();
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                    }
                    
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (group.loanType == "goldv2") {
                goldLoanRLMSService.getYonoDedupe().then(function(data) {
                    if (group.loanType == "goldv2") {
                        goldLoanRLMSService.setYonoDedupeData(data);  
                    }
                    var goldBtnText = '';
                    if (data.status == "0") {
                        goldBtnText = "Apply Now";
                    } else if (data.status == "1") {
                        goldBtnText = "Resume";
                    } else if (data.status == "2") {
                        goldBtnText = "Retrieve";
                    }
                    goldLoanRLMSService.setButtonText(goldBtnText);
                    // get know more data
                    var payload = {
                        "loan": "Gold"
                    };
                    newLoansLandingService.getLoansLandingKnowMoreData(payload).then(function(data){
                        newLoansLandingService.setGoldKnowMoreData(data);
                        newLoansLandingService.getlandingPageData();  
                    },function(error){
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }, function(error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (group.loanType == "RTXC") {
                rxtcService.getYonoDedupe().then(function (data) {
                    if (group.loanType == "RTXC") {
                        rxtcService.setYonoDedupeData(data);
                    }
                    var rtxcBtnText = '';
                    if (data.status == "0") {
                        rtxcBtnText = "Apply Now";
                    } else if (data.status == "1") {
                        rtxcBtnText = "Resume";
                    }
                    rxtcService.setButtonText(rtxcBtnText);
                    // get know more data
                    var payload = {
                        "loan": "Personal"
                    };
                    newLoansLandingService.getLoansLandingKnowMoreData(payload).then(function(data){
                        newLoansLandingService.setPersonalKnowMoreData(data);
                        newLoansLandingService.getlandingPageData(); 
                    },function(error){
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else if (group.loanType == "allloan") {
                homeScreenService.ishamburgerMenuRO=false;
                homeScreenService.isLoansFlag = true;
                getAccountDetailsService.tabIndex.tabIndex=2;
                newLoansLandingService.redirectToNewLoansLanding();
            }else{
                newLoansLandingService.redirectToNewLoansLanding();
                $ionicPopup.alert({
                    template: "<p class='nll-comingSoon'>Coming Soon</p>"
                });
            }
        };

        newLoansLandingService.getlandingPageData = function (){
            if(homeScreenService.ishamMenu || homeLoanService.hambergerSelectedLoanType){
                newLoansLandingService.getLoansLandingData().then(function(data){
                        newLoansLandingService.setBannersData(data);
                        newLoansLandingService.setPreApprovedBannerData(newLoansLandingService.getBannersData().preApprovedBanners);

                        var osType = '';
                        if (utilityService.isAndroidPlatform()) {
                            osType = "android";
                        }
                        if (utilityService.isIOSPlatform()) { 
                            osType = "ios";
                        }
                        var payload = {
                            "osType": osType ? osType : ''
                        }
            
                        homeLoanService.getLoanLanding(payload).then(function(data) {
                            homeLoanService.setlandingPageDetails(data.getLoans);
                            newLoansLandingService.redirectToEntryPointPage();
                        }, function(error) {
                            utilityService.hideSpinner();
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    },function(error){
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
            } else {
                newLoansLandingService.reloadFlag = false;
                $state.go('menu.newLoansEntry');
            }
        }

        newLoansLandingService.redirectToNewLoansLanding = function(){
            var currentStateName = $ionicHistory.currentStateName();
            if(currentStateName=='menu.newLoansLanding'){
                utilityService.hideSpinner();
            }else {
                utilityService.showSpinner();
            }
           
            newLoansLandingService.getLoansLandingData().then(function(data){
                newLoansLandingService.setBannersData(data);
                $state.go('menu.newLoansLanding');
            },function(error){
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        newLoansLandingService.redirectToEntryPointPage = function(){
            if(newLoansLandingService.reloadFlag){
                $state.go('menu.newLoansEntry', {}, {reload: true});
            } else {
                $state.go('menu.newLoansEntry');
                newLoansLandingService.reloadFlag = true;
            }
        }

        newLoansLandingService.getPreApprovedKnowMoreAPICall = function(category) {
            newLoansLandingService.getPreApprovedKnowMoreData({preapproveloan : category}).then(function(data) {
                newLoansLandingService.setPreApprovedContentData(data);
                newLoansLandingService.preApprovedCategory = category;
                if(category == 'IHL'){
                    $state.go('menu.newPreApprovedKnowMoreIHL');
                } else {
                    $state.go('menu.newPreApprovedKnowMore');
                }
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            }); 
        }

        return newLoansLandingService;
    }]);