angularApp.config([
    '$stateProvider',
    function($stateProvider) {
        //Cards start
        $stateProvider
            .state('menu.cardetails', {
                url: '/carDetails',
                data: {
                    pageId: 'CL_CD'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanRAAS/carDetailsRAAS.html',
                        controller: 'carDetailsRAASController',
                        controllerAs: 'carDetailsVm'
                    }
                }
            })


            .state('menu.carPersonaldetails', {
                url: '/carPersonaldetails',
                data: {
                    pageId: 'CL_CPD'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanRAAS/carPersonalDetailsRAAS.html',
                        controller: 'carPersonalDetailsRAASController',
                        controllerAs: 'carPersonalDetailsVm'
                    }
                }
            })

            .state('menu.carLoanSelectBranch', {
                url: '/carLoanSelectBranch',
                data: {
                    pageId: 'CL_SELBRNCH'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanRAAS/clSelectBranchRAAS.html',
                        controller: 'clSelectBranchRAASController',
                        controllerAs: 'clSelectBranchVm'
                    }
                }
            })

            .state('menu.carLoanAppStatus', {
                url: '/carLoanAppStatus',
                data: {
                    pageId: 'CL_SELBRNCH'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanLOS/carAppStatus.html',
                        controller: 'carAppStatusController',
                        controllerAs: 'carAppStatusVm'
                    }
                }
            })

            


            .state('menu.carLoanWorkDetails', {
                url: '/carLoanWorkDetails.html',
                data: {
                    pageId: 'CL_CWD'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanRAAS/carLoanWorkDetailsRAAS.html',
                        controller: 'carLoanWorkDetailsRAASController',
                        controllerAs: 'carLoanWorkDetailsVm'
                    }
                }
            })


            .state('menu.carLoanCalculator', {
                url: '/carLoanCalculator',
                data: {
                    pageId: 'CL_CL'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanLOS/carLoanCalculator.html',
                        controller: 'carLoanCalculatorController',
                        controllerAs: 'carLoanCalculatorVm'
                    }
                }
            })


            .state('menu.carLoancalculateEMI', {
                url: '/carLoancalculateEMI',
                data: {
                    pageId: 'CL_CEMI'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanRAAS/carLoancalculateEMIRAAS.html',
                        controller: 'carLoancalculateEMIRAASController',
                        controllerAs: 'carLoancalculateEMIVm'
                    }
                }
            })


            .state('menu.clApplicationStatus', {
                url: '/clApplicationStatus',
                data: {
                    pageId: 'CL_APS'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanRAAS/clApplicationStatusRAAS.html',
                        controller: 'clApplicationStatusRAASController',
                        controllerAs: 'clApplicationStatusVm'
                    }
                }
            })

            .state('menu.carLoanKnowMore', {
                url: '/carLoanKnowMore',
                data: {
                    pageId: 'CL_APS'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanLOS/carLoanKnowMore.html',
                        controller: 'carLoanKnowMoreController',
                        controllerAs: 'carLoanKnowMoreVm'
                    }
                }
            })



            .state('menu.cLReferenceNumber', {
                url: '/cLReferenceNumber',
                data: {
                    pageId: 'CL_REF'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanRAAS/cLReferenceNumberRAAS.html',
                        controller: 'cLReferenceNumberRAASController',
                        controllerAs: 'cLReferenceNumberVm'
                    }
                }
            })

              .state('menu.cLExtinginLos', {
                url: '/cLExtinginLos',
                data: {
                    pageId: 'CL_REF'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanRAAS/cLExistinginLosRAAS.html',
                        controller: 'cLExistinginLosRAASController',
                        controllerAs: 'cLExistinginLosVm'
                    }
                }
            })

            .state('menu.carLoanAdditionalInfo', {
                url: '/carLoanAdditionalInfo',
                data: {
                    pageId: 'CL_AI'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanRAAS/carLoanAdditionalInfoRAAS.html',
                        controller: 'carLoanAdditionalInfoRAASController',
                        controllerAs: 'carLoanAdditionalInfoVm'
                    }
                }
            })

            .state('menu.carLoanCicProcessing', {
                url: '/carLoanCicProcessing',
                data: {
                    pageId: 'CL_CP'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanRAAS/carLoanProcessingRAAS.html',
                        controller: 'carLoanProcessingRAASController',
                        controllerAs: 'carLoanProcessingVm'
                    }
                }
            })




    }
]);