"use strict";

angularApp.controller("newHomeScreenController", [
  "$timeout", "$state", "$ionicPopup", "$scope", "$rootScope", "$ionicScrollDelegate", "$ionicSlideBoxDelegate", "$filter","$translate", "homeScreenService", "getAccountDetailsService", "loggedInUserService", "customerInfoService", "instaHomeService", "paclService", "mutualFundsService","clickStreamService", "fTBeneficiaryService", "myDreamsService", "newLoansLandingService","ompOffersService","personalLoanService","safalService","newCardService", "agriMandiService", "patwlService", "pablService", "utilityService", "sampoornSurakshaService", "openAccountService", "linkCardService", "applyNowService", "cardsService", "mySecurityProfileService", "jvOffersService", "$ionicSideMenuDelegate", "myBalanceService", "currentLocationService", "cardConfig", "fixedDepositService", "aoService", "billDeskService","mobilityLandingService", "irctcService", "bhimUpiService", "ionicToast", "constantConfig", "serviceRequestService", "locateNearestBranchService","homeLoanService", "ompMerchantsService", "emaillDetailsService", "generalInsurenceHomeService", "cryptoService", "internetBankingService", "bQRService","mPinLoginService","wealthService","wearableServices", "csatServices", function (
    $timeout, $state, $ionicPopup, $scope, $rootScope, $ionicScrollDelegate, $ionicSlideBoxDelegate, $filter, $translate, homeScreenService,
    getAccountDetailsService, loggedInUserService, customerInfoService, instaHomeService, paclService, mutualFundsService,clickStreamService,
    fTBeneficiaryService, myDreamsService, newLoansLandingService, ompOffersService, personalLoanService, safalService, newCardService, agriMandiService, patwlService, pablService, utilityService, sampoornSurakshaService, openAccountService, linkCardService, applyNowService, cardsService, mySecurityProfileService, jvOffersService, $ionicSideMenuDelegate, myBalanceService, currentLocationService, cardConfig, fixedDepositService, aoService, billDeskService, mobilityLandingService, irctcService, bhimUpiService, ionicToast, constantConfig, serviceRequestService, locateNearestBranchService, homeLoanService, ompMerchantsService, emaillDetailsService, generalInsurenceHomeService, cryptoService, internetBankingService, bQRService, mPinLoginService,wealthService,wearableServices,csatServices) {
      var newHomeScreenVm = this;
      newHomeScreenVm.alertsData = [];
      newHomeScreenVm.offersData = [];
      newHomeScreenVm.dateForInsta = "";
      $rootScope.searchObj = {};
      newHomeScreenVm.isSearched = false;
      newHomeScreenVm.selectedMerchantAffiliateId = "";
      var footerContentPopup;

      function initPage() {
        $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        if (!$rootScope.bellNotificationCnt) {
          $rootScope.bellNotificationCnt = 0;
        }
        $ionicSlideBoxDelegate.update();
        $ionicSlideBoxDelegate.loop(true);
        redirectToIrctc();
      }

      function redirectToIrctc() {
        if (ompOffersService.irctcNotificationRecieved === true) {
          ompOffersService.irctcNotificationRecieved = false;
          if ("string" == typeof (irctcService.pushNotificationData)) {
            irctcService.pushNotificationData = JSON.parse(irctcService.pushNotificationData);
          }
          if (irctcService.pushNotificationData && irctcService.pushNotificationData.isTargeted) {
            irctcService.getStationMaster().then(function (data) {
                if (data.username) {
                  irctcService.userLinkedStatus = true;
                  irctcService.username = data.username;
                } else {
                  irctcService.username = "Menu";
                  irctcService.userLinkedStatus = false;
                }
                irctcService.selTab = "Y";
                $state.go('menu.bookingHistory');
              }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
          } else {
            $state.go('menu.irctcBookTicketSearch');
          }
        }
      }

      function isEmpty(obj) {
          return !Object.keys(obj).length > 0;
      }

    //Generic redirection
    newHomeScreenVm.newHomecardRedirect = function (category) {
        if (category == "shop") {
          $state.go("menu.ompMerchants");
        }
        if(category == 'bill'){
          billDeskService.billDeskToken();
        }
        if (category == "mobility") {
          mobilityLandingService.getMobilityData().then(function(data) {
				    mobilityLandingService.setBannersData(data);
            $state.go('menu.mobilityLanding');
          },function(error){
              utilityService.showErrorMessage(error.responseMessage);
          });
        }
        if (category == "train") {
          irctcService.searchTrainObj = "";
          irctcService.myList = "";
          irctcService.masterData = "";
          irctcService.selectedTrainData = "";
          irctcService.myListFullData = "";
          irctcService.infantArray = [];
          irctcService.passArray = [];
          homeScreenService.ishamburgerMenuIRCTC = false;
          $state.go("menu.irctcBookTicketSearch");
        }
        if (category == "agri") {
          agriMandiService.isUserFromSettings = false;
          if (getAccountDetailsService.accountOverviewData) {
            if (getAccountDetailsService.accountOverviewData.customerInformation.language) {
              agriMandiService.selectLanguage = getAccountDetailsService.accountOverviewData.customerInformation.language.toLowerCase();
              if (!agriMandiService.kucFlag) {
                agriMandiService.checkEligibilityKUC().then(function (data) {
                  agriMandiService.kucFlag = data.eligibilityStatus;
                  $state.go("menu.agriLanding");
                },function (error) {
                  $state.go("menu.agriLanding");
                });
              } else {
                $state.go("menu.agriLanding");
              }
            } else {
              $state.go("menu.selectLanguage");
            }
          } else {
            utilityService.showBhimUpiAlert( "alert", "Customer details are being fetched. Please try again.");
          }
        }
        if(category == 'settings'){
          $scope.showHideDrawer('close');
          $state.go('menu.settings');
        }
        if (category == "shop_best_offers") {
          $scope.showHideDrawer('close');
          homeScreenService.ishamburgerMenuShop = true;
          homeScreenService.ishamburgerShop = true;
          homeScreenService.isBackCheck = true;
          homeScreenService.menuOption = "shop";
          homeScreenService.categoryCode = 'OMPBO60';
          homeScreenService.storeSelected = 'Best Offers';
          clickStreamService.clickStreamData = "websiteId," + 'OMPBO60';
          utilityService.clearHistoryExceptCurrentView();
          if (homeScreenService.dummymenuCheck) {
            $state.go('menu.menudummy');
          }else {
            $state.go('menu.merchantList');
          }
        }
        if(category == 'pending_request'){
          $scope.showHideDrawer('close');
          $state.go('menu.pendingRequest');
        }
        if(category == 'profile'){
          $scope.showHideDrawer('close');
          var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
          if (!isEmptyCustomerInfo) {
              if (customerInfoService.customer.residentialStatus == "1") {    
                  //KYC VALIDATION start here    
                  serviceRequestService.kycValidation().then(function (data) {
                    newHomeScreenVm.kycValidation = data.flag;
                      if (newHomeScreenVm.kycValidation == "TRUE") {
                          emaillDetailsService.clearAllData();
                          $state.go('menu.emailDetails');
                      }
                  }, function (error) {
                      utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
                  });
                  //KYC VALIDATION END here
              } else {
                  var errorText = "Sorry, you cannot access Personal Details services online.Please visit / contact your home branch.";
                  utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
              }    
            } else {
                var errorData = "Something went wrong. Please try again after sometime.";
                utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");
            }
        }
        
        if(category == 'service_request_view_more'){
          $scope.showHideDrawer('close');
          homeScreenService.ishamburgerMenuSR = false;
          $state.go('menu.serviceRequest');
        }
        if(category == 'pay_via_upi_view_more'){
          $scope.showHideDrawer('close');
          homeScreenService.ishamburgerMenuFTL = false;
          newHomeScreenVm.redirectToBhimUpi("pay_via_upi_view_more");
        }
        if(category == 'financial_products'){
          $scope.showHideDrawer('close');
          utilityService.showSpinner();
          homeScreenService.ishamburgerMenuRO = false;
          jvOffersService.getJvOffersList().then(function (res) {
            utilityService.hideSpinner();
            if(res && res.offersSections.length > 0) {
              jvOffersService.setIsCrmRcmmndsExist(res.crmRcmmndsExist);
              jvOffersService.setOfferBanners(res.offersSections);
              $state.go('menu.jvOffers');
            }
          }, function (error) {
            utilityService.hideSpinner();
            utilityService.showErrorMessage(error.responseMessage);
          });
        }
        if(category == 'redeem'){
          $scope.showHideDrawer('close');
          homeScreenService.ishamburgerMenuRO = false;
          homeScreenService.isMyRewardsFlag = true;
          getAccountDetailsService.setRewTab = true;
          getAccountDetailsService.tabIndex.tabIndex = 7;
          $state.go('menu.accountOverviewMyBalance');
        }
        if(category == 'faq'){
          $scope.showHideDrawer('close');
          homeScreenService.isRedirectionFromHomeScreen = true;
          $state.go('menu.FAQ');
        }
        if(category == 'my_wearables'){
          $scope.showHideDrawer('close');
          homeScreenService.ishamburgerMenuRO = true;
          fTBeneficiaryService.isCreditCardFlag = true;
          homeScreenService.menuOption = "relationshipOverview";
          getAccountDetailsService.tabIndex.tabIndex = 6;
          if (getAccountDetailsService.accountOverviewData.customerInformation && (getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus && getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus != "1")) {
            newHomeScreenVm.popUpNRI = $ionicPopup.show({
              title: '',
              cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
              templateUrl: 'pages/newHomeScreen/nriCheckPopup.html',
              scope: $scope
            });
          } else {
            newHomeScreenVm.checkWhiteListedUsers();
          }
        }
        if(category == 'link_insurance'){
          $scope.showHideDrawer('close');
          $state.go('menu.linkingLIPolicy');
        }
        if(category == 'link_cc'){
          $scope.showHideDrawer('close');
          homeScreenService.ishamburgerMenuRO = true;
          homeScreenService.isBackCheck = true;
          homeScreenService.ishamMenu = true;
          utilityService.hideSpinner();
          utilityService.showSpinner();
          linkCardService.getLinkedCards({}).then(function (response) {
            cardsService.errorLogger(response);
            if (response.responseCode == cardConfig.responseCode["success"]) {
              newHomeScreenVm.cardList = (response.data.cards) ? response.data.cards : [];
              getAccountDetailsService.accountOverviewData.cards = response.data;
              cardsService.setCardList(newHomeScreenVm.cardList);
              newHomeScreenVm.showLinkCards = (newHomeScreenVm.cardList.length) ? false : true;
              if (newHomeScreenVm.showLinkCards) {
                utilityService.hideSpinner();
                myBalanceService.LinkCreditCards();
              } else {
                utilityService.hideSpinner();
                fTBeneficiaryService.isCreditCardFlag = true;
                homeScreenService.menuOption = "relationshipOverview";
                getAccountDetailsService.tabIndex.tabIndex = 5;
                if (myBalanceService.dummymenuCheck) {
                  $state.go('menu.menudummy');
                } else {
                  $state.go('menu.accountOverviewMyBalance');
                }
              }
            }
          }, function (error) {
            console.log(error);
          });
        }
        if(category == 'link_demat'){
          utilityService.showSpinner();
          $scope.showHideDrawer('close');
          homeScreenService.ishamMenu = true;
          homeScreenService.isBackCheck = true;
          newHomeScreenVm.accounts = getAccountDetailsService.accountOverviewData.accounts;
          mySecurityProfileService.addDetails(newHomeScreenVm.accounts);
          mySecurityProfileService.getSecProfile().then(function (data) {
            utilityService.hideSpinner();
            mutualFundsService.totalSecurities = data.securities;
            if (mutualFundsService.totalSecurities.dpList === null || mutualFundsService.totalSecurities.dpList === '') {
              $state.go('menu.linkAccount');
            }else{
              newHomeScreenVm.goToInvestments();
            }
          },function (error) {
            utilityService.hideSpinner();
            newHomeScreenVm.goToInvestments();
          });
        }
        if(category == 'quick_mf'){
          $scope.showHideDrawer('close');
          $state.go('menu.Investments');
        }
        if(category == 'apply_loan'){
          $scope.showHideDrawer('close');
          newHomeScreenVm.goToLoans();
        }
        if(category == 'my_dream'){
          $scope.showHideDrawer('close');
          homeScreenService.isBackCheck = true;
          homeScreenService.ishamMenu = true;
          myDreamsService.getDefaultDreams().then(function (response) {
            myDreamsService.defaultDreamsData = response;
            $state.go('menu.createNewDream');
            }, function (error) {
              utilityService.showBhimUpiAlert("error", error.responseMessage);
          });
        }
        if(category == 'create_fd'){
          $scope.showHideDrawer('close');
          homeScreenService.ishamMenu = true;
          homeScreenService.menuOption = "fixedDeposit";
          homeScreenService.fromHamFD = true;
          homeScreenService.ishamburgerMenuFD = true;
          fixedDepositService.initializeFDvariables();
          fixedDepositService.customer.isTaxable = false;
          getAccountDetailsService.tabIndex.tabIndex = 1;
          if (homeScreenService.dummymenuCheck) {
            $state.go('menu.menudummy');
          }else {
            $state.go('menu.fixedDeposit');
          }
        }
        if(category == 'cardless_withdrawal'){
          $scope.showHideDrawer('close');
          $state.go('menu.yonoCash');
        }
        if(category == 'nearest_branch'){
          $scope.showHideDrawer('close');
          utilityService.showSpinner();
            $timeout(function () {
              currentLocationService.getCurrentPosition().then(function (position) {
                var latitude = position.coords.latitude;
                var longitude = position.coords.longitude;
                aoService.locateByGPS.length = 0;
                var params = {
                    "latitude": latitude,
                    "longitude": longitude,
                    "branchLocator": "true"
                }
                if (utilityService.isUndefined(aoService.locateByGPS) || aoService.locateByGPS.length === 0) {
                    locateNearestBranchService.getBranchesForGeo(params).then(function (data) {
                        utilityService.hideSpinner();
                        if (!utilityService.isUndefined(data)) {
                            for (var i = 0; i < data.branches.length; i++) {
                                aoService.locateByGPS.push(data.branches[i]);
                            }
                            if (aoService.locateByGPS.length == 0) {
                                var title = '';
                                var template = 'No Branch is available within 5 km from your location';
                                var onTap = '';
                                var buttontext = 'OK';
                                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                            } else {
                                homeScreenService.isRedirectionFromHomeScreen = true;
                                $state.go('menu.locateNearestBranchByGPS');
                            }
                        }
                    }, function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                  } else {
                      utilityService.hideSpinner();
                  }
                },
                function (err) {
                    utilityService.hideSpinner();
                    var title = '';
                    var template = '{{"ON_GPS" | translate}}';
                    var onTap = '';
                    var buttontext = '<b>OK</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                });
            }, 2000);
        }
        if(category == 'quick_transfer'){
          $scope.showHideDrawer('close');
          $state.go('menu.quickTransferLanding');
        }
        if(category == 'scan_qr_code'){
          utilityService.showSpinner();
          newHomeScreenVm.redirectToBhimUpi("scan_qr_code");
        }
        if(category == 'pay_contacts'){
          $scope.showHideDrawer('close');
          newHomeScreenVm.redirectToBhimUpi("pay_contacts");
        }
        if(category == 'generate_qr'){
          $scope.showHideDrawer('close');
          newHomeScreenVm.redirectToBhimUpi("generate_qr");
        }
        if(category == 'request_payment'){
          $scope.showHideDrawer('close');
          newHomeScreenVm.redirectToBhimUpi("request_payment");
        }
	if(category == 'yono_chatbot'){
          $scope.showHideDrawer('close');
          $state.go('menu.chatbotlanding');
        }
    };

    newHomeScreenVm.closeNRI = function () {
			newHomeScreenVm.popUpNRI.close();
		}

    newHomeScreenVm.checkWhiteListedUsers = function(){
			wearableServices.isUserWhiteListed().then(function(response) {
				if (response.isUserWhiteListed == true) {
					$state.go('menu.accountOverviewMyBalance');
				}else{
					var comingsoonPopup = $ionicPopup.alert({
            template: '<div class="CSPadding font-dark-grey"><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'+ "Coming Soon" + '</div></div></div></div></div></div>',
            cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
            buttons: [{
              text: 'OK',
              type: 'button-positive',
              onTap: function (e) {
                comingsoonPopup.close();
              }
            }]
				  });
				}
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

    newHomeScreenVm.redirectToBhimUpi = function (upiType) {
        utilityService.showSpinner();
        if (!localStorage.getItem("appGenId")) {
            bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                if (device.platform.toLowerCase() == 'android') {
                    bhimUpiService.appGenId = data.appGenId;
                } else {
                    bhimUpiService.appGenId = data;
                }
                if(upiType == "scan_qr_code"){
                  newHomeScreenVm.redirectToBharatQrFloating();
                }else{
                  newHomeScreenVm.redirectToBhimUpiFlow(upiType);
                }                
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        } else {
            bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
                if(upiType == "scan_qr_code"){
                  newHomeScreenVm.redirectToBharatQrFloating();
                }else{
                  newHomeScreenVm.redirectToBhimUpiFlow(upiType);
                }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
        }
    }

    //UPI footer options
    newHomeScreenVm.redirectToBhimUpiFlow = function (upiType) {
      if (device.platform.toLowerCase() == 'android') {
          utilityService.showSpinner();
          var json = JSON.stringify({});
          bhimUpiService.getNativeData(constantConfig.upiConstant.getpermission, json).then(function (data) {
              if (data.permission === 'Allowed') {
                  newHomeScreenVm.redirectToAllowedBhimUpiJourney(upiType);
              } else {
                  utilityService.hideSpinner();
                  utilityService.showBhimUpiAlert("alert", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
              }
          }, function (msg) {
              utilityService.hideSpinner();
              utilityService.showBhimUpiAlert("error", msg);
          });
      } else if (device.platform.toLowerCase() == 'windows') {
          ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
      } else {
          utilityService.showSpinner();
          var json = JSON.stringify({
              "pspId": constantConfig.upiConstant.pspId,
              "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
          });
          bhimUpiService.getNativeData("initializeIOSsdk", json).then(function (data) {
              if (data !== "S") {
                  utilityService.hideSpinner();
                  utilityService.showBhimUpiAlert("error", data);
                  return false;
              }
              utilityService.showSpinner();
              var json = JSON.stringify({
                  "addInfo": {
                      "addInfo10": constantConfig.upiConstant.addInfo10,
                      "addInfo9": constantConfig.upiConstant.addInfo9
                  },
                  "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                  "requestInfo": {
                      "pspId": constantConfig.upiConstant.pspId,
                      "pspRefNo": generateRandomString(27)
                  },
                  "updateFlag": constantConfig.upiConstant.updateFlag,
                  "smsSent": "false"
              });
              bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                  $rootScope.checkDeviceInfo = JSON.parse(data);
                  if ($rootScope.checkDeviceInfo.status == 'S') {
                      if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                          bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                              utilityService.hideSpinner();
                              bhimUpiService.appGenId = data;
                              $state.go('menu.createNewVpa');
                          }, function (msg) {
                              utilityService.hideSpinner();
                              utilityService.showBhimUpiAlert("error", msg);
                          });
                      } else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                          utilityService.hideSpinner();
                          if ($rootScope.checkDeviceInfo.re_verify && $rootScope.checkDeviceInfo.re_verify == 'Y') {
                            utilityService.showBhimUpiAlert("alert", $rootScope.checkDeviceInfo.statusDesc);
                          } else {
                            if(upiType == "pay_contacts"){
                              newHomeScreenVm.payToContacts();
                            }else if(upiType == "generate_qr"){
                              newHomeScreenVm.generateMyQrCode();
                            }else if(upiType == "request_payment"){
                              newHomeScreenVm.requestPayment();
                            }else if(upiType == "pay_via_upi_view_more"){
                              $state.go('menu.fundtrans');
                            }                              
                          }
                      } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
                          bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                              utilityService.hideSpinner();
                              bhimUpiService.appGenId = data;
                              $state.go('menu.vpaOptions');
                          }, function (msg) {
                              utilityService.hideSpinner();
                              utilityService.showBhimUpiAlert("error", msg);
                          });
                      }
                  } else {
                      utilityService.hideSpinner();
                      utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
                  }
              }, function (msg) {
                  utilityService.hideSpinner();
                  utilityService.showBhimUpiAlert("error", msg);
              });
          }, function (msg) {
              utilityService.hideSpinner();
              utilityService.showBhimUpiAlert("error", msg);
          });
        }
    }

    newHomeScreenVm.redirectToAllowedBhimUpiJourney = function (upiType) {
      /*Sim card Info fetching - Start*/
      function simInfosuccessCallback(result) {
        if (result !== undefined && result != null && result != '') {
          if (result.cards && result.cards.length > 0) {
            customerInfoService.simCardInfo = result;
            utilityService.showSpinner();
            var json = JSON.stringify({
                "addInfo": {
                    "addInfo10": constantConfig.upiConstant.addInfo10,
                    "addInfo9": constantConfig.upiConstant.addInfo9
                },
                "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                "requestInfo": {
                    "pspId": constantConfig.upiConstant.pspId,
                    "pspRefNo": generateRandomString(27)
                },
                "updateFlag": constantConfig.upiConstant.updateFlag,
                "smsSent": false
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
              $rootScope.checkDeviceInfo = JSON.parse(data);
              if ($rootScope.checkDeviceInfo.status == 'S') {
                if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                    bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                      utilityService.hideSpinner();
                      bhimUpiService.appGenId = data.appGenId;
                      $state.go('menu.createNewVpa');
                    }, function (msg) {
                      utilityService.hideSpinner();
                      utilityService.showBhimUpiAlert("error", msg);
                    });
                } else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                    utilityService.hideSpinner();
                    if ($rootScope.checkDeviceInfo.re_verify && $rootScope.checkDeviceInfo.re_verify == 'Y') {
                      utilityService.showBhimUpiAlert("alert", $rootScope.checkDeviceInfo.statusDesc);
                    } else {
                      if(upiType == "pay_contacts"){
                        newHomeScreenVm.payToContacts();
                      }else if(upiType == "generate_qr"){
                        newHomeScreenVm.generateMyQrCode();
                      }else if(upiType == "request_payment"){
                        newHomeScreenVm.requestPayment();
                      }else if(upiType == "pay_via_upi_view_more"){
                        $state.go('menu.fundtrans');
                      }
                    }
                } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
                    bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                      utilityService.hideSpinner();
                      bhimUpiService.appGenId = data.appGenId;
                      $state.go('menu.vpaOptions');
                    }, function (msg) {
                      utilityService.hideSpinner();
                      utilityService.showBhimUpiAlert("error", msg);
                    });
                }
              } else {
                  utilityService.hideSpinner();
                  utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
              }
            }, function (msg) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", msg);
            });
            } else {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
            }
          } else {
              utilityService.hideSpinner();
              utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
          }
      }

      function HasPerminionSuccessCallback(result) {
          if (result) {
              window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
          } else {
              requestReadPermission();
          }
      }

      function errorCallback(error) {
          var elementSimInfo = document.getElementById('ErrorInfo');
          elementSimInfo.innerHTML = error;
      }

      function requestSuccessCallback(result) {
          if (result) {
              hasReadPermission();
          }
      }

      // Android only: check permission
      function hasReadPermission() {
          window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
      }

      // Android only: request permission
      function requestReadPermission() {
          window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
      }

      hasReadPermission();
      /*Sim card Info fetching - End*/
    };

    //UPI floating scan QR
    newHomeScreenVm.redirectToBharatQrFloating = function () {
      if (device.platform.toLowerCase() == 'android') {
        utilityService.showSpinner();
        var json = JSON.stringify({});
        bhimUpiService.getNativeData(constantConfig.upiConstant.getpermission, json).then(function (data) {
          if (data.permission === 'Allowed') {
            newHomeScreenVm.redirectToBharatQRJourney();
          } else {
            utilityService.hideSpinner();
            utilityService.showBhimUpiAlert("alert", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
          }
        }, function (msg) {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("error", msg);
        });
      } else if (device.platform.toLowerCase() == 'windows') {
        ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
      } else {
        utilityService.showSpinner();
        var json = JSON.stringify({
          "pspId": constantConfig.upiConstant.pspId,
          "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
        });
        bhimUpiService.getNativeData("initializeIOSsdk", json).then(function (data) {
          if (data !== "S") {
            utilityService.hideSpinner();
            utilityService.showBhimUpiAlert("error", data);
            return false;
          }
          utilityService.showSpinner();
          var json = JSON.stringify({
            "addInfo": {
              "addInfo10": constantConfig.upiConstant.addInfo10,
              "addInfo9": constantConfig.upiConstant.addInfo9
            },
            "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
            "requestInfo": {
              "pspId": constantConfig.upiConstant.pspId,
              "pspRefNo": generateRandomString(27)
            },
            "updateFlag": constantConfig.upiConstant.updateFlag,
            "smsSent": "false"
          });
          bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
            $rootScope.checkDeviceInfo = JSON.parse(data);
            utilityService.hideSpinner();
            if ($rootScope.checkDeviceInfo.status == 'S') {
              if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                utilityService.showBhimUpiAlert("alert", "Looks like you do not have a UPI profile to make payments. Please register UPI for making further transactions", "menu.createNewVpa");
              } else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                customerInfoService.scanQrEntrypoint = 'FTLANDING';
                customerInfoService.payerDetails = {};
                customerInfoService.payeeDetails = {};
                newHomeScreenVm.scanQrCode();
              } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
                utilityService.showBhimUpiAlert("alert", "Looks like you have changed Device/Sim. Please register UPI for making further transactions", "menu.vpaOptions");
              }
            } else {
              utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
            }
          }, function (msg) {
            utilityService.hideSpinner();
            utilityService.showBhimUpiAlert("error", msg);
          });
        }, function (msg) {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("error", msg);
        });
      }
    }

    // UPI Pay Contacts
    newHomeScreenVm.payToContacts = function () {
			fTBeneficiaryService.tabIndexVal = "";
			if (device.platform.toLowerCase() == 'android') {
				bhimUpiService.getNativeData("getcontactpermission", {}).then(function (data) {
					if (data.contactpermission === 'Allowed') {
						bhimUpiService.getNativeData("openContacts", {}).then(function (data) {
							  newHomeScreenVm.payToContactJourney(data);
						}, function (msg) {
							utilityService.hideSpinner();
							utilityService.showBhimUpiAlert("error", msg);
						});
					} else {
						utilityService.hideSpinner();
						ionicToast.show("Contact permission denied. Please allow to proceed", 'bottom', false, 3000);
					}
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			} else {
				bhimUpiService.getNativeData("openContacts", {}).then(function (data) {
            newHomeScreenVm.payToContactJourney(data);
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			}
		}

    newHomeScreenVm.payToContactJourney = function (contactData) {
      bhimUpiService.selectMobileNumber(contactData).then(function (response) {
        var mobNumber = response;
        bhimUpiService.verifyMobileNumber(mobNumber).then(function (verifyMobResponse) {
            if (verifyMobResponse && verifyMobResponse.accntDetails && verifyMobResponse.accntDetails.length > 0) {
                bhimUpiService.payToContactData.payment_type = 'account';
                bhimUpiService.payToContactData.account_number = verifyMobResponse.accntDetails[0].accountNumber;
                utilityService.showBhimUpiAlert("alert", "Beneficiary mobile number is already linked to SBI A/C. Please use ‘PreLogin – Quick Pay’ option to proceed");
            }else if (verifyMobResponse && verifyMobResponse.vpaAccountDetails && verifyMobResponse.vpaAccountDetails.length > 0) {
              bhimUpiService.payToContactData.payment_type = 'vpa';
              var upiId =verifyMobResponse.vpaAccountDetails[0].virtualAddress;
              utilityService.showSpinner();
              bhimUpiService.checkVirtualAddress(upiId).then(function (upiRespone) {
                var checkVpaResponse = JSON.parse(upiRespone);
                if (checkVpaResponse.status == 'VE') {
                  customerInfoService.payeeDetails = {
                      payeeType: "VA",
                      requestType: 'pay',
                      accountNo: "",
                      ifsc: "",
                      name: checkVpaResponse.payeeType.name || "",
                      vpa: checkVpaResponse.payeeType.virtualAddress || "",
                      amount: "",
                      remark: "",
                      nickName: "",
                      phoneNumber: "",
                      savePayee: false
                  }
                  bhimUpiService.getProfile().then(function (profileResponse) {
                      utilityService.hideSpinner();
                      var getProfileResponse = JSON.parse(profileResponse);
                      if (getProfileResponse.status == "S") {
                          customerInfoService.payerProfileDtls = getProfileResponse;
                          $state.go('menu.payToVpa_PayeeDetails');
                      } else {
                          utilityService.hideSpinner();
                          utilityService.showBhimUpiAlert("alert", getProfileResponse.statusDesc);
                      }
                  },function (error) {
                      utilityService.hideSpinner();
                      utilityService.showErrorMessage(error.errorMsg);
                  });
              } else {
                  utilityService.hideSpinner();
                  utilityService.showBhimUpiAlert("alert", checkVpaResponse.statusDesc);
              }
            },function (error) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", error.errorMsg);
            });
          }else {
            utilityService.showErrorMessage("It appears that no account or sbi vpa is linked to this mobile no. Please use Pay to Beneficiary or VPA");
          }
          },function (error) {
            utilityService.showErrorMessage(error.errorMsg);
          });
        },function (error) {
          utilityService.showBhimUpiAlert("Alert", error.errorMsg);
      },function (error) {
        utilityService.showBhimUpiAlert("Alert", error.errorMsg);
      });
    }

    // UPI Generate QR
    newHomeScreenVm.generateMyQrCode = function () {
      utilityService.showSpinner();
      var json = JSON.stringify({
        "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "updateFlag": constantConfig.upiConstant.updateFlag
      });
      bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json).then(function (data) {
        utilityService.hideSpinner();
        var getProfileResponse = JSON.parse(data);
        if (getProfileResponse.status == "S") {
          customerInfoService.payerProfileDtls = getProfileResponse;
          $state.go('menu.viewMyQrCode');
        } else {
          utilityService.showBhimUpiAlert("error", getProfileResponse.statusDesc);
        }
      }, function (msg) {
        utilityService.hideSpinner();
        utilityService.showBhimUpiAlert("error", msg);
      });
		}

    //UPI Payment Request 
    newHomeScreenVm.requestPayment = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag
			});
			bhimUpiService.getNativeData(constantConfig.upiConstant.getcollectList, json).then(function (data) {
				var collectRequestsResp = JSON.parse(data);
				utilityService.hideSpinner();
				if (collectRequestsResp.status == 'S') {
					customerInfoService.collectRequestsList = collectRequestsResp.collectList;
					$state.go('menu.pendingRequests');
				} else {
					utilityService.showBhimUpiAlert("error", collectRequestsResp.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				utilityService.showBhimUpiAlert("error", msg);
			});
		}

    $scope.draggedStyle = {
      bottom: '20px',
      right: '20px'
    };

    var onDraggableEvent = function (evt, data) {
      if (evt.name == 'draggable:start') {
        $scope.OffsetDifferenceTop = data.y - data.element[0].offsetTop;
        $scope.OffsetDifferenceLeft = data.x - data.element[0].offsetLeft;
        $scope.newTop = $scope.OffsetDifferenceTop;
        $scope.newLeft = $scope.OffsetDifferenceLeft;
      } else if (evt.name == 'draggable:end') {
        if (data.y - $scope.OffsetDifferenceTop < 20) {
          $scope.newTop = 40;
          data.y = 80;
        } else if (((data.y - $scope.OffsetDifferenceTop) + 20) > document.getElementsByClassName("nhs-homeScreenbg")[1].clientHeight) {
          $scope.newTop = 20;
          data.y = document.getElementsByClassName("nhs-homeScreenbg")[1].clientHeight;
        }
        if (data.x - $scope.OffsetDifferenceLeft < 0) {
          $scope.newLeft = 20;
          data.x = 20;
        } else if (((data.x - $scope.OffsetDifferenceLeft) + 75) > document.getElementsByClassName("nhs-homeScreenbg")[1].clientWidth) {
          $scope.newLeft = 75;
          data.x = document.getElementsByClassName("nhs-homeScreenbg")[1].clientWidth;
        }
        $scope.setPosition(data);
      }
    }

    $scope.$on('draggable:start', onDraggableEvent);
    $scope.$on('draggable:end', onDraggableEvent);
    $scope.$on('touch', onDraggableEvent);
    $scope.setPosition = function (data) {
      $scope.draggedStyle = {
        top: (data.y - $scope.newTop) + 'px',
        left: (data.x - $scope.newLeft) + 'px'
      };
    }

    //Direct Scan QR complete functionality
    newHomeScreenVm.redirectToBharatQRJourney = function () {
      /*Sim card Info fetching - Start*/
      var simInfosuccessCallback = function (result) {
        if (result !== undefined && result != null && result != '') {
          if (result.cards && result.cards.length > 0) {
            customerInfoService.simCardInfo = result;
            utilityService.showSpinner();
            var json = JSON.stringify({
              "addInfo": {
                "addInfo10": constantConfig.upiConstant.addInfo10,
                "addInfo9": constantConfig.upiConstant.addInfo9
              },
              "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
              "requestInfo": {
                "pspId": constantConfig.upiConstant.pspId,
                "pspRefNo": generateRandomString(27)
              },
              "updateFlag": constantConfig.upiConstant.updateFlag,
              "smsSent": false
            });
            bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
              $rootScope.checkDeviceInfo = JSON.parse(data);
              if ($rootScope.checkDeviceInfo.status == 'S') {
                if ($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNN') {
                  bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                    utilityService.hideSpinner();
                    bhimUpiService.appGenId = data;
                    utilityService.showBhimUpiAlert("alert", "Looks like you do not have a UPI profile to make payments. Please register UPI for making further transactions", "menu.createNewVpa");
                  }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                  });
                } else if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                  utilityService.hideSpinner();
                  if ($rootScope.checkDeviceInfo.re_verify && $rootScope.checkDeviceInfo.re_verify == 'Y') {
                    utilityService.showBhimUpiAlert("alert", $rootScope.checkDeviceInfo.statusDesc);
                  } else {
                    customerInfoService.scanQrEntrypoint = 'FTLANDING';
                    customerInfoService.payerDetails = {};
                    customerInfoService.payeeDetails = {};
                    newHomeScreenVm.scanQrCode();
                  }
                } else if (($rootScope.checkDeviceInfo.deviceStatus == 'DN' && $rootScope.checkDeviceInfo.simStatus == 'SNM') || ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNN')) {
                  bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                    utilityService.hideSpinner();
                    bhimUpiService.appGenId = data.appGenId;
                    utilityService.showBhimUpiAlert("alert", "Looks like you have changed Device/Sim. Please register UPI for making further transactions", "menu.vpaOptions");
                  }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                  });
                }
              } else {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
              }
            }, function (msg) {
              utilityService.hideSpinner();
              utilityService.showBhimUpiAlert("error", msg);
            });
          } else {
            utilityService.hideSpinner();
            utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
          }
        } else {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
        }
      }

      var HasPerminionSuccessCallback = function (result) {
        if (result) {
          window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
        } else {
          requestReadPermission();
        }
      }

      var errorCallback = function (error) {
        var elementSimInfo = document.getElementById('ErrorInfo');
        elementSimInfo.innerHTML = error;
      }

      var requestSuccessCallback = function (result) {
        if (result) {
          hasReadPermission();
        }
      }

      // Android only: check permission
      function hasReadPermission() {
        window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
      }

      // Android only: request permission
      function requestReadPermission() {
        window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
      }

      hasReadPermission();
      /*Sim card Info fetching - End*/
    };

    newHomeScreenVm.scanQrCode = function () {
      newHomeScreenVm.isBarcodeScanned = false;
      if (device.platform.toLowerCase() == 'android') {
        bhimUpiService.getNativeData(constantConfig.upiConstant.scanqrcode, {}, "YSP").then(function (data) {
          var barcodeData = data.scanResult;
          if (barcodeData.indexOf('upi://') == -1) {
            //Commented as part of new login page journey, since the subsequent flow is incomplete.
            utilityService.showBhimUpiAlert("error", "Invalid QR");					
          } else {
            goToBhimUpiPayment(barcodeData);
          }
        }, function (error) {
          utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.");
        });
      } else {
        bhimUpiService.getNativeData(constantConfig.upiConstant.scanqrcode, {}, "YSP").then(function (data) {
          var barcodeData = data;
          if (barcodeData.indexOf("upi://pay?") !== 0) {
            //Commented as part of new login page journey, since the subsequent flow is incomplete.
            utilityService.showBhimUpiAlert("error", "Invalid QR");					
          } else {
            goToBhimUpiPayment(barcodeData);
          }
        }, function (error) {
          utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.");
        });
      }
    }

    function goToBhimUpiPayment (barcodeData) {
      try {
        newHomeScreenVm.isBarcodeScanned = !utilityService.isEmpty(barcodeData);
        if (newHomeScreenVm.isBarcodeScanned) {
          newHomeScreenVm.payeeVpa = getParameterByName('pa', barcodeData);
          newHomeScreenVm.scannedImage = "img/FT/qrScanTap.svg";
          if (getParameterByName('am', barcodeData))
            newHomeScreenVm.amount = Number(getParameterByName('am', barcodeData));
          if (getParameterByName('tn', barcodeData))
            newHomeScreenVm.remark = getParameterByName('tn', barcodeData);
          if (getParameterByName('cu', barcodeData))
            newHomeScreenVm.currencyCode = getParameterByName('cu', barcodeData);
          if (getParameterByName('tr', barcodeData))
            newHomeScreenVm.ref_id = getParameterByName('tr', barcodeData);
          if (getParameterByName('mc', barcodeData))
            newHomeScreenVm.merchantCatCode = getParameterByName('mc', barcodeData);
          if (getParameterByName('mam', barcodeData))
            newHomeScreenVm.minAmount = getParameterByName('mam', barcodeData);
          if (getParameterByName('url', barcodeData))
            newHomeScreenVm.ref_url = getParameterByName('url', barcodeData);
          if (getParameterByName('tid', barcodeData))
            newHomeScreenVm.tid = getParameterByName('tid', barcodeData);			
          checkVpaAvailability();
        } else {
          newHomeScreenVm.scannedImage = "img/FT/qrScanTap.svg";
        }
      } catch (e) { }
    }

    function getParameterByName (name, url) {
      if (!url) url = window.location.href;
      name = name.replace(/[\[\]]/g, "\\$&");
      var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
      if (!results) return null;
      if (!results[2]) return '';
      if(name=='am'){
        if(results[2].search("E")!==-1 || results[2].search("e")!==-1){
          return results[2];
        }
      }			
      return decodeURIComponent(results[2].replace(/\+/g, " "));
    }

    function checkVpaAvailability () {
      if (!newHomeScreenVm.payeeVpa) {
        utilityService.showBhimUpiAlert("alert", "Please Enter Payee UPI Id");
        return false;
      }

      utilityService.showSpinner();
      var json = JSON.stringify({
        "addInfo": {
          "addInfo10": constantConfig.upiConstant.addInfo10,
          "addInfo9": constantConfig.upiConstant.addInfo9
        },
        "payeeType": {
          "virtualAddress": newHomeScreenVm.payeeVpa.toString()
        },
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "vAReqType": constantConfig.upiConstant.vAReqType_T
      });
      bhimUpiService.getNativeData(constantConfig.upiConstant.checkVirtualAddressAPI, json, "YSP").then(function (data) {
        var checkVpaResponse = JSON.parse(data);
        if (checkVpaResponse.status == 'VE') {
          customerInfoService.payeeDetails = {
            payeeType: "QR",
            requestType: 'pay',
            accountNo: "",
            ifsc: "",
            name: checkVpaResponse.payeeType.name || "",
            vpa: checkVpaResponse.payeeType.virtualAddress || "",
            amount: newHomeScreenVm.amount || "",
            remark: newHomeScreenVm.remark || "",
            nickName: "",
            phoneNumber: "",
            savePayee: false,
            currencyCode : newHomeScreenVm.currencyCode || "",
            ref_id : newHomeScreenVm.ref_id || "",
            merchantCatCode : newHomeScreenVm.merchantCatCode || "",
            minAmount : newHomeScreenVm.minAmount || "",
            ref_url : newHomeScreenVm.ref_url || "",
            tid : newHomeScreenVm.tid || ""
          }
          getProfile();
        } else {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("error", checkVpaResponse.statusDesc);
        }
      }, function (msg) {
        utilityService.hideSpinner();			
        utilityService.showBhimUpiAlert("error", "There is some technical issue while proceeding. Please retry.", "menu.prehomeLoginRevamp");
      });
    }

    function getProfile () {
      utilityService.showSpinner();
      var json = JSON.stringify({
        "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
        "requestInfo": {
          "pspId": constantConfig.upiConstant.pspId,
          "pspRefNo": generateRandomString(27)
        },
        "updateFlag": constantConfig.upiConstant.updateFlag
      });
      bhimUpiService.getNativeData(constantConfig.upiConstant.getProfile, json, "YSP").then(function (data) {
        utilityService.hideSpinner();
        var getProfileResponse = JSON.parse(data);
        if (getProfileResponse.status == "S") {
          customerInfoService.payerProfileDtls = getProfileResponse;
          $state.go('menu.payToVpa_PayeeDetails');
        } else {
            ionicToast.show(getProfileResponse.statusDesc, 'bottom', false, 3000);
          }
        }, function (msg) {
          utilityService.hideSpinner();
          utilityService.showBhimUpiAlert("error", msg);
        });
    }
    
    //Account redirection
    newHomeScreenVm.goToAccounts = function () {
      homeScreenService.ishamburgerMenuRO = false;
      homeScreenService.isAccountsFlag = true;
      getAccountDetailsService.tabIndex.tabIndex = 0;
      $state.go("menu.accountOverviewMyBalance");
    };

    //Deposits redirection
    newHomeScreenVm.goToDeposits = function () {
      homeScreenService.ishamburgerMenuRO = false;
      homeScreenService.isDepositsFlag = true;
      getAccountDetailsService.tabIndex.tabIndex = 1;
      $state.go("menu.accountOverviewMyBalance");
    };

    //Loan redirection
    newHomeScreenVm.goToLoans = function () {
      homeScreenService.ishamburgerMenuRO = false;
      homeScreenService.isLoansFlag = true;
      getAccountDetailsService.tabIndex.tabIndex = 2;
      newLoansLandingService.redirectToNewLoansLanding();
    };

    //Investment redirection
    newHomeScreenVm.goToInvestments = function () {
      myDreamsService.dreamId = "";
      homeScreenService.ishamburgerMenuRO = false;
      homeScreenService.isInvestmentFlag = true;
      getAccountDetailsService.tabIndex.tabIndex = 3;
      $state.go("menu.accountOverviewMyBalance");
    };

    //Insurance redirection
    newHomeScreenVm.goToInsurance = function () {
      homeScreenService.ishamburgerMenuRO = false;
      homeScreenService.isInsuranceFlag = true;
      getAccountDetailsService.tabIndex.tabIndex = 4;
      $state.go("menu.accountOverviewMyBalance");
    };

    //Card redirection
    newHomeScreenVm.goToCreditCardPay = function () {
      homeScreenService.ishamburgerMenuRO = false;
      fTBeneficiaryService.isCreditCardFlag = true;
      getAccountDetailsService.setRewTab = true;
      getAccountDetailsService.tabIndex.tabIndex = 5;
      $state.go("menu.accountOverviewMyBalance");
    };
    
    //Card redirection
    // newHomeScreenVm.goToMyCreditCard = function () {
    //   homeScreenService.ishamburgerMenuRO = false;
    //   fTBeneficiaryService.isCreditCardFlag = true;
    //   getAccountDetailsService.setRewTab = true;
    //   getAccountDetailsService.tabIndex.tabIndex = 5;
    //   $state.go('menu.accountOverviewMyBalance');
    // };

    //yonocash redirection
    newHomeScreenVm.fundTransfer = function () {
      homeScreenService.ishamburgerMenuFTL = false;
      $state.go("menu.fundsTransferLanding");
    };

    //yonocash redirection
    newHomeScreenVm.yonoCash = function () {
      $state.go("menu.yonoCash");
    };

    newHomeScreenVm.omp = function () {
      clickStreamService.clickStreamData = "websiteId,";
      homeScreenService.ishamburgerMenuomp = false;
      if ($rootScope.showInProgress) {
        newHomeScreenVm.showpopup();
      } else {
        $state.go("menu.ompMerchants");
      }
    };

    newHomeScreenVm.showpopup = function () {
      this.option = "sup";
      $ionicPopup.alert({template:"<p style='text-align:center;font-weight:bold;font-size:16px'>Coming Soon</p>"});
    };

    // search goes here
    newHomeScreenVm.getSearchJSONData = function () {
      if (Object.keys(homeScreenService.searchedList).length === 0) {
        homeScreenService.getSearchFunctionalityData().then( function (data) {
          homeScreenService.searchedList = data;
          newHomeScreenVm.searchedList = data;
        }, function (error) {
          console.log(error);
        });
      } else {
        newHomeScreenVm.searchedList = homeScreenService.searchedList;
      }
    };

    newHomeScreenVm.yonoSearch = function (inputItem) {
      if(inputItem.length >= 2){
        angular.element(document.querySelector(".nhs-newhomeScreenSearchContainerinput"))[0].style.color = "#ffffff";
      }else{
        angular.element(document.querySelector(".nhs-newhomeScreenSearchContainerinput"))[0].style.color = "#000000";
      }
      var arrForinputItem = [];
      var regExpInput = "";
      var str = "";
      newHomeScreenVm.filteredList = [];
      newHomeScreenVm.isSearched = false;
      var arr = [];
      if (inputItem && inputItem.length >= 2) {
        arrForinputItem = inputItem.toLowerCase().split(/[,\s]+/g);
        for (var i = 0; i < arrForinputItem.length; i++) {
          str += "(?=.*" + arrForinputItem[i] + ")";
        }
        regExpInput = new RegExp("^" + str + ".*$");
        angular.forEach(newHomeScreenVm.searchedList, function (v1, k1) {
          if (newHomeScreenVm.searchedList[k1]["searchLabel"].toString().toLowerCase().match(regExpInput)) {
            arr.push(v1);
            newHomeScreenVm.filteredList = removedDuplicateObjects(arr);
            newHomeScreenVm.isSearched = true;
            $ionicScrollDelegate.$getByHandle("search-functionality-handle").scrollTop();
          }
        });
      } else {
        newHomeScreenVm.isSearched = false;
        newHomeScreenVm.filteredList = [];
      }
      var reportStr = newHomeScreenVm.searchLabel;
      newHomeScreenVm.reportId = reportStr.replace(/\s+/g, ",").substring(0, reportStr.length) + "β";
      if (!newHomeScreenVm.isSearched && newHomeScreenVm.filteredList.length === 0 && newHomeScreenVm.searchLabel.length > 3)
        clickStreamService.clickStreamData ="CNTNT_SRCHβ" + newHomeScreenVm.reportId;
      return newHomeScreenVm.filteredList;
    };

    // selected object redirection

    newHomeScreenVm.selectedObj = function (selectedItem) {
      clickStreamService.clickStreamData ="CNTNT_SRCHβ" +newHomeScreenVm.reportId +selectedItem.phraseInDropdown;
      var spinner = $ionicPopup.show({
        cssClass: "removePopupHeader removePopupBodyPading spinnerPopup",
        templateUrl: "common/directives/templates/spinner.html",
      });
      cordova.plugins.Keyboard.close();
      setTimeout(function () {
        spinner.close();
      }, 1000);
      if (selectedItem.isRoutingToVPAView && selectedItem.isRoutingToVPAView.toLowerCase()  === "true") {
        //Code for UPI, Scan and Pay to contact
        newHomeScreenVm.redirectToBhimUpi(selectedItem);
      } else {
        var selectedValue = selectedItem.view;
        if (selectedValue.includes("goToAccounts")) {
          newHomeScreenVm.goToAccounts();
        } else if (selectedValue.includes("goToDeposits")) {
          newHomeScreenVm.goToAccounts();
        } else if (selectedValue.includes("goToLoans")) {
          newHomeScreenVm.goToLoans();
        } else if (selectedValue.includes("goToInvestments")) {
          newHomeScreenVm.goToInvestments();
        } else if (selectedValue.includes("goToInsurance")) {
          newHomeScreenVm.goToInsurance();
        } else if (selectedValue.includes("goToCreditCardPay")) {
          newHomeScreenVm.goToCreditCardPay();
        } else if (selectedValue.includes("fundTransfer")) {
          newHomeScreenVm.fundTransfer();
        } else if (selectedValue.includes("yonoCash")) {
          newHomeScreenVm.yonoCash();
        }else if(selectedValue.includes("omp")){
          newHomeScreenVm.omp();
        } else {
          console.log("Some error here");
        }
      }
    };

    // msgForNRICustomers same as old home screen controller in prod
    newHomeScreenVm.msgForNRICustomers = function () {
      var msg = $filter('translate')('MESSAGE_FOR_NRI_CUSTOMERS');
			ionicToast.show(msg, "middle", false, 7000);
			var dynamicDiv = document.createElement("div");
			var imgDiv = document.createElement("img");
			imgDiv.setAttribute("src","img/Info_icon.svg");
			imgDiv.setAttribute("style","width:30px;text-align:center;");
			dynamicDiv.appendChild(imgDiv);
			if(document.getElementsByClassName('ionic_toast')){
				document.getElementsByClassName('ionic_toast')[0].setAttribute("style","background:rgba(255,255,255,1);margin:0 10px;padding-left: 5px;padding-right: 5px;font-size:14px;border-radius:5px;color:#3F3F3F;box-shadow: 0 0 20px #4c4c4c;");
				document.getElementsByClassName('ionic_toast')[0].insertBefore(dynamicDiv,document.getElementsByClassName('ionic_toast')[0].firstChild);
				var getNRICounterFromLocalStorage = parseInt(sessionStorage.getItem('getNRICounterFromLocalStorage') ? sessionStorage.getItem('getNRICounterFromLocalStorage') : 0);
				sessionStorage.setItem('getNRICounterFromLocalStorage',getNRICounterFromLocalStorage+1);
			}
    };

    // getCustomerInfo same as old home screen controller in prod
    newHomeScreenVm.getCustomerInfo = function () {
      var user = {};
      if (!getAccountDetailsService.accountOverviewData) {
        homeScreenService.isCustCalled = true;
        homeScreenService.getCustomerInfo().then(function (data) {
            if (data.customerInformation && data.customerInformation.residentialStatus && data.customerInformation.residentialStatus === "2") {
              var getNRICounterFromLocalStorage = sessionStorage.getItem("getNRICounterFromLocalStorage");
              if (!getNRICounterFromLocalStorage || getNRICounterFromLocalStorage === "0") {
                newHomeScreenVm.msgForNRICustomers();
              }
            }
            homeScreenService.isCustCalled = false;
					  getAccountDetailsService.accountOverviewData = data;
            if (getAccountDetailsService.isProfilePwdSet && getAccountDetailsService.accountOverviewData.profilePasswordFlag) {
              getAccountDetailsService.accountOverviewData.profilePasswordFlag = true;
            }
            newHomeScreenVm.data = data.customerInformation;
            customerInfoService.customerInfo = data.customerInformation;
            newHomeScreenVm.setCustomerInofAndAccountDetails();
            newHomeScreenVm.customerAge = newHomeScreenVm.calculateAge(newHomeScreenVm.data.dob);
            if (homeScreenService.offersData && newHomeScreenVm.customerAge > 55 ) {
              newHomeScreenVm.offers = [];
              newHomeScreenVm.offers = homeScreenService.offersData.filter(function (offer) {
                return offer.category !== "SS";
              });
              homeScreenService.offersData = newHomeScreenVm.offers;
              newHomeScreenVm.offersData = newHomeScreenVm.offers;
            }
        },function (error) {
          homeScreenService.isCustCalled = false;
          $rootScope.profileImageUrl = "img/profile_placeholder.svg";
        });
      } else {
        newHomeScreenVm.data = getAccountDetailsService.accountOverviewData.customerInformation;
        if (getAccountDetailsService.isProfilePwdSet && getAccountDetailsService.accountOverviewData.profilePasswordFlag) {
          getAccountDetailsService.accountOverviewData.profilePasswordFlag = true;
        }
        newHomeScreenVm.setCustomerInofAndAccountDetails();
      }
    };    

    newHomeScreenVm.calculateAge = function (dob) {
      if (dob) {
        var today = new Date();
        var tempDate = dob;
        tempDate = tempDate.split(" ");
        var monList = [
          "JAN",
          "FEB",
          "MAR",
          "APR",
          "MAY",
          "JUN",
          "JUL",
          "AUG",
          "SEP",
          "OCT",
          "NOV",
          "DEC",
        ];
        for (var i = 0; i < monList.length; i++) {
          if (tempDate[1].toUpperCase() == monList[i]) {
            tempDate[1] = i + 1;
            break;
          }
        }
        var newTmepDate = tempDate[2] + "/" + tempDate[1] + "/" + tempDate[0];
        var birthDate = new Date(newTmepDate);
        var age = today.getFullYear() - birthDate.getFullYear();
        var m = today.getMonth() - birthDate.getMonth();
        if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
          age--;
        }
        return age;
      } else {
        return 18;
      }
    };

    newHomeScreenVm.getnotificationOffer = function () {
      if (!homeScreenService.isNotificationDataAvail) {
        newHomeScreenVm.isPageCurrent = true;
        homeScreenService.getnotificationOffer().then(function (data) {
            homeScreenService.isNotificationDataAvail = true;
            if (data.suggestedData.offers && data.suggestedData.alerts) {
              homeScreenService.alertsData = data.suggestedData.alerts;
              if (newHomeScreenVm.customerAge && newHomeScreenVm.customerAge > 55) {
                homeScreenService.offersData = data.suggestedData.offers.filter(function (offer) {
                  return offer.category !== "SS";
                });
              } else {
                homeScreenService.offersData = data.suggestedData.offers;
              }
              newHomeScreenVm.offersData = homeScreenService.offersData;
              newHomeScreenVm.alertsData = homeScreenService.alertsData;
              homeScreenService.isOfferApplicableForBell = data.suggestedData.isOfferApplicableForBell;
              homeScreenService.isOfferApplicableForThumbnail = data.suggestedData.isOfferApplicableForThumbnail;
              newHomeScreenVm.isOfferApplicableForThumbnail = data.suggestedData.isOfferApplicableForThumbnail;
              $rootScope.bellNotificationCnt = homeScreenService.getBellNotificationCount();
              for (var i = 0; i < data.suggestedData.offers.length; i++) {
                // same categories as in old home screen controller
                data.suggestedData.offers[i].category = data.suggestedData.offers[i].category.toUpperCase();
                if (data.suggestedData.offers[i].category == "SS") {
                  var eligibleSumAssured = String.fromCharCode(8377) +$filter("INR")(parseInt(data.suggestedData.offers[i].amount));
                  data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("FIELD_1}}", eligibleSumAssured).replace("Rs. ", String.fromCharCode(8377)) : eligibleSumAssured;
                }
                if (data.suggestedData.offers[i].category == "IHL") {
                  var eligibleSumAssured = $filter("INR")(parseInt(data.suggestedData.offers[i].amount));
                  data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("FIELD_1}}", eligibleSumAssured).replace("FIELD_2}}", '<a href="javscript:;">here</a>')
                    : eligibleSumAssured;
                  instaHomeService.isInstaAvail = true;
                }
                if (data.suggestedData.offers[i].category == "PAPL") {
                  var eligibleSumAssured = String.fromCharCode(8377) + $filter("INR")(parseInt(data.suggestedData.offers[i].palAmount));
                  data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace(data.suggestedData.offers[i].palAmount,eligibleSumAssured).replace("Rs. ", String.fromCharCode(8377))
                    : eligibleSumAssured;
                }
                if (data.suggestedData.offers[i].category == "WEALTH") {
                  if(data.suggestedData.offers[i].bannerFlag == "True"){
                    wealthService.bannerFlag = true;
                    data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription : '';
                  }else{
                    data.suggestedData.offers.splice(i,1);
                    wealthService.bannerFlag = false;
                  }
                }
                if (data.suggestedData.offers[i].category == "PACL") {
                  var eligibleSumAssured = $filter("INR")(parseInt(data.suggestedData.offers[i].amount));
                  data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("FIELD_1}}", eligibleSumAssured).replace("Rs. ", String.fromCharCode(8377))
                    : eligibleSumAssured;
                  paclService.setPACLData(data.suggestedData.offers[i]);
                }
                if (data.suggestedData.offers[i].category == "PA2WL") {
                  var eligibleSumAssured = $filter("INR")(parseInt(data.suggestedData.offers[i].maxLoanAmt));
                  data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("FIELD_1}}", eligibleSumAssured).replace("Rs. ", String.fromCharCode(8377)) : eligibleSumAssured;
                }
                if (data.suggestedData.offers[i].category == "SAFAL-CROP") {
                  var eligibleSumAssured = String.fromCharCode(8377) + $filter("INR")(parseInt(data.suggestedData.offers[i].amount));
                  data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("SAFAL", "<b>SAFAL</b>").replace("Loan", "<b>Loan</b>").replace("FIELD_1}}", eligibleSumAssured)
                    : eligibleSumAssured;
                }
                if (data.suggestedData.offers[i].category == "SAFAL-DAIRY") {
                  var eligibleSumAssured = String.fromCharCode(8377) + $filter("INR")(parseInt(data.suggestedData.offers[i].amount));
                  data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("SAFAL", "<b>SAFAL</b>").replace("Loan", "<b>Loan</b>").replace("FIELD_1}}", eligibleSumAssured)
                    : eligibleSumAssured;
                }               
              }
            }
            //code for ysf starts
            ompOffersService.ysfData = data;
            if (ompOffersService.ysfData.suggestedData.ysf == "TRUE") {              
              if (newHomeScreenVm.isPageCurrent) {
                newHomeScreenVm.disclaimer(ompOffersService.ysfData.suggestedData.ysfDetails);
              }
            }
            //code for ysf ends
          },function (error) {
            homeScreenService.isNotificationDataAvail = false;
            ompOffersService.ysfData = "";
          });
      } else {
        if (homeScreenService.offersData && homeScreenService.alertsData) {
          newHomeScreenVm.offersData = homeScreenService.offersData;
          newHomeScreenVm.alertsData = homeScreenService.alertsData;
          newHomeScreenVm.isOfferApplicableForThumbnail = homeScreenService.isOfferApplicableForThumbnail;
          $rootScope.bellNotificationCnt = homeScreenService.getBellNotificationCount();
        }
      }
    };

    newHomeScreenVm.disclaimer = function (offerData) {
			newHomeScreenVm.selectedOffer = offerData;
			newHomeScreenVm.myPopup = $ionicPopup.show({
				title: '',
				cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
				templateUrl: "pages/newHomeScreen/disclaimerPopup.html",
				scope: $scope
			});
		};

		newHomeScreenVm.cancel = function () {
			newHomeScreenVm.myPopup.close();
		};

		newHomeScreenVm.agree = function () {
			clickStreamService.clickStreamData = "websiteId," + "";
			newHomeScreenVm.myPopup.close();
			$state.go('menu.ompMerchants');
		}

    newHomeScreenVm.navigateEmiAlerts = function (offerData) {
      if (!customerInfoService.customer.mobile) {
        homeScreenService.getCustomerInfo().then(function (data) {
            getAccountDetailsService.accountOverviewData = data;
            customerInfoService.customer.name = data.customerInformation.customerName;
            customerInfoService.customer.type = data.customerInformation.customerType;
            customerInfoService.customer.DOB = data.customerInformation.dob;
            customerInfoService.customer.isPanAvailable = data.customerInformation.panNumber;
            customerInfoService.customer.isStaffFlag = data.customerInformation.isStaffFlag;
            customerInfoService.customer.emailID = data.customerInformation.emailID;
            customerInfoService.customer.mobile = data.customerInformation.mobile;
            customerInfoService.customer.title = data.customerInformation.title;
            customerInfoService.customer.residentialStatus = data.customerInformation.residentialStatus;
          },function (error) {
            console.log(error);
          });
      }

      offerData.category = offerData.category.toUpperCase();
      switch (offerData.category) {
        case "LI":
          generalInsurenceHomeService.setGIProductsID(offerData.category);
          $state.go("menu.sbiLifeIntro");
          break;
        case "DEMAT":
          openAccountService.setStatusOfOpenAccount(0);
          $state.go("menu.openSecurityAccount");
          break;
        case "CC":
          cardsService.setParams({cardName: offerData.name});
          $state.go("menu.cardIntroduction");
          break;
        case "PAPL":
          newHomeScreenVm.goToPAPL(offerData.category);
          break;
        case "KAVACH":
          newHomeScreenVm.goToPAPL(offerData.category);
          break;
        case "OMP":
          $state.go(offerData.stateGo);
          break;
        case "LI-RENEWAL":
          $state.go("menu.newRenewalHome");
          break;
        case "GI":
          generalInsurenceHomeService.setGIProductsID(offerData.category);
          $state.go("menu.declaimer");
          break;
        case "SS":
          sampoornSurakshaService.getPremiumAndNomineeInfo().then(function (data) {
              sampoornSurakshaService.clearAll();
              sampoornSurakshaService.setPremiumDetails(data);
              $state.go("menu.ssPremiumCalculation");
            },function (error) {
              utilityService.showErrorMessage(error.responseMessage);
            }
          );
          break;
        case "ODTA":
          if (!mutualFundsService.totalSecurities) {
            mySecurityProfileService.getSecProfile().then(function (data) {
              mutualFundsService.totalSecurities = data.securities;
              newHomeScreenVm.checkDpList();
            },function (error) {
              utilityService.showErrorMessage(error.responseMessage);
            });
          } else {
            newHomeScreenVm.checkDpList();
          }
          break;
        case "LR":
          homeScreenService.isInsuranceFlag = true;
          getAccountDetailsService.tabIndex.tabIndex = 4;
          $state.go("menu.accountOverviewMyBalance");
          break;
        case "YSS":
          homeScreenService.onYSSBuyNow();
          break;
        // YCC is not in existing prod
        // case "YCC":
        //   linkCardService.getPendingApplicationStatus({}).then(function (response) {
        //       cardsService.errorLogger(response);
        //       if (response.data) {
        //         if (response.data.allow == "false") {
        //           utilityService.hideSpinner();
        //           utilityService.enableShowErrorMessage();
        //           utilityService.showErrorMessage(response.data.allowMessage);
        //           return false;
        //         } else {
        //           allowApplication();
        //         }
        //       }
        //     },function (error) {
        //       allowApplication();
        //     });
        //   break;
        case "MF":
          $state.go("menu.mutualFunds");
          break; //Here MF developer need to confirm redirection
        case "IHL":
          newHomeScreenVm.goToIHL();
          break; //Here MF developer need to confirm redirection
        case 'WEALTH':
					newHomeScreenVm.eligibleWealth();
					break;//Here MF developer need to confirm redirection
        case "SAFAL-CROP":
          safalService.setSAFALData(offerData);
          newHomeScreenVm.goToSAFAL();
          break;
        case "SAFAL-DAIRY":
          safalService.setSAFALData(offerData);
          newHomeScreenVm.goToSAFAL(offerData);
          break;
        case "PACL":
          paclService.setPACLData(offerData);
          $state.go("menu.paclReqDetails");
          break;
        case "PA2WL":
          newHomeScreenVm.goToPATWL();
          patwlService.setOfferBannerData(offerData);
          break;
        case "PABL":
          newHomeScreenVm.goToPABL();
          break;
        default:
      }
    };

    // Not in SIT or UAT
    newHomeScreenVm.eligibleWealth = function () {
			if (wealthService.wealthLinkToKnowMore != "") {
				newHomeScreenVm.createKnowMore(wealthService.wealthLinkToKnowMore);
			} else {
				var obj = {
					"type": "wealthLinkToKnowMore"
				}
				wealthService.WealthLinkToSbiExclusif(obj).then(function (data) {
					wealthService.wealthLinkToKnowMore = data;
					newHomeScreenVm.createKnowMore(data);
				}, function (error) {

					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		}

    newHomeScreenVm.createKnowMore = function (contentWcm) {
			var template = '';
			template = '<div class ="exlusif_know_more">' + contentWcm + '</div>';
			$ionicPopup.show({
				title: '',
				template: template,
				scope: $scope,
				cssClass: 'my-custom-popup',
				buttons: [{
					text: 'OK',
					type: 'button-assertive',
					onTap: function () {
						$state.go('menu.verifyDetails');
					}
				}],
			});
		}

    newHomeScreenVm.goToPAPL = function (categoryType) {
      personalLoanService.clearAll();
      personalLoanService.getLoanDetails({ category: categoryType }).then(function (data) {
          personalLoanService.setPANDOBData();
          personalLoanService.personalLoanData = data;
          personalLoanService.minDuration = data.minTenure;
          personalLoanService.maxDuration = data.maxTenure;
          personalLoanService.interestRate = data.interestRate;
          personalLoanService.product = data.productCode;
          personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
          personalLoanService.processingFee = data.processingFee;
          personalLoanService.minBestOffer = data.minPalAmount;
          personalLoanService.activityCode = data.activityCode;
          personalLoanService.schemeCode = data.schemeCode;
          personalLoanService.categoryType = categoryType;
          if (categoryType.toUpperCase() == "PAPL") {
            newLoansLandingService.getPreApprovedKnowMoreAPICall('PAPL');
          } else {
            personalLoanService.getKavachDeclaration().then(function (data) {
              personalLoanService.kavachDeclarationText = data;
              $state.go("menu.paplKawachDeclaration");
            },
            function (error) {
              utilityService.showErrorMessage(error.responseMessage);
            });
          }
        },function (error) {
          homeScreenService.isNotificationDataAvail = false;
          newHomeScreenVm.getnotificationOffer();
          utilityService.showErrorMessage(error.responseMessage);
        });
    };

    newHomeScreenVm.goToIHL = function () {
      instaHomeService.getFetchData().then(function (data) {
          instaHomeService.initialValueInsta();
          if (data) {
            instaHomeService.customer.accountno = data.loanAccountNumber;
            instaHomeService.customer.bestofferamount = data.maxLoanAmount;
            instaHomeService.customer.selectedamount = data.maxLoanAmount;
            instaHomeService.customer.interestrate = data.interestRate;
            instaHomeService.customer.loanduration = data.duration;
            instaHomeService.customer.processingfees = data.processingFees;
            instaHomeService.customer.creditToAccount = data.disbursementAccountNumber;
            instaHomeService.customer.mclr = data.mclr;
            instaHomeService.customer.nightMode = data.nightMode;
            instaHomeService.customer.reviewProcessingFee = data.reviewProcessingFee;
            instaHomeService.customer.minLoanAmount = data.minLoanAmount;
            instaHomeService.customer.steppingAmount = data.steppingAmount;
            instaHomeService.customer.customerName = data.customerName;
          }
          newLoansLandingService.getPreApprovedKnowMoreAPICall('IHL');
        },function (error) {
          if (error.responseCode == "0002") {
            $ionicPopup.show({
              title: null,
              cssClass: "my-custom-popup",
              template:'<div style="text-align:center"><img class="approvedIconPosition" src="img/errorImage.png"></div><div class="button_fund fontSize-subHeading roboto-light font-dark-grey">' + error.responseMessage + "</div>",
              buttons: [{
                  text: "OK",
                  type: "button-assertive",
                }],
            });
          } else {
            utilityService.showErrorMessage(error.responseMessage);
          }
      });
    };

    newHomeScreenVm.goToSAFAL = function (offerData) {
      safalService.setSAFALData(offerData);
      agriMandiService.isUserFromSettings = false;
      if (getAccountDetailsService.accountOverviewData) {
        if (getAccountDetailsService.accountOverviewData.customerInformation.language) {
          agriMandiService.selectLanguage = getAccountDetailsService.accountOverviewData.customerInformation.language.toLowerCase();
          $state.go("menu.safalIntroduction");
        } else {
          $state.go("menu.selectLanguage");
        }
      } else {
        agriMandiService.langError = true;
        $state.go("menu.selectLanguage");
      }
    };

    newHomeScreenVm.goToPATWL = function () {
      patwlService.getInitialEligibility().then(function (response) {
				if (response.eligibilityResult.toUpperCase() == 'Y') {
					patwlService.setInitailEligibilityData(response);
					newLoansLandingService.getPreApprovedKnowMoreAPICall('PA2WL');
				}
			}, function (error) {
				if (error.responseCode == "IE01") {
					homeScreenService.isNotificationDataAvail = false;
					newHomeScreenVm.getnotificationOffer();
					patwlService.showAlertPopup("error", error.responseMessage, "", "menu.homeScreen", "OK", "", "", "");
				} else {
					utilityService.showErrorMessage(error.responseMessage);
				}
			});
    };  

    newHomeScreenVm.goToPABL = function() {
			pablService.getPABLBasicEligibility().then(function (response) {
				pablService.setEligibilityDetailsData(response);
				$state.go('menu.pablChoose');
			}, function (error) {
				if (error.errorType == "SO") {
					pablService.showAlertPopup("alert","Sorry!", error.responseMessage, "menu.homeScreen", "OK", "", "", "");
				}else if (error.errorType == "TA"){
					pablService.showAlertPopup("alert","Try Again!", error.responseMessage, "menu.homeScreen", "OK", "", "", "");
				}else if (error.errorType == "AA"){
					pablService.showAlertPopup("alert","Already Applied!", error.responseMessage, "menu.homeScreen", "OK", "", "", "");
				}else if (error.errorType == "TR"){
					pablService.showAlertPopup("alert","Transaction Rights", error.responseMessage, "menu.homeScreen", "OK", "", "", "");
				}else{
					pablService.showAlertPopup("error","", error.responseMessage, "menu.homeScreen", "OK", "", "", "");
				}				
			});
		}

    newHomeScreenVm.checkDpList = function () {
      if (mutualFundsService.totalSecurities.dpList != null && mutualFundsService.totalSecurities.dpList.length > 0) {
        newHomeScreenVm.showError($translate.instant("OPEN_DEMAT_ALREADY_HAVE_ACCOUNT_LBL"));
      } else {
        openAccountService.checkDematApplicationExists().then(function (data) {
          if (data.applicationStatus == null || data.applicationStatus.trim() == "" || data.applicationStatus.toLowerCase() == "initiated") {
            openAccountService.setStatusOfOpenAccount(0);
            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "ONLINE_DEMAT_OPEN_NOW"));
            $state.go("menu.dematAndTradingAccount");
          } else {
            homeScreenService.isInvestmentFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 3;
            $state.go("menu.accountOverviewMyBalance");
          }
        },
        function (error) {
          utilityService.showErrorMessage(error.responseMessage);
        });
      }
    };

    //Show popup of showError if user is already having Demat ID
		newHomeScreenVm.showError = function (message) {
			$ionicPopup.show({
				template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
					+ message + '</span></div></div></div>',
				title: 'Alert',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'Ok',
					onTap: function (e) {
						homeScreenService.isInvestmentFlag = true;
						getAccountDetailsService.tabIndex.tabIndex = 3;
						$state.go('menu.accountOverviewMyBalance');
					}
				}]
			});
		}

    // not in existing prod
    // function allowApplication() {
    //   applyNowService.resetApplyForm();
    //   newCardService.setParams({ applyCardType: "PRSE" });
    //   newCardService.setParams({ applyCardName: "YONO SimplyEARN SBI Card" });
    //   newCardService.setParams({
    //     applyPictureURL:"https://www.sbicard.com/sbi-card-en/assets/media/images/personal/credit-cards/rewards/simply-earn-yono-card/simplyearn-card-face.png",
    //   });
    //   newCardService.setParams({ applyCardCategory: "reward" });

    //   applyNowService.getCities().then(function (response) {
    //     cardsService.errorLogger(response);
    //     cardsService.setParams({ city: response.data.cities });
    //     cardsService.setParams({ pendingApplication: false });
    //     $state.go("menu.cardPersonalDetails1");      
    //   },
    //   function (error) {
    //     utilityService.showErrorMessage(error.responseMessage);
    //   });
    // }

    var removedDuplicateObjects = function (arr) {
      return arr.filter(function (item, index) {
        return arr.indexOf(item) >= index;
      });
    };

    newHomeScreenVm.setCustomerInofAndAccountDetails = function () {
      mutualFundsService.addUserDetails(newHomeScreenVm.data, true);
			mutualFundsService.addUserPanDetails(newHomeScreenVm.data);
			$rootScope.customerInfoForProfile = newHomeScreenVm.data;
			customerInfoService.customer.name = newHomeScreenVm.data.customerName;
			customerInfoService.customer.type = newHomeScreenVm.data.customerType;
			customerInfoService.customer.DOB = newHomeScreenVm.data.dob;
			customerInfoService.customer.isPanAvailable = newHomeScreenVm.data.panNumber;
			customerInfoService.customer.isStaffFlag = newHomeScreenVm.data.isStaffFlag;
			customerInfoService.customer.emailID = newHomeScreenVm.data.emailID;
			customerInfoService.customer.mobile = newHomeScreenVm.data.mobile;
			customerInfoService.customer.title = newHomeScreenVm.data.title;
			customerInfoService.customer.residentialStatus = newHomeScreenVm.data.residentialStatus;

			$rootScope.customerAccNo = newHomeScreenVm.data.accountNumber;
			$rootScope.mobileNo = newHomeScreenVm.data.mobile;
			localStorage.setItem("customername", newHomeScreenVm.data.customerName);
			localStorage.setItem("customerlanguage", newHomeScreenVm.data.language);
			$rootScope.customerName = localStorage.getItem('customername');
			customerInfoService.customer.imageurl = newHomeScreenVm.data.imageUrl;
			var balData = newHomeScreenVm.data.balance;
			balData = balData.split("+");
			if (balData.length === 1) {
				newHomeScreenVm.symbol = "";
				newHomeScreenVm.balance = balData[0];
			} else if (balData.length > 1) {
				newHomeScreenVm.symbol = "";
				newHomeScreenVm.balance = balData[1];
			} else {
				balData = balData.split("-");
				if (balData.length === 1) {
					newHomeScreenVm.symbol = "";
					newHomeScreenVm.balance = balData[0];
				} else {
					newHomeScreenVm.symbol = "-";
					newHomeScreenVm.balance = balData[1];
				}
			}
    };

    $scope.showHideDrawer = function(slideFlow){
      $scope.activeFooterTab = slideFlow;
      if($scope.slideUpTrueServiceReq || $scope.slideUpTrueRewards || $scope.slideUpTruePayViaUPI || $scope.slideUpTrueBestOffers || $scope.slideUpTrueLinks){
        if(slideFlow == 'service'){
          $scope.slideUpTrueServiceReq = true;
          $scope.slideUpTrueRewards = false;
          $scope.slideUpTruePayViaUPI = false;
          $scope.slideUpTrueBestOffers = false;
          $scope.slideUpTrueLinks = false;
        }

        if (slideFlow == "rewards") {
          newHomeScreenVm.getRewardPoints();
        }

        if (slideFlow == "upi") {
          $scope.slideUpTruePayViaUPI = true;
          $scope.slideUpTrueRewards = false;
          $scope.slideUpTrueServiceReq = false;
          $scope.slideUpTrueBestOffers = false;
          $scope.slideUpTrueLinks = false;
        }

        if (slideFlow == "offers") {
          $scope.slideUpTrueBestOffers = true;
          $scope.slideUpTruePayViaUPI = false;
          $scope.slideUpTrueRewards = false;
          $scope.slideUpTrueServiceReq =false;
          $scope.slideUpTrueLinks = false;
        }

        if(slideFlow == 'links'){
          $scope.slideUpTrueLinks = true;
          $scope.slideUpTrueBestOffers = false;
          $scope.slideUpTruePayViaUPI = false;
          $scope.slideUpTrueRewards = false;
          $scope.slideUpTrueServiceReq = false;
        }
      }else{
        if(slideFlow == 'service'){
          $scope.slideUpTrueServiceReq = true;
        }

        if(slideFlow == "rewards") {
          newHomeScreenVm.getRewardPoints();
        }

        if (slideFlow == "upi") {
          $scope.slideUpTruePayViaUPI = true;
        }

        if (slideFlow == "offers") {
          $scope.slideUpTrueBestOffers = true;
        } 

        if(slideFlow == 'links'){
          $scope.slideUpTrueLinks = true;
        }

        if(slideFlow == 'close'){
          footerContentPopup.close();
          $scope.slideUpTrueServiceReq = false;
          $scope.slideUpTrueRewards = false;
          $scope.slideUpTruePayViaUPI = false;
          $scope.slideUpTrueBestOffers = false;
          $scope.slideUpTrueLinks = false;
        }

        if(slideFlow != 'close'){
          footerContentPopup = $ionicPopup.show({
            templateUrl: 'pages/newHomeScreen/newHomeScreenFooterContentPopup.html',
            title: '',
            scope: $scope,
            cssClass: 'newHomeScreenFooterContentPopup'
          });
        }
      }
      if(slideFlow == 'close'){
        footerContentPopup.close();
          $scope.slideUpTrueServiceReq = false;
          $scope.slideUpTrueRewards = false;
          $scope.slideUpTruePayViaUPI = false;
          $scope.slideUpTrueBestOffers = false;
          $scope.slideUpTrueLinks = false;
      }
    }

    newHomeScreenVm.getRewardPoints =function(){
      homeScreenService.getPointsSummary().then(function (data) {
        $scope.slideUpTrueRewards = true;
        $scope.slideUpTrueServiceReq = false;
        $scope.slideUpTruePayViaUPI = false;
        $scope.slideUpTrueBestOffers = false;
        $scope.slideUpTrueLinks = false;
        newHomeScreenVm.rewardPoints = data.points;
      }, function (error) {
        footerContentPopup.close();
        $scope.slideUpTrueLinks = false;
        $scope.slideUpTrueBestOffers = false;
        $scope.slideUpTruePayViaUPI = false;
        $scope.slideUpTrueRewards = false;
        $scope.slideUpTrueServiceReq = false;
        utilityService.showErrorMessage(error.responseMessage);
      });
    }   

    newHomeScreenVm.goToBanner = function (store, BannerIndex) {
      // revised redirection rule logic
      BannerIndex = BannerIndex + 1;
      if (store.redirectionType == "MERCHANT") {
        clickStreamService.clickStreamData = "websiteId," + store.affiliateId +",index," + BannerIndex;
        newHomeScreenVm.selectedMerchantAffiliateId = store.affiliateId;
        homeScreenService.getMerchantDetailsByAffId({ "affiliateId": newHomeScreenVm.selectedMerchantAffiliateId, "merchantKey": cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + newHomeScreenVm.selectedMerchantAffiliateId).toString() }).then(function (data) {
            $scope.merchantDetails = data[0];
            ompMerchantsService.listName = data[0];
            ompMerchantsService.listName.pageId = $state.current.data.pageId;
            ompMerchantsService.psudoIdEnble = data[0].psudoIdEnble;
            if ((data[0].coupons || data[0].offerPoints) && (data[0].coupons.length > 0 || data[0].offerPoints.length > 0)) {
              $state.go('menu.redirectionDiscliamer');
            } else {
              newHomeScreenVm.dynamicDisclaimer = decodeURIComponent(data[0].disclaimerContent).replace(new RegExp("\\+", "g"), ' ');
              newHomeScreenVm.ompdisclaimer(data[0]);
            }
          }, function (error) {
            utilityService.showErrorMessage(error.responseMessage);
          });
      } else if (store.redirectionType == "CATEGORY") {
      // redirection based on categoryCode
        clickStreamService.clickStreamData = "websiteId," + store.categoryCode +",index," + BannerIndex;
        homeScreenService.storeSelected = store.title;
        homeScreenService.categoryCode = store.categoryCode;
        $state.go('menu.merchantList');
      } else {
        clickStreamService.clickStreamData = "websiteId," + store.categoryCode +",index," + BannerIndex;
        if (store.categoryCode == 'IRCTC') {
          irctcService.searchTrainObj = "";
          irctcService.myList = "";
          irctcService.masterData = "";
          irctcService.selectedTrainData = "";
          irctcService.myListFullData = "";
          irctcService.infantArray = [];
          irctcService.passArray = [];
          $state.go(store.redirectionURL);
        } else if (store.categoryCode.toLowerCase() == 'mandi') {
          agriMandiService.source = "mandi";
          newHomeScreenVm.mitraMandiRedirection(store.redirectionURL);
        } else if (store.categoryCode.toLowerCase() == 'mitra') {
          agriMandiService.source = "mitra";
          newHomeScreenVm.mitraMandiRedirection(store.redirectionURL);
        } else {
          $state.go(store.redirectionURL);
        }
      }
    }

    newHomeScreenVm.ompdisclaimer = function (data) {
      newHomeScreenVm.merchantsList = data
      newHomeScreenVm.bannerPopup = $ionicPopup.show({
        title: '',
        cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
        templateUrl: "pages/newHomeScreen/bannerDisclaimerPopup.html",
        scope: $scope
      });
	  }

    newHomeScreenVm.bannerPopupCancel = function () {
      clickStreamService.clickStreamData = "websiteId," + newHomeScreenVm.merchantsList.affiliateId;
      newHomeScreenVm.bannerPopup.close();
    }

    newHomeScreenVm.bannerPopupAgree = function () {
      newHomeScreenVm.bannerPopup.close();
          
      if (newHomeScreenVm.merchantsList.merchantType === 'Redirection') {
        clickStreamService.clickStreamData = "websiteId," + newHomeScreenVm.merchantsList.affiliateId;

        newHomeScreenVm.loadPopup = $ionicPopup.show({
          title: '',
          cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
          templateUrl: "pages/newHomeScreen/bannerLoadPopup.html",
          scope: $scope
        })

        var mobileRedirectKey='';
          mobileRedirectKey= cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + newHomeScreenVm.merchantsList.mobileRedirectUrl).toString();
        var saveLeadObj = {
          "leadId": "",
          "websiteId": newHomeScreenVm.merchantsList.websiteId,
          "affiliateId": newHomeScreenVm.merchantsList.affiliateId,
          "request": {
            "ompCcustToken": "",
            "loggedIn": "",
            "channel": "",
            "segId": "",
            "ompTokenId": "",
            "merchantSku": "",
            "prdPrice": "",
            "wishlistSkus": "",
            "ompDisValue": "",
            "ompDisPct": "",
            "ompDisType": "",
            "isLoggedIn": mPinLoginService.isLoggedIn
          },
          "leadParam": newHomeScreenVm.merchantsList.leadParam,
          "segmentParam": newHomeScreenVm.merchantsList.segmentParam,
          "affiliateIdParam": newHomeScreenVm.merchantsList.affiliateIdParam,
          "mobileRedirectUrl" : newHomeScreenVm.merchantsList.mobileRedirectUrl,
          "mobileRedirectKey" : mobileRedirectKey,
          "shopNOrder": "",
          "psudoIdEnble": ompMerchantsService.psudoIdEnble
        }

        ompMerchantsService.saveLead(saveLeadObj).then(function (response) {
          const hRespCheck = response.data.resourceParameter;
          if (hRespCheck == undefined || hRespCheck == null || hRespCheck == "" || hRespCheck == cryptoService.getSHA512EncryptedData(response.data.mobileUrl).toString()) {
            newHomeScreenVm.saveLeadData = response;
            newHomeScreenVm.loadPopup.close();
            if (isWebviewLoadingCanceled == true) {
              return "";
            }
            isWebviewLoadingCanceled = true;
              if (mPinLoginService.isLoggedIn) {
                if (newHomeScreenVm.merchantsList.merchantCode == "ubr") {
                  if (utilityService.isAndroidPlatform()) {
                    appAvailability.check('com.ubercab',
                      function () {
                        var url = response.data.mobileUrl;        
                        ompMerchantsService.inChromeBrowser(url);
                      },
                      function () {
                        var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                        ompMerchantsService.inChromeBrowser(url);
                      });
                  } else {
                    appAvailability.check('uber://', function () {
                      var url = response.data.mobileUrl;
                      ompMerchantsService.inChromeBrowser(url);
                    }, function () {
                      var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                      ompMerchantsService.inChromeBrowser(url);
                    });
                  }
                  return true;
                }
                else if (newHomeScreenVm.merchantsList.browserType === 'inApp') {
                ompMerchantsService.inAppBrowser(response.data.mobileUrl,$scope.merchantDetails);
                } else if (newHomeScreenVm.merchantsList.browserType === 'default') {
                  ompMerchantsService.inChromeBrowser(response.data.mobileUrl);
                } else if (newHomeScreenVm.merchantsList.browserType === 'chrome_tab') {
                  ompMerchantsService.inChromeTabBrowser(response.data.mobileUrl);
                }
              }
            } else {
            newHomeScreenVm.loadPopup.close();
            utilityService.showErrorMessage("Invalid request");
          }          
        }, function (error) {
          newHomeScreenVm.loadPopup.close();
          utilityService.showErrorMessage(error.responseMessage);
        });
      } 
    }

    newHomeScreenVm.tapCancel = function () {
      newHomeScreenVm.loadPopup.close();
      isWebviewLoadingCanceled = true;
      $state.go('menu.homeScreen');
    }

    newHomeScreenVm.mitraMandiRedirection = function(URL){
			if (getAccountDetailsService.accountOverviewData) {
				if (getAccountDetailsService.accountOverviewData.customerInformation.language) {
          agriMandiService.selectLanguage = getAccountDetailsService.accountOverviewData.customerInformation.language.toLowerCase();
					$state.go(URL);
        } else {
					 agriMandiService.selectLanguage = 'en';
					 $state.go(URL);
				}
			} else {
				utilityService.showBhimUpiAlert("alert", "Customer details are being fetched. Please try again.");
			}
		}

    newHomeScreenVm.registerForPush = function () {
      try {
          WLAuthorizationManager.obtainAccessToken("push.mobileclient").then(
            MFPPush.registerDevice(null, function (successResponse) {
                  homeScreenService.isPushEnabled = true;
              },function (failureResponse) {
                console.log(failureResponse);
              })
            );
        }
        catch(err) {
          console.log(err);
        }            
    }    

    $scope.sliderOptions = {
      effect: "slide",
      paginationHide: true,
      initialSlide: 0,
      onInit: function (swiper) {
        $scope.swiper = swiper;
      },
      onSlideChangeEnd: function (swiper) {
        // ....
      },
    };

    $scope.slideChanged = function (index) {
      $scope.slideIndex = index;
    };

    newHomeScreenVm.next = function () {
      $ionicSlideBoxDelegate.next();
    };

    newHomeScreenVm.previous = function () {
      $ionicSlideBoxDelegate.previous();
    };

    $scope.$on("$ionicView.loaded", function () {
      newHomeScreenVm.getCustomerInfo();
      newHomeScreenVm.getnotificationOffer();
    });

    $scope.$on("$ionicView.beforeEnter", function () {
      if (ompMerchantsService.CTAPush && ompMerchantsService.isPushLoginFlagEnabled) {
			  utilityService.showSpinner();
				ompMerchantsService.CTAPush = false;
				ompMerchantsService.authOnDisclaimer = false;
				ompMerchantsService.isPushLoginFlagEnabled = false;
				if (ompMerchantsService.CTAPushData.redirectionType == "MERCHANT") {
					clickStreamService.clickStreamData = "websiteId," + ompMerchantsService.CTAPushData.affiliateId;
					homeScreenService.getMerchantDetailsByAffId({ "affiliateId": ompMerchantsService.CTAPushData.affiliateId, "merchantKey": cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + ompMerchantsService.CTAPushData.affiliateId).toString()}).then(function (data) {
						$scope.merchantDetails = data[0];
						ompMerchantsService.listName = data[0];
						ompMerchantsService.listName.pageId = $state.current.data.pageId;
						ompMerchantsService.psudoIdEnble = data[0].psudoIdEnble;
						utilityService.hideSpinner();
						$state.go('menu.redirectionDiscliamer');
					}, function (error) {
						utilityService.hideSpinner();
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else if (ompMerchantsService.CTAPushData.redirectionType == "CATEGORY") {
					clickStreamService.clickStreamData = "websiteId," + ompMerchantsService.CTAPushData.categoryCode;
					homeScreenService.categoryCode = ompMerchantsService.CTAPushData.categoryCode;
					homeScreenService.storeSelected = ompMerchantsService.CTAPushData.categoryTitle;
					utilityService.hideSpinner();
					$state.go('menu.merchantList');
				} else {
					clickStreamService.clickStreamData = "websiteId," + ompMerchantsService.CTAPushData.categoryCode;
					utilityService.hideSpinner();
					if (ompMerchantsService.CTAPushData.categoryCode == 'IRCTC') {
						irctcService.searchTrainObj = "";
						irctcService.myList = "";
						irctcService.masterData = "";
						irctcService.selectedTrainData = "";
						irctcService.myListFullData = "";
						irctcService.infantArray = [];
						irctcService.passArray = [];
						$state.go(ompMerchantsService.CTAPushData.redirectUrl);
					} else if (ompMerchantsService.CTAPushData.categoryCode.toLowerCase() == 'mandi') {
						agriMandiService.source = "mandi";
						newHomeScreenVm.mitraMandiRedirection(store.redirectionURL);
					} else if (ompMerchantsService.CTAPushData.categoryCode.toLowerCase() == 'mitra') {
						agriMandiService.source = "mitra";
						newHomeScreenVm.mitraMandiRedirection(store.redirectionURL);
					} else {
						$state.go(ompMerchantsService.CTAPushData.redirectUrl);
					}
				}
			}
      newHomeScreenVm.getSearchJSONData();
      if (homeScreenService.grabOffers.length != 0) {
        newHomeScreenVm.graboffers = homeScreenService.grabOffers;
      } else {
        homeScreenService.getRevisedOfferOptions().then(function(response) {
          csatServices.csatFeedbackdata = response.feedbackData;
          csatServices.highestGoldenJourneyCounter = parseInt(csatServices.csatFeedbackdata.feedbackMaxCounter);
          csatServices.feedbackGoldenJourneyList = csatServices.csatFeedbackdata.feedbackGoldenJourneyList;
          if(parseInt(internetBankingService.goldenJourneyCompletionCounter) == 1){
            csatServices.whetherGoldenJourney("REG");
          }
          homeScreenService.grabOffers = response.data;
          newHomeScreenVm.graboffers = homeScreenService.grabOffers;
          $ionicSlideBoxDelegate.update();
          $ionicSlideBoxDelegate.loop(true);
        },function (err) {
            var offers = [{
								"bannerSubject": "Property",
								"categoryCode": "OMPBO90",
								"imageurl": "img/landingPage/Banner_1-100.jpg",
								"redirectionURL": "menu.ompMerchants"
							},{
								"bannerSubject": "Fashion &amp; Lifestyle",
								"categoryCode": "OMPS20",
								"imageurl": "img/landingPage/Banner_2-100.jpg",
								"redirectionURL": "menu.ompMerchants"
							},{
								"bannerSubject": "Automobiles",
								"categoryCode": "OMPS100",
								"imageurl": "img/landingPage/Banner_3-100.jpg",
								"redirectionURL": "menu.ompMerchants"
							},{
								"bannerSubject": "Multi Category",
								"categoryCode": "OMPS10",
								"imageurl": "img/landingPage/Banner_4-100.jpg",
								"redirectionURL": "menu.ompMerchants"
							},{
								"bannerSubject": "Flight &amp; Bus",
								"categoryCode": "OMPBO10",
								"imageurl": "img/landingPage/Banner_5-100.jpg",
								"redirectionURL": "menu.ompMerchants"
							},{
								"bannerSubject": "Hospitality &amp; Hotels",
								"categoryCode": "OMPBO20",
								"imageurl": "img/landingPage/Banner_6-100.jpg",
								"redirectionURL": "menu.ompMerchants"
						}];
            newHomeScreenVm.graboffers = offers;
            $ionicSlideBoxDelegate.update();
            $ionicSlideBoxDelegate.loop(true);
          });
        }
        setTimeout(function() {
          var data = localStorage.getItem('reraId');
          var pageRedirect = localStorage.getItem('isRedirectedTowdsLoan');
          if (data && pageRedirect === "false") {
            newLoansLandingService.redirectToNewLoansLanding();
            localStorage.setItem('isRedirectedTowdsLoan', "");
          }
        }, 900);
        $scope.slideUpTrue = false;
        $scope.slideDownTrue = true;
    });

    $scope.$on('$ionicView.afterEnter', function () {
      initPage();
      setTimeout(function() { // loan page call after login
        var data = localStorage.getItem('reraId');
				var pageRedirect = localStorage.getItem('isRedirectedTowdsLoan');
				var redirectOnly = localStorage.getItem('redirectOnlyFlow');
				if ((data && pageRedirect === "false") || redirectOnly === "true") {
					newLoansLandingService.redirectToNewLoansLanding();
					localStorage.setItem('isRedirectedTowdsLoan', "");
					localStorage.setItem('redirectOnlyFlow', "");
				}
      }, 90);
      setTimeout(function() {  //Yono cash in case of prelogin
        if(homeScreenService.preLoginYonoCash){
          $state.go('menu.yonoCashLanding');
          homeScreenService.preLoginYonoCash=false;
        }
      },500);
      
      setTimeout(function() {   //redirect to irctc after login
        if(homeScreenService.irctcCallAfterSuccLogin){
          homeScreenService.irctcCallAfterSuccLogin = false;
          irctcService.searchTrainObj = "";
          irctcService.myList = "";
          irctcService.masterData = "";
          irctcService.selectedTrainData = "";
          irctcService.myListFullData = "";
          irctcService.infantArray = [];
          irctcService.passArray = [];
          $state.go('menu.irctcBookTicketSearch');
        }
        if(homeScreenService.automobileCallAfterSuccLogin){
          homeScreenService.automobileCallAfterSuccLogin = false;
          $state.go('menu.automobileLanding');
        }
        if(homeScreenService.automallCallAfterSuccLogin){ //redirect to automall after login
          homeScreenService.automallCallAfterSuccLogin = false;
          automallService.getEmiMasterService().then(function (emiMaster) {
            automallService.setMasterEmiData(emiMaster);
            automallService.getAutomallBanners().then(function (banner) {
                automallService.setLandingBanners(banner);
                automallService.getOEMListService().then(function (oemList) {
                    automallService.setOemList(oemList);
                    $state.go('menu.automall');
                }, function (error) {
                  utilityService.showErrorMessage(error.responseMessage);
                });
              }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
              });
          }, function (error) {
              utilityService.showErrorMessage(error.responseMessage);
          });
        }
      },100);
    });

    /*Home Screen API Optimization:UX2.0 */
    $scope.$on('$ionicView.afterLeave', function(){
      if (!homeScreenService.isPushEnabled) {
          newHomeScreenVm.registerForPush();
      }
    });

    $scope.$on('$ionicView.beforeLeave', function(){
      newHomeScreenVm.isPageCurrent = false;
    });
    return this;
  },
]);