'use strict';

angularApp.controller('addressDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter) {

        var addressDetailsNPSControllerVM = this;
        $scope.currentPage = "6";
        $scope.lastPage = "16";


        addressDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        addressDetailsNPSControllerVM.goBack = function () {
            if(addressDetailsNPSControllerVM.isOrphan == 'N'){
                $state.go('menu.npsParentDetails');
            }else{
                $state.go('menu.npsOrpLooksGreat');
            }
            
        }

        addressDetailsNPSControllerVM.goNext = function () {
            npsServices.applicantData.stateCode = addressDetailsNPSControllerVM.applicantData.stateCode;
            npsServices.applicantData.state = addressDetailsNPSControllerVM.applicantData.stateValue;
             $state.go("menu.npsContactDetails");
            
            
        }

        //select list for state
        addressDetailsNPSControllerVM.selectedStateUnionTerritory = function (index) {
            
            
                for (var i = 0; i < addressDetailsNPSControllerVM.stateList.length; i++) {
                    addressDetailsNPSControllerVM.applicantData.stateCodeFData = addressDetailsNPSControllerVM.stateList[i].value;
                     if(addressDetailsNPSControllerVM.applicantData.stateCode == addressDetailsNPSControllerVM.applicantData.stateCodeFData){
                        addressDetailsNPSControllerVM.applicantData.stateValue = addressDetailsNPSControllerVM.stateList[i].description;
                     }
                 }
             }
        

       

        $scope.$on('$ionicView.beforeEnter', function () {
            addressDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            addressDetailsNPSControllerVM.stateList = npsServices.npsDropdownData.stateMasters;
            
            addressDetailsNPSControllerVM.applicantData = angular.copy(npsServices.applicantData);
            addressDetailsNPSControllerVM.selectedStateUnionTerritory();
            addressDetailsNPSControllerVM.isOrphan = npsServices.applicantData.isorphanflag;
            
           
        });

        return this;
    }
]);
