'use strict';

angularApp.controller('moneyLaunderingDeclarationNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "npsServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        npsServices) {

        var moneyLaunderingDeclarationNPSControllerVM = this;
        $scope.currentPage = "14";
        $scope.lastPage = "16";
        

        moneyLaunderingDeclarationNPSControllerVM.goBack = function(){
            if( moneyLaunderingDeclarationNPSControllerVM.isUsCitizen == 'N' && moneyLaunderingDeclarationNPSControllerVM.countryOfBirthValue == "United States"){
                 $state.go('menu.npsFatcaLooksRelGreat'); 
            }else{
                $state.go("menu.fatcaDetails");
            }
            
        }

        moneyLaunderingDeclarationNPSControllerVM.goNext = function () {
            npsServices.npsMoneyLaunderingDetails.moneyLaunderingFlag = moneyLaunderingDeclarationNPSControllerVM.npsMoneyLaunderingDetails.moneyLaunderingFlag;
            $state.go("menu.contributionDetails");
            
        }


        $scope.$on('$ionicView.beforeEnter', function () {
            moneyLaunderingDeclarationNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            moneyLaunderingDeclarationNPSControllerVM.npsMoneyLaunderingDetails = angular.copy(npsServices.npsMoneyLaunderingDetails);
            moneyLaunderingDeclarationNPSControllerVM.isUsCitizen = npsServices.npsFatcaDetails.isUsCitizen;
            moneyLaunderingDeclarationNPSControllerVM.countryOfBirthValue = npsServices.applicantData.countryOfBirthValue;
            moneyLaunderingDeclarationNPSControllerVM.NPSDetails = npsServices.NPSDetails;
        });


        return this;
    }
]);
