'use strict';

angularApp.controller('parentsDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter) {

        var parentsDetailsNPSControllerVM = this;
        $scope.currentPage = "5";
        $scope.lastPage = "16";
       


         //contact data edit from review page 
            parentsDetailsNPSControllerVM.reviewBtn = false;
            parentsDetailsNPSControllerVM.originalFBtn = true;
            parentsDetailsNPSControllerVM.isReviewAct = true;
            var reviewEditData = npsServices.getReviewEditData();
            parentsDetailsNPSControllerVM.npsCheckBoxDisabled = true;
            parentsDetailsNPSControllerVM.comingFromReview = function () {
                if(reviewEditData == 'parentsDetails'){
                    parentsDetailsNPSControllerVM.reviewBtn = true;
                    parentsDetailsNPSControllerVM.originalFBtn = false;
                }
            }

            parentsDetailsNPSControllerVM.goCancel = function(){
                parentsDetailsNPSControllerVM.originalFBtn = true;
                parentsDetailsNPSControllerVM.reviewBtn = false;
                $state.go("menu.reviewDetailsNps");
            }

           
        //end code here
        
        parentsDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        parentsDetailsNPSControllerVM.goBack = function () {

            $state.go("menu.npsTakeSelfie");
        }

        
        
    //marital status validation
    parentsDetailsNPSControllerVM.validationForMarital = function(){

            if(parentsDetailsNPSControllerVM.applicantData.maritalStatus == null || parentsDetailsNPSControllerVM.applicantData.maritalStatus == "" || parentsDetailsNPSControllerVM.applicantData.maritalStatus == undefined ){
                parentsDetailsNPSControllerVM.mStatus = false;
            }else{
                parentsDetailsNPSControllerVM.mStatus = true;
            }


            if(parentsDetailsNPSControllerVM.applicantData.maritalStatus == 'M'){
                if(parentsDetailsNPSControllerVM.applicantData.spouseFirstName =='' || parentsDetailsNPSControllerVM.applicantData.spouseFirstName == undefined ){
                    parentsDetailsNPSControllerVM.SFnameR = true;
                    
                }else{
                    parentsDetailsNPSControllerVM.SFnameR = false;
                }
            }
            
        }

        parentsDetailsNPSControllerVM.validationMNextBtn = function(){
             if((parentsDetailsNPSControllerVM.SFnameR || !parentsDetailsNPSControllerVM.mStatus) ){
                    parentsDetailsNPSControllerVM.nextBtn = true;
                }else{
                    parentsDetailsNPSControllerVM.nextBtn = false;
                }
        }

        //end here


        parentsDetailsNPSControllerVM.npsFormValidation = function(){
             if(parentsDetailsNPSControllerVM.npsOrphan == 'N'){

                 if( (parentsDetailsNPSControllerVM.applicantData.motherFirstName !== '' &&  parentsDetailsNPSControllerVM.applicantData.fatherFirstName == '') || (parentsDetailsNPSControllerVM.applicantData.motherFirstName !== '' &&  parentsDetailsNPSControllerVM.applicantData.fatherFirstName !== '' && parentsDetailsNPSControllerVM.npsMotherDetails) ){
                        parentsDetailsNPSControllerVM.npsMotherDetails = true;
                        parentsDetailsNPSControllerVM.npsCheckBoxDisabled = false;
                       
                    }
                    else if((parentsDetailsNPSControllerVM.applicantData.motherFirstName !== '' &&  parentsDetailsNPSControllerVM.applicantData.fatherFirstName !== '')){
                        parentsDetailsNPSControllerVM.npsMotherDetails = false;
                        parentsDetailsNPSControllerVM.npsCheckBoxDisabled = false;
                    }
                    
                    else{
                       parentsDetailsNPSControllerVM.npsMotherDetails = false;
                        parentsDetailsNPSControllerVM.npsCheckBoxDisabled = true; 
                    }

                     if(parentsDetailsNPSControllerVM.npsMotherDetails){
                        parentsDetailsNPSControllerVM.npsParentsDetails.motherNamePrintCheckbox = true;
                        
                    }else{
                        parentsDetailsNPSControllerVM.npsParentsDetails.motherNamePrintCheckbox = false;
                        
                    }

                  

                    parentsDetailsNPSControllerVM.validationForMarital();
                    

                    if( (parentsDetailsNPSControllerVM.npsMotherDetails && parentsDetailsNPSControllerVM.applicantData.fatherFirstName == '') || parentsDetailsNPSControllerVM.applicantData.fatherFirstName !== '' ){
                        parentsDetailsNPSControllerVM.fFnameR = false;
                        
                    }else{
                        parentsDetailsNPSControllerVM.fFnameR = true;
                        
                    }

                    if((parentsDetailsNPSControllerVM.SFnameR && parentsDetailsNPSControllerVM.fFnameR) || parentsDetailsNPSControllerVM.fFnameR || (parentsDetailsNPSControllerVM.SFnameR && !parentsDetailsNPSControllerVM.fFnameR ) || (!parentsDetailsNPSControllerVM.mStatus && parentsDetailsNPSControllerVM.fFnameR) || !parentsDetailsNPSControllerVM.mStatus ){
                        parentsDetailsNPSControllerVM.nextBtn = true;
                    }else{
                        parentsDetailsNPSControllerVM.nextBtn = false;
                    }
               
           
       
             }else{
                 parentsDetailsNPSControllerVM.validationForMarital();
                 parentsDetailsNPSControllerVM.validationMNextBtn();
               
             }
        }

         parentsDetailsNPSControllerVM.npsCheckD = function(){
            parentsDetailsNPSControllerVM.npsFormValidation();
                
        }

        //check orphan or not - on switch radio button
        parentsDetailsNPSControllerVM.checkOrphanOrNot = function (npsCheck) {
            
            if(npsCheck == "N"){
                 parentsDetailsNPSControllerVM.isReviewAct = true;
                 parentsDetailsNPSControllerVM.applicantData.fatherFirstName = npsServices.applicantData.fatherFirstName;
                 parentsDetailsNPSControllerVM.applicantData.fatherMiddleName = npsServices.applicantData.fatherMiddleName;
                  parentsDetailsNPSControllerVM.applicantData.fatherLastName = npsServices.applicantData.fatherLastName;

                 parentsDetailsNPSControllerVM.npsParentsDetails.motherNamePrintCheckbox = npsServices.npsParentsDetails.motherNamePrintCheckbox

                parentsDetailsNPSControllerVM.applicantData.motherFirstName = npsServices.applicantData.motherFirstName;
                parentsDetailsNPSControllerVM.applicantData.motherMiddleName = npsServices.applicantData.motherMiddleName;
                parentsDetailsNPSControllerVM.applicantData.motherLastName = npsServices.applicantData.motherLastName;

                parentsDetailsNPSControllerVM.applicantData.maritalStatus =  npsServices.applicantData.maritalStatus;
                parentsDetailsNPSControllerVM.npsFormValidation();

              

               
            }else{
                parentsDetailsNPSControllerVM.isReviewAct = false;
                parentsDetailsNPSControllerVM.applicantData.fatherFirstName = "";
                parentsDetailsNPSControllerVM.applicantData.fatherMiddleName = "";
                parentsDetailsNPSControllerVM.applicantData.fatherLastName = "";

                parentsDetailsNPSControllerVM.npsParentsDetails.motherNamePrintCheckbox = false;

                parentsDetailsNPSControllerVM.applicantData.motherFirstName = "";
                parentsDetailsNPSControllerVM.applicantData.motherMiddleName = "";
                parentsDetailsNPSControllerVM.applicantData.motherLastName = "";

                parentsDetailsNPSControllerVM.validationForMarital();
                parentsDetailsNPSControllerVM.validationMNextBtn();
            }
        }

        //end switch radio code


        //go to next button 
        parentsDetailsNPSControllerVM.goNext = function () {

            npsServices.applicantData.fatherFirstName = parentsDetailsNPSControllerVM.applicantData.fatherFirstName;
            npsServices.applicantData.fatherMiddleName = parentsDetailsNPSControllerVM.applicantData.fatherMiddleName;
            npsServices.applicantData.fatherLastName = parentsDetailsNPSControllerVM.applicantData.fatherLastName;

            npsServices.npsParentsDetails.motherNamePrintCheckbox = parentsDetailsNPSControllerVM.npsParentsDetails.motherNamePrintCheckbox;

            npsServices.applicantData.motherFirstName = parentsDetailsNPSControllerVM.applicantData.motherFirstName;
            npsServices.applicantData.motherMiddleName = parentsDetailsNPSControllerVM.applicantData.motherMiddleName;
            npsServices.applicantData.motherLastName = parentsDetailsNPSControllerVM.applicantData.motherLastName;

            npsServices.applicantData.maritalStatus = parentsDetailsNPSControllerVM.applicantData.maritalStatus;

            npsServices.applicantData.spouseFirstName = parentsDetailsNPSControllerVM.applicantData.spouseFirstName;
            npsServices.applicantData.spouseMiddleName = parentsDetailsNPSControllerVM.applicantData.spouseMiddleName;
            npsServices.applicantData.spouseLastName = parentsDetailsNPSControllerVM.applicantData.spouseLastName;
            npsServices.applicantData.isorphanflag = parentsDetailsNPSControllerVM.npsOrphan;


            var requestParams = {
               
                "familyDetails": {
                    "motherFirstName": parentsDetailsNPSControllerVM.applicantData.motherFirstName,
                    "motherMiddleName": parentsDetailsNPSControllerVM.applicantData.motherMiddleName,
                    "motherLastName": parentsDetailsNPSControllerVM.applicantData.motherLastName,
                    "motherNamePrintRequired": parentsDetailsNPSControllerVM.npsParentsDetails.motherNamePrintCheckbox ? "Y" : "N",
                    "maritalStatus": parentsDetailsNPSControllerVM.applicantData.maritalStatusValue,
                    "maritalStatusCode": parentsDetailsNPSControllerVM.applicantData.maritalStatus,
                    "spouseFirstName": parentsDetailsNPSControllerVM.applicantData.spouseFirstName,
                    "spouseMiddleName": parentsDetailsNPSControllerVM.applicantData.spouseMiddleName,
                    "spouseLastName": parentsDetailsNPSControllerVM.applicantData.spouseLastName,
                    "fatherFirstName": parentsDetailsNPSControllerVM.applicantData.fatherFirstName,
                    "fatherMiddleName": parentsDetailsNPSControllerVM.applicantData.fatherMiddleName,
                    "fatherLastName": parentsDetailsNPSControllerVM.applicantData.fatherLastName,
                    "isorphanflag": parentsDetailsNPSControllerVM.npsOrphan
                }
            };

               
                
            npsServices.saveParentsDetails(requestParams).then(function (response) {
                        if(parentsDetailsNPSControllerVM.reviewBtn && reviewEditData == 'parentsDetails' && parentsDetailsNPSControllerVM.isReviewAct){
                            $state.go("menu.reviewDetailsNps");
                        }else{
                            if(npsServices.applicantData.isorphanflag == 'Y'){
                                if(npsServices.applicantData.orphanPhoto || npsServices.applicantData.orphanevidencedocid){
                                    $state.go('menu.npsOrpLooksGreat');
                                }else{
                                    $state.go('menu.npsOrpSelfi');
                                }
                            }else{
                                $state.go("menu.npsAddressDetails");
                            }
                        }
                                     
                        
                    }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            

        }

        //select and reset  marital status 
        parentsDetailsNPSControllerVM.selectedMaritalStatus = function () {

            parentsDetailsNPSControllerVM.applicantData.maritalStatusValue = utilityService.getTextFromDropdown("value", parentsDetailsNPSControllerVM.applicantData.maritalStatus, parentsDetailsNPSControllerVM.maritalStatusList, "description");

            if(parentsDetailsNPSControllerVM.npsOrphan == 'N'){
                if((parentsDetailsNPSControllerVM.applicantData.maritalStatus == 'M' || parentsDetailsNPSControllerVM.applicantData.maritalStatus == undefined) &&(parentsDetailsNPSControllerVM.applicantData.motherFirstName == '' ||  parentsDetailsNPSControllerVM.applicantData.fatherFirstName == '') || (parentsDetailsNPSControllerVM.applicantData.maritalStatus == 'M' || parentsDetailsNPSControllerVM.applicantData.maritalStatus == undefined) &&(parentsDetailsNPSControllerVM.applicantData.motherFirstName !== '' ||  parentsDetailsNPSControllerVM.applicantData.fatherFirstName !== '')){
                parentsDetailsNPSControllerVM.nextBtn = true;
                }else{
                    parentsDetailsNPSControllerVM.nextBtn = false;
                }
            }else{
                if(parentsDetailsNPSControllerVM.applicantData.maritalStatus == 'M' || parentsDetailsNPSControllerVM.applicantData.maritalStatus == undefined){
                    parentsDetailsNPSControllerVM.nextBtn = true;
                }else{
                    parentsDetailsNPSControllerVM.nextBtn = false;
                }
            }
            

            if(parentsDetailsNPSControllerVM.applicantData.maritalStatusValue){
                parentsDetailsNPSControllerVM.isReviewAct = false;
                npsServices.setReviewEditData('');
            }else{
                parentsDetailsNPSControllerVM.isReviewAct = true;
            }

            
        }

        parentsDetailsNPSControllerVM.resetMaritalStatus = function () {

            parentsDetailsNPSControllerVM.applicantData.spouseFirstName = "";
            parentsDetailsNPSControllerVM.applicantData.spouseMiddleName = "";
            parentsDetailsNPSControllerVM.applicantData.spouseLastName = "";

        }

        //end reset and select marital status 

       
        $scope.$on('$ionicView.beforeEnter', function () {
            parentsDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            
            
            parentsDetailsNPSControllerVM.maritalStatusList = npsServices.npsDropdownData.maritalStatusMaster;
            parentsDetailsNPSControllerVM.applicantData = angular.copy(npsServices.applicantData);
            parentsDetailsNPSControllerVM.npsParentsDetails = angular.copy(npsServices.npsParentsDetails);
            parentsDetailsNPSControllerVM.npsOrphan = npsServices.applicantData.isorphanflag;
            
            if(parentsDetailsNPSControllerVM.npsOrphan === null || parentsDetailsNPSControllerVM.npsOrphan === undefined || parentsDetailsNPSControllerVM.npsOrphan === "" ){
                parentsDetailsNPSControllerVM.npsOrphan = "N";
                npsServices.applicantData.isorphanflag = parentsDetailsNPSControllerVM.npsOrphan;
                
               
            }else{
                parentsDetailsNPSControllerVM.npsOrphan = npsServices.applicantData.isorphanflag;
            }


            if(parentsDetailsNPSControllerVM.applicantData.maritalStatus){
                parentsDetailsNPSControllerVM.nextBtn = true;
            }else{
                parentsDetailsNPSControllerVM.nextBtn = false;
            }

        
            
            parentsDetailsNPSControllerVM.npsParentsDetails.motherNamePrintCheckbox = npsServices.npsParentsDetails.motherNamePrintCheckbox;
            if(parentsDetailsNPSControllerVM.npsParentsDetails.motherNamePrintCheckbox){
                parentsDetailsNPSControllerVM.npsMotherDetails = true;
            }else{
                parentsDetailsNPSControllerVM.npsMotherDetails = false;
            }

            parentsDetailsNPSControllerVM.comingFromReview();
            parentsDetailsNPSControllerVM.npsFormValidation();
            

           

            

        });

        return this;
    }
]);
