'use strict';

angularApp.controller('showSiContributionDetailController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "$ionicViewSwitcher",
    "$ionicPopover",
    "homeScreenService",
    "npsContributionServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        $ionicViewSwitcher,
        $ionicPopover,
        homeScreenService,
        npsContributionServices,
        $filter) {

        var showSiContributionDetailControllerVM = this;
        showSiContributionDetailControllerVM.statusReasonTrue = false;


        showSiContributionDetailControllerVM.goBackToSIList = function () {
            $state.go("menu.showAllSiContribution");  
        }

        showSiContributionDetailControllerVM.siFailedInfo = function (stReason, index, $event) {
            if(stReason){
                    for (var i = 0; i < showSiContributionDetailControllerVM.siExecutionDetails.length; i++) {
                        if(showSiContributionDetailControllerVM.siExecutionDetails[i].statusReason === stReason && index === i){
                            showSiContributionDetailControllerVM.indexStR = i;
                            showSiContributionDetailControllerVM.statusReasonTrue = true;
                            showSiContributionDetailControllerVM.statusReason = showSiContributionDetailControllerVM.siExecutionDetails[i].statusReason;
                            $scope.popover.show($event);
                            console.log("index", showSiContributionDetailControllerVM.indexStR);
                        }
                        
                     }
                }
            }

             /* Info Popup */
            var template = '<ion-popover-view class="nps-tooltip-after tooltiptext nps-otherDetails-tooltip npsContriSiPopup roboto-regular">' + '<ion-content>' +
                '<p class="text-left siStatusReason" ng-bind-html="showSiContributionDetailControllerVM.statusReason"></p>' + '</ion-content>' + '</ion-popover-view>';

            $scope.popover = $ionicPopover.fromTemplate(template, {
                scope: $scope
            });

             



      // on page landing
        $scope.$on('$ionicView.beforeEnter', function () {
            showSiContributionDetailControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            showSiContributionDetailControllerVM.getSIDetailData = npsContributionServices.getSIDetailData;
            showSiContributionDetailControllerVM.siExecutionDetails = npsContributionServices.siExecutionDetails;

            //for date format(date pipe not working properly) - create new array
            showSiContributionDetailControllerVM.siExecutionData = [];
            if(showSiContributionDetailControllerVM.siExecutionDetails){
                for (var k = 0; k < showSiContributionDetailControllerVM.siExecutionDetails.length; k++) {
                    
                    showSiContributionDetailControllerVM.siExecDate = moment(showSiContributionDetailControllerVM.siExecutionDetails[k].siExecDate, 'DD/MM/YYYY').format("DD MMM YYYY");
                    var obj = {
                                'execStatus':showSiContributionDetailControllerVM.siExecutionDetails[k].execStatus,
                                'nsdlStatus':showSiContributionDetailControllerVM.siExecutionDetails[k].nsdlStatus,
                                'siExecDate':showSiContributionDetailControllerVM.siExecDate,
                                'statusReason':showSiContributionDetailControllerVM.siExecutionDetails[k].statusReason,

                              }

                    showSiContributionDetailControllerVM.siExecutionData.push(obj);
                    
                }  
                
            }

            showSiContributionDetailControllerVM.siStartDate = moment(showSiContributionDetailControllerVM.getSIDetailData.siStartDate, 'DD-MM-YYYY').format("DD MMM YYYY");
            showSiContributionDetailControllerVM.epactRefno = npsContributionServices.epactRefno;

            //calculation of two contribution 
            var tier1ContriAmnt =  parseInt(showSiContributionDetailControllerVM.getSIDetailData.tier1ContriAmnt);
            var tier2ContriAmnt =  parseInt(showSiContributionDetailControllerVM.getSIDetailData.tier1ContriAmnt);

            if(tier2ContriAmnt && tier1ContriAmnt){
                showSiContributionDetailControllerVM.totalContri = tier1ContriAmnt + tier2ContriAmnt;
            }else{
                showSiContributionDetailControllerVM.totalContri = tier2ContriAmnt;
            }
            
            showSiContributionDetailControllerVM.totalContriAmt = $filter('INR')(showSiContributionDetailControllerVM.totalContri);
            
         });


        return this;
    }
]);
