angularApp.service('npsContributionServices', function ($q, $http, AdapterUtils, utilityService, $cordovaDevice, $ionicPopup, $state) {
    var npsContributionServices = this;
    npsContributionServices.pranNo = "";
    npsContributionServices.username = "";
    var npsAccntData = "";

    npsContributionServices.getUserList = {
        tier2PopSpRegNo: "",
        tier1PopSpRegNo: "",
        tier1StsReasonCd: "",
        tier2StsCode: "",
        iraFlag: "",
        tier2Sts: "",
        tier1Sts: "",
        tier2SectorCd: "",
        fatcaFlag: "",
        tier1StsCode: "",
        tier1PopRegNo: "",
        tier2StsReasonCd: "",
        tier1SectorCd: "",
        craFlag: "",
        username: "",
        tier2PopRegNo: "",
        pranNo: "",
        cif: ""

    };

    npsContributionServices.contributionDetails = {
        tierTypePassData: "",
        contributionAmountTierI: "",
        contributionAmountTierII: "",
        gst: "",
        tierId: "",
        charges: "",
        totalAmtReceivable: ""
    }

    npsContributionServices.SIStandingAccntDetails = {
        tierTypePassData: "",
        contributionAmountTierI: "",
        contributionAmountTierII: "",
        gst: "",
        tierId: "",
        charges: "",
        totalAmtReceivable: ""
    }

    npsContributionServices.userAccntDetails = {
        balance: "",
        accType: "",
        accountNumber: "",
        pranNoOnClick: ""
    }

    npsContributionServices.SIStngUserAccntDetails = {
        balance: "",
        accType: "",
        accountNumber: "",
        pranNoOnClick: ""
    }

    npsContributionServices.setSIStandingDetails = {
        siStartDate: "",
        equityVal: "",
        siDay: ""
    }

    npsContributionServices.pranDetails = {
        pranNo: "",
        confirmPranNo: "",
        nickName: "",
        consentFlag: ""
    }


    npsContributionServices.setNpsAccntData = function (dataSet) {
        npsAccntData = dataSet;
    }

    npsContributionServices.getNpsAccntData = function () {
        return npsAccntData;
    }





    // -----------------------------------------------------API CALL START----------------------------------------------


    // -----------------FETCH API START-----------------------

    npsContributionServices.fetchNpsUserList = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/retrieveLinkedNPSAcc", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };


    //for link nps Accnt
    npsContributionServices.validatePRAN = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/validatePRAN", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    //for delete link nps accout
    npsContributionServices.deleteLinkedNPSAcc = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/deleteLinkedNPSAcc", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    //for get all active SI
    npsContributionServices.getAllActiveSI = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/getAllActiveSI", requestData, true).then(
            function (response) {
                q.resolve(response); // remove data
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };


    //for get SI Details
    npsContributionServices.getSIDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/getSIDetails", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };


    //for link nps account
    npsContributionServices.linkNpsAccnt = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/linkNPSAcc", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    //for get all wcm content
    npsContributionServices.getNpsContributionInfo = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/getNpsContributionInfo", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };


    //for delete single SI
    npsContributionServices.deleteSI = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/deleteSI", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };


    //for contribution charges
    npsContributionServices.fetchCharges = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/fetchCharges", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };


    //for pre confirmation contribution charges
    npsContributionServices.preConfirmContribution = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/preConfirmContribution", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };


    //for  confirmation contribution charges
    npsContributionServices.confirmContribution = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/confirmContribution", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    //for set SI
    npsContributionServices.setSI = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/setSI", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    //for set getPRANDetails
    npsContributionServices.getPRANDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/getPRANDetails", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    //for set getNPSReciept for contribution
    npsContributionServices.getNPSReciept = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/getNPSReciept", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    //for check if ifSIExist or not
    npsContributionServices.checkSIExist = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPSContribution/isSIExist", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);    
            }
        );
        return q.promise;
    };



    npsContributionServices.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
        var btn_array = [];
        if (buttontext1 != "" && buttontext2 != "") {
            btn_array = [
                {
                    text: buttontext2 || "Cancel",
                    type: 'button-negative',
                    onTap: function () {
                        obj.addressChangeFlag = false;
                        obj.resiAddressFlag = "";
                    }
                },
                {
                    text: buttontext1 || "OK",
                    type: 'button-positive',
                    onTap: function () {
                        console.log('');
                    }
                }
            ];
        }
        else {
            btn_array = [
                {
                    text: buttontext1 || "OK",
                    type: 'button-positive',
                    onTap: function () {
                        if (onTapgo) {
                            $state.go(onTapgo);
                        }
                    }
                }
            ];
        }

        if (imageType && imageType.toLowerCase() == 'error') {
            imageType += '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
        } else if (imageType && imageType.toLowerCase() == 'success') {
            imageType += '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
        } else if (imageType && imageType.toLowerCase() == 'alert') {
            imageType += '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
        } else {
            imageType += "";
        }
        var bhimErrorPopup = $ionicPopup.alert({
            template: '<div class="font-dark-grey npsContriPopupImg">' + imageType + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading npsContriPopupHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
            + message1 + '</span><div ng-if="message2" class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div></div></div></div>', //template,
            scope: $scope,
            cssClass: 'bhim-alert-popup',
            buttons: btn_array,
        });
        bhimErrorPopup.then(function (res) {
            console.log('');
        });
        console.log(imageType);
    };




    return npsContributionServices;
});